/*$Id: admin_alter_r.c,v 5.19 2011-08-29 07:08:59 sasa Exp $*/
/*19.07.2011	09.07.2010	Белых А.И.	admin_alter_r.c
Перобразование базы данных
*/
#define DVERSIQ "10.08.2011"
#include        <pwd.h>
#include <errno.h>
#include <glib.h>
#include <sys/stat.h>
#include "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

void alter_uosgrup_ta(const char *imabaz);
void rnn_ko(int metka,WINDOW *win1);
void alter_cp_alx(int metka,const char *imaf,const char *imabaz,const char *put_na_alx,WINDOW *win1);
void alter_cat_str(const char *stroka,const char *param,const char *imaf,WINDOW *win1);
void alter_icebuser(const char *imabaz,WINDOW *win1);
void admin_alter_r_zzb(const char *imabazz);
void admin_alter_r_alxin(const char *imabazz,WINDOW *win1);
void adimi_alter_r_ins_str_alx(const char *imaf,const char *naststr,const char *znahnast);
void admin_alter_r_nnni();

extern char *putnansi;
extern char *imabaz;

int admin_alter_r(const char *imabazz,
int kolvsehbaz,
const char *put_na_alx,
const char *put_na_doc)
{
char		strsql[2048];
class SQLCURSOR cur;
WINDOW		*win1;
static int	nombaz=0;

clear();
GDITE();

/*имя базы используется в подпрограммах глобально*/
if(imabaz != NULL)
 delete [] imabaz;

imabaz=new char[strlen(imabazz)+1];
strcpy(imabaz,imabazz);

sprintf(strsql,"USE %s",imabazz);
if(sql_zapis(strsql,1,0) != 0)
 return(1);

icebstart_rf(); //чтение и выполнение запросов к базе

if((win1=subwin(stdscr,LINES-3,COLS,3,0)) == (WINDOW*)ERR)
 {
  printw("\nОшибка создания окна win1!\n");
//  perror("*******");
  OSTANOV();
  return(1);
 }
scrollok(win1,TRUE); /*Разрешение ролинга на экране*/
move(0,0);
printw("%s N%d %s %s:%d\n",
gettext("Преобразование базы"),
++nombaz,imabazz,
gettext("Количество всех баз"),
kolvsehbaz);
printw("%s %s от %s\n",gettext("Версия"),VERSION,DVERSIQ);
printw("-----------------------------------------------------------------------\n");
refresh();




/****************************************/
/*********** 9.9 05.11.2008 ************/
/****************************************/

wprintw(win1,"Добавляем индекс nb в таблицу Kasord\n");
wrefresh(win1);

sprintf(strsql,"alter table Kasord add index nb (nb)");

if(sql_zap(&bd,strsql) != 0)
 {
  if(sql_nerror(&bd) == ER_DUP_KEYNAME)
   {
    wprintw(win1,"Индекс уже существует.\n");
    wrefresh(win1);
   }
 else
  wprintw(win1,"Ошибка ! %d\n%s\n",sql_nerror(&bd),sql_error(&bd));

 }
/****************************************/
/*********** 9.12 29.11.2008 ************/
/****************************************/
wprintw(win1,"Вставляем колонку mi в таблицу Uospod.\n");
wrefresh(win1);

sprintf(strsql,"alter table Uospod add mi tinyint not null default 0");

if(sql_zap(&bd,strsql) != 0)
 {
  if(sql_nerror(&bd) == ER_DUP_FIELDNAME)
   {
    wprintw(win1,"Колонкa в таблице уже существуeт.\n");
    wrefresh(win1);
   }
  else
   {
    wprintw(win1,"Ошибка ! %d\n%s\n",sql_nerror(&bd),sql_error(&bd));
    OSTANOVW(win1);
   }
 }
/****************************************/
/*********** 9.15 10.02.2009 ************/
/****************************************/
wprintw(win1,"Создание таблицы перечня драг-металлов Uosdm !\n");
memset(strsql,'\0',sizeof(strsql));

strcpy(strsql,"CREATE TABLE Uosdm \
(kod    smallint not null default 0 primary key,\
naik    varchar(100) not null default '',\
ei      varchar(20) not null default '',\
ktoz	smallint unsigned not null default 0,\
vrem	int unsigned not null default 0)");
/*
0 kod    Код драгоценного металла
1 naik   Наименование металла
2 ei     Единица измерения
2 ktoz   Кто записал
3 vrem   Время записи
*/

if(sql_zap(&bd,strsql) != 0)
 { 
  wprintw(win1,"%s\n",sql_error(&bd));
 } 
else
  wprintw(win1,"Таблица создана\n");
wrefresh(win1);

wprintw(win1,"Создание таблицы содержимого драг-металлов в инвентарном номере Uosindm !\n");
memset(strsql,'\0',sizeof(strsql));

strcpy(strsql,"CREATE TABLE Uosindm \
(innom int not null,\
kod    smallint not null default 0,\
ei     varchar(20) not null default '',\
ves    double(12,6) not null default 0,\
ktoz	smallint unsigned not null default 0,\
vrem	int unsigned not null default 0,\
unique(innom,kod))");
/*
0 innom    инвентарный номер
1 kod    Код драгоценного металла
2 ei     Единица измерения
3 ves    вес материала
4 ktoz   Кто записал
5 vrem   Время записи
*/

if(sql_zap(&bd,strsql) != 0)
 { 
  wprintw(win1,"%s\n",sql_error(&bd));
 } 
else
  wprintw(win1,"Таблица создана\n");
wrefresh(win1);

/****************************************/
/*********** 9.20 30.03.2009 ************/
/****************************************/
wprintw(win1,"Создание таблицы заголовков доверенностей Uddok !\n");
wrefresh(win1);

memset(strsql,'\0',sizeof(strsql));
strcpy(strsql,"CREATE TABLE Uddok \
(datd   DATE not null default '0000-00-00',\
nomd    varchar(20) not null default '',\
datds   DATE NOT NULL default '0000-00-00',\
komu    varchar(80) NOT NULL default '',\
post    varchar(80) NOT NULL default '',\
podok   varchar(50) NOT NULL default '',\
otis    varchar(100) NOT NULL default '',\
datn    DATE NOT NULL default '0000-00-00',\
nomn    varchar(100) NOT NULL default '',\
seriq varchar(20) NOT NULL default '',\
nomerd varchar(20) NOT NULL default '',\
datavd DATE NOT NULL default '0000-00-00',\
vidan  varchar(200) NOT NULL default '',\
dolg   varchar(50) NOT NULL default '',\
ktoz	smallint unsigned not null default 0,\
vrem	int unsigned not null default 0,\
unique(datd,nomd),\
index(nomd))");

if(sql_zap(&bd,strsql) != 0)
 { 
  wprintw(win1,"%s\n",sql_error(&bd));
 } 
else
 wprintw(win1,"Таблица создана.\n\n");


wprintw(win1,"Создание таблицы записей в доверенности Uddok1 !\n");
wrefresh(win1);

memset(strsql,'\0',sizeof(strsql));
strcpy(strsql,"CREATE TABLE Uddok1 \
(datd   DATE not null default '0000-00-00',\
nomd    varchar(20) not null default '',\
nz      smallint NOT NULL default 0,\
zapis   varchar(200) NOT NULL default '',\
ei      varchar(20) NOT NULL default '',\
kol     double(16,4) NOT NULL default 0,\
ktoz	smallint unsigned not null default 0,\
vrem	int unsigned not null default 0,\
unique(datd,nomd,nz))");
/*
0  datd Дата выдачи доверенности
1  nomd номер доверенности
2  nz    уникальный номер записи
3  zapis содержимое записи
4  ei    единица измерения
5  kol   количество
6  ktoz  кто записал
7  vrem  время записи
*/

if(sql_zap(&bd,strsql) != 0)
 { 
  wprintw(win1,"%s\n",sql_error(&bd));
 } 
else
 wprintw(win1,"Таблица создана.\n\n");


/****************************************/
/*********** 9.24 12.04.2009 ************/
/****************************************/
wprintw(win1,"Удаляем колонку kof1 из Таблицы Uosgrup1\n");
wrefresh(win1);

sprintf(strsql,"alter table Uosgrup drop kof1");

if(sql_zap(&bd,strsql) != 0)
 {
  if(sql_nerror(&bd) != ER_CANT_DROP_FIELD_OR_KEY)
    wprintw(win1,"Ошибка ! %d\n%s\n",sql_nerror(&bd),sql_error(&bd));
  else
    wprintw(win1,"Колонка уже удалена\n");

 }


wprintw(win1,"Вставляем колонки ta,ar в таблицу Uosgrup\n");
wrefresh(win1);

sprintf(strsql,"alter table Uosgrup add ta tinyint not null default 0, add ar tinyint not null default 0");

if(sql_zap(&bd,strsql) != 0)
 {
  if(sql_nerror(&bd) == ER_DUP_FIELDNAME)
   {
    wprintw(win1,"Колонки в таблице уже существуют\n");
    wrefresh(win1);
   }
  else
   {
    wprintw(win1,"Ошибка ! %d\n%s\n",sql_nerror(&bd),sql_error(&bd));
    OSTANOVW(win1);
   }
 }

wprintw(win1,"Вставляем колонку ar в таблицу Uosgrup1\n");
wrefresh(win1);

sprintf(strsql,"alter table Uosgrup1 add ar tinyint not null default 0");

if(sql_zap(&bd,strsql) != 0)
 {
  if(sql_nerror(&bd) == ER_DUP_FIELDNAME)
   {
    wprintw(win1,"Колонкa в таблице уже существуeт\n");
    wrefresh(win1);
   }
  else
   {
    wprintw(win1,"Ошибка ! %d\n%s\n",sql_nerror(&bd),sql_error(&bd));
    OSTANOVW(win1);
   }
 }
else
 {
  alter_uosgrup_ta(imabazz);

 }
/****************************************/
/*********** 9.29 29.05.2009 ************/
/****************************************/

wprintw(win1,"Увеличиваем длинну колонки osnov в таблице Kasord\n");
wrefresh(win1);

sprintf(strsql,"alter table Kasord change osnov osnov varchar(250) not null default ''");

if(sql_zap(&bd,strsql) != 0)
 {
  wprintw(win1,"Ошибка ! %d\n%s\n",sql_nerror(&bd),sql_error(&bd));
  OSTANOVW(win1);
 }

/****************************************/
/*********** 9.30 01.06.2009 ************/
/****************************************/

wprintw(win1,"Увеличиваем длинну колонки naik в таблице Kasop1\n");
wrefresh(win1);

sprintf(strsql,"alter table Kasop1 change naik naik varchar(250) not null default ''");

if(sql_zap(&bd,strsql) != 0)
 {
  wprintw(win1,"Ошибка ! %d\n%s\n",sql_nerror(&bd),sql_error(&bd));
  OSTANOVW(win1);
 }

wprintw(win1,"Увеличиваем длинну колонки naik в таблице Kasop2\n");
wrefresh(win1);

sprintf(strsql,"alter table Kasop2 change naik naik varchar(250) not null");

if(sql_zap(&bd,strsql) != 0)
 {
  wprintw(win1,"Ошибка ! %d\n%s\n",sql_nerror(&bd),sql_error(&bd));
  OSTANOVW(win1);
 }

/****************************************/
/*********** 9.31 09.06.2009 ************/
/****************************************/

wprintw(win1,"Меняем тип колонки nomv в таблице Kasnomved\n");
wrefresh(win1);

sprintf(strsql,"alter table Kasnomved change nomv nomv varchar(10) not null default ''");

if(sql_zap(&bd,strsql) != 0)
 {
  wprintw(win1,"Ошибка ! %d\n%s\n",sql_nerror(&bd),sql_error(&bd));
  OSTANOVW(win1);
 }

/****************************************/
/*********** 9.35 23.06.2009 ************/
/****************************************/

wprintw(win1,"Добавляем колонку koment в таблицу Kasord1\n");
wrefresh(win1);

sprintf(strsql,"alter table Kasord1 add koment varchar(100) not null default ''");

if(sql_zap(&bd,strsql) != 0)
 {
  if(sql_nerror(&bd) == ER_DUP_FIELDNAME)
   {
    wprintw(win1,"Колонкa в таблице уже существуeт\n");
    wrefresh(win1);
   }
  else
   {
    wprintw(win1,"Ошибка ! %d\n%s\n",sql_nerror(&bd),sql_error(&bd));
    OSTANOVW(win1);
   }
 }

/****************************************/
/*********** 9.37 29.06.2009 ************/
/****************************************/

wprintw(win1,"Добавляем колонку nomv в таблицу Kasord\n");
wrefresh(win1);

sprintf(strsql,"alter table Kasord add nomv varchar(20) not null default ''");

if(sql_zap(&bd,strsql) != 0)
 {
  if(sql_nerror(&bd) == ER_DUP_FIELDNAME)
   {
    wprintw(win1,"Колонкa в таблице уже существуeт\n");
    wrefresh(win1);
   }
  else
   {
    wprintw(win1,"Ошибка ! %d\n%s\n",sql_nerror(&bd),sql_error(&bd));
    OSTANOVW(win1);
   }
 }

wprintw(win1,"Добавляем колонку nomd в таблицу Kasnomved\n");
wrefresh(win1);

sprintf(strsql,"alter table Kasnomved add nomd varchar(20) not null default ''");

if(sql_zap(&bd,strsql) != 0)
 {
  if(sql_nerror(&bd) == ER_DUP_FIELDNAME)
   {
    wprintw(win1,"Колонкa в таблице уже существуeт\n");
    wrefresh(win1);
   }
  else
   {
    wprintw(win1,"Ошибка ! %d\n%s\n",sql_nerror(&bd),sql_error(&bd));
    OSTANOVW(win1);
   }
 }



/****************************************/
/*********** 10.2 09.09.2009 ************/
/****************************************/

wprintw(win1,"Создание таблицы списка банков Zarsb !\n");
wrefresh(win1);

memset(strsql,'\0',sizeof(strsql));
strcpy(strsql,"CREATE TABLE Zarsb \
(kod    int not null default 0 primary key,\
naik    varchar(80) not null default '',\
ktoz	smallint unsigned not null default 0,\
vrem	int unsigned not null default 0)");
/*
0 kod   код банка
1 naik  наименование банка
2 ktoz  кто записал
3 vrem  время записи
*/

if(sql_zap(&bd,strsql) != 0)
 { 
  wprintw(win1,"%s\n",sql_error(&bd));
 } 
else
 wprintw(win1,"Таблица создана.\n\n");

wprintw(win1,"Добавляем колонку kb в таблицу  Kartb\n");
wrefresh(win1);

sprintf(strsql,"alter table Kartb add kb int not null default 0");

if(sql_zap(&bd,strsql) != 0)
 {
  if(sql_nerror(&bd) == ER_DUP_FIELDNAME)
   {
    wprintw(win1,"Колонкa в таблице уже существуeт\n");
    wrefresh(win1);
   }
  else
   {
    wprintw(win1,"Ошибка ! %d\n%s\n",sql_nerror(&bd),sql_error(&bd));
    OSTANOVW(win1);
   }
 }

/****************************************/
/*********** 10.5 12.10.2009 ************/
/****************************************/
wprintw(win1,"Добавляем колонку mo в таблицу Dokummat\n");
wrefresh(win1);

sprintf(strsql,"alter table Dokummat add mo tinyint not null default 0");

if(sql_zap(&bd,strsql) != 0)
 {
  if(sql_nerror(&bd) == ER_DUP_FIELDNAME)
   {
    wprintw(win1,"Колонкa в таблице уже существуeт\n");
    wrefresh(win1);
   }
  else
   {
    wprintw(win1,"Ошибка ! %d\n%s\n",sql_nerror(&bd),sql_error(&bd));
    OSTANOVW(win1);
   }
 }

wprintw(win1,"Добавляем колонку mo в таблицу Usldokum\n");
wrefresh(win1);

sprintf(strsql,"alter table Usldokum add mo tinyint not null default 0");

if(sql_zap(&bd,strsql) != 0)
 {
  if(sql_nerror(&bd) == ER_DUP_FIELDNAME)
   {
    wprintw(win1,"Колонкa в таблице уже существуeт\n");
    wrefresh(win1);
   }
  else
   {
    wprintw(win1,"Ошибка ! %d\n%s\n",sql_nerror(&bd),sql_error(&bd));
    OSTANOVW(win1);
   }
 }

wprintw(win1,"Добавляем колонку mo в таблицу Uosdok\n");
wrefresh(win1);

sprintf(strsql,"alter table Uosdok add mo tinyint not null default 0");

if(sql_zap(&bd,strsql) != 0)
 {
  if(sql_nerror(&bd) == ER_DUP_FIELDNAME)
   {
    wprintw(win1,"Колонкa в таблице уже существуeт\n");
    wrefresh(win1);
   }
  else
   {
    wprintw(win1,"Ошибка ! %d\n%s\n",sql_nerror(&bd),sql_error(&bd));
    OSTANOVW(win1);
   }
 }

/****************************************/
/*********** 10.10 03.12.2009 ************/
/****************************************/
wprintw(win1,"Добавляем колонку vd в таблицу Reenn\n");
wrefresh(win1);

sprintf(strsql,"alter table Reenn add vd char(8) not null default ''");

if(sql_zap(&bd,strsql) != 0)
 {
  if(sql_nerror(&bd) == ER_DUP_FIELDNAME)
   {
    wprintw(win1,"Колонкa в таблице уже существуeт\n");
    wrefresh(win1);
   }
  else
   {
    wprintw(win1,"Ошибка ! %d\n%s\n",sql_nerror(&bd),sql_error(&bd));
    OSTANOVW(win1);
   }
 }
wprintw(win1,"Добавляем колонку vd в таблицу Reenn1\n");
wrefresh(win1);

sprintf(strsql,"alter table Reenn1 add vd char(8) not null default ''");

if(sql_zap(&bd,strsql) != 0)
 {
  if(sql_nerror(&bd) == ER_DUP_FIELDNAME)
   {
    wprintw(win1,"Колонкa в таблице уже существуeт\n");
    wrefresh(win1);
   }
  else
   {
    wprintw(win1,"Ошибка ! %d\n%s\n",sql_nerror(&bd),sql_error(&bd));
    OSTANOVW(win1);
   }
 }

wprintw(win1,"Создание таблицы списка картсчетов работников Zarkh !\n");
memset(strsql,'\0',sizeof(strsql));
strcpy(strsql,"CREATE TABLE Zarkh (\
tn int not null default 0,\
kb  int not null default 0,\
nks varchar(40) not null default '',\
ktoz smallint unsigned not null default 0,\
vrem int unsigned not null default 0,\
unique(tn,kb))");
/****
0 tn - табельный номер
1 kb - код банка
2 nks - номер карт-счёта
3 ktoz кто записал
4 vrem время записи
****/
if(sql_zap(&bd,strsql) != 0)
 { 
  wprintw(win1,"Ошибка ! %d\n%s\n",sql_nerror(&bd),sql_error(&bd));
 } 
else
 wprintw(win1,"Таблица создана\n\n");

wrefresh(win1);

/****************************************/
/*********** 10.10 30.01.2010 ************/
/****************************************/
/**************
alter_cp_alx(0,"rpvnn0_1.alx",imabazz,put_na_alx,win1);
alter_cp_alx(0,"rpvnn1_1.alx",imabazz,put_na_alx,win1);
alter_cp_alx(0,"rpvnn2_1.alx",imabazz,put_na_alx,win1);
alter_cp_alx(0,"rnnovdp.alx",imabazz,put_na_alx,win1);
alter_cp_alx(0,"rnnovdr.alx",imabazz,put_na_alx,win1);

alter_cp_alx(0,"zarbanks.alx",imabazz,put_na_alx,win1);
alter_cp_alx(0,"zarsrbold.alx",imabazz,put_na_alx,win1);
alter_cp_alx(0,"zarpensm.alx",imabazz,put_na_alx,win1);
alter_cp_alx(0,"zarindexv.alx",imabazz,put_na_alx,win1);
****************/
/****************************************/
/*********** 10.11 01.02.2010 ************/
/****************************************/
wprintw(win1,"Изменям размерность в колонке ves для таблицы Uosindm\n");
wrefresh(win1);

sprintf(strsql,"alter table Uosindm change ves ves double(13,8) not null default 0");

if(sql_zap(&bd,strsql) != 0)
 {
  wprintw(win1,"Ошибка ! %d\n%s\n",sql_nerror(&bd),sql_error(&bd));
  OSTANOVW(win1);
 }


/****************************************/
/*********** 10.11 04.02.2010 ************/
/****************************************/
//alter_cat_str("Код филиала пенсионного фонда","|","zarpensm.alx",win1);


/****************************************/
/*********** 10.22 22.02.2010 ************/
/****************************************/
wprintw(win1,"Добавляем колонку kss в таблицу Kartb\n");
wrefresh(win1);

sprintf(strsql,"alter table Kartb add kss varchar(16) not null default ''");

if(sql_zap(&bd,strsql) != 0)
 {
  if(sql_nerror(&bd) == ER_DUP_FIELDNAME)
   {
    wprintw(win1,"Колонкa в таблице уже существуeт\n");
    wrefresh(win1);
   }
  else
   {
    wprintw(win1,"Ошибка ! %d\n%s\n",sql_nerror(&bd),sql_error(&bd));
    OSTANOVW(win1);
   }
 }

//alter_cat_str("Коды звания неатестованых","|","zarpensm.alx",win1);

/****************************************/
/*********** 10.28 22.03.2010 ************/
/****************************************/
//alter_cp_alx(0,"nastud.alx",imabazz,put_na_alx,win1);


/****************************************/
/*********** 10.32 20.06.2010 ************/
/****************************************/
/**********
sprintf(strsql,"alter table Uosdok change podrv podrv smallint not null");

if(sql_zap(&bd,strsql) != 0)
 {
  wprintw(win1,"Ошибка ! %d\n%s\n",sql_nerror(&bd),sql_error(&bd));
  OSTANOVW(win1);
 }
sprintf(strsql,"alter table Uosdok change osnov osnov varchar(60) not null");

if(sql_zap(&bd,strsql) != 0)
 {
  wprintw(win1,"Ошибка ! %d\n%s\n",sql_nerror(&bd),sql_error(&bd));
  OSTANOVW(win1);
 }
***************/
/****************************************/
/*********** 10.35 05.08.2010 ************/
/****************************************/

wprintw(win1,"Добавляем колонку ss в таблицу Ukrdok1\n");
wrefresh(win1);
sprintf(strsql,"alter table Ukrdok1 add ss double(10,2) not null default 0");

if(sql_zap(&bd,strsql) != 0)
 {
  if(sql_nerror(&bd) == ER_DUP_FIELDNAME)
   {
    wprintw(win1,"Колонка ss в таблице Ukrdok1 уже существует\n");
    wrefresh(win1);
   }
  else
   {
    beep();
    wprintw(win1,"Ошибка ! %d\n%s\n",sql_nerror(&bd),sql_error(&bd));
    OSTANOVW(win1);
   }
 }
//alter_cp_alx(1,"nakl.alx",imabazz,put_na_alx,win1);

/****************************************/
/*********** 11.00 01.09.2010 ************/
/****************************************/
wprintw(win1,"Создание таблицы операторов icebuser !\n");
memset(strsql,'\0',sizeof(strsql));

strcpy(strsql,"CREATE TABLE icebuser \
(login char(32) not null default '' primary key,\
fio varchar(255) not null default '',\
un  int unsigned not null default 0,\
kom varchar(255) not null default '',\
logz   varchar(32) not null default '',\
vrem   int unsigned not null default 0,\
gkd tinyint not null default 0,\
gkb tinyint not null default 0,\
gkn tinyint not null default 0,\
mud tinyint not null default 0,\
mub tinyint not null default 0,\
mun tinyint not null default 0,\
pdd tinyint not null default 0,\
pdb tinyint not null default 0,\
pdn tinyint not null default 0,\
zpd tinyint not null default 0,\
zpb tinyint not null default 0,\
zpn tinyint not null default 0,\
osd tinyint not null default 0,\
osb tinyint not null default 0,\
osn tinyint not null default 0,\
uud tinyint not null default 0,\
uub tinyint not null default 0,\
uun tinyint not null default 0,\
kod tinyint not null default 0,\
kob tinyint not null default 0,\
kon tinyint not null default 0,\
krd tinyint not null default 0,\
krb tinyint not null default 0,\
krn tinyint not null default 0,\
pld tinyint not null default 0,\
plb tinyint not null default 0,\
pln tinyint not null default 0,\
nnd tinyint not null default 0,\
nnb tinyint not null default 0,\
nnn tinyint not null default 0,\
udd tinyint not null default 0,\
udb tinyint not null default 0,\
udn tinyint not null default 0,\
unique(un))");

/*
 0 login  логин оператора
 1 fio    фамилия имя отчество
 2 un     уникальный номер оператора
 3 kom    коментарий
 4 logz   логин сделавшего запись
 5 vrem   Время записи
 6 gkd    если равно 0 то разрешена работа с подсистемой "Главная книга"
 7 gkb    если равно 0 то разрешена блокировка подсистемы "Главная книга"
 8 gkn    если равно 0 то разрешена работа с настроечными файлами подсистемы "Главная книга"
 9 mud    если равно 0 то разрешена работа с подсистемой "Материальный учёт"
10 mub    если равно 0 то разрешена блокировка подсистемы "Материальный учёт"
11 mun    если равно 0 то разрешена работа с настроечными файлами подсистемы "Материальный учёт"
12 pdd    если равно 0 то разрешена работа с подсистемой "Платёжные документы"
13 pdb    если равно 0 то разрешена блокировка подсистемы "Платёжные документы"
14 pdn    если равно 0 то разрешена работа с настроечными файлами подсистемы "Платёжные документы"
15 zpd    если равно 0 то разрешена работа с подсистемой "Заработная плата"
16 zpb    если равно 0 то разрешена блокировка подсистемы "Заработная плата"
17 zpn    если равно 0 то разрешена работа с настроечными файлами подсистемы "Заработная плата"
18 osd    если равно 0 то разрешена работа с подсистемой "Учёт основных средств"
19 osb    если равно 0 то разрешена блокировка подсистемы "Учёт основных средств"
20 osn    если равно 0 то разрешена работа с настроечными файлами подсистемы "Учёт основных средств"
21 uud    если равно 0 то разрешена работа с подсистемой "Учёт услуг"
22 uub    если равно 0 то разрешена блокировка подсистемы "Учёт услуг"
23 uun    если равно 0 то разрешена работа с настроечными файлами подсистемы "Учёт услуг"
24 kod    если равно 0 то разрешена работа с подсистемой "Учёт кассовых ордеров"
25 kob    если равно 0 то разрешена блокировка подсистемы "Учёт кассовых ордеров"
26 kon    если равно 0 то разрешена работа с настроечными файлами подсистемы "Учёт кассовых ордеров"
27 krd    если равно 0 то разрешена работа с подсистемой "Учёт командировочных расходов"
28 krb    если равно 1 то разрешена блокировка подсистемы "Учёт командировочных расходов"
29 krn    если равно 0 то разрешена работа с настроечными файлами подсистемы "Учёт командироваочных расходов"
30 pld    если равно 0 то разрешена работа с подсистемой "Учёт путевых листов"
31 plb    если равно 0 то разрешена блокировка подсистемы "Учёт путувых листов"
32 pln    если равно 0 то разрешена работа с настроечными файлами подсистемы "Учёт путевых листов"
33 nnd    если равно 0 то разрешена работа с подсистемой "Реестр налоговых накладных"
34 nnb    если равно 0 то разрешена блокировка подсистемы "Реестр налоговых накладных"
35 nnn    если равно 0 то разрешена работа с настроечными файлами подсистемы "Реестр налоговых накладных"
36 udd    если равно 0 то разрешена работа с подсистемой "Учёт доверенностей"
37 udb    если равно 0 то разрешена блокировка подсистемы "Учёт доверенностей"
38 udn    если равно 0 то разрешена работа с настроечными файлами подсистемы "Учёт доверенностей"
*/

if(sql_zap(&bd,strsql) != 0)
 { 
  wprintw(win1,"%s\n",sql_error(&bd));
 } 
else
 {
  wprintw(win1,"Таблица создана\n");
  alter_icebuser(imabazz,win1);
 }
wrefresh(win1);

wprintw(win1,"Создание таблицы блокировок Blok !\n");
memset(strsql,'\0',sizeof(strsql));

strcpy(strsql,"CREATE TABLE Blok \
(kod int not null default 0,\
god smallint unsigned not null default 0,\
mes smallint unsigned not null default 0,\
log varchar(255) not null default '',\
shet varchar(255) not null default '',\
ktoz int not null default 0,\
vrem int unsigned not null default 0,\
unique(kod,god,mes))");

if(sql_zap(&bd,strsql) != 0)
 { 
  wprintw(win1,"%s\n",sql_error(&bd));
 } 
else
 {
  wprintw(win1,"Таблица создана\n");
  admin_alter_r_zzb(imabazz);
 }
wrefresh(win1);

/*
0 kod  - код подсистемы
1 god  - год
2 mes  - месяц
3 log  - логины операторов которым отменена блокировка
4 shet - счёта которые заблокированы (только для подсистемы "Главная книга*)
5 ktoz - номер оператора сделавшего запись
6 vrem - время записи
*/

wprintw(win1,"Создание таблицы настроек Alx !\n");
memset(strsql,'\0',sizeof(strsql));

strcpy(strsql,"CREATE TABLE Alx \
(fil varchar(255) not null default '',\
ns int not null default 0,\
ktoz int not null default 0,\
vrem int unsigned not null default 0,\
str TEXT not null default '',\
unique(fil,ns))");

if(sql_zap(&bd,strsql) != 0)
 { 
  wprintw(win1,"%s\n",sql_error(&bd));
 } 
else
 {
  wprintw(win1,"Таблица создана\n");
  admin_alter_r_alxin(imabazz,win1);
 }
wrefresh(win1);

/*
0 fil  - имя файла
1 ns   - номер строки
2 ktoz - номер оператора сделавшего запись
3 vrem - время записи
4 str  - строка текста
*/

wprintw(win1,"Создание таблицы документации Doc !\n");
memset(strsql,'\0',sizeof(strsql));

strcpy(strsql,"CREATE TABLE Doc \
(fil varchar(255) not null default '',\
ns int not null default 0,\
str TEXT not null default '',\
unique(fil,ns))");

if(sql_zap(&bd,strsql) != 0)
 { 
  wprintw(win1,"%s\n",sql_error(&bd));
 } 
else
 {
  wprintw(win1,"Таблица создана\n");
 }
wrefresh(win1);

/*
0 fil  - имя файла
1 ns   - номер строки
2 str  - строка текста
*/

wprintw(win1,"Создание таблицы налогов Nalog !\n");
memset(strsql,'\0',sizeof(strsql));

strcpy(strsql,"CREATE TABLE Nalog \
(vn int not null default 0,\
dndn DATE not null default 0,\
pr double not null default 0,\
kom varchar(255) not null default '',\
ktoz int not null default 0,\
vrem int unsigned not null default 0,\
unique(vn,dndn))");

if(sql_zap(&bd,strsql) != 0)
 { 
  wprintw(win1,"%s\n",sql_error(&bd));
 } 
else
 {
  wprintw(win1,"Таблица создана\n");

  sprintf(strsql,"insert into Nalog values (0,'1990-1-1',20.,'',%d,%ld)",
  getuid(),time(NULL));

  sql_zapis(strsql,1,0);

  sprintf(strsql,"delete from Alx where fil='matnast.alx' and str like 'Н.Д.С.|%%'");
  sql_zapis(strsql,1,0);
 }
wrefresh(win1);

/*
0 vn   - вид налога 0-НДС
1 dndn - Дата начала действия налога
2 pr   - процент
3 kom  - коментарий
4 ktoz - номер оператора сделавшего запись
5 vrem - время записи
*/

/****************************************/
/*********** 11.2 04.11.2010 ************/
/****************************************/
wprintw(win1,"Добавляем колонку datv в таблицу Reenn\n");
wrefresh(win1);
sprintf(strsql,"alter table Reenn add datv DATE not null default '0000-00-00'");

if(sql_zap(&bd,strsql) != 0)
 {
  if(sql_nerror(&bd) == ER_DUP_FIELDNAME)
   {
    wprintw(win1,"Колонка в таблице уже существует\n");
    wrefresh(win1);
   }
  else
   {
    beep();
    wprintw(win1,"Ошибка ! %d\n%s\n",sql_nerror(&bd),sql_error(&bd));
    OSTANOVW(win1);
   }
 }

/****************************************/
/*********** 11.6 06.12.2010 ************/
/****************************************/

adimi_alter_r_ins_str_alx("nastud.alx","Печать доверенности на одной стороне листа","Выключено");

sprintf(strsql,"delete from Alx where fil='zarnast.alx' and str like 'Процент налога на добавленную стоимость|%%'");
sql_zapis(strsql,1,0);

sprintf(strsql,"delete from Alx where fil='zarnast.alx' and str like 'Список логинов доступ в программу которым разрешен|%%'");
sql_zapis(strsql,1,0);

/****************************************/
/*********** 11.10 14.01.2011 ************/
/****************************************/

wprintw(win1,"Добавляем колонку nzv в таблицу Zarsocz\n");
wrefresh(win1);
sprintf(strsql,"alter table Zarsocz add nz int unsigned PRIMARY KEY AUTO_INCREMENT NOT NULL");

if(sql_zap(&bd,strsql) != 0)
 {
  if(sql_nerror(&bd) == ER_DUP_FIELDNAME)
   {
    wprintw(win1,"Колонка в таблице уже существует\n");
    wrefresh(win1);
   }
  else
   {
    beep();
    wprintw(win1,"Ошибка ! %d\n%s\n",sql_nerror(&bd),sql_error(&bd));
    OSTANOVW(win1);
   }
 }
else
 {
  sprintf(strsql,"alter table Zarsocz drop index datz");
  sql_zapis(strsql,1,0);
  sprintf(strsql,"alter table Zarsocz add index (datz,tabn,kodz)");
  sql_zapis(strsql,1,0);

 }
wprintw(win1,"Добавляем колонку shetb в таблицу Uder\n");
wrefresh(win1);
sprintf(strsql,"alter table Uder add shetb varchar(32) NOT NULL default ''");

if(sql_zap(&bd,strsql) != 0)
 {
  if(sql_nerror(&bd) == ER_DUP_FIELDNAME)
   {
    wprintw(win1,"Колонка в таблице уже существует\n");
    wrefresh(win1);
   }
  else
   {
    beep();
    wprintw(win1,"Ошибка ! %d\n%s\n",sql_nerror(&bd),sql_error(&bd));
    OSTANOVW(win1);
   }
 }
wprintw(win1,"Добавляем колонку shetb в таблицу Zarsoc\n");
wrefresh(win1);
sprintf(strsql,"alter table Zarsoc add shetb varchar(32) NOT NULL default ''");

if(sql_zap(&bd,strsql) != 0)
 {
  if(sql_nerror(&bd) == ER_DUP_FIELDNAME)
   {
    wprintw(win1,"Колонка в таблице уже существует\n");
    wrefresh(win1);
   }
  else
   {
    beep();
    wprintw(win1,"Ошибка ! %d\n%s\n",sql_nerror(&bd),sql_error(&bd));
    OSTANOVW(win1);
   }
 }


wprintw(win1,"Создание таблицы настроек Zaresv !\n");
wrefresh(win1);

memset(strsql,'\0',sizeof(strsql));
strcpy(strsql,"CREATE TABLE Zaresv \
(kf int not null default 0,\
datnd DATE not null default '0000-00-00',\
pr float not null default 0.,\
pr1 float not null default 0.,\
ktoz	smallint unsigned not null default 0,\
vrem	int unsigned not null default 0,\
unique(kf,datnd))");


if(sql_zap(&bd,strsql) != 0)
 { 
  wprintw(win1,"%s\n",sql_error(&bd));
 } 
else
 wprintw(win1,"Таблица создана.\n\n");



if(iceb_t_poldan("Код фонда единого социального взноса",strsql,"zarnast.alx") != 0)
 {
  int nom=0;
  for(nom=1;; nom++)
   {
    sprintf(strsql,"select kod from Zarsoc where kod=%d",nom);
    if(readkey(strsql) == 0)
     break;
   }
  sprintf(strsql,"insert into Zarsoc (kod,naik,shet,proc,kodn,ktoz,vrem) values (%d,'Єдиний соціальний внесок','',0.,'',%d,%ld)",nom,iceb_t_getuid(),time(NULL));

  sql_zapis(strsql,1,0);

  sprintf(strsql,"%d",nom);
  adimi_alter_r_ins_str_alx("zarnast.alx","Код фонда единого социального взноса",strsql);

  sprintf(strsql,"insert into Zaresv (kf,datnd,pr,pr1,ktoz,vrem) values (%d,'2011-1-1',38.52,3.6,%d,%ld)",nom,iceb_t_getuid(),time(NULL));
  sql_zapis(strsql,1,0);
 }

if(iceb_t_poldan("Код фонда единого социального взноса для инвалидов",strsql,"zarnast.alx") != 0)
 {
  int nom=0;
  for(nom=1;; nom++)
   {
    sprintf(strsql,"select kod from Zarsoc where kod=%d",nom);
    if(readkey(strsql) == 0)
     break;
   }
  sprintf(strsql,"insert into Zarsoc (kod,naik,shet,proc,kodn,ktoz,vrem) values (%d,'Єдиний соціальний внесок для інвалідів','',0.,'',%d,%ld)",nom,iceb_t_getuid(),time(NULL));

  sql_zapis(strsql,1,0);

  sprintf(strsql,"%d",nom);
  adimi_alter_r_ins_str_alx("zarnast.alx","Код фонда единого социального взноса для инвалидов",strsql);

  sprintf(strsql,"insert into Zaresv (kf,datnd,pr,pr1,ktoz,vrem) values (%d,'2011-1-1',8.41,2.85,%d,%ld)",nom,iceb_t_getuid(),time(NULL));
  sql_zapis(strsql,1,0);
 }

if(iceb_t_poldan("Код фонда единого социального взноса для больничных",strsql,"zarnast.alx") != 0)
 {
  int nom=0;
  for(nom=1;; nom++)
   {
    sprintf(strsql,"select kod from Zarsoc where kod=%d",nom);
    if(readkey(strsql) == 0)
     break;
   }
  sprintf(strsql,"insert into Zarsoc (kod,naik,shet,proc,kodn,ktoz,vrem) values (%d,'Єдиний соціальний внесок для лікарняних','',0.,'',%d,%ld)",nom,iceb_t_getuid(),time(NULL));

  sql_zapis(strsql,1,0);

  sprintf(strsql,"%d",nom);
  adimi_alter_r_ins_str_alx("zarnast.alx","Код фонда единого социального взноса для больничных",strsql);

  sprintf(strsql,"insert into Zaresv (kf,datnd,pr,pr1,ktoz,vrem) values (%d,'2011-1-1',33.2,2.,%d,%ld)",nom,iceb_t_getuid(),time(NULL));
  sql_zapis(strsql,1,0);
 }

if(iceb_t_poldan("Код фонда единого социального взноса для договоров",strsql,"zarnast.alx") != 0)
 {
  int nom=0;
  for(nom=1;; nom++)
   {
    sprintf(strsql,"select kod from Zarsoc where kod=%d",nom);
    if(readkey(strsql) == 0)
     break;
   }
  sprintf(strsql,"insert into Zarsoc (kod,naik,shet,proc,kodn,ktoz,vrem) values (%d,'Єдиний соціальний внесок для договорів','',0.,'',%d,%ld)",nom,iceb_t_getuid(),time(NULL));

  sql_zapis(strsql,1,0);

  sprintf(strsql,"%d",nom);
  adimi_alter_r_ins_str_alx("zarnast.alx","Код фонда единого социального взноса для договоров",strsql);

  sprintf(strsql,"insert into Zaresv (kf,datnd,pr,pr1,ktoz,vrem) values (%d,'2011-1-1',34.7,2.6,%d,%ld)",nom,iceb_t_getuid(),time(NULL));
  sql_zapis(strsql,1,0);
 }
 
if(iceb_t_poldan("Код удержания единого социального взноса",strsql,"zarnast.alx") != 0)
 {
  int nom=0;
  for(nom=1;; nom++)
   {
    sprintf(strsql,"select kod from Uder where kod=%d",nom);
    if(readkey(strsql) == 0)
     break;
   }
  sprintf(strsql,"insert into Uder (kod,naik,shet,ktoz,vrem,prov,shetb) values (%d,'Єдиний соціальний внесок','',%d,%ld,0,'')",nom,iceb_t_getuid(),time(NULL));
  sql_zapis(strsql,1,0);
  sprintf(strsql,"%d",nom);
  adimi_alter_r_ins_str_alx("zarnast.alx","Код удержания единого социального взноса",strsql);
 }

if(iceb_t_poldan("Код удержания единого социального взноса для больничных",strsql,"zarnast.alx") != 0)
 {
  int nom=0;
  for(nom=1;; nom++)
   {
    sprintf(strsql,"select kod from Uder where kod=%d",nom);
    if(readkey(strsql) == 0)
     break;
   }
  sprintf(strsql,"insert into Uder (kod,naik,shet,ktoz,vrem,prov,shetb) values (%d,'Єдиний соціальний внесок для лікарняних','',%d,%ld,0,'')",nom,iceb_t_getuid(),time(NULL));
  sql_zapis(strsql,1,0);
  sprintf(strsql,"%d",nom);
  adimi_alter_r_ins_str_alx("zarnast.alx","Код удержания единого социального взноса для больничных",strsql);
 }


if(iceb_t_poldan("Код удержания единого социального взноса для инвалидов",strsql,"zarnast.alx") != 0)
 {
  int nom=0;
  for(nom=1;; nom++)
   {
    sprintf(strsql,"select kod from Uder where kod=%d",nom);
    if(readkey(strsql) == 0)
     break;
   }
  sprintf(strsql,"insert into Uder (kod,naik,shet,ktoz,vrem,prov,shetb) values (%d,'Єдиний соціальний внесок для інвалідів','',%d,%ld,0,'')",nom,iceb_t_getuid(),time(NULL));
  sql_zapis(strsql,1,0);
  sprintf(strsql,"%d",nom);
  adimi_alter_r_ins_str_alx("zarnast.alx","Код удержания единого социального взноса для инвалидов",strsql);
 }



if(iceb_t_poldan("Код удержания единого социального взноса для договоров",strsql,"zarnast.alx") != 0)
 {
  int nom=0;
  for(nom=1;; nom++)
   {
    sprintf(strsql,"select kod from Uder where kod=%d",nom);
    if(readkey(strsql) == 0)
     break;
   }
  sprintf(strsql,"insert into Uder (kod,naik,shet,ktoz,vrem,prov,shetb) values (%d,'Єдиний соціальний внесок для договорів','',%d,%ld,0,'')",nom,iceb_t_getuid(),time(NULL));
  sql_zapis(strsql,1,0);
  sprintf(strsql,"%d",nom);
  adimi_alter_r_ins_str_alx("zarnast.alx","Код удержания единого социального взноса для договоров",strsql);
 }
adimi_alter_r_ins_str_alx("zarnast.alx","Коды начислений не входящие в расчёт удержания единого социального взноса","");

if(iceb_t_poldan("Процент от минимальной зароботной платы",strsql,"zarnast.alx") == 0)
 {
  float proc=atof(strsql);
  sprintf(strsql,"update Alx set str='Процент от минимальной заработной платы|%.2f\n' where fil='zarnast.alx' and str like 'Процент от минимальной зароботной платы|%%'",proc);
  sql_zapis(strsql,1,0);
 }
if(iceb_t_poldan("Процент от минимальной зароботной платы",strsql,"zarppn.alx") == 0)
 {
  float proc=atof(strsql);
  sprintf(strsql,"update Alx set str='Процент от минимальной заработной платы|%.2f\n' where fil='zarppn.alx' and str like 'Процент от минимальной зароботной платы|%%'",proc);
  sql_zapis(strsql,1,0);
 }
 


/****************************************/
/*********** 11.15 04.02.2011 ************/
/****************************************/
wprintw(win1,"Изменям размерность в колонке kss для таблицы Kartb\n");
wrefresh(win1);

sprintf(strsql,"alter table Kartb change kss kss varchar(128) not null default ''");

if(sql_zap(&bd,strsql) != 0)
 {
  wprintw(win1,"Ошибка ! %d\n%s\n",sql_nerror(&bd),sql_error(&bd));
  OSTANOVW(win1);
 }

wprintw(win1,"Добавляем колонку art в таблицу Uslugi\n");
wrefresh(win1);
sprintf(strsql,"alter table Uslugi add art varchar(64) NOT NULL default ''");

if(sql_zap(&bd,strsql) != 0)
 {
  if(sql_nerror(&bd) == ER_DUP_FIELDNAME)
   {
    wprintw(win1,"Колонка в таблице уже существует\n");
    wrefresh(win1);
   }
  else
   {
    beep();
    wprintw(win1,"Ошибка ! %d\n%s\n",sql_nerror(&bd),sql_error(&bd));
    OSTANOVW(win1);
   }
 }

/****************************************/
/*********** 11.17 15.02.2011 ************/
/****************************************/
wprintw(win1,"Добавляем колонку dnz в таблицу Reenn\n");
wrefresh(win1);
sprintf(strsql,"alter table Reenn add dnz int NOT NULL default 0");

if(sql_zap(&bd,strsql) != 0)
 {
  if(sql_nerror(&bd) == ER_DUP_FIELDNAME)
   {
    wprintw(win1,"Колонка в таблице уже существует\n");
    wrefresh(win1);
   }
  else
   {
    beep();
    wprintw(win1,"Ошибка ! %d\n%s\n",sql_nerror(&bd),sql_error(&bd));
    OSTANOVW(win1);
   }
 }

wprintw(win1,"Создаём таблицу Kontragent2\n");
wrefresh(win1);

memset(strsql,'\0',sizeof(strsql));
strcpy(strsql,"CREATE TABLE Kontragent2 (\
nz int unsigned PRIMARY KEY AUTO_INCREMENT NOT NULL ,\
kodkon varchar(32) not null default '',\
datd DATE NOT NULL DEFAULT '0000-00-00',\
nomd VARCHAR (64) NOT NULL DEFAULT '',\
vidd VARCHAR (255) NOT NULL DEFAULT '',\
ktoz	smallint unsigned not null default 0,\
vrem	int unsigned not null default 0,\
index(kodkon))");
/*
0 nz      уникальный номер записи
1 kodkon  код контрагента
2 datd    дата договора
3 nomd    номер договора
4 vidd    вид договора
5 ktoz    Кто записал
6 vrem    Время записи
*/

if(sql_zap(&bd,strsql) != 0)
 {
  if(sql_nerror(&bd) == ER_TABLE_EXISTS_ERROR) /*Таблица уже существует*/
   {
    wprintw(win1,"Таблица уже существует\n");
    wrefresh(win1);
   }
  else
   {
    beep();
    wprintw(win1,"Ошибка ! %d\n%s\n",sql_nerror(&bd),sql_error(&bd));
    OSTANOVW(win1);
   }
 }


/****************************************/
/*********** 11.19 11.03.2011 ************/
/****************************************/

adimi_alter_r_ins_str_alx("zarnast.alx","Автоматическое выполнение проводок с использованием таблицы","Включено");

/****************************************/
/*********** 11.20 16.03.2011 ************/
/****************************************/

adimi_alter_r_ins_str_alx("zarnast.alx","Код подоходного налога с больничного","");

wprintw(win1,"Добавляем колонку nnni в таблицу Reenn\n");
wrefresh(win1);
sprintf(strsql,"alter table Reenn add nnni int NOT NULL default 0");

if(sql_zap(&bd,strsql) != 0)
 {
  if(sql_nerror(&bd) == ER_DUP_FIELDNAME)
   {
    wprintw(win1,"Колонка в таблице уже существует\n");
    wrefresh(win1);
   }
  else
   {
    beep();
    wprintw(win1,"Ошибка ! %d\n%s\n",sql_nerror(&bd),sql_error(&bd));
    OSTANOVW(win1);
   }
 }
else
 admin_alter_r_nnni();

wprintw(win1,"Создаём таблицу Uosls\n");
wrefresh(win1);

memset(strsql,'\0',sizeof(strsql));
strcpy(strsql,"CREATE TABLE Uosls (\
inn INT NOT NULL DEFAULT 0,\
data DATE NOT NULL DEFAULT '0000-00-00',\
lsnu DOUBLE (16,2) NOT NULL DEFAULT 0.,\
lsbu DOUBLE (16,2) NOT NULL DEFAULT 0.,\
kom VARCHAR(255) NOT NULL DEFAULT '',\
ktoz smallint unsigned not null default 0,\
vrem int unsigned not null default 0,\
index(inn,data))");
/*
0 inn    инвентарный номер
1 data  дата 
2 lsnu  ликвидационная стоимость для налогового учёта
3 lsbu  ликвидационная стоимость для бухгалетского учёта
4 kom   коментарий
5 ktoz  Кто записал
6 vrem  Время записи
*/

if(sql_zap(&bd,strsql) != 0)
 {
  if(sql_nerror(&bd) == ER_TABLE_EXISTS_ERROR) /*Таблица уже существует*/
   {
    wprintw(win1,"Таблица уже существует\n");
    wrefresh(win1);
   }
  else
   {
    beep();
    wprintw(win1,"Ошибка ! %d\n%s\n",sql_nerror(&bd),sql_error(&bd));
    OSTANOVW(win1);
   }
 }

/****************************************/
/*********** 11.24 14.04.2011 ************/
/****************************************/

adimi_alter_r_ins_str_alx("zarnast.alx","Отключение/включение применения социальной льготы при расчёте подоходного","Выключено");

/****************************************/
/*********** 11.33 19.07.2011 ************/
/****************************************/

wprintw(win1,"Увеличиваем размерность колонки popkf в таблице Uosinp\n");
wrefresh(win1);

sprintf(strsql,"alter table Uosinp change popkof popkof double(12,6) not null default 0.");

if(sql_zap(&bd,strsql) != 0)
 {
  wprintw(win1,"Ошибка ! %d\n%s\n",sql_nerror(&bd),sql_error(&bd));
  OSTANOVW(win1);
 }

wprintw(win1,"Увеличиваем размерность колонки popkfby в таблице Uosinp\n");
wrefresh(win1);

sprintf(strsql,"alter table Uosinp change popkofby popkofby double(12,6) not null default 0.");

if(sql_zap(&bd,strsql) != 0)
 {
  wprintw(win1,"Ошибка ! %d\n%s\n",sql_nerror(&bd),sql_error(&bd));
  OSTANOVW(win1);
 }

/****************************************/
/*********** 11.34 10.08.2011 ************/
/****************************************/

wprintw(win1,"Вставляем колонку vd в таблицу Uosdok\n");
wrefresh(win1);

sprintf(strsql,"alter table Uosdok add vd varchar(255) not null default ''");

if(sql_zap(&bd,strsql) != 0)
 {
  if(sql_nerror(&bd) == ER_DUP_FIELDNAME)
   {
    wprintw(win1,"Колонкa в таблице уже существуeт\n");
    wrefresh(win1);
   }
  else
   {
    wprintw(win1,"Ошибка ! %d\n%s\n",sql_nerror(&bd),sql_error(&bd));
    OSTANOVW(win1);
   }
 }









/*Догрузит новые настроечные файлы*/
wprintw(win1,"Загрузка новых настроечных файлов\n");
wrefresh(win1);
alxin(put_na_alx,0,win1);

sprintf(strsql,"delete from Alx where fil='zarsf1df.alx'");
sql_zapis(strsql,1,0);

/*Обновляем документцию*/
wprintw(win1,"Обновляем документацию\n");
wrefresh(win1);
docin(put_na_doc,win1);

/*************************/
/*************************/


sql_zapis("USE mysql",1,0);

wrefresh(win1);

return(0);
}

/********************************************************/
/*Подпрограмма отметки групп с пообъектной амортизацией*/
/********************************************************/

void alter_uosgrup_ta(const char *imabaz)
{
char strsql[1024];
char imaf_nast[512];
class iceb_tu_str sp_grup("");
sprintf(imaf_nast,"/%s/%s/uosnast.alx",putnansi,imabaz);

if(poldan("Список групп налогового учета с не пообъектной амортизацией",&sp_grup,imaf_nast) != 0)
 {
//  iceb_t_soob("Не найден \"Список групп налогового учета с не пообъектной амортизацией\"!");
 }
else
 { 
  class iceb_tu_str kodgr("");
  for(int ii=1;;ii++)
   {
    if(polen(sp_grup.ravno(),&kodgr,ii,',') != 0)
     break;

    if(kodgr.getdlinna() <= 1)
     break;      

    sprintf(strsql,"update Uosgrup set ta=1 where kod='%s'",kodgr.ravno());
    sql_zapis(strsql,0,0);
   }
 }

if(poldan("Список всех групп налогового учета",&sp_grup,imaf_nast) != 0)
 {
//  iceb_t_soob("Не найден \"Список всех групп налогового учета\"!");
 }
else
 { 
  class iceb_tu_str kodgr("");
  for(int ii=1;;ii++)
   {
    if(polen(sp_grup.ravno(),&kodgr,ii,',') != 0)
     break;

    if(kodgr.getdlinna() <= 1)
     break;      

    sprintf(strsql,"update Uosgrup set ar=1 where kod='%s'",kodgr.ravno());
    sql_zapis(strsql,0,0);
   }
 }

if(poldan("Вариант расчета амортизации для бух. учета",&sp_grup,imaf_nast) != 0)
 {
//  iceb_t_soob("Не найден \"Вариант расчета амортизации для бух. учета\"!");
 }
else
 {
  int varr=sp_grup.ravno_atoi();
  
  if(varr == 1) /* от остаточной*/
    sprintf(strsql,"update Uosgrup1 set ar=1");  
  if(varr == 2) /* от начальной*/
    sprintf(strsql,"update Uosgrup1 set ar=0");  

  sql_zapis(strsql,1,0);

  if(poldan("Группы бух. учёта с альтернативным вариантом расчёта",&sp_grup,imaf_nast) != 0)
   {
//    iceb_t_soob("Не найден \"Группы бух. учёта с альтернативным вариантом расчёта\"!");
   }
  if(sp_grup.getdlinna() > 1)
   {
    
    class iceb_tu_str kodgr("");
    for(int ii=1;;ii++)
     {
      if(polen(sp_grup.ravno(),&kodgr,ii,',') != 0)
       break;

      if(kodgr.getdlinna() <= 1)
       break;      

      if(varr == 1)
        sprintf(strsql,"update Uosgrup1 set ar=1 where kod='%s'",kodgr.ravno());
      if(varr == 2)
        sprintf(strsql,"update Uosgrup1 set ar=0 where kod='%s'",kodgr.ravno());

      sql_zapis(strsql,0,0);
    }    
   }
 }
}
/****************************/
/*Копирование новых настроечных файлов*/
/**************************************/

void alter_cp_alx(int metka, /*0-копировать если файла там нет 1-всегда копировать*/
const char *imaf,const char *imabaz,const char *put_na_alx,WINDOW *win1)
{
struct stat buff;

class iceb_tu_str imafout; /*откуда копируем*/
class iceb_tu_str imafin;  /*куда копируем*/
imafout.plus(put_na_alx);
imafout.plus(G_DIR_SEPARATOR_S,imaf);

imafin.plus(putnansi);
imafin.plus(G_DIR_SEPARATOR_S,imabaz);
imafin.plus(G_DIR_SEPARATOR_S,imaf);

if(SRAV(imafout.ravno(),imafin.ravno(),0) == 0) /*не нужно копировать в самого себя*/
 return; 

wprintw(win1,"Копируем файл %s > %s\n",imafout.ravno(),imafin.ravno());
wrefresh(win1);

/*проверяем есть ли этот файл*/
if(stat(imafout.ravno(),&buff) == -1) /*файл там нет*/
 {
  wprintw(win1,"Не найден файл для копирования %s\n",imafout.ravno());
  OSTANOVW(win1);
  return;
 }


/*проверяем может файл там уже есть*/
if(metka == 0)
if(stat(imafin.ravno(),&buff) == 0) /*файл там уже есть*/
 {
  wprintw(win1,"Файл %s там уже есть!\n",imafin.ravno());
  wrefresh(win1);
  return;
 }

iceb_t_cp(imafout.ravno(),imafin.ravno(),0);
}


/*************************************************/
/*Добавить строку настройки в существующий файл*/
/*************************************************/
void alter_cat_str(const char *stroka,const char *param,const char *imaf,WINDOW *win1)
{
FILE *ff;
struct stat buff;
class iceb_tu_str imaf_nsi(iceb_t_imafnsi(imaf));
wprintw(win1,"Вставляем строку \"%s%s\"\nв файл %s\n",stroka,param,imaf_nsi.ravno());
wrefresh(win1);

/*проверяем есть ли этот файл*/
if(stat(imaf_nsi.ravno(),&buff) == -1) /*файл там нет*/
 {
  wprintw(win1,"Не найден файл для вставки строки %s\n",imaf_nsi.ravno());
  OSTANOVW(win1);
  return;
 }
class iceb_tu_str nast;
if(poldan(stroka,&nast,iceb_t_imafnsi(imaf)) == 0)
 {
  wprintw(win1,"Эта строка там уже есть!\n");
  wrefresh(win1);
  return;
 } 

if((ff = fopen(imaf_nsi.ravno(),"a")) == NULL)
 {
  error_op_nfil(imaf_nsi.ravno(),errno,"");
  return;
 }
fprintf(ff,"%s%s\n",stroka,param);
fclose(ff);

}


/************************************/
/*Вставить записи в таблицу icebuser*/
/************************************/
void alter_icebuser(const char *imabaz,WINDOW *win1)
{
char strsql[512];
int kolstr=0;
SQL_str row;
class SQLCURSOR cur;
struct  passwd  *ktor; /*Кто работает*/
class iceb_tu_str log_op;
ktor=getpwuid(getuid());
log_op.plus(ktor->pw_name);

sprintf(strsql,"select distinct User from mysql.db where Db='%s'",imabaz);

if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return;
 }

if(kolstr == 0)
 {
  iceb_t_soob(gettext("Не найдено ни одной записи !"));
  return;
 }
class iceb_tu_str slsd("");
poldan("Список логинов доступ в программу которым разрешен",&slsd,iceb_t_imafnsi("zarnast.alx"));

int zpd=0;
int metka_zap=0;
while(cur.read_cursor(&row) != 0)
 {
  metka_zap=0;
  if((ktor=getpwnam(row[0])) == NULL) /*узнаём реквизиты оператора*/
   {
    wprintw(win1,"Неизвестный логин-%s\n\n",row[0]);
    OSTANOVW(win1);        
    metka_zap=1;
   }
  zpd=0; 

  if(slsd.getdlinna() > 1)
   {
    if(proverka(slsd.ravno(),row[0],0,0) == 0)
     zpd=0;
    else
     zpd=1;
   }

  if(metka_zap == 0)
    sprintf(strsql,"insert into icebuser (login,fio,un,logz,vrem,zpd) values('%s','%s',%d,'%s',%ld,%d)",
    row[0],ktor->pw_gecos,ktor->pw_uid,log_op.ravno(),time(NULL),zpd);
  else
   {
    int nomer=0;
    /*Узнаём свободный номер оператора*/
    for(nomer=1;;nomer++)
     {
      sprintf(strsql,"select un from %s.icebuser where un=%d",imabaz,nomer);
      if(readkey(strsql) == 0)
       break;
     }

    sprintf(strsql,"insert into icebuser (login,fio,un,logz,vrem,zpd) values('%s','%s',%d,'%s',%ld,%d)",
    row[0],"",nomer,log_op.ravno(),time(NULL),zpd);
   }  
  sql_zapis(strsql,1,0);
    
 }
 
}


/***************************/
/*Загрузка файлов блокировок*/
/****************************/
void admin_alter_r_zb(const char *imaf,int kod,int metka)
{
FILE *ff;
char strsql[512];
char stroka[1024];
class iceb_tu_str god;
class iceb_tu_str mes;
class iceb_tu_str shet;
class iceb_tu_str login;

if((ff = fopen(imaf,"r")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return;
 }

while(fgets(stroka,sizeof(stroka),ff) != NULL)
 {
  if(stroka[0] == '#')
   continue;

  shet.new_plus("");
  login.new_plus("");

  if(polen(stroka,&mes,1,'.') != 0)
   continue;

  polen(stroka,&god,2,'.');
  if(god.ravno_atoi() == 0)
   continue;

  if(metka == 0)
   {
    polen(stroka,&login,2,'|');
   }
  else
   {
    polen(stroka,&shet,2,'|');
    polen(stroka,&login,3,'|');
   }
  sprintf(strsql,"insert into Blok values(%d,%d,%d,'%s','%s',%d,%ld)",
  kod,god.ravno_atoi(),mes.ravno_atoi(),login.ravno(),shet.ravno(),iceb_t_getuid(),time(NULL));

  sql_zapis(strsql,1,1);

 }
fclose(ff); 

}
/**********************************/
/*запуск загрузки файлов блокировок*/
/*************************************/
void admin_alter_r_zzb(const char *imabazp)
{

class iceb_tu_str imaf;

imaf.new_plus(putnansi);
imaf.plus(G_DIR_SEPARATOR_S,imabazp);
imaf.plus(G_DIR_SEPARATOR_S,"blok.alx");
admin_alter_r_zb(imaf.ravno(),1,0);
unlink(imaf.ravno());

imaf.new_plus(putnansi);
imaf.plus(G_DIR_SEPARATOR_S,imabazp);
imaf.plus(G_DIR_SEPARATOR_S,"blokshet.alx");
admin_alter_r_zb(imaf.ravno(),1,1);
unlink(imaf.ravno());

imaf.new_plus(putnansi);
imaf.plus(G_DIR_SEPARATOR_S,imabazp);
imaf.plus(G_DIR_SEPARATOR_S,"blokmak.alx");
admin_alter_r_zb(imaf.ravno(),2,0);
unlink(imaf.ravno());

imaf.new_plus(putnansi);
imaf.plus(G_DIR_SEPARATOR_S,imabazp);
imaf.plus(G_DIR_SEPARATOR_S,"blokdok.alx");
admin_alter_r_zb(imaf.ravno(),3,0);
unlink(imaf.ravno());

imaf.new_plus(putnansi);
imaf.plus(G_DIR_SEPARATOR_S,imabazp);
imaf.plus(G_DIR_SEPARATOR_S,"zarblok.alx");
admin_alter_r_zb(imaf.ravno(),4,0);
unlink(imaf.ravno());

imaf.new_plus(putnansi);
imaf.plus(G_DIR_SEPARATOR_S,imabazp);
imaf.plus(G_DIR_SEPARATOR_S,"bluos.alx");
admin_alter_r_zb(imaf.ravno(),5,0);
unlink(imaf.ravno());

imaf.new_plus(putnansi);
imaf.plus(G_DIR_SEPARATOR_S,imabazp);
imaf.plus(G_DIR_SEPARATOR_S,"uslugbl.alx");
admin_alter_r_zb(imaf.ravno(),6,0);
unlink(imaf.ravno());

imaf.new_plus(putnansi);
imaf.plus(G_DIR_SEPARATOR_S,imabazp);
imaf.plus(G_DIR_SEPARATOR_S,"kasblok.alx");
admin_alter_r_zb(imaf.ravno(),7,0);
unlink(imaf.ravno());

imaf.new_plus(putnansi);
imaf.plus(G_DIR_SEPARATOR_S,imabazp);
imaf.plus(G_DIR_SEPARATOR_S,"ukrblok.alx");
admin_alter_r_zb(imaf.ravno(),8,0);
unlink(imaf.ravno());

imaf.new_plus(putnansi);
imaf.plus(G_DIR_SEPARATOR_S,imabazp);
imaf.plus(G_DIR_SEPARATOR_S,"uplblok.alx");
admin_alter_r_zb(imaf.ravno(),9,0);
unlink(imaf.ravno());

imaf.new_plus(putnansi);
imaf.plus(G_DIR_SEPARATOR_S,imabazp);
imaf.plus(G_DIR_SEPARATOR_S,"rnn_blok.alx");
admin_alter_r_zb(imaf.ravno(),10,0);
unlink(imaf.ravno());

imaf.new_plus(putnansi);
imaf.plus(G_DIR_SEPARATOR_S,imabazp);
imaf.plus(G_DIR_SEPARATOR_S,"dovblok.alx");
admin_alter_r_zb(imaf.ravno(),11,0);
unlink(imaf.ravno());
}

/***********************************/
/*Загрузка файлов alx в базу*/
/**********************************/
void admin_alter_r_alxin(const char *imabazz,WINDOW *win1)
{
class iceb_tu_str allput(putnansi);
allput.plus(G_DIR_SEPARATOR_S,imabazz);

GDir *dirp;
if((dirp=g_dir_open(allput.ravno(),0,NULL)) == NULL)
 {
  perror(__FUNCTION__);
  class iceb_tu_str repl;
  repl.plus(__FUNCTION__);
  repl.ps_plus(gettext("Не могу открыть каталог !"));
  repl.ps_plus(allput.ravno());
  repl.ps_plus(strerror(errno));
  iceb_t_soob(repl.ravno());
  
  return;
 }
class iceb_tu_str imafil;
class iceb_tu_str rashir;
const char *imafil_read;

while((imafil_read=g_dir_read_name(dirp)) != NULL)
 {
  if(polen(imafil_read,&rashir,2,'.') != 0)
   continue;

  if(SRAV("alx",rashir.ravno(),0) != 0 && SRAV("ALX",rashir.ravno(),0) != 0)
   continue;

  if(SRAV("icebstart",imafil_read,1) == 0 || SRAV("ICEBSTART",imafil_read,1) == 0)
   continue;

  imafil.new_plus(allput.ravno());
  imafil.plus(G_DIR_SEPARATOR_S,imafil_read);
  wprintw(win1,"Загрузка файла-%s\n",imafil.ravno());
  wrefresh(win1);
  iceb_t_alxin(imafil.ravno());

  unlink(imafil.ravno());

 }
g_dir_close(dirp);
}
/*************************************/
/*Вставить новую строку настройки в файл в таблице Alx*/
/********************************************************/

void adimi_alter_r_ins_str_alx(const char *imaf,const char *naststr,const char *znahnast)
{
char strsql[512];
SQL_str row;
class SQLCURSOR cur;

/*Проверяем может такая настройка уже есть*/

sprintf(strsql,"select ns from Alx where fil='%s' and str like '%s|%%'",imaf,naststr);
if(readkey(strsql) > 0)
 return;

/*Узнаём номер последней строки*/
sprintf(strsql,"select ns from Alx where fil='%s' order by ns desc limit 1",imaf);
if(readkey(strsql,&row,&cur) <= 0)
 return;

sprintf(strsql,"insert into Alx values('%s',%d,%d,%ld,'%s|%s\n')",
imaf,
atoi(row[0])+1,
getuid(),
time(NULL),
naststr,
znahnast);

sql_zapis(strsql,1,0);

}
/********************************************/
/*Записываем номера налоговых накладных в цифровом виде*/
/********************************************************/

void admin_alter_r_nnni()
{
char strsql[512];
int kolstr=0;
SQL_str row;
class SQLCURSOR cur;

sprintf(strsql,"select nz,nnn from Reenn");

if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return;
 }

while(cur.read_cursor(&row) != 0)
 {
  sprintf(strsql,"update Reenn set nnni=%d where nz=%s",atoi(row[1]),row[0]);
  sql_zapis(strsql,1,0);
 }

}
