/* $Id: amortby.c,v 5.25 2011-03-28 06:53:58 sasa Exp $ */
/*18.08.2008    06.12.2000      Белых А.И.      amortby.c
Расчет амортзационных отчислений
для заданного инвентарного номера за заданный месяц
Определить числиться ли инвентарны номер и в каком подразделении
он находиться на заданную дату. Если не числится расчет не проводим
Если числится смотрим настройку и делаем расчет
В месяце убытия амортизация считается в подразделении
где числился. В подразделении где прибыл амотизация считается со
следующего месяца
Если вернули 0 - расчитали
	     1 - нет
*/
#include        <time.h>
#include        <pwd.h>
#include        <errno.h>
#include        "buhg.h"
#include        "uos.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

extern float      nemi; /*Необлагаемый минимум*/
extern struct UOS uos;
//extern short	vrabu; //Вариант расчета амотизации бухгалтерского учета
//extern char *gbu_s_avr; //Группы бух. учёта с алтернативным вариантом расчёта

short amortby(long in,
short mr,short gr,
short mra, //0-расчет в потоке 1-нет
const char *grup_bu, //Группа бухгалтерского учёта
FILE *ff_prot)
{
int             i;
double		sbs,siz;
double          bs,iz,iz1;
double		sbsby,sizby;
double          bsby,izby,iz1by;
double		amort[4];
double		kof;
int		podr;
short		m1,g1;
SQL_str         row;
SQLCURSOR curr;
char		strsql[512];
time_t		vrem;
int		kodotl;
int	vrabu=uosprovar(grup_bu,1); //Вариант расчета амотизации бухгалтерского учета


podr=0;
 
memset(amort,'\0',sizeof(amort));
 

//printw("in-%ld %d.%d\n",in,mr,gr);
if(ff_prot != NULL)
  fprintf(ff_prot,"Расчёт амортизационных отчислений для бухгалтерского учёта\nin-%ld %d.%d\n",in,mr,gr);


if((i=poiin(in,1,mr,gr,&podr,&kodotl)) != 0)
 {
  printw("%s %ld %s %d.%d ! %s %d.\n",
  gettext("Инвентарный номер"),in,
  gettext("не числится по дате"),mr,gr,
  gettext("Код ошибки"),i);
  
  if(ff_prot != NULL)
   fprintf(ff_prot,"%s %ld %s %d.%d ! %s %d.\n",
  gettext("Инвентарный номер"),in,
  gettext("не числится по дате"),mr,gr,
  gettext("Код ошибки"),i);
  return(1);
 }   


if((i=poiinpd(in,mr,gr,uos.shetu,uos.hzt,uos.hau,uos.hna,&uos.popkf,&uos.soso,uos.nomz,&m1,&g1,uos.hnaby,&uos.popkfby)) != 0)
 {
  printw("%s %ld %s %d.%d ! %s %d.\n",
  gettext("Инвентарный номер"),in,
  gettext("не найдено настройки на дату"),mr,gr,
  gettext("Код ошибки"),i);
  if(ff_prot != NULL)
   fprintf(ff_prot,"%s %ld %s %d.%d ! %s %d.\n",
  gettext("Инвентарный номер"),in,
  gettext("не найдено настройки на дату"),mr,gr,
  gettext("Код ошибки"),i);

  return(1);
 }  
/*
printw("uos.popkfby=%f uos.popkf=%f\n",uos.popkfby,uos.popkf);
OSTANOV();
*/
sbs=siz=bs=iz=iz1=0.;
sbsby=sizby=bsby=izby=iz1by=0.;
//Должны знать начальную стоимость даже если не считается амортизация
bsiz(in,podr,1,mr,gr,&sbs,&siz,&bs,&iz,&iz1,&sbsby,&sizby,&bsby,&izby,&iz1by,ff_prot);

//printw("in=%d podr=%d %d.%d\n",in,podr,mr,gr);
/************
printw("bsby=%f sbsby=%f sizby=%f iz1by=%f\n",
bsby,sbsby,sizby,iz1by);
OSTANOV();
*******************/

bsby+=sbsby-uosgetls(in,1,mr,gr,1);
izby+=sizby;
izby+=iz1by;
double balst=bsby;
if(uos.soso == 1 ||  uos.soso == 3)
 {
/*************
  printw("%s %ld %s.\n",
  gettext("Инвентарный номер"),in,
  gettext("не эксплуатируется"));
***********/
  if(ff_prot != NULL)
    fprintf(ff_prot,"%s %ld %s.\n",
  gettext("Инвентарный номер"),in,
  gettext("не эксплуатируется"));
  refresh();
  if(mra == 1)
   {
    VVOD SOOB(1);
    sprintf(strsql,"%s %ld %s.",
    gettext("Инвентарный номер"),in,
    gettext("не эксплуатируется"));

    SOOB.VVOD_SPISOK_add_MD(strsql);
    soobshw(&SOOB,stdscr,-1,-1,0,1);
   }
  goto vp;
 }



if(bsby <= izby)
 {
//  map=1;

  if(mra == 0)
   printw("%s %ld %s. %.2f <= %.2f\n",
   gettext("Инвентарный номер"),in,
   gettext("амортизирован полностью"),bsby,izby);

  refresh();
  if(ff_prot != NULL)
    fprintf(ff_prot,"%s %ld %s. bsby=%.2f <= izby=%.2f\n",
  gettext("Инвентарный номер"),in,
  gettext("амортизирован полностью"),bsby,izby);

  if(mra == 1)
   {
    VVOD SOOB(1);
    sprintf(strsql,"%s %ld %s. %.2f <= %.2f",
    gettext("Инвентарный номер"),in,
    gettext("амортизирован полностью"),bsby,izby);
    SOOB.VVOD_SPISOK_add_MD(strsql);
    soobshw(&SOOB,stdscr,-1,-1,0,1);
   }
  bsby=izby=0.;
 }

/*Читаем коэффициент*/
sprintf(strsql,"select kof from Uosgrup1 where kod='%s'",uos.hnaby);
if(sql_readkey(&bd,strsql,&row,&curr) != 1)
 {
  beep();
  printw("%s %ld - %s %s !\n",
  gettext("Инвентарный номер"),in,
  gettext("не нашли кода группы"),uos.hnaby);
  if(ff_prot != NULL)
    fprintf(ff_prot,"%s %ld - %s %s !\n",
  gettext("Инвентарный номер"),in,
  gettext("не нашли кода группы"),uos.hnaby);
  refresh();
  if(mra == 1)
     OSTANOV();
  return(1);
 }

kof=atof(row[0]);
/*
printw("bsby=%f izby=%f popkfby=%f kof=%f nemi=%f\n",bsby,izby,uos.popkfby,kof,nemi);
OSTANOV();    
*/

if(vrabu == 1)
  amort[1]=(bsby-izby)*uos.popkfby*kof/100/12.;
if(vrabu == 0)
 {
  amort[1]=bsby*uos.popkfby*kof/100/12.;
  if(amort[1] > bsby -izby)
     amort[1]=bsby -izby;
 }
amort[0]=okrug(amort[0],0.01);
if(mra == 1)
 {
  VVOD SOOB(1);
  if(vrabu == 1)
    sprintf(strsql,"(%.2f-%.2f)*%.2f/100/12*%.2f=%.2f",
    bsby,izby,kof,uos.popkfby,amort[1]);
  if(vrabu == 0)
    sprintf(strsql,"%.2f*%.2f/100/12*%.2f=%.2f",
    bsby,kof,uos.popkfby,amort[1]);
  SOOB.VVOD_SPISOK_add_MD(strsql);
  soobshw(&SOOB,stdscr,-1,-1,0,1);
 }

if(izby + amort[0] > bsby)
 {
  
  printw("%s %ld %s.\n",
  gettext("Инвентарный номер"),in,
  gettext("остаточная амортизация"));
  if(ff_prot != NULL)
    fprintf(ff_prot,"%s %ld %s.\n",
  gettext("Инвентарный номер"),in,
  gettext("остаточная амортизация"));
  if(mra == 1)
     OSTANOV();
 }

vp:;

/*Удаляем старую запись если она есть*/
sprintf(strsql,"delete from Uosamor1 where innom=%ld and god=%d and \
mes=%d",in,gr,mr);
if(sql_zap(&bd,strsql) != 0)
 {
  sprintf(strsql,"amort-Ошибка видалення запису !\n%s\n",sql_error(&bd));
  error2(20,0,1,strsql);
 }

printw("%s: %5.2f %s: %.2f\n",
gettext("Амортизация"),amort[1],
gettext("Балансовая стоимость"),bsby);

if(ff_prot != NULL)
  fprintf(ff_prot,"%s: %5.2f %s: %.2f\n",
gettext("Амортизация"),amort[1],
gettext("Балансовая стоимость"),bsby);

if(balst != 0.) //Если начальная балансовая стоимость равна 0. амортизацию не записывать
 { 
  time(&vrem);

  sprintf(strsql,"insert into Uosamor1 \
  values (%ld,%d,%d,%d,'%s','%s',%.2f,%d,%ld)",
  in,mr,gr,podr,uos.hzt,uos.hnaby,amort[1],iceb_t_getuid(),vrem);

  sql_zapis(strsql,0,0);
 }
else
 if(ff_prot != NULL)
  fprintf(ff_prot,"Начальная балансовая стоимость равна нолю. Амортизация не записывается.\n");

return(0);
}



