/* $Id: avtprpld.c,v 5.24 2011-01-13 13:43:21 sasa1 Exp $ */
/*10.12.2010    28.05.1998      Белых А.И.      avtprpld.c
Автоматическое проведение проводок для платежних документов
*/
#include        <time.h>
#include        <errno.h>
#include        <math.h>
#include        "buhg.h"
#include        "dok4.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

extern struct REC rec;

void avtprpld(const char *tabl,
const char *kop,  //Код операции
const char *npp,  //Номер документа
const char *kor,  //Код организации
const char *shet,
FILE *ff_prot)
{
char		bros[1024];
double          bb,deb,kre;
int             i,i1;
char		kodop[40];
double		sump; /*Сумма подтвержденная общая*/
double		sumpp; /*Сумма последнего подтверждения*/
double		sumpr; /*Сумма по проводкам*/
time_t		vrem;
char		tipd[8];
char		strsql[512];
class iceb_tu_str kontr("");
class iceb_tu_str kontr1("");;
char		kor1[32],kor2[32];
short		metpr;
char		shet1[32],shet2[32],shet3[32];
char		koresp[112];
short		kp;
char		kom[512];
int		pod;
short		dp,mp,gp;
short		tp1,tp2;
struct OPSHET	shetv;
int		kolpr=2;
int kekv=0;
class SPISOK sp_prov;
class masiv_din_double sum_prov_dk;
SQL_str row_alx;
class SQLCURSOR cur_alx;
int kolstr=0;

if(ff_prot != NULL)
 fprintf(ff_prot,"%s-tabl=%s kop=%s npp-%s kor-%s shet-%s\n",__FUNCTION__,tabl,kop,npp,kor,shet);

int metka_vkontr=2; /*метка режима выполнения проводки для контрагента если его нет в списке счёта 0-запрос 2-автоматическая вставка*/
if(iceb_t_poldan("Автоматическая запись нового контрагента в список счёта",strsql,"nastdok.alx") == 0)
 {
   if(SRAV("Вкл",strsql,1) == 0)
    metka_vkontr=2;
   else
    metka_vkontr=0;
 }


if(shet[0] == '\0')
  return;
memset(kom,'\0',sizeof(kom));

/*Узнаем сумму подтвержденных записей*/
sump=sumpzpd(tabl,&dp,&mp,&gp,&sumpp);

if(SRAV(tabl,"Pltp",0) == 0)
 sprintf(tipd,gettext("ПЛТ"));
if(SRAV(tabl,"Pltt",0) == 0)
 sprintf(tipd,gettext("ТРЕ"));

/*Суммируем выполненные проводки*/

sumpr=0.;

sumpr=sumprpd(rec.dd,rec.md,rec.gd,npp,0,tipd,shet);
/*
printw("sumpr=%f sump=%f\n",sumpr,sump);
OSTANOV();
*/
/*Нужные проводки сделаны*/

if(sumpr == sump)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Все проводки сделаны !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return;
 }


memset(kor1,'\0',sizeof(kor1));
memset(kor2,'\0',sizeof(kor2));
kontr.new_plus(kor);

if(provsh(&kontr,shet,&shetv,metka_vkontr,0) != 0)
   return;
tp1=shetv.saldo;
strncpy(kor1,kontr.ravno(),sizeof(kor1)-1);
strncpy(kor2,kontr.ravno(),sizeof(kor2)-1);


/*Открываем файл настроек*/
class iceb_tu_str imaf_np;
if(SRAV(tabl,"Pltp",0) == 0)
  imaf_np.new_plus("avtprodok.alx");
if(SRAV(tabl,"Pltt",0) == 0)
  imaf_np.new_plus("avtprodokt.alx");

sprintf(strsql,"select str from Alx where fil='%s' order by ns asc",imaf_np.ravno());
if((kolstr=cur_alx.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return;
 }

if(kolstr == 0)
 {
  if(ff_prot != NULL)
   fprintf(ff_prot,"Не найдены настройки %s\n",imaf_np.ravno());
  return;
 }


strcpy(shet3,shet);

kp=0;
time(&vrem);
while(cur_alx.read_cursor(&row_alx) != 0)
 {
  if(row_alx[0][0] == '#')
    continue;
    
  if(polen(row_alx[0],kodop,sizeof(kodop),2,'|') != 0)
   continue;
  
  if(SRAV(kodop,kop,0) != 0)
   continue;
  
  memset(bros,'\0',sizeof(bros));    
  polen(row_alx[0],bros,sizeof(bros),1,'|');
  metpr=0;
  if(strstrm(bros,"У") == 1)
      metpr=1;
  if(strstrm(bros,"С") == 1)
      metpr=2;

  if(ff_prot != NULL)
   fprintf(ff_prot,"metpr=%d\n",metpr);

  if(metpr == 0)
   continue;
  if(ff_prot != NULL)
   fprintf(ff_prot,"%s",row_alx[0]);
  deb=kre=0.;
  if(metpr == 1)
   {
    deb=okrug(rec.uslb,0.01);
    kre=0.;   
   }

  if(metpr == 2)
   {
    bb=sumpp-rec.uslb;
    deb=okrug(bb,0.01);
    kre=0.;
   }

  if(ff_prot != NULL)
   fprintf(ff_prot,"deb=%f\n",deb);
   
  if(fabs(deb) < 0.01)
    continue;
       
  /*Берем счет*/
  memset(bros,'\0',sizeof(bros));
  polen(row_alx[0],bros,sizeof(bros),3,'|');

  memset(shet1,'\0',sizeof(shet1));
  if(polen(bros,shet1,sizeof(shet1),1,':') != 0)
   strncpy(shet1,bros,sizeof(shet1)-1);
  else
   polen(bros,&kontr1,2,':');
  
  /*Берем кореспонденцию*/
  memset(koresp,'\0',sizeof(koresp));
  polen(row_alx[0],koresp,sizeof(koresp),4,'|');

  i1=pole2(koresp,',');
  
  for(i=0; i <= i1; i++)
   {
    memset(shet2,'\0',sizeof(shet2));
    kontr.new_plus("");

    if(i1 > 0)
     POLE(koresp,bros,i+1,',');
    else
     strcpy(bros,koresp);      

    if(i1 > 0 && i == 0)
     i1--;
     
    /*Проверяем есть ли код контрагента*/
    if(POLE(bros,shet2,1,':') != 0)
     strcpy(shet2,bros);
    else
     polen(bros,&kontr,2,':');

    if(shet2[0] == '\0')
     continue;

    if(provsh(&kontr,shet2,&shetv,metka_vkontr,0) != 0)
       continue;
    tp2=shetv.saldo;

    if(kontr.getdlinna() > 1)
      strcpy(kor1,kontr.ravno());
    if(kor2[0] == '\0' && kontr.getdlinna() > 1)
      strcpy(kor2,kontr.ravno());
//    printw("shet1=%s shet2=%s kor1=%s kor2=%s kontr=%s\n",shet1,shet2,kor1,kor2,kontr);
    
    zapmpr(gp,mp,dp,shet2,shet3,kor1,kor2,deb,kre,kom,kolpr,kekv,&sp_prov,&sum_prov_dk,ff_prot);

    strcpy(shet3,shet2);
    memset(kor1,'\0',sizeof(kor1));
    memset(kor2,'\0',sizeof(kor2));
    strcpy(kor1,kontr.ravno());
    strcpy(kor2,kontr.ravno());
   /*
    printw("shet=%s shet1=%s kor1=%s kor2=%s kontr=%s\n",shet,shet1,kor1,kor2,kontr.ravno());
    OSTANOV();        
   */
   }


  if(kontr.ravno()[0] == '\0')
     kontr1.new_plus(kor);

   if(ff_prot != NULL)
     fprintf(ff_prot,"shet1=%s kontr1=%s korr=%s\n",shet1,kontr1.ravno(),kor);

   if(provsh(&kontr1,shet1,&shetv,metka_vkontr,0) != 0)
      continue;

 

   tp1=shetv.saldo;

   if(kontr1.getdlinna() > 1)
     strncpy(kor1,kontr1.ravno(),sizeof(kor1)-1);
   if(kor2[0] == '\0' && kontr1.getdlinna() > 1)
     strncpy(kor2,kontr1.ravno(),sizeof(kor2)-1);

   if(ff_prot != NULL)
     fprintf(ff_prot,"shet3=%s shet1=%s kor1=%s kor2=%s kontr1=%s deb=%.2f kre=%.2f\n",
     shet3,shet1,kor1,kor2,kontr1.ravno(),deb,kre);

   zapmpr(gp,mp,dp,shet1,shet3,kor1,kor2,deb,kre,kom,kolpr,kekv,&sp_prov,&sum_prov_dk,ff_prot);

 }

/*Запись проводок из памяти в базу*/
pod=0;
time(&vrem);
int tipz=0;
if(SRAV(tabl,"Pltp",0) == 0)
 tipz=2;
if(SRAV(tabl,"Pltt",0) == 0)
 tipz=1;
zapmpr1(npp,kop,pod,vrem,tipd,rec.dd,rec.md,rec.gd,tipz,&sp_prov,&sum_prov_dk,ff_prot);

}
