/*$Id: b_iBank_2_UA.c,v 5.12 2011-03-28 06:53:58 sasa Exp $*/
/*16.02.2010	09.06.2006	Белых А.И.	b_iBank_2_UA.c

Экспорт платёжек для системы iBank 2 UA
Кодировка Cp1251
---------------------------------------------------------------
Наименование    Описание                        Тип        
поля
---------------------------------------------------------------
DATE_DOC        Дата документа                  date     10
NUM_DOC         Номер документа                 string   10
AMOUNT          Сумма документа                 decimal  11.2
CLN_NAME        Наименование плательщика        string   40
CLN_OKPO        ЕГРПОУ плательщика              string   10
CLN_ACCOUNT     Счёт плательщика                string   14
CLN_BANK_NAME   Наименование банка плательщика  string   45
CLN_BANK_MFO    МФО банка плательщика           string   6
RCPT_NAME       Наименование получателя         string   40
RCPT_OKPO       ЕГРПОУ получателя               string   10
RCPT_ACCOUNT    Счёт получателя                 string   14
RCPT_BANK_NAME  Наименование банка получателя   string   45
RCPT_BANK_MFO   МФО банка получателя            string   6
PAYMENT_DETAILS Назначение платежа              string   160
VALUE_DATE      Дата валютирования              date     10


*/

#include        <errno.h>
#include        <math.h>
#include        "buhg.h"
#include        "dok4.h"

extern struct REC rec;

void b_iBank_2_UA(const char *tabl)
{
char		imaf[32],imaf1[32];
FILE		*ff,*ff1;
char		stt[1024];
class iceb_tu_str koment("");
char		strsql[512];
short		d,m,g;
char		nomerdok[32];

sprintf(imaf,"platp.txt");
if((ff = fopen(imaf,"r")) == NULL)
 {
 if(errno == ENOENT)
  {
   return;
  }
 else
   {
    error_op_nfil(imaf,errno,"");
    return;
   }
 }
sprintf(imaf1,"plat.txt");
if((ff1 = fopen(imaf1,"w")) == NULL)
 {
  error_op_nfil(imaf1,errno,"");
  return;
 }
fprintf(ff1,"Content-Type=doc/ua_payment\n\n");
short dv,mv,gv;

while(fgets(stt,sizeof(stt),ff) != NULL)
 {
  polen(stt,strsql,sizeof(strsql),1,'|');
  rsdat(&d,&m,&g,strsql,1);
  polen(stt,nomerdok,sizeof(nomerdok),2,'|');

  if(readpdok(tabl,g,nomerdok) != 0)
     continue;

  /*Читаем комментарий*/
  readkom(tabl,rec.dd,rec.md,rec.gd,rec.nomdk,&koment);

  dv=rec.dv;
  mv=rec.mv;
  gv=rec.gv;
  if(dv == 0)
   {
    dv=d;
    mv=m;
    gv=g;
   }

  fprintf(ff1,"\
DATE_DOC=%02d.%02d.%04d\n\
NUM_DOC=%s\n\
AMOUNT=%.2f\n\
CLN_NAME=%.*s\n\
CLN_OKPO=%s\n\
CLN_ACCOUNT=%s\n\
CLN_BANK_NAME=%.*s\n\
CLN_BANK_MFO=%s\n\
RCPT_NAME=%.*s\n\
RCPT_OKPO=%s\n\
RCPT_ACCOUNT=%s\n\
RCPT_BANK_NAME=%.*s\n\
RCPT_BANK_MFO=%.6s\n\
PAYMENT_DETAILS=%.*s\n\
VALUE_DATE=%02d.%02d.%04d\n\n",
  d,m,g,
  nomerdok,
  rec.sumd,
  iceb_tu_kolbait(40,rec.naior),rec.naior,
  rec.kod,
  rec.nsh,
  iceb_tu_kolbait(45,rec.naiban),rec.naiban,
  rec.mfo,
  iceb_tu_kolbait(40,rec.naior1),rec.naior1,
  rec.kod1,
  rec.nsh1,
  iceb_tu_kolbait(45,rec.naiban1),rec.naiban1,
  rec.mfo1,
  iceb_tu_kolbait(160,koment.ravno()),koment.ravno(),
  dv,mv,gv);
  
  
 }

fclose(ff1);
fclose(ff);
perecod(2,imaf1);
}
