/*$Id: b_skarb.c,v 5.12 2011-03-28 06:53:58 sasa Exp $*/
/*29.10.2008	15.10.2008	Белых А.И.	b_skarb.c
Экспорт платёжек в систему АБС "СКАРБ" для Сбербанка

Имя файла произвольное с обязательным первым символом "$"
Кодировка файла cp866


Структура информационной строки
-----------------------------------------------------------
N   Наименование          Тип   Позиция   Содержимое
-----------------------------------------------------------
1   МФО банка А           N9    1-9       Имеет не меньше 6 цифр. Равно МФО банка - отправителя
2   Лицевой счёт клиента  N14   10-23     Имеет не меньше 5 цифр
    банка А
3   МФО банка Б           N9    24-33     Имеет не меньше 6 цифр. Равно МФО банка - получателя
4   Лицевой счёт клиента  N14   33-46     Имеет не меньше 5 цифр
    банка Б
5   Флаг "дебет/кредит"   С1    47-47     Признак определяестя по отношению к банку-получателю
    платежа                               платёжного документа (тоесть, кредитовый документ - 
                                          банк А переводит деньги банку Б)
                                          Может принимать значения 0,1,2,3
                                          0-дебет
                                          1-кредит
                                          2-дебет (информационный запрос)
                                          3-кредит (информационный запрос)
6   Сумма платежа         N16   48-63     
7   Вид документа         N2    64-65     1-платёжное поручение
                                          2-платёжное требование
                                          6-мемориальный ордер
8   Номер (операционный)  С10   66-75     
    платежа                                        
9   Валюта платежа        N3    76-78     
10  Дата платёжного док-  D6    79-84     Дата указанная в первичном платёжном документе
    умента
11  Дата поступлени пла-  D6    85-90
    тёжног документа в
    банк А
12  Наименование платель- С38   91-128
    щика (клиент А)
13  Наименование получа-  С38   129-166
    теля (клиет Б)
14  Назначение платежа    С160  167-326
15  Вспомогательные       С60   327-386
    реквизиты
16  Код назначения пла-   С3    387-389
    тежа
17  Способ заполнения     С2    390-391
    реквизитов 14-16
18  Идентефикатор клиента С14   392-405
    А
19  Идентефикатор клиента С14   406-419
    Б
20  Идентефикатор доку-   N9    420-428  Уникальный номер в течении дня
    мента
21  Время проводки доку-  N4    429-432
    мента
22  CRLF                  B2    593-594  Возврат каретки + перевод строки

Пример файла

375218   26000301454   315643   260045013010521         1138803 11961      980081013081013ТОВ "Шепетiвський м"ясокомбiнат"      П-ць Вознюк Лiлiя Петрiвна            за прийняту худобу по кв. N   3224 вiд 10.10.2008   Без ПДВ. трансп. i оргвитр.  2695.41                                                                                                                                       1400444257      2718402683           11                                                                                                                                                                    
375218   26000301454   375155   26006305086   1         2306582 11962      980081013081013ТОВ "Шепетiвський м"ясокомбiнат"      Гаврилюк Микола Васильовч             за прийняту худобу по кв. N   3238 вiд 10.10.2008   Без ПДВ. трансп. i оргвитр.  2150.13                                                                                                                                       1400444257      2615508957           12                                                                                                                                                                    
375218   26000301454   375218   2600950895    1         1571921 11963      980081013081013ТОВ "Шепетiвський м"ясокомбiнат"      П-ЦЬ ДЕМЧИШИН ВАСИЛЬ ДМИТ             за прийняту худобу по кв. N   3241 вiд 10.10.2008   Без ПДВ. трансп. i оргвитр.  1349.57                                                                                                                                       1400444257      2015722510           13                                                                                                                                                                    

*/

#include        <errno.h>
#include        <math.h>
#include        "buhg.h"
#include        "dok4.h"

extern struct REC rec;

void b_skarb(const char *tabl)
{
char		imaf[32],imaf1[32];
FILE		*ff,*ff1;
char		stt[1024];
class iceb_tu_str koment("");
char		strsql[512];
short		d,m,g;
char		nomerdok[32];

sprintf(imaf,"platp.txt");
if((ff = fopen(imaf,"r")) == NULL)
 {
 if(errno == ENOENT)
  {
   return;
  }
 else
   {
    error_op_nfil(imaf,errno,"");
    return;
   }
 }
sprintf(imaf1,"plat.txt");
if((ff1 = fopen(imaf1,"w")) == NULL)
 {
  error_op_nfil(imaf1,errno,"");
  return;
 }
int suma_int=0;
double suma_double=0.;
double bb=0.;
while(fgets(stt,sizeof(stt),ff) != NULL)
 {
  polen(stt,strsql,sizeof(strsql),1,'|');
  rsdat(&d,&m,&g,strsql,1);
  polen(stt,nomerdok,sizeof(nomerdok),2,'|');

  if(readpdok(tabl,g,nomerdok) != 0)
     continue;

  //Округляем, чтобы не пропадали копейки
  rec.sumd=okrug(rec.sumd,0.01);

  bb=rec.sumd*100.;
 
  modf(bb,&suma_double);
  suma_int=(int)suma_double;

  /*Читаем комментарий*/
  readkom(tabl,rec.dd,rec.md,rec.gd,rec.nomdk,&koment);

  fprintf(ff1,"%-9.9s\
%-14.14s\
%-9.9s\
%-14.14s\
%1d\
%16d\
%2d\
%-*.*s\
%3d\
%02d%02d%02d\
%02d%02d%02d\
%-*.*s\
%-*.*s\
%-*.*s\
%-60.60s\
%-3.3s\
%-2.2s\
%-14.14s\
%-14.14s\
%173s\r\n",
  rec.mfo,
  rec.nsh,
  rec.mfo1,
  rec.nsh1,
  1,
  suma_int,
  1,
  iceb_tu_kolbait(10,rec.nomdk),
  iceb_tu_kolbait(10,rec.nomdk),
  rec.nomdk,
  980,
  g-2000,m,d,
  g-2000,m,d,
  iceb_tu_kolbait(38,rec.naior),
  iceb_tu_kolbait(38,rec.naior),
  rec.naior,
  iceb_tu_kolbait(38,rec.naior1),
  iceb_tu_kolbait(38,rec.naior1),
  rec.naior1,
  iceb_tu_kolbait(160,koment.ravno()),
  iceb_tu_kolbait(160,koment.ravno()),
  koment.ravno(),
  "",
  "",
  "14",
  rec.kod,
  rec.kod1,
  "");
  
 }

fclose(ff1);
fclose(ff);
/*Перекодировка файла в ДОС кодировку*/
//perecod(1,imaf1,putnansi);

}
