/*$Id: b_ukrprom.c,v 5.11 2011-03-28 06:53:58 sasa Exp $*/
/*07.11.2005	27.10.2005	Белых А.И.	b_ukrprom.c
Формирование файла для импорта платёжек в подсистему Укрпромбанка, Биг-Энергия
Формат для автоматизированной системы банков "Мебиус-банк"
Имя файла
INxnnnnn.kmm
 где
  IN    - тип файла
  x     - номер дня недели
  nnnnn - номер клиента
  k     - символ "k"
  mm    - номер сеанса

Структура записи

char MfoD[9]         МФО плательщика
char AccD[14]        Лицевой счёт плательшика
char OkpoD[10]       ОКПО плательщика
char MfoK[9]         МФО получателя
char AccK[14]        Лицевой счёт получателя
char OkpoK[10]       ОКПО получателя
char DocN[10]        Номер документа
char Amt[19]         Сумма (в коп.) платежа
char Opr[2]          01-платёжное поручение
char NamD[38]        Наименование плательщика
char NamK[38]        Наименование получателя
char NameP[160]      Назначение платежа
char day[2]          Ден
char day[2]          Месяц
char year[2]         Год
char sym[1]
char rezerv[40]
char eol[2]=0x0a0d   Признак конца строки




*/



#include        <errno.h>
#include        <math.h>
#include        "buhg.h"
#include        "dok4.h"

extern struct REC rec;

void b_ukrprom(const char *tabl)
{
char		imaf[32],imaf1[32];
FILE		*ff,*ff1;
char		stt[1024];
class iceb_tu_str koment("");
char		strsql[512];
short		d,m,g;
char		nomerdok[32];

sprintf(imaf,"platp.txt");
if((ff = fopen(imaf,"r")) == NULL)
 {
 if(errno == ENOENT)
  {
   return;
  }
 else
   {
    error_op_nfil(imaf,errno,"");
    return;
   }
 }
sprintf(imaf1,"plat.txt");
if((ff1 = fopen(imaf1,"w")) == NULL)
 {
  error_op_nfil(imaf1,errno,"");
  return;
 }
int suma_int=0;
double suma_double=0.;
double bb=0.;
while(fgets(stt,sizeof(stt),ff) != NULL)
 {
  polen(stt,strsql,sizeof(strsql),1,'|');
  rsdat(&d,&m,&g,strsql,1);
  polen(stt,nomerdok,sizeof(nomerdok),2,'|');

  if(readpdok(tabl,g,nomerdok) != 0)
     continue;

  //Округляем, чтобы не пропадали копейки
  rec.sumd=okrug(rec.sumd,0.01);

  bb=rec.sumd*100.;
 
  modf(bb,&suma_double);
  suma_int=(int)suma_double;

  /*Читаем комментарий*/
  readkom(tabl,rec.dd,rec.md,rec.gd,rec.nomdk,&koment);

  fprintf(ff1,"%9.9s%14.14s%10.10s%9.9s%14.14s%10.10s%-10.10s%19d\
%2.2s%-*.*s%-*.*s%-*.*s%02d%02d%02d%1.1s%-40.40s\n",
  rec.mfo,
  rec.nsh,
  rec.kod,
  rec.mfo1,
  rec.nsh1,
  rec.kod1,
  nomerdok, 
  suma_int,
  "01",
  iceb_tu_kolbait(38,rec.naior),iceb_tu_kolbait(38,rec.naior),rec.naior,
  iceb_tu_kolbait(38,rec.naior1),iceb_tu_kolbait(38,rec.naior1),rec.naior1,
  iceb_tu_kolbait(160,koment.ravno()),iceb_tu_kolbait(160,koment.ravno()),koment.ravno(),
  d,m,g-2000,
  " ",
  " ");
  
  
 }
memset(stt,'\0',sizeof(stt));
memset(stt,'0',380);
fprintf(ff1,"%s\n",stt);

fclose(ff1);
fclose(ff);

}
