/* $Id: dolhn.c,v 5.21 2011-05-06 08:29:23 sasa Exp $ */
/*28.11.2008    06.01.1993      Белых А.И.      dolhn.c
Автоматизированное начисление за должность с учетом
отработанного времени
Если в конце стоит буква Ч значит это не оклад а
почасовая ставка
Возвращяем коэффициент полноты выплаты
*/
#include        <ctype.h>
#include        <errno.h>
#include        "buhg.h"

extern double   okrg;
extern float    hasov; /*Количество рабочих часов в текущем месяце*/
extern float    dnei;

double dolhn(long tn, //Табельный номер
short mp,short gp, //Дата
int kp,  //Код подразделения
const char *kom, //Коментарий
const char *nah_only,
FILE *ff_prot) //Файл протокола
{
double		koefpv;
short           d;
int             kodokl; /*Код должносного оклада*/
double          oklad;  /*Оклад*/
double          nah;
int             met; /*0-оклад 1-часовая ставка 2-не пересчитываемый оклад*/
SQL_str         row;
SQLCURSOR curr;
char		strsql[512];
float		dneii,has;
float		kolrd; /*Количество рабочих дней в месяце*/
class iceb_tu_str shet("");
float		has1;   /*Количество часов в одном рабочем дне*/
float		kof;   /*Коэффициент оплаты ставки*/
float		mesnoh;  /*Месячная норма отработанных часов*/
double		procent=0.,procb=0.;
int		metka; /*0-нет метки 1-есть Метка пересчета на процент выполнения плана подразделением*/
int		metka1; /*0-расчет выполнять по отработанным часам 1-дням*/
int		nomz=0;
int metka_no;
struct ZARP     zp;
int		kodtab=0;

koefpv=oklad=nah=0.;

/*
printw("dolhn-%ld %d.%d %d\n",tn,mp,gp,kp);
refresh();
*/
kolrd=dnei;
met=0;
if(ff_prot != NULL)
 fprintf(ff_prot,"Просматриваем файл должностных окладов\n");
if(dolhn1(tn,&oklad,&has1,&kof,&met,&kodokl,&metka,&metka1,&shet,&metka_no,ff_prot) != 0)
  return(koefpv);

if(proverka(nah_only,kodokl,0,0) != 0)
 {
  if(ff_prot != NULL)
    fprintf(ff_prot,"Код должностного оклада исключён из расчёта %d\n",kodokl);
  return(koefpv);
  
 }

if(shet.ravno()[0] == '*')
 {
  //читаем счёт в карточке
  sprintf(strsql,"select shet from Kartb where tabn=%ld",tn);
  if(readkey(strsql,&row,&curr) == 1)
   shet.new_plus(row[0]);
  else
   shet.new_plus("");
 }
if(shet.ravno()[0] != '\0')
 {
  OPSHET opshet;
  if(prsh1(shet.ravno(),&opshet) != 0)
    shet.new_plus("");
 }

if(ff_prot != NULL)
 {
  fprintf(ff_prot,"\nРасчёт от должностного оклада.\n-------------------------------\n\
Табельный номер:%ld dolhn-dnei=%.2f hasov=%.2f oklad=%.2f has1=%.2f kof=%.2f met=%d kodok=%d\n",
  tn,dnei,hasov,oklad,has1,kof,met,kodokl);
  
 }

if(met == 2)
  oklad=okladtr(mp,gp,(int)oklad,ff_prot); /*oklad содержит тарифный разряд*/

if(kodokl == 0)
 {
  if(ff_prot != NULL)
   fprintf(ff_prot,"%s\n",gettext("dolhn-Не введен код оклада !!!"));
  return(koefpv);
 }



/*Проверяем есть ли код начисления в списке*/

sprintf(strsql,"select shet from Zarn1 where tabn=%ld and prn='1' and \
knah=%d",tn,kodokl); 
if(sql_readkey(&bd,strsql,&row,&curr) != 1)
 {
  if(ff_prot != NULL)
   fprintf(ff_prot,"Не нашли код %d в списке начислений для %ld табельного номера !\n",
   kodokl,tn);
  return(koefpv);
 }
if(shet.ravno()[0] == '\0')
  shet.new_plus(row[0]);

/*Читаем код табеля*/
sprintf(strsql,"select kodt from Nash where kod=%d",
kodokl);
if(sql_readkey(&bd,strsql,&row,&curr) != 1)
 {
  if(ff_prot != NULL)
    fprintf(ff_prot,"Нет кода начисления %d в списке начислений !\n",kodokl);
  return(koefpv);
 }
kodtab=atoi(row[0]);
if(ff_prot != NULL)
  fprintf(ff_prot,"Код табеля для автоматизированного расчета %d\n",
  kodtab);

/*Читаем табель*/
if(kom[0] == '\0')
 sprintf(strsql,"select dnei,has,kolrd,kolrh,nomz from Ztab \
where god=%d and mes=%d and tabn=%ld and kodt=%d order by nomz asc",
 gp,mp,tn,kodtab);
else
 sprintf(strsql,"select dnei,has,kolrd,kolrh,nomz from Ztab \
where god=%d and mes=%d and tabn=%ld and kodt=%d and kom='%s' \
order by nomz asc",gp,mp,tn,kodtab,kom);

if(sql_readkey(&bd,strsql,&row,&curr) == 0)
 {
  dneii=has=0.;
  kolrd=0.;
  nomz=0;
  if(ff_prot != NULL)
   fprintf(ff_prot,"Не найден код табеля %d указанного в начислении.\n",kodtab);
 }
else
 {
  nomz=atoi(row[4]);
  dneii=atof(row[0]);
  has=atof(row[1]);
  if(atof(row[2]) != 0.)
   {
    kolrd=atof(row[2]);
    if(ff_prot != NULL)
      fprintf(ff_prot,"Количество рабочих дней=%.2f\n",kolrd);
   }
  if(atof(row[3]) != 0.)
   {
    has1=atof(row[3]);
    if(ff_prot != NULL)
      fprintf(ff_prot,"Количество часов в смене=%.2f\n",has1);
   }
 }

mesnoh=hasov;
if(has1 != 0.)
 {
  mesnoh=kolrd*has1;
  if(ff_prot != NULL)
   fprintf(ff_prot,"mesnoh=%.2f*%.2f=%.2f\n",kolrd,has1,mesnoh);
 }  
else
  if(ff_prot != NULL)
   fprintf(ff_prot,"mesnoh=%.2f\n",mesnoh);
/*
printw("\nmet=%d metka1=%d kolrd=%d\n",met,metka1,kolrd);
OSTANOV();
*/
nah=0.;
if(metka_no == 1) /*не пересчитываемый оклад*/
 {
  nah=oklad;
  koefpv=1.;
 }
else
 {
  if(met == 0 || met == 2) /*расчёт по окладу*/
   {
    if(mesnoh > 0.00001 && metka1 == 0)
     {
      nah=oklad/mesnoh*has;
      koefpv=has/mesnoh;
      if(ff_prot != NULL)
         fprintf(ff_prot,"Начислено(по часам)=%.2f/%.2f*%.2f=%.2f koefpv=%.2f/%.2f=%f\n",
         oklad,mesnoh,has,nah,has,mesnoh,koefpv);
     }
    if(metka1 == 1 && kolrd > 0)
     {
      nah=oklad/kolrd*dneii;
      koefpv=dneii/kolrd;
      if(ff_prot != NULL)
         fprintf(ff_prot,"Начислено(по дням)=%.2f/%.2f*%.2f=%.2f koefpv=%f\n",
         oklad,kolrd,dneii,nah,koefpv);
     }   
   }
  if(met == 1) /*расчёт по часовой ставке*/
   {
    nah=oklad*has;
    koefpv=1.;
     if(ff_prot != NULL)
       fprintf(ff_prot,"Начислено=%.2f*%.2f=%.2f koefpv=%f\n",
       oklad,has,nah,koefpv);
   }
 }
 
if(metka == 1)
 {
  
  procent=zarpodpr(kp,&procb);
  if(ff_prot != NULL)
   fprintf(ff_prot,"Учет процента выполнения плана подразделением %d, процент: %.2f %%\n",
   kp,procent);   
  if(ff_prot != NULL)
     fprintf(ff_prot,"%.2f*%.2f/100=",
     nah,procent);
  koefpv*=procent/100.;
  nah=nah*procent/100.;
  if(ff_prot != NULL)
     fprintf(ff_prot,"%.2f koefpv=%f\n",nah,koefpv);

 } 

if(nah > 0.)
  nah=okrug(nah,okrg);
/*
if(ff_prot != NULL)
  fprintf(ff_prot,"%s: %.2f (%s:%.2f/%.2f %s:%.2f %s:%.2f)\n\n",
gettext("Начислено"),
nah,
gettext("Часов"),
mesnoh,has,
gettext("Дней"),dneii,
gettext("Оклад"),oklad);
*/
dpm(&d,&mp,&gp,5);

memset(&zp,'\0',sizeof(zp));
zp.dz=d;
zp.mesn=mp; zp.godn=gp;
zp.nomz=0;
zp.podr=kp;
strcpy(zp.shet,shet.ravno());
zapzarp(d,mp,gp,tn,1,kodokl,nah,shet.ravno(),mp,gp,0,nomz,kom,kp,"",zp); 

return(koefpv);
}
