/*$Id: gosrs.c,v 5.12 2011-01-13 13:43:22 sasa1 Exp $*/
/*09.11.2009	28.08.2009	Белых А.И.	gosrs.c
Расчёт журнала-ордера для счёта с развёрнутым сальдо
Новый алгоритм
*/
#include <math.h>
#include <errno.h>
#include "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

void gosrs_hapgo(short dn,short mn,short gn,short dk,short mk,short gk,int *kollist,int *kolstr,FILE *ff);
void gosrs_ss(int metka,short dn,short mn,short gn,short dk,short mk,short gk,int *kollist,int *kolstr,FILE *ff);
void gosrs_itoggo(const char *shet,short dn,short mn,short gn,short dk,short mk,short gk,const char *naim_shet,class SPISOK *oss,class SPISOK *kontr_shet,class masiv_din_double *kontr_shet_deb,class masiv_din_double *kontr_shet_kre,FILE *ff);
void gossrs_sapsk(short dk,short gk,short mk,int *kollist_sk,int *kolstr_sk,FILE *ff);
int gorsrs_provk(int nomer_kontr,class masiv_din_double *debs,class masiv_din_double *kres,class masiv_din_double *debp,class masiv_din_double *krep,class SPISOK *kontr_shet,class SPISOK *skontr);
void gosrs_goriz(const char *shet,short,short,short,short,short,short,class SPISOK *skontr,class SPISOK *skontr_sort,class SPISOK *ssd,class SPISOK *ssk,class SPISOK *kontr_shet,class masiv_din_double *kontr_shet_deb,class masiv_din_double *kontr_shet_kre,class masiv_din_double *debs,class masiv_din_double *kres,class masiv_din_double *debp,class masiv_din_double *krep,char *imaf_gor);
void gorsrs_podn(const char *shet,const char *naim_shet,short dn,short mn,short gn,short dk,short mk,short gk,class SPISOK *ssd,class SPISOK *ssk,
class SPISOK *den_shet_deb,class SPISOK *den_shet_kre,class masiv_din_double *den_shet_deb_suma,class masiv_din_double *den_shet_kre_suma,double debs,double kres,double debp,double krep,double debk,double krek,int metka_f,char *imaf);

extern short	startgodb; /*Стартовый год*/
extern short	vplsh; /*0-двух уровневый план счетов 1-многоуровневый*/
extern char *organ;
extern int kol_strok_na_liste;



int gosrs(const char *shet, //Номер счета
short dn,short mn,short gn, //Дата начала периода
short dk,short mk,short gk, //Дата конца периода
short vds, //0-счет 1-субсчет
const char *kodgr, //Код группы контрагентов
int metkasort,
class spis_oth *oth)
{
char strsql[512];
int kolstr=0;
double deb=0.,kre=0.;
SQL_str row,row1;
class SQLCURSOR cur,cur1;
class SPISOK skontr; /*Список контрагентов*/
class SPISOK skontr_sort; /*Список контрагентов отсортированный*/
class SPISOK ssd; /*Список счетов дебета*/
class SPISOK ssk; /*Список счетов кредита*/
class SPISOK oss; /*Общий список счетов*/


class SPISOK kontr_shet; /*Список код контрагента|счёт корреспондент*/
class masiv_din_double kontr_shet_deb; /*суммы по дебету по списку */
class masiv_din_double kontr_shet_kre; /*суммы по кредиту по списку*/

class masiv_din_double hach_kontr_shet_deb; /*шахматка контрагент-счёт по дебету*/
class masiv_din_double hach_kontr_shet_kre; /*шахматка контрагент-счёт по кредиту*/

class masiv_din_double debs; /*Дебеты стартовые на начало периода*/
class masiv_din_double kres; /*Кредиты стартовые на начало периода*/
class masiv_din_double debp; /*Дебеты за период*/
class masiv_din_double krep; /*Кредиты за период*/

time_t tmmn=time(NULL);
short godn=startgodb;
if(startgodb == 0 || startgodb > gn)
 godn=gn;

clear();

/*Узнаём наименование счёта*/
class iceb_tu_str naim_shet("");
sprintf(strsql,"select nais from Plansh where ns='%s'",shet);
if(readkey(strsql,&row,&cur) == 1)
 naim_shet.new_plus(row[0]);
printw("%s %s\n",shet,naim_shet.ravno());
printw("%02d.%02d.%d -> %02d.%02d.%d\n",dn,mn,gn,dk,mk,gk);

/*Узнаем начальное сальдо по каждой организации*/
printw(gettext("Вычисляем стартовое сальдо по всем контрагентам\n"));
refresh();

if(vds == 0 || vplsh == 1)
 sprintf(strsql,"select kodkon,deb,kre from Saldo where kkk='1' and gs=%d \
and ns like '%s%%'",godn,shet);

if(vds == 1 && vplsh == 0)
 sprintf(strsql,"select kodkon,deb,kre from Saldo where kkk='1' and gs=%d \
and ns='%s'",godn,shet);

//printw("%s\n",strsql);

if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }
int nomer_kontr=0;
if(kolstr > 0)
while(cur.read_cursor(&row) != 0)
 {
  if(kodgr[0] != '\0')
   {
    sprintf(strsql,"select grup from Kontragent where kodkon='%s'",row[0]);
    if(readkey(strsql,&row1,&cur1) != 1)
     {
      VVOD SOOB(1);
      sprintf(strsql,"%s %s !",gettext("Не найден код контрагента"),row[0]);
      SOOB.VVOD_SPISOK_add_MD(strsql);
      soobshw(&SOOB,stdscr,-1,-1,0,1);
      continue;
     }
    if(proverka(kodgr,row1[0],0,0) != 0)
      continue;  
   }

  if((nomer_kontr=skontr.find_r(row[0])) < 0)
   {
    skontr.plus(row[0]);   
    debp.plus(0.,-1);
    krep.plus(0.,-1);
   }
  debs.plus(atof(row[1]),nomer_kontr);
  kres.plus(atof(row[2]),nomer_kontr);


 }
int kolih_mes_v_per=period(1,mn,gn,1,mk,gk,1);
class SPISOK den_shet_deb[kolih_mes_v_per]; /*Список день|счёт для дебетов*/
class SPISOK den_shet_kre[kolih_mes_v_per]; /*Список день|счёт для кредитов*/
class masiv_din_double den_shet_deb_suma[kolih_mes_v_per]; /*Сумма по дню дебета*/
class masiv_din_double den_shet_kre_suma[kolih_mes_v_per]; /*Сумма по дню кредита*/

/*смотрим проводки заполняем массивы*/
int nomer_mes_v_per=-1;
int nomer_den_shet=0;
int nomer_kontr_shet=0;
short d=1,m=1,g=godn;
int kolih_den=period(1,1,godn,dk,mk,gk,0);
int kolstr1=0;
short mes_zap=0;
while(sravmydat(d,m,g,dk,mk,gk) <= 0)
 {
  
  strzag(LINES-1,0,kolih_den,++kolstr1);

  if(vds == 0 || vplsh == 1)
   sprintf(strsql,"select sh,shk,kodkon,deb,kre from Prov \
 where val=0 and datp='%d-%02d-%02d' and sh like '%s%%'",g,m,d,shet);

  if(vds == 1 && vplsh == 0)
   sprintf(strsql,"select sh,shk,kodkon,deb,kre from Prov \
 where val=0 and datp='%d-%02d-%02d' and sh='%s'",g,m,d,shet);

  if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
   {
    msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
    return(1);
   }

  if(sravmydat(d,m,g,dn,mn,gn) >= 0) /*период*/
  if(mes_zap != m)
   {
    nomer_mes_v_per++;
    mes_zap=m;
   }            
  
  while(cur.read_cursor(&row) != 0)
   {
/********
    printw("%02d.%02d.%04d %6s %6s %6s %10s %10s\n",d,m,g,row[0],row[1],row[2],row[3],row[4]);
    refresh();
************/
    if(kodgr[0] != '\0')
     {
      sprintf(strsql,"select grup from Kontragent where kodkon='%s'",row[2]);
      if(readkey(strsql,&row1,&cur1) != 1)
       {
        VVOD SOOB(1);
        sprintf(strsql,"%s %s !",gettext("Не найден код контрагента"),row[2]);
        SOOB.VVOD_SPISOK_add_MD(strsql);
        soobshw(&SOOB,stdscr,-1,-1,0,1);
        continue;
       }
      if(proverka(kodgr,row1[0],0,0) != 0)
        continue;  
     }



    if(row[2][0] == '\0')
     {
      VVOD SOOB(1);
      sprintf(strsql,"%d.%d.%d %s %s %s %s %s",d,m,g,row[9],row[1],row[2],row[3],row[4]);
      SOOB.VVOD_SPISOK_add_MD(strsql);
      SOOB.VVOD_SPISOK_add_MD(gettext("В проводке нет кода контрагента !"));
      soobshw(&SOOB,stdscr,-1,-1,0,1);

      continue;
     }

    deb=atof(row[3]);
    kre=atof(row[4]);
    if((nomer_kontr=skontr.find_r(row[2])) < 0)
     {
      skontr.plus(row[2]);
      debs.plus(0.,-1);
      kres.plus(0.,-1);
      debp.plus(0.,-1);
      krep.plus(0.,-1);
      /*узнаём под каким номером записан*/
      nomer_kontr=skontr.kolih()-1;    
     }

    if(sravmydat(d,m,g,dn,mn,gn) < 0) /*До периода*/
     {
      debs.plus(deb,nomer_kontr);
      kres.plus(kre,nomer_kontr);
     }
    else /*Период*/
     {
      if(oss.find_r(row[1]) < 0)
         oss.plus(row[1]);
      debp.plus(deb,nomer_kontr);
      krep.plus(kre,nomer_kontr);

      sprintf(strsql,"%s|%s",row[2],row[1]);
      if((nomer_kontr_shet=kontr_shet.find_r(strsql)) < 0)
       kontr_shet.plus(strsql);

      /*Всегда дебет и кредит независимо от их значений*/
      kontr_shet_deb.plus(deb,nomer_kontr_shet);
      kontr_shet_kre.plus(kre,nomer_kontr_shet);


      if(fabs(deb) > 0.009)
       {
        if(ssd.find_r(row[1]) < 0)
         ssd.plus(row[1]);

        sprintf(strsql,"%02d.%02d.%04d|%s",d,m,g,row[1]);
        if((nomer_den_shet=den_shet_deb[nomer_mes_v_per].find_r(strsql)) < 0)
         den_shet_deb[nomer_mes_v_per].plus(strsql);
        den_shet_deb_suma[nomer_mes_v_per].plus(deb,nomer_den_shet);
       }
      else
       {
        if(ssk.find_r(row[1]) < 0)
          ssk.plus(row[1]);

        sprintf(strsql,"%02d.%02d.%04d|%s",d,m,g,row[1]);
        if((nomer_den_shet=den_shet_kre[nomer_mes_v_per].find_r(strsql)) < 0)
         den_shet_kre[nomer_mes_v_per].plus(strsql);
        den_shet_kre_suma[nomer_mes_v_per].plus(kre,nomer_den_shet);
       }
     }
   }

  dpm(&d,&m,&g,1);
 }
GDITE();

int kolih_kontr=skontr.kolih();
if(iceb_t_sortkk(metkasort,&skontr,&skontr_sort) != 0)
 return(1);


int kolih_shet=oss.kolih();
int nomer_sheta=0;
char kod_kontr0[20];
char shet_k[20];
/*заряжаем шахматки*/
hach_kontr_shet_deb.make_class(kolih_kontr*kolih_shet);
hach_kontr_shet_kre.make_class(kolih_kontr*kolih_shet);
for(int nomer_kontr_shet=0; nomer_kontr_shet < kontr_shet.kolih(); nomer_kontr_shet++)
 {
  polen(kontr_shet.ravno(nomer_kontr_shet),kod_kontr0,sizeof(kod_kontr0),1,'|');  
  polen(kontr_shet.ravno(nomer_kontr_shet),shet_k,sizeof(shet_k),2,'|');  

  nomer_kontr=skontr_sort.find_r(kod_kontr0);

  nomer_sheta=oss.find_r(shet_k);

  hach_kontr_shet_deb.plus(kontr_shet_deb.ravno(nomer_kontr_shet),nomer_kontr*kolih_shet+nomer_sheta);

  hach_kontr_shet_kre.plus(kontr_shet_kre.ravno(nomer_kontr_shet),nomer_kontr*kolih_shet+nomer_sheta);
 }

printw("%s\n",gettext("Вертикальна форма распечатки по контрагентам"));
refresh();


int metka_naim_shet=0;
memset(strsql,'\0',sizeof(strsql));
if(iceb_t_poldan("Печатать наименование счёта корреспондента в журналах-ордерах для счетов с развёрнутым сальдо",strsql,"nastrb.alx") == 0)
 if(SRAV("Вкл",strsql,1) == 0)
  metka_naim_shet=1;

char imaf_obor[50];
char imaf_gur[50];
char imaf_sk[50];
FILE *ff_obor;
FILE *ff_gur;
FILE *ff_sk;

sprintf(imaf_obor,"obor%d.lst",getpid());
sprintf(imaf_gur,"gurrs%d.lst",getpid());
sprintf(imaf_sk,"salk%d.lst",getpid());

if((ff_obor = fopen(imaf_obor,"w")) == NULL)
 {
  error_op_nfil(imaf_obor,errno,"");
  return(1);
 }

if((ff_gur = fopen(imaf_gur,"w")) == NULL)
 {
  error_op_nfil(imaf_gur,errno,"");
  return(1);
 }

if((ff_sk = fopen(imaf_sk,"w")) == NULL)
 {
  error_op_nfil(imaf_sk,errno,"");
  return(1);
 }

struct  tm      *bf;
time_t tmm=time(NULL);

bf=localtime(&tmm);
fprintf(ff_obor,"%s\n\n\
			      %s %s %s\n\
				  %s %d.%d.%d%s %s %d.%d.%d%s\n\
			      %s %d.%d.%d%s  %s: %d.%d\n",
organ,
gettext("Оборот по счету"),
shet,naim_shet.ravno(),
gettext("Период с"),
dn,mn,gn,
gettext("г."),
gettext("до"),
dk,mk,gk,
gettext("г."),
gettext("По состоянию на"),
bf->tm_mday,bf->tm_mon+1,bf->tm_year+1900,
gettext("г."),
gettext("Время"),
bf->tm_hour,bf->tm_min);

int kolstr_obor=5; 

fprintf(ff_gur,"%s\n\n\
			       %s %s %s\n\
				  %s %d.%d.%d%s %s %d.%d.%d%s\n\
			       %s %d.%d.%d  %s - %d:%d\n",
organ,
gettext("Журнал ордер по счету"),
shet,naim_shet.ravno(),
gettext("Период с"),
dn,mn,gn,
gettext("г."),
gettext("до"),
dk,mk,gk,
gettext("г."),
gettext("По состоянию на"),
bf->tm_mday,bf->tm_mon+1,bf->tm_year+1900,
gettext("Время"),
bf->tm_hour,bf->tm_min);

int kolstr_gur=5;

fprintf(ff_sk,"%s\n\n\
%s %d.%d.%d%s %s %s %s\n\
%s %d.%d.%d%s  %s: %d.%d\n",
organ,
gettext("Конечное сальдо на"),
dk,mk,gk,
gettext("г."),
gettext("по счету"),
shet,naim_shet.ravno(),
gettext("По состоянию на"),
bf->tm_mday,bf->tm_mon+1,bf->tm_year+1900,
gettext("г."),
gettext("Время"),
bf->tm_hour,bf->tm_min);

int kolstr_sk=4;

int klst=1;
if(kodgr[0] != '\0')
 {
  fprintf(ff_obor,"%s: %s\n",gettext("Список контрагентов"),kodgr);
  printcod(ff_obor,"Gkont","kod","naik",0,kodgr,&klst);

  klst=0;
  fprintf(ff_gur,"%s: %s\n",gettext("Список контрагентов"),kodgr);
  printcod(ff_gur,"Gkont","kod","naik",0,kodgr,&klst);

  klst=0;
  fprintf(ff_sk,"%s: %s\n",gettext("Список контрагентов"),kodgr);
  printcod(ff_sk,"Gkont","kod","naik",0,kodgr,&klst);
 }

kolstr_gur+=klst;
kolstr_obor+=klst;
kolstr_sk+=klst;
int kollist_gur=0;
int kollist_obor=0;
int kollist_sk=0;
/*Шапка оборотного баланса*/
sapgors(dn,mn,gn,dk,mk,gk,&kollist_obor,&kolstr_obor,ff_obor);
/*Шапка журнал-ордера*/
gosrs_hapgo(dn,mn,gn,dk,mk,gk,&kollist_gur,&kolstr_gur,ff_gur);
/*Шапка конечного сальдо*/
gossrs_sapsk(dk,gk,mk,&kollist_sk,&kolstr_sk,ff_sk);

//int metka_prop=0;
class iceb_tu_str kod_kontr;
class iceb_tu_str naim_kontr;
class iceb_tu_str telef;
int grupa=0;
int grupaz=0;
double   sdgr=0.,skgr=0.,sdngr=0.,skngr=0.,dnsgr=0.,knsgr=0.;
double idebs=0.,ikres=0.;
double idebp=0.,ikrep=0.;
double idebk=0.,ikrek=0.;
//int kolih_kontr_shet=kontr_shet.kolih();
for(int nomer_kontr_sort=0; nomer_kontr_sort < kolih_kontr; nomer_kontr_sort++)
 {
  nomer_kontr=skontr.find_r(skontr_sort.ravno(nomer_kontr_sort));
  if(gorsrs_provk(nomer_kontr,&debs,&kres,&debp,&krep,&kontr_shet,&skontr) != 0)
   continue;

  sprintf(strsql,"select kodkon,naikon,telef,grup from Kontragent where kodkon='%s'",skontr.ravno(nomer_kontr));
  if(readkey(strsql,&row1,&cur1) != 1)
   {
    fprintf(ff_obor,"\n\n%s %s!!!\n\n",gettext("Не найден код контрагента"),skontr.ravno(nomer_kontr));
    fprintf(ff_gur,"\n\n%s %s!!!\n\n",gettext("Не найден код контрагента"),skontr.ravno(nomer_kontr));
    sprintf(strsql,"%s %s",gettext("Не найден код контрагента"),skontr.ravno(nomer_kontr));
    iceb_t_soob(strsql);
    continue;
   }
  naim_kontr.new_plus(row1[1]);
  telef.new_plus(row1[2]);
  grupa=atoi(row1[3]); 

  if(metkasort == 4)
   if(grupaz != grupa)
    {
     if(grupaz != 0)
      {
     gosrs_ss(0,dn,mn,gn,dk,mk,gk,&kollist_obor,&kolstr_obor,ff_obor);
     fprintf(ff_obor,"\
 . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .\n");
     class iceb_tu_str naimgrup("");       
     sprintf(strsql,"select naik from Gkont where kod=%d",grupaz);
     if(readkey(strsql,&row1,&cur1) == 1)
         naimgrup.new_plus(row1[0]);

     gosrs_ss(0,dn,mn,gn,dk,mk,gk,&kollist_obor,&kolstr_obor,ff_obor);

     sprintf(strsql,"%s %d %s",gettext(" Итого по группе"),grupaz,naimgrup.ravno());
     fprintf(ff_obor,"\
%-*.*s %14.2f %14.2f %14.2f %14.2f %14.2f %14.2f\n",
     iceb_tu_kolbait(31,strsql),iceb_tu_kolbait(31,strsql),strsql,dnsgr,knsgr,sdngr,skngr,sdgr,skgr);

     /*****************************************/

     gosrs_ss(1,dn,mn,gn,dk,mk,gk,&kollist_gur,&kolstr_gur,ff_gur);
     fprintf(ff_gur,"\
 - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -\n");


     sprintf(strsql,"%s %d %s",gettext(" Итого по группе"),grupaz,naimgrup.ravno());

     gosrs_ss(1,dn,mn,gn,dk,mk,gk,&kollist_gur,&kolstr_gur,ff_gur);
     fprintf(ff_gur,"\
%-*.*s %14.2f %14.2f %10s %14.2f %14.2f %14.2f %14.2f\n",
     iceb_tu_kolbait(31,strsql),iceb_tu_kolbait(31,strsql),strsql,dnsgr,knsgr," ",sdngr,skngr,sdgr,skgr);
     }

     sdgr=skgr=sdngr=skngr=dnsgr=knsgr=0.;
     grupaz=grupa;
    }

  deb=kre=0.;
  if(debs.ravno(nomer_kontr) > kres.ravno(nomer_kontr))
   deb=debs.ravno(nomer_kontr)-kres.ravno(nomer_kontr);
  else
   kre=kres.ravno(nomer_kontr)-debs.ravno(nomer_kontr);

  gosrs_ss(0,dn,mn,gn,dk,mk,gk,&kollist_obor,&kolstr_obor,ff_obor);
  gosrs_ss(1,dn,mn,gn,dk,mk,gk,&kollist_gur,&kolstr_gur,ff_gur);
  gosrs_ss(2,dn,mn,gn,dk,mk,gk,&kollist_sk,&kolstr_sk,ff_sk);
  if(deb > 0.)
   {
    idebs+=deb;
    dnsgr+=deb;
    fprintf(ff_obor,"%*s %-*.*s %14.2f %14s %14.2f %14.2f ",
    iceb_tu_kolbait(10,skontr.ravno(nomer_kontr)),skontr.ravno(nomer_kontr),
    iceb_tu_kolbait(20,naim_kontr.ravno()),iceb_tu_kolbait(20,naim_kontr.ravno()),naim_kontr.ravno(),
    deb," ",debp.ravno(nomer_kontr),krep.ravno(nomer_kontr));

    fprintf(ff_gur,"%*s %-*.*s %14.2f %14s %10s %14.2f %14.2f ",
    iceb_tu_kolbait(10,skontr.ravno(nomer_kontr)),skontr.ravno(nomer_kontr),
    iceb_tu_kolbait(20,naim_kontr.ravno()),iceb_tu_kolbait(20,naim_kontr.ravno()),naim_kontr.ravno(),
    deb," "," ",debp.ravno(nomer_kontr),krep.ravno(nomer_kontr));
   }
  else
   {
    ikres+=kre;
    knsgr+=kre;
    fprintf(ff_obor,"%*s %-*.*s %14s %14.2f %14.2f %14.2f ",
    iceb_tu_kolbait(10,skontr.ravno(nomer_kontr)),skontr.ravno(nomer_kontr),
    iceb_tu_kolbait(20,naim_kontr.ravno()),iceb_tu_kolbait(20,naim_kontr.ravno()),naim_kontr.ravno(),
    " ",kre,debp.ravno(nomer_kontr),krep.ravno(nomer_kontr));

    fprintf(ff_gur,"%*s %-*.*s %14s %14.2f %10s %14.2f %14.2f ",
    iceb_tu_kolbait(10,skontr.ravno(nomer_kontr)),skontr.ravno(nomer_kontr),
    iceb_tu_kolbait(20,naim_kontr.ravno()),iceb_tu_kolbait(20,naim_kontr.ravno()),naim_kontr.ravno(),
    " ",kre," ",debp.ravno(nomer_kontr),krep.ravno(nomer_kontr));
   }


  idebp+=debp.ravno(nomer_kontr);
  ikrep+=krep.ravno(nomer_kontr);

  deb=kre=0.;
  if(debs.ravno(nomer_kontr)+debp.ravno(nomer_kontr) > kres.ravno(nomer_kontr)+krep.ravno(nomer_kontr))
   deb=debs.ravno(nomer_kontr)+debp.ravno(nomer_kontr) - (kres.ravno(nomer_kontr)+krep.ravno(nomer_kontr));
  else
   kre=kres.ravno(nomer_kontr)+krep.ravno(nomer_kontr)-(debs.ravno(nomer_kontr)+debp.ravno(nomer_kontr));

  if(deb > 0.)
   {
    idebk+=deb;
    sdgr+=deb;
    fprintf(ff_obor,"%14.2f\n",deb);
    fprintf(ff_gur,"%14.2f\n",deb);

    fprintf(ff_sk,"%*s %-*.*s %14.2f %14s %s\n",
    iceb_tu_kolbait(10,skontr.ravno(nomer_kontr)),skontr.ravno(nomer_kontr),
    iceb_tu_kolbait(20,naim_kontr.ravno()),iceb_tu_kolbait(20,naim_kontr.ravno()),naim_kontr.ravno(),
    deb," ",telef.ravno());

   }
  else
   {
    fprintf(ff_obor,"%14s %14.2f\n"," ",kre);
    fprintf(ff_gur,"%14s %14.2f\n"," ",kre);
    fprintf(ff_sk,"%*s %-*.*s %14s %14.2f %s\n",
    iceb_tu_kolbait(10,skontr.ravno(nomer_kontr)),skontr.ravno(nomer_kontr),
    iceb_tu_kolbait(20,naim_kontr.ravno()),iceb_tu_kolbait(20,naim_kontr.ravno()),naim_kontr.ravno(),
    " ",kre,telef.ravno());
    ikrek+=kre;
    skgr+=kre;
   }

  if(iceb_tu_strlen(naim_kontr.ravno()) > 20)
   {
    gosrs_ss(0,dn,mn,gn,dk,mk,gk,&kollist_obor,&kolstr_obor,ff_obor);
    fprintf(ff_obor,"%-10s %s\n"," ",iceb_tu_adrsimv(20,naim_kontr.ravno()));

    gosrs_ss(1,dn,mn,gn,dk,mk,gk,&kollist_gur,&kolstr_gur,ff_gur);
    fprintf(ff_gur,"%-10s %s\n"," ",iceb_tu_adrsimv(20,naim_kontr.ravno()));

    gosrs_ss(2,dn,mn,gn,dk,mk,gk,&kollist_sk,&kolstr_sk,ff_sk);
    fprintf(ff_sk,"%-10s %s\n"," ",iceb_tu_adrsimv(20,naim_kontr.ravno()));
   }

 for(int nomer_shet=0; nomer_shet < kolih_shet; nomer_shet++)
  {
   deb=hach_kontr_shet_deb.ravno(nomer_kontr_sort*kolih_shet+nomer_shet);
   kre=hach_kontr_shet_kre.ravno(nomer_kontr_sort*kolih_shet+nomer_shet);

   if(fabs(deb) < 0.009 && fabs(kre) < 0.009)
    continue;
    if(metka_naim_shet == 1)
     {
        class iceb_tu_str naim_shet_kor("");
        sprintf(strsql,"select nais from Plansh where ns='%s'",oss.ravno(nomer_shet));
        if(readkey(strsql,&row,&cur) == 1)
         naim_shet_kor.new_plus(row[0]);
        sprintf(strsql,"%s %s",naim_shet_kor.ravno(),oss.ravno(nomer_shet));
     }
    else
      sprintf(strsql,"%s",oss.ravno(nomer_shet));
      
    gosrs_ss(1,dn,mn,gn,dk,mk,gk,&kollist_gur,&kolstr_gur,ff_gur);

    fprintf(ff_gur,"%*.*s %14.2f %14.2f\n",
    iceb_tu_kolbait(72,strsql),iceb_tu_kolbait(72,strsql),strsql,deb,kre);


  }

  gosrs_ss(1,dn,mn,gn,dk,mk,gk,&kollist_gur,&kolstr_gur,ff_gur);
  fprintf(ff_gur,"\
.....................................................................................................................................\n");

  sdngr+=debp.ravno(nomer_kontr);
  skngr+=krep.ravno(nomer_kontr);
 }
if(metkasort == 4)
  {
     gosrs_ss(0,dn,mn,gn,dk,mk,gk,&kollist_obor,&kolstr_obor,ff_obor);
     fprintf(ff_obor,"\
 . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .\n");
     class iceb_tu_str naimgrup("");       
     sprintf(strsql,"select naik from Gkont where kod=%d",grupa);
     if(readkey(strsql,&row1,&cur1) == 1)
         naimgrup.new_plus(row1[0]);

     gosrs_ss(0,dn,mn,gn,dk,mk,gk,&kollist_obor,&kolstr_obor,ff_obor);

     sprintf(strsql,"%s %d %s",gettext(" Итого по группе"),grupa,naimgrup.ravno());
     fprintf(ff_obor,"\
%-*.*s %14.2f %14.2f %14.2f %14.2f %14.2f %14.2f\n",
     iceb_tu_kolbait(31,strsql),iceb_tu_kolbait(31,strsql),strsql,
     dnsgr,knsgr,sdngr,skngr,sdgr,skgr);

     /*****************************************/

     gosrs_ss(1,dn,mn,gn,dk,mk,gk,&kollist_gur,&kolstr_gur,ff_gur);
     fprintf(ff_gur,"\
 - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -\n");


     sprintf(strsql,"%s %d %s",gettext(" Итого по группе"),grupa,naimgrup.ravno());

     gosrs_ss(1,dn,mn,gn,dk,mk,gk,&kollist_gur,&kolstr_gur,ff_gur);
     fprintf(ff_gur,"\
%-*.*s %14.2f %14.2f %10s %14.2f %14.2f %14.2f %14.2f\n",
     iceb_tu_kolbait(31,strsql),iceb_tu_kolbait(31,strsql),strsql,
     dnsgr,knsgr," ",sdngr,skngr,sdgr,skgr);

  }

fprintf(ff_obor,"\
--------------------------------------------------------------------------------------------------------------------------\n\
%-*.*s %14.2f %14.2f %14.2f %14.2f %14.2f %14.2f\n",
iceb_tu_kolbait(31,gettext(" И т о г о")),iceb_tu_kolbait(31,gettext(" И т о г о")),gettext(" И т о г о"),idebs,ikres,idebp,ikrep,idebk,ikrek);

fprintf(ff_obor,"\n%s__________________________\n",
gettext("Главный бухгалтер"));

podpis(ff_obor);
fclose(ff_obor);


fprintf(ff_gur,"\
-------------------------------------------------------------------------------------------------------------------------------------\n\
%-*.*s %14.2f %14.2f %10s %14.2f %14.2f %14.2f %14.2f\n",
iceb_tu_kolbait(31,gettext(" И т о г о")),iceb_tu_kolbait(31,gettext(" И т о г о")),gettext(" И т о г о"),idebs,ikres," ",idebp,ikrep,idebk,ikrek);

gosrs_itoggo(shet,dn,mn,gn,dk,mk,gk,naim_shet.ravno(),&oss,&kontr_shet,&kontr_shet_deb,&kontr_shet_kre,ff_gur);

fprintf(ff_gur,"\n%s__________________________\n",
gettext("Главный бухгалтер"));
podpis(ff_gur);

fclose(ff_gur);

fprintf(ff_sk,"\
----------------------------------------------------------------------------------\n");
fprintf(ff_sk,"%-*.*s %14.2f %14.2f\n",
iceb_tu_kolbait(31,gettext(" И т о г о")),iceb_tu_kolbait(31,gettext(" И т о г о")),gettext(" И т о г о"),idebk,ikrek);

fprintf(ff_sk,"\n%s__________________________\n",
gettext("Главный бухгалтер"));
podpis(ff_sk);
fclose(ff_sk);


/*Распечатка горизонтального отчёта*/
printw("%s\n",gettext("Горизонтальна форма распечатки по контрагентам"));
refresh();
char imaf_gor[56];

gosrs_goriz(shet,dn,mn,gn,dk,mk,gk,&skontr,&skontr_sort,&ssd,&ssk,&kontr_shet,&kontr_shet_deb,&kontr_shet_kre,&debs,&kres,&debp,&krep,imaf_gor);

/*Распечатка по дням*/
printw("%s\n",gettext("Распечатка по дням"));
refresh();

/*распечатка в формате А4*/
char imaf_dn[56];
sprintf(imaf_dn,"gopd%d.lst",getpid());
gorsrs_podn(shet,naim_shet.ravno(),dn,mn,gn,dk,mk,gk,&ssd,&ssk,den_shet_deb,den_shet_kre,den_shet_deb_suma,den_shet_kre_suma,idebs,ikres,idebp,ikrep,idebk,ikrek,0,imaf_dn);

/*распечатка в формате А3*/
char imaf_dn_a3[56];
sprintf(imaf_dn_a3,"gopda%d.lst",getpid());
gorsrs_podn(shet,naim_shet.ravno(),dn,mn,gn,dk,mk,gk,&ssd,&ssk,den_shet_deb,den_shet_kre,den_shet_deb_suma,den_shet_kre_suma,idebs,ikres,idebp,ikrep,idebk,ikrek,1,imaf_dn_a3);


printw("\n%*s:%20s",iceb_tu_kolbait(18,gettext("Сальдо начальное")),gettext("Сальдо начальное"),prnbr(idebs));

printw(" %20s\n",prnbr(ikres));

printw("%*s:%20s",iceb_tu_kolbait(18,gettext("Оборот за период")),gettext("Оборот за период"),prnbr(idebp));

printw(" %20s\n",prnbr(ikrep));

printw("%*s:%20s",iceb_tu_kolbait(18,gettext("Сальдо конечное")),gettext("Сальдо конечное"),prnbr(idebk));

printw(" %20s\n\n",prnbr(ikrek));

printw_vr(tmmn);
OSTANOV();

oth->spis_imaf.plus(imaf_obor);

sprintf(strsql,"%s %s",gettext("Оборотный баланс по счёту"),shet);
oth->spis_naim.plus(strsql);

oth->spis_imaf.plus(imaf_gur);
sprintf(strsql,"%s %s",gettext("Журнал-ордер по счёту"),shet);
oth->spis_naim.plus(strsql);

oth->spis_imaf.plus(imaf_sk);
sprintf(strsql,"%s %s",gettext("Конечное сальдо по счёту"),shet);
oth->spis_naim.plus(strsql);

oth->spis_imaf.plus(imaf_gor);
oth->spis_naim.plus(gettext("Горизонтальная форма распечатки по контрагентам"));

oth->spis_imaf.plus(imaf_dn);
oth->spis_naim.plus(gettext("Распечатка по дням A4"));

oth->spis_imaf.plus(imaf_dn_a3);
oth->spis_naim.plus(gettext("Распечатка по дням A3"));

for(int nom=0; nom < oth->spis_imaf.kolih(); nom++)
 iceb_t_ustpeh(oth->spis_imaf.ravno(nom),1);

return(0);
}
/****************************/
/*Шапка журнала ордера*/
/*****************************/
void gosrs_hapgo(short dn,short mn,short gn,
short dk,short mk,short gk,
int *kollist,
int *kolstr,
FILE *ff)
{
*kollist+=1;
*kolstr+=6;
fprintf(ff,"%*s%d\n",iceb_tu_kolbait(100,gettext("Лист N")),gettext("Лист N"),*kollist);
fprintf(ff,"\
-------------------------------------------------------------------------------------------------------------------------------------\n");

fprintf(ff,gettext("  Код     |    Наименование    | C а л ь д о  на  %02d.%02d.%d |   Счет   |      Оборот за период       | С а л ь д о  на  %02d.%02d.%d |\n"),
dn,mn,gn,dk,mk,gk);
fprintf(ff,gettext("контраген-|    контрагента     ------------------------------|кореспон- |------------------------------------------------------------\n"));
fprintf(ff,gettext("   та     |                    |   Дебет      |   Кредит     | дент     |   Дебет      |    Кредит    |   Дебет      |   Кредит     |\n"));

fprintf(ff,"\
-------------------------------------------------------------------------------------------------------------------------------------\n");

}
/************************************/
/*Шапка конечного сальдо*/
/**********************************/
void gossrs_sapsk(short dk,short gk,short mk,int *kollist_sk,int *kolstr_sk,FILE *ff)
{
*kollist_sk+=1;
*kolstr_sk+=5;
fprintf(ff,"%*s%d\n",iceb_tu_kolbait(68,gettext("Лист N")),gettext("Лист N"),*kollist_sk);

fprintf(ff,"\
----------------------------------------------------------------------------------\n");

fprintf(ff,gettext("  Код     |    Наименование    | C а л ь д о  на  %02d.%02d.%d |                    \n"),
dk,mk,gk);
fprintf(ff,gettext("контраген-|    контрагента     -------------------------------     Т е л е ф о н  \n"));
fprintf(ff,gettext("   та     |                    |   Дебет      |   Кредит     |                    \n"));

fprintf(ff,"\
----------------------------------------------------------------------------------\n");
}
/******************/
/*Счётчик строк*/
/*****************/
void gosrs_ss(int metka, /*0-оборотный баланс  1-журнал ордер*/
short dn,short mn,short gn,
short dk,short mk,short gk,
int *kollist,int *kolstr,FILE *ff)
{
*kolstr+=1;

if(*kolstr <= kol_strok_na_liste)
  return;

fprintf(ff,"\f");
*kolstr=1;

if(metka == 0)
  sapgors(dn,mn,gn,dk,mk,gk,kollist,kolstr,ff);
if(metka == 1)
  gosrs_hapgo(dn,mn,gn,dk,mk,gk,kollist,kolstr,ff);
if(metka == 2)
  gossrs_sapsk(dk,gk,mk,kollist,kolstr,ff);
 
}

/**************************************/
/*Распечатка свода по счетам корреспондентам для журнала ордера*/
/**************************************************************/

void gosrs_itoggo(const char *shet,
short dn,short mn,short gn, //Дата начала периода
short dk,short mk,short gk, //Дата конца периода
const char *naim_shet,
class SPISOK *oss,
class SPISOK *kontr_shet,
class masiv_din_double *kontr_shet_deb,
class masiv_din_double *kontr_shet_kre,
FILE *ff)
{
SQL_str row;
class SQLCURSOR cur;
char strsql[512];
struct  tm      *bf;
time_t tmm=time(NULL);
bf=localtime(&tmm);

fprintf(ff,"\f\%s\n\n\
%s %s %s\n\
%s\n\
%s %d.%d.%d%s %s %d.%d.%d%s\n\
%s %d.%d.%d%s %s - %d:%d\n",
organ,
gettext("Счет"),
shet,naim_shet,
gettext("Всего по счетам корреспондентам."),
gettext("Период с"),
dn,mn,gn,
gettext("г."),
gettext("до"),
dk,mk,gk,
gettext("г."),
gettext("По состоянию на"),
bf->tm_mday,bf->tm_mon+1,bf->tm_year+1900,
gettext("г."),
gettext("Время"),
bf->tm_hour,bf->tm_min);

fprintf(ff,"\
--------------------------------------------------------------------------\n");
fprintf(ff,gettext("  Счет    |   Наименование счета         |   Дебет       |   Кредит      |\n"));
fprintf(ff,"\
--------------------------------------------------------------------------\n");
double ideb=0.;
double ikre=0.;
double deb=0.;
double kre=0.;
class iceb_tu_str shet_kor("");
for(int nomer_sheta=0; nomer_sheta < oss->kolih(); nomer_sheta++)
 {
  deb=kre=0.;
  for(int nomer_kontr_shet=0; nomer_kontr_shet < kontr_shet->kolih(); nomer_kontr_shet++)
   {
     
    polen(kontr_shet->ravno(nomer_kontr_shet),&shet_kor,2,'|');
    if(iceb_tu_srav_r(shet_kor.ravno(),oss->ravno(nomer_sheta),0) != 0)
      continue;
    deb+=kontr_shet_deb->ravno(nomer_kontr_shet);
    kre+=kontr_shet_kre->ravno(nomer_kontr_shet);

   }

  sprintf(strsql,"select nais from Plansh where ns='%s'",oss->ravno(nomer_sheta));

  if(readkey(strsql,&row,&cur) != 1)
   {
    beep();
    printw(gettext("Не найден счет %s в плане счетов !\n"),oss->ravno(nomer_sheta));
    OSTANOV();
    continue;
   }
  strncpy(strsql,row[0],sizeof(strsql)-1);

  fprintf(ff,"%-*s %-*.*s %15s",
  iceb_tu_kolbait(10,oss->ravno(nomer_sheta)),oss->ravno(nomer_sheta),
  iceb_tu_kolbait(30,strsql),iceb_tu_kolbait(30,strsql),strsql,
  prnbr(deb));
  
  fprintf(ff," %15s\n",prnbr(kre));
  ideb+=deb;
  ikre+=kre;

 }
fprintf(ff,"\
--------------------------------------------------------------------------\n");
fprintf(ff,"%*s %15s",iceb_tu_kolbait(41,gettext("Итого")),gettext("Итого"),prnbr(ideb));

fprintf(ff," %15s\n",prnbr(ikre));

}
/************************/
/*проверка контрагента*/
/************************/
int gorsrs_provk(int nomer_kontr,
class masiv_din_double *debs,
class masiv_din_double *kres,
class masiv_din_double *debp,
class masiv_din_double *krep,
class SPISOK *kontr_shet,
class SPISOK *skontr)
{
int   metka_prop=0;  
int kolih_kontr_shet=kontr_shet->kolih();
class iceb_tu_str kod_kontr("");

if(fabs(debs->ravno(nomer_kontr) - kres->ravno(nomer_kontr)) < 0.009)
 if(fabs(debp->ravno(nomer_kontr)) < 0.01 && fabs(krep->ravno(nomer_kontr)) < 0.009)
  {
   int nomer_kontr_shet=0;
   for(nomer_kontr_shet=0 ; nomer_kontr_shet < kolih_kontr_shet; nomer_kontr_shet++)
    {
      polen(kontr_shet->ravno(nomer_kontr_shet),&kod_kontr,1,'|');
      if(iceb_tu_srav_r(kod_kontr.ravno(),skontr->ravno(nomer_kontr),0) == 0)
       {
        break;
       }
    }
   if(nomer_kontr_shet == kolih_kontr_shet)
    metka_prop=1;
  }
return(metka_prop);
}

/*******************************************/
/*Журнал ордер горизонтальный*/
/******************************************/
void gosrs_goriz(const char *shet,
short dn,short mn,short gn, //Дата начала периода
short dk,short mk,short gk, //Дата конца периода
class SPISOK *skontr, /*Список контрагентов*/
class SPISOK *skontr_sort, /*Список контрагентов отсортированный*/
class SPISOK *ssd, /*Список счетов дебета*/
class SPISOK *ssk, /*Список счетов кредита*/
class SPISOK *kontr_shet, /*Список код контрагента|счёт корреспондент*/
class masiv_din_double *kontr_shet_deb, /*суммы по дебету по списку */
class masiv_din_double *kontr_shet_kre, /*суммы по кредику по списку*/
class masiv_din_double *debs, /*Дебеты стартовые на начало периода*/
class masiv_din_double *kres, /*Кредиты стартовые на начало периода*/
class masiv_din_double *debp, /*Дебеты за период*/
class masiv_din_double *krep, /*Кредиты за период*/
char *imaf_gor)
{
SQL_str row;
class SQLCURSOR cur;
class iceb_tu_str naim_kontr("");
char strsql[512];
sprintf(imaf_gor,"gorgo%d.lst",getpid());
FILE *ff;

if((ff = fopen(imaf_gor,"w")) == NULL)
 {
  error_op_nfil(imaf_gor,errno,"");
  return;
 }

int kolih_kre=ssk->kolih();
int kolih_deb=ssd->kolih();


class iceb_tu_str liniq("----------------------------------------------------");
for(int nomer=0; nomer < kolih_deb+1; nomer++)
 liniq.plus("-----------");


int kolih_kontr=skontr->kolih();

class masiv_din_double kontr_shet_suma_deb;
class masiv_din_double kontr_shet_suma_kre;
kontr_shet_suma_deb.make_class(kolih_kontr*kolih_deb);
kontr_shet_suma_kre.make_class(kolih_kontr*kolih_kre);

char kod_kontr[32];
char shet_k[20];
int nomer_kontr=0;
int nomer_sheta=0;

for(int nomer_kontr_shet=0; nomer_kontr_shet < kontr_shet->kolih(); nomer_kontr_shet++)
 {
  polen(kontr_shet->ravno(nomer_kontr_shet),kod_kontr,sizeof(kod_kontr),1,'|');
  polen(kontr_shet->ravno(nomer_kontr_shet),shet_k,sizeof(shet_k),2,'|');
  nomer_kontr=skontr_sort->find_r(kod_kontr);

  nomer_sheta=ssd->find_r(shet_k);
  kontr_shet_suma_deb.plus(kontr_shet_deb->ravno(nomer_kontr_shet),nomer_kontr*kolih_deb+nomer_sheta);

  nomer_sheta=ssk->find_r(shet_k);
  kontr_shet_suma_kre.plus(kontr_shet_kre->ravno(nomer_kontr_shet),nomer_kontr*kolih_kre+nomer_sheta);

 }
            
fprintf(ff,gettext("Д е б е т ы по счету %s за период с %d.%d.%dг. по %d.%d.%dг.\n%s\n"),
shet,dn,mn,gn,dk,mk,gk,liniq.ravno());

fprintf(ff,"  Код   |   Наименование     |Сальдо на %02d.%02d.%04dг|",dn,mn,gn);
for(int kolih_deb=0; kolih_deb < ssd->kolih() ; kolih_deb++)
 fprintf(ff,"%10s|",ssd->ravno(kolih_deb));

fprintf(ff,"%-*.*s|\n",iceb_tu_kolbait(10,gettext("Итого")),iceb_tu_kolbait(10,gettext("Итого")),gettext("Итого"));


fprintf(ff,"контраг.|   контрагента      |  дебет   |  кредит  |");
for(int kolih_deb=0; kolih_deb < ssd->kolih() ; kolih_deb++)
 fprintf(ff,"%10s|","");
fprintf(ff,"%-10.10s|\n","");


fprintf(ff,"%s\n",liniq.ravno());

double deb=0.,kre=0.;
double itogo_gor=0.;
double idebs=0.;
double ikres=0.;
class masiv_din_double itogo_kol;
itogo_kol.make_class(kolih_deb);

for(int nomer_kontr_sort=0; nomer_kontr_sort < kolih_kontr; nomer_kontr_sort++)
 {
  nomer_kontr=skontr->find_r(skontr_sort->ravno(nomer_kontr_sort));
  if(gorsrs_provk(nomer_kontr,debs,kres,debp,krep,kontr_shet,skontr) != 0)
     continue;

  sprintf(strsql,"select naikon from Kontragent where kodkon='%s'",skontr->ravno(nomer_kontr));
  if(readkey(strsql,&row,&cur) != 1)
      continue;
  naim_kontr.new_plus(row[0]);

  deb=kre=0.;
  if(debs->ravno(nomer_kontr) > kres->ravno(nomer_kontr))
     deb=debs->ravno(nomer_kontr)-kres->ravno(nomer_kontr);
  else
     kre=kres->ravno(nomer_kontr)-debs->ravno(nomer_kontr);

  idebs+=deb;
  ikres+=kre;

  if(fabs(deb) > 0.009)
     fprintf(ff,"%-*s|%-*.*s|%10.2f|%10s|",
     iceb_tu_kolbait(8,skontr->ravno(nomer_kontr)),skontr->ravno(nomer_kontr),
     iceb_tu_kolbait(20,naim_kontr.ravno()),iceb_tu_kolbait(20,naim_kontr.ravno()),naim_kontr.ravno(),
     deb,"");
  else
     fprintf(ff,"%-*s|%-*.*s|%10s|%10.2f|",
     iceb_tu_kolbait(8,skontr->ravno(nomer_kontr)),skontr->ravno(nomer_kontr),
     iceb_tu_kolbait(20,naim_kontr.ravno()),iceb_tu_kolbait(20,naim_kontr.ravno()),naim_kontr.ravno(),
     "",kre);

  itogo_gor=0.;
  for(int nomer_sheta=0; nomer_sheta < kolih_deb; nomer_sheta++)
   {
    deb=kontr_shet_suma_deb.ravno(nomer_kontr_sort*kolih_deb+nomer_sheta);
    if(fabs(deb) > 0.009)
     {
      fprintf(ff,"%10.2f|",deb);
      itogo_gor+=deb;
      itogo_kol.plus(deb,nomer_sheta);
     }     
    else
     {
      fprintf(ff,"%10s|","");
     }
   }
  if(fabs(itogo_gor) > 0.009)
   fprintf(ff,"%10.2f|\n",itogo_gor);
  else
   fprintf(ff,"%10s|\n","");
  fprintf(ff,"%s\n",liniq.ravno());
 }

fprintf(ff,"%*s|%10.2f|%10.2f|",iceb_tu_kolbait(29,gettext("Итого")),gettext("Итого"),idebs,ikres);
double idebp=0.;
for(int nomer_deb=0; nomer_deb < itogo_kol.kolih(); nomer_deb++)
 {
  fprintf(ff,"%10.2f|",itogo_kol.ravno(nomer_deb));
  idebp+=itogo_kol.ravno(nomer_deb);
 }

fprintf(ff,"%10.2f|\n",idebp);

/*******************************************/

itogo_kol.free_class();
itogo_kol.make_class(kolih_kre);

liniq.new_plus("------------------------------");
for(int nomer=0; nomer < kolih_kre+3; nomer++)
 liniq.plus("-----------");


fprintf(ff,"\f");


fprintf(ff,gettext("К р е д и т ы по счету %s за период с %d.%d.%dг. по %d.%d.%dг.\n%s\n"),
shet,dn,mn,gn,dk,mk,gk,liniq.ravno());

fprintf(ff,"  Код   |   Наименование     |");
for(int nomer=0; nomer < kolih_kre ; nomer++)
 fprintf(ff,"%*s|",iceb_tu_kolbait(10,ssk->ravno(nomer)),ssk->ravno(nomer));
fprintf(ff,"%-*.*s|Сальдо на %02d.%02d.%04dг|\n",
iceb_tu_kolbait(10,gettext("Итого")),iceb_tu_kolbait(10,gettext("Итого")),gettext("Итого"),dk,mk,gk);


fprintf(ff,"контраг.|   контрагента      |");
for(int nomer=0; nomer < ssk->kolih() ; nomer++)
 fprintf(ff,"%10s|","");
fprintf(ff,"%-10.10s|  дебет   |  кредит  |\n","");

fprintf(ff,"%s\n",liniq.ravno());

/*Печатаем Кредиты*/
double debk=0.;
double krek=0.;
double idebk=0.;
double ikrek=0.;

for(int nomer_kontr_sort=0; nomer_kontr_sort < kolih_kontr; nomer_kontr_sort++)
 {
  nomer_kontr=skontr->find_r(skontr_sort->ravno(nomer_kontr_sort));
  if(gorsrs_provk(nomer_kontr,debs,kres,debp,krep,kontr_shet,skontr) != 0)
   continue;

  debk=krek=0.;
  if(debs->ravno(nomer_kontr)+debp->ravno(nomer_kontr) > kres->ravno(nomer_kontr)+krep->ravno(nomer_kontr))
   debk=debs->ravno(nomer_kontr)+debp->ravno(nomer_kontr) - (kres->ravno(nomer_kontr)+krep->ravno(nomer_kontr));
  else
   krek=kres->ravno(nomer_kontr)+krep->ravno(nomer_kontr)-(debs->ravno(nomer_kontr)+debp->ravno(nomer_kontr));

  idebk+=debk;
  ikrek+=krek;
    
  sprintf(strsql,"select naikon from Kontragent where kodkon='%s'",skontr->ravno(nomer_kontr));
  if(readkey(strsql,&row,&cur) != 1)
    continue;
  naim_kontr.new_plus(row[0]);
  
  
  fprintf(ff,"%-*s|%-*.*s|",
  iceb_tu_kolbait(8,skontr->ravno(nomer_kontr)),skontr->ravno(nomer_kontr),
  iceb_tu_kolbait(20,naim_kontr.ravno()),iceb_tu_kolbait(20,naim_kontr.ravno()),naim_kontr.ravno());

  itogo_gor=0.;
  for(int nomer_sheta=0; nomer_sheta < kolih_kre; nomer_sheta++)
   {
    kre=kontr_shet_suma_kre.ravno(nomer_kontr_sort*kolih_kre+nomer_sheta);
    if(kre != 0.)
     {
      fprintf(ff,"%10.2f|",kre);
      itogo_gor+=kre;
      itogo_kol.plus(kre,nomer_sheta);
     }     
    else
     {
      fprintf(ff,"%10s|","");
     }
   }

  if(fabs(itogo_gor) > 0.009)
    fprintf(ff,"%10.2f|",itogo_gor);
  else
    fprintf(ff,"%10s|","");

  if(fabs(debk) > 0.009)
    fprintf(ff,"%10.2f|",debk);
  else
    fprintf(ff,"%10s|","");

  if(fabs(krek) > 0.009)
    fprintf(ff,"%10.2f|\n",krek);
  else
    fprintf(ff,"%10s|\n","");

  fprintf(ff,"%s\n",liniq.ravno());
 }
fprintf(ff,"%*s|",iceb_tu_kolbait(29,gettext("Итого")),gettext("Итого"));
double ikrep=0.;
for(int nomer_kre=0; nomer_kre < itogo_kol.kolih(); nomer_kre++)
 {
  fprintf(ff,"%10.2f|",itogo_kol.ravno(nomer_kre));
  ikrep+=itogo_kol.ravno(nomer_kre);
 }

fprintf(ff,"%10.2f|%10.2f|%10.2f|\n",ikrep,idebk,ikrek);




fprintf(ff,"\n%s__________________________\n",
gettext("Главный бухгалтер"));

podpis(ff);
fclose(ff);



}
/*********************/
/*Распечатка по дням*/
/***********************/
void gorsrs_podn(const char *shet,
const char *naim_shet,
short dn,short mn,short gn, //Дата начала периода
short dk,short mk,short gk, //Дата конца периода

class SPISOK *ssd, /*Список счетов дебета*/
class SPISOK *ssk, /*Список счетов кредита*/

class SPISOK *den_shet_deb, /*Список день|счёт для дебетов*/
class SPISOK *den_shet_kre, /*Список день|счёт для кредитов*/
class masiv_din_double *den_shet_deb_suma, /*Сумма по дню дебета*/
class masiv_din_double *den_shet_kre_suma, /*Сумма по дню кредита*/
double debs,double kres,
double debp,double krep,
double debk,double krek,
int metka_f, /*0-A4 1-A3*/
char *imaf)
{
char strsql[512];
FILE *ff;

if((ff = fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return;
 }

int kolih_deb=ssd->kolih();
int kolih_kre=ssk->kolih();


class iceb_tu_str liniq;
for(int nomer=0; nomer < kolih_deb+2; nomer++)
 liniq.plus("-----------");


class SPISOK dni;
int kolih_dni=period(dn,mn,gn,dk,mk,gk,0);
int kolih_mes_v_per=period(dn,mn,gn,dk,mk,gk,1);
short d=dn,m=mn,g=gn;

for(int nomer=0; nomer < kolih_dni; nomer++)
 {
  sprintf(strsql,"%02d.%02d.%04d",d,m,g);
  dni.plus(strsql);
  dpm(&d,&m,&g,1);
 }

class masiv_din_double den_shet_suma;
den_shet_suma.make_class(kolih_dni*kolih_deb);
char den_mes_god[20];
char shet_d[20];
int nomer_sheta=0;
int nomer_data=0;
for(int nomer_mes_v_per=0; nomer_mes_v_per < kolih_mes_v_per; nomer_mes_v_per++)
for(int nomer_den_shet=0; nomer_den_shet < den_shet_deb[nomer_mes_v_per].kolih(); nomer_den_shet++)
 {
  polen(den_shet_deb[nomer_mes_v_per].ravno(nomer_den_shet),den_mes_god,sizeof(den_mes_god),1,'|');
  polen(den_shet_deb[nomer_mes_v_per].ravno(nomer_den_shet),shet_d,sizeof(shet_d),2,'|');
  nomer_data=dni.find(den_mes_god);  
  nomer_sheta=ssd->find_r(shet_d);
  den_shet_suma.plus(den_shet_deb_suma[nomer_mes_v_per].ravno(nomer_den_shet),nomer_data*kolih_deb+nomer_sheta);
 }

struct  tm      *bf;
time_t tmmn=time(NULL);
bf=localtime(&tmmn);


fprintf(ff,"\x1B%s\x1E\n","3"); /*Изменение межстрочного интервала*/

fprintf(ff,"%s\n%s %s %s\n",organ,
gettext("Журнал-ордер по счёту"),shet,naim_shet);

//fprintf(ff,"%s %s\n",gettext("Оборот по дебету счета"),shet);

sprintf(strsql,"%s %s %s %d.%d.%d%s %s: %d:%d",
gettext("Оборот по дебету счета"),shet,
gettext("По состоянию на"),
bf->tm_mday,bf->tm_mon+1,bf->tm_year+1900,
gettext("г."),
gettext("Время"),
bf->tm_hour,bf->tm_min);

buhdenshet(strsql,&dni,ssd,&den_shet_suma,metka_f,ff);
podpis(ff);


/************************************************************/




den_shet_suma.free_class();
den_shet_suma.make_class(kolih_dni*kolih_kre);

for(int nomer_mes_v_per=0; nomer_mes_v_per < kolih_mes_v_per; nomer_mes_v_per++)
for(int nomer_den_shet=0; nomer_den_shet < den_shet_kre[nomer_mes_v_per].kolih(); nomer_den_shet++)
 {
  polen(den_shet_kre[nomer_mes_v_per].ravno(nomer_den_shet),den_mes_god,sizeof(den_mes_god),1,'|');
  polen(den_shet_kre[nomer_mes_v_per].ravno(nomer_den_shet),shet_d,sizeof(shet_d),2,'|');
  nomer_data=dni.find(den_mes_god);  
  nomer_sheta=ssk->find_r(shet_d);
  den_shet_suma.plus(den_shet_kre_suma[nomer_mes_v_per].ravno(nomer_den_shet),nomer_data*kolih_kre+nomer_sheta);
 }

fprintf(ff,"\f");
fprintf(ff,"%s\n%s %s %s\n",organ,
gettext("Журнал-ордер по счёту"),shet,naim_shet);

sprintf(strsql,"%s %s %s %d.%d.%d%s %s: %d:%d",
gettext("Оборот по кредиту счета"),shet,
gettext("По состоянию на"),
bf->tm_mday,bf->tm_mon+1,bf->tm_year+1900,
gettext("г."),
gettext("Время"),
bf->tm_hour,bf->tm_min);


buhdenshet(strsql,&dni,ssk,&den_shet_suma,metka_f,ff);


fprintf(ff,"\
        		   %s           %s\n",
gettext("Дебет"),
gettext("Кредит"));

fprintf(ff,"\
%*s:%15.2f %15.2f\n",
iceb_tu_kolbait(18,gettext("Сальдо начальное")),gettext("Сальдо начальное"),debs,kres);

fprintf(ff,"\
%*s:%15.2f  %15.2f\n",
iceb_tu_kolbait(18,gettext("Оборот за период")),gettext("Оборот за период"),
debp,krep);

fprintf(ff,"\
%*s:%15.2f %15.2f\n",
iceb_tu_kolbait(18,gettext("Сальдо конечное")),gettext("Сальдо конечное"),
debk,krek);

fprintf(ff,"\n%s__________________________\n",
gettext("Главный бухгалтер"));

fclose(ff);

}
