/*$Id: knnfnds.c,v 5.3 2011-08-29 07:08:59 sasa Exp $*/
/*08.09.2009	12.08.2009	Белых А.И.	knnfnds.c
Начисление НДС на неденежные формы оплаты
Возвращает либо увеличенную сумму либо туже самую если НДС на этот код не начисляется
*/
#include "buhg.h"
extern short *kn_bsl; //Коды начислений на которые не распространяется льгота по подоходному налогу
extern short *knnf; /*Коды начислений неденежными формами*/
extern short *knnf_nds; /*Коды начислений неденежными формами на которые начисляется НДС*/
extern float pnds; 
extern double okrg;
extern char *shetb; /*Бюджетные счета*/

double knnfnds(int metka,/*0-для расчёта подоходного налога 1-все остальные случаи*/
int knu,const char *shet,double suma,double *sumab,FILE *ff_prot)
{
/***************
Коды на которые не распространяется социальная льгота, могут также быть
в списке кодов не денежных форм начисления зарплаты. Тоесть на них может быть 
начислен НДС и применён коэффициент увеличения. При расчёте подоходного налога это
делается в другом месте
***********/
if(metka == 0)
 if(provkod(kn_bsl,knu) >= 0) /*Для них отдельно начисляется если это нужно*/
  {
  return(0.);
  }

if(provkod(knnf,knu) < 0)
 {
  return(0.);
 }
if(ff_prot != NULL)
 fprintf(ff_prot,"Не денежная форма оплаты %d %.2f\n",knu,suma);


double suma_s_nds=suma;
if(provkod(knnf_nds,knu) >= 0)
 {
  double suma_nds=suma*pnds/100.;
  suma_nds=okrug(suma_nds,okrg);

  suma_s_nds+=suma_nds;
  if(ff_prot != NULL)
   fprintf(ff_prot,"knnfnds-На начисление начисляется НДС = %f+%f*%f/100.=%f\n",suma,suma,pnds,suma_s_nds);

  if(proverka(shetb,shet,0,1) == 0)
   {
    if(ff_prot != NULL)
     fprintf(ff_prot,"Не денежная форма оплаты (бюджет) %d %.2f\n",knu,suma);
    *sumab+=suma+suma_nds;  
   }

 }
 
return(suma_s_nds);

}

