/* $Id: konrz.c,v 5.49 2011-04-14 16:07:34 sasa Exp $ */
/*26.01.2011    30.11.1992      Белых А.И.      konrz.c
Контроль расчета зарплаты
*/
#include        <math.h>
#include        <errno.h>
#include        <time.h>
#include        "buhg.h"
#include        "zar11.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

extern short	kodpenf; /*Код пенсионного фонда*/
extern double   okrg; /*Округление*/
extern short    *kodmp;   /*Код материальной помощи*/
extern short    mmm,ggg;
extern char     *organ;/*Наименование организации*/
extern short    kodpen;  /*Код пенсионных отчислений*/
extern float    procpen[2]; /*Процент отчисления в пенсионный фонд*/
extern char	shrpz[16]; /*Счет расчетов по зарплате*/
extern struct ZAR zar;
extern short    *knvr;/*Коды начислений не входящие в расчет подоходного налога*/
extern short	*kodnvpen; /*Коды не входящие в расчет пенсионного отчисления*/
extern int kod_esv; /*Код удержания единого социального взноса*/
extern int kod_esv_bol; /*Код фонда удержания единого социального взноса*/
extern int kod_esv_inv; /*Код фонда удержания единого социального взноса*/
extern int kod_esv_dog; /*Код фонда удержания единого социального взноса*/

void            konrz()
{
short           sovm; /*Совместитель 0-нет 1- да*/
short		d,m,g;
struct  tm      *bf;
time_t          tmm;
int            tabb;   /*Табельный номер*/
char            pr[64]; /*Дата приема и увольнения с работы*/
FILE            *f,*ff;
char            imaf[64],imaf1[64];
int            kol;  /*Количество человек*/
short           metk=1; /*1-нет записей 0-есть*/
double          sum,sumn,sumu,bb;
double          itsl,itsn,itsu,itdl;
short           i;
double          pens1,nah;
short           mvz;
short           kolkd,kolkd1; /*Количество календарных дней*/
short		kolrd=0; //Количество рабочих дней
char            sss[64];
char		knvp[512];
double		snvr; //Суммы не входящие в расчет пенсионного
double		nahh[5];
double		sal;
double		sumd,sumk;
long		kolstr,kolstr1,kols;
SQL_str         row,row1;
char		strsql[512];
char		fio[512];
int		podr,kateg;
short		zvan;
char		shet[64];
char		lgoti[64];
double		s1,s2;
double		saldb;
short		dn,mn,gn,dk,mk,gk;
short		mkont,gkont;
double		sumnprov=0.;//Сумма начисленная на которую надо сделать проводки
double		sumuprov=0.;//Сумма удержаний на которую надо сделать проводки
double          suma_zarp_o; //Сумма чистой зарплаты общая
double          suma_zarp_b; //Сумма чистой зарплаты бюджетная
class iceb_tu_str vstr("");
double suma_boln_rm=0.;
mvz=0;
clear(); /*Очистить экран и закрасить фоновым цветом*/
VVOD VVOD1(2);

VVOD1.VVOD_SPISOK_add_ZAG(gettext("Контроль расчета зарплаты"));

VVOD1.VVOD_SPISOK_add_MD(gettext("Введите дату (м.г)."));
sprintf(strsql,"%d.%d",mmm,ggg);

naz:;

if((i=vvod1(&vstr,8,&VVOD1,NULL,stdscr,-1,-1)) == FK10)
  return;
if(i == ESC)
  return;

if(rsdat1(&mkont,&gkont,vstr.ravno()) != 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введене дата !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz; 
 }

clear();
GDITE();
time(&tmm);
bf=localtime(&tmm);

//читаем текущие настройки
zar_read_tn(1,mkont,gkont,NULL);

sprintf(strsql,"select tabn,fio,datk,sovm,datn,podr,kateg,shet,zvan,\
lgoti,datn,dolg from Kartb");
SQLCURSOR cur,cur1;
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return;
 }

if(kolstr == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return;
 }

/*Чтение настроек для расчёта единого социального взноса*/
zarrnesv(NULL);

sprintf(imaf,"nnz%d.lst",getpid());
sprintf(imaf1,"szr%d.lst",getpid());

if((ff = fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return;
 }
startfil(ff);
if((f = fopen(imaf1,"w")) == NULL)
 {
  error_op_nfil(imaf1,errno,"");
  return;
 }

memset(knvp,'\0',sizeof(knvp));


fprintf(f,"%s\n\n\
	     %s %d.%d%s\n\
	   %s %d.%d.%d%s %s: %d:%d\n",
organ,
gettext("Зарплата по организации за"),
mkont,gkont,
gettext("г."),
gettext("По состоянию на"),
bf->tm_mday,bf->tm_mon+1,bf->tm_year+1900,
gettext("г."),
gettext("Время"),
bf->tm_hour,bf->tm_min);

fprintf(f,"\
------------------------------------------------------------------------------------------\n");
fprintf(f,gettext("Т.Н.|    Фамилия  Имя Отчество               | Сальдо   |Начислено |  Удержано |К выдаче\n"));

fprintf(f,"\
------------------------------------------------------------------------------------------\n");

fprintf(ff,"%s\n%s %d.%d%s\n\n\
%s %d.%d.%d%s %s: %d:%d\n\
---------------------------------------------------------------\n\n",
organ,
gettext("Контроль расчета зарплаты за"),
mkont,gkont,
gettext("г."),
gettext("По состоянию на"),
bf->tm_mday,bf->tm_mon+1,bf->tm_year+1900,
gettext("г."),
gettext("Время"),
bf->tm_hour,bf->tm_min);
SQLCURSOR curr;
kols=kol=0;
itdl=itsl=itsn=itsu=0.;
sovm=0;
short dp,mp,gp; /*Дата приёма на работу*/
short du,mu,gu; /*Дата увольнения*/

while(cur.read_cursor(&row) != 0)
 {
  kols++;
  strzag(LINES-1,0,kolstr,kols);
  
  tabb=atoi(row[0]);
/*
  printw("%d\n",tabb);
  refresh();
*/  
  memset(fio,'\0',sizeof(fio));
  strncpy(fio,row[1],sizeof(fio)-1);

  rsdat(&dp,&mp,&gp,row[4],2);
  rsdat(&du,&mu,&gu,row[2],2);
  
  memset(pr,'\0',sizeof(pr));
  sprintf(pr,"%s/%s",row[4],row[2]);

  sovm=atoi(row[3]);
  podr=atoi(row[5]);
  kateg=atoi(row[6]);
  strncpy(shet,row[7],sizeof(shet));
  zvan=atoi(row[8]);
  strncpy(lgoti,row[9],sizeof(lgoti));

  sum=sumn=sumu=0.;

  /*Читаем сальдо*/
  sal=0.;
  sum=sal=zarsald(1,mkont,gkont,tabb,&saldb);
  
  if(fabs(sal) > 0.009)
   {
    /*Проверяем был ли вход в карточку*/
    sprintf(strsql,"select tabn from Zarn where tabn=%d and god=%d and \
mes=%d",tabb,gkont,mkont);
    if(sql_readkey(&bd,strsql,&row1,&curr) != 1)
     {
      rsdat(&dn,&mn,&gn,row[10],2);
      rsdat(&dk,&mk,&gk,row[2],2);
      zapzarn(mkont,gkont,podr,tabb,kateg,sovm,zvan,shet,lgoti,dn,mn,gn,dk,mk,gk,0,row[11]);
     }

    if(rsdat(&d,&m,&g,row[2],2) == 0)
     {
      printw("%d %20.20s %s %d.%d.%d - %s %.2f\n",
      tabb,fio,gettext("Уволен"),d,m,g,
      gettext("не нулевое сальдо"),sal);

      fprintf(ff,"\n%d %s %s %d.%d.%d - %s %.2f\n",
      tabb,fio,gettext("Уволен"),d,m,g,
      gettext("не нулевое сальдо"),sal);
      continue;
     }
   }
  else
   {
    //Проверяем нет ли начислений или удержаний 
    sprintf(strsql,"select prn from Zarp where tabn=%d and datz >= '%04d-%2d-%2d' \
and datz <= '%04d-%2d-%2d' and suma <> 0.",tabb,gkont,mkont,1,gkont,mkont,31);
    if(readkey(strsql,&row1,&curr) == 0)
     {
      /*Проверяем был ли вход в карточку*/
      sprintf(strsql,"select tabn from Zarn where tabn=%d and god=%d and \
mes=%d",tabb,gkont,mkont);
      if(sql_readkey(&bd,strsql,&row1,&curr) != 1)
       {
        rsdat(&dn,&mn,&gn,row[10],2);
        rsdat(&dk,&mk,&gk,row[2],2);
        zapzarn(mkont,gkont,podr,tabb,kateg,sovm,zvan,shet,lgoti,dn,mn,gn,dk,mk,gk,0,row[11]);
       }
     }    
   }
   
  itsl+=sal;

  if(rsdat(&d,&m,&g,row[2],2) == 0)
    continue;

  snvr=0.;
  pens1=0.;
  sumnprov=sumuprov=0.;

  if((metk=zapmas(tabb,mkont,gkont)) == 0)
   {
    for(i=0;i<razm;i++)
     {
      if(zar.prnu[i] == 0)
        break;
      sum+=zar.sm[i];
      
      if(zar.prnu[i] == 1)
       {
        sumn+=zar.sm[i];
        //отнимается в findnahm
//        if(provkod(knvr,zar.knu[i]) >= 0)
//          snvr+=zar.sm[i];
        if(provkod(kodnvpen,zar.knu[i]) >= 0)
          snvr+=zar.sm[i];
       //Определяем нужно ли делать проводки
       sprintf(strsql,"select prov from Nash where kod=%d",zar.knu[i]);
       if(sql_readkey(&bd,strsql,&row1,&curr) == 1)
        if(atoi(row1[0]) == 0)
          sumnprov+=zar.sm[i];
       }
      if(zar.prnu[i] == 2)
       {
        sumu+=zar.sm[i];
       //Определяем нужно ли делать проводки
       
       sprintf(strsql,"select prov from Uder where kod=%d",zar.knu[i]);
//       printw("%s\n",strsql);
       if(sql_readkey(&bd,strsql,&row1,&curr) == 1)
        if(atoi(row1[0]) == 0)
          sumuprov+=zar.sm[i];
       }
     
      if(zar.prnu[i] == 2 && kodpen == zar.knu[i])   /*Удержания*/
      if(zar.mes[i] == mkont && zar.god[i] == gkont)
       {
        pens1+=zar.sm[i];
       }
     }
    itsn+=sumn;
    itsu+=sumu;
    if(sal+sumn+sumu < 0.)
      itdl+=sal+sumn+sumu;

    if(sravmydat(1,mkont,gkont,ICEB_DNDESV,ICEB_MNDESV,ICEB_GNDESV) < 0)
     {
      double suma_nfnz,suma_nfnz_b;
      nahh[0]=nah=findnahm(mkont,1,NULL,NULL,&s1,&s2,&suma_nfnz,&suma_nfnz_b,&suma_zarp_o,&suma_zarp_b,&suma_boln_rm); /*Поиск всех начислений*/
      nahh[0]-=snvr;
      nah-=snvr;

      nahh[1]=nah;
      nahh[2]=nah;
      nah=pens(tabb,mkont,gkont,nah,NULL)*-1;

      nahh[3]=nah;
      nah=okrug(nahh[3],okrg);
      nahh[4]=nah;
      if(fabs(nah - pens1) > 0.009)
       {
        /*
        printw("nah=%.2f - pens1=%.2f = %.2f\n",nah,pens1,nah-pens1);
        */
        printw("%4d %-*s %s\n",tabb,iceb_tu_kolbait(30,fio),fio,pr);
        
        printw("%s %.2f (%.2f/%.2f)\n",
        gettext("Отчисления на пенсию не верны"),nahh[0],nah,pens1);


        fprintf(ff,"\n%d %-*s %s\n",
        tabb,
        iceb_tu_kolbait(30,fio),fio,
        pr);
        fprintf(ff,"%s %.2f(%.2f/%.2f) %.2f %.2f %.2f %.2f %.2f %.4f\n",
        gettext("Отчисления на пенсию не верны"),nahh[0],
        nah,pens1,nahh[1],nahh[2],snvr,nahh[3],nahh[4],okrg);

        refresh();
        kol++;
       }
     }
    else
     {
      double esv_only_zar=0.;
      double esv_only_zarb=0.;
      double suma_esv_nah=0.;
      /*Делаем расчёт единого социального отчисления*/    
      double suma_esv_r=zaresv(tabb,mkont,gkont,podr,&esv_only_zar,&esv_only_zarb,1,0.,"",NULL);
   
      /*смотрим сколько его посчитано*/
      sprintf(strsql,"select suma from Zarp where datz >= '%04d-%02d-01' and datz <= '%04d-%02d-31' \
   and tabn=%d and prn='2' and (knah=%d or knah=%d or knah=%d or knah=%d)",gkont,mkont,gkont,mkont,tabb,
      kod_esv,
      kod_esv_bol,
      kod_esv_inv,
      kod_esv_dog);
      
      if((kolstr1=cur1.make_cursor(&bd,strsql)) < 0)
       {
        msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
        continue;
       }
      while(cur1.read_cursor(&row1) != 0)
       {
        suma_esv_nah+=atof(row1[0]);
       }     
      if(fabs(suma_esv_nah - suma_esv_r) > 0.009)
       {
        printw("%4d %-*s %s\n",tabb,iceb_tu_kolbait(30,fio),fio,pr);
        printw("%s %.2f != %.2f\n",gettext("Неправильно посчитан единий социальный взнос"),suma_esv_nah,suma_esv_r);
        fprintf(ff,"%4d %-*s %s\n",tabb,iceb_tu_kolbait(30,fio),fio,pr);
        fprintf(ff,"%s %.2f != %.2f\n",gettext("Неправильно посчитан единий социальный взнос"),suma_esv_nah,suma_esv_r);
        refresh();
        kol++;
       }
     }

   }

  if(metk == 1 || sum <=0. || sumn == 0. || sumu == 0.)
   {

    if(metk == 1)
     {
      printw("%s ",gettext("Нет записей."));
      fprintf(ff,"%s ",gettext("Нет записей."));
     }
    else
     {
      if(sumn == 0.)
       {
        printw("%s ",gettext("Нет начислений."));
        fprintf(ff,"%s ",gettext("Нет начислений."));
       }
      if(sumu == 0.)
       {
        printw("%s ",gettext("Нет удержаний."));
        fprintf(ff,"%s ",gettext("Нет удержаний."));
       }

      if(sumn != 0. && sumu != 0.)
       {
      if(fabs(sum) <= 0.0001 )
       {
        printw("%s ",gettext("Ноль."));
        fprintf(ff,"%s ",gettext("Ноль."));
       }
      else
       {
        printw("%s ",gettext("Долг."));
        fprintf(ff,"%s ",gettext("Долг."));
       }
      }
     }
    printw("%4d %-30s %s\n",tabb,fio,pr);
    fprintf(ff,"%4d %-30s %s\n",tabb,fio,pr);
    kol++;
    refresh();
   }

  /*Смотрим сумму выполненых проводок*/ 
  if(shrpz[0] != '\0')
   {
    sprintf(sss,"%d-%d",mkont,tabb);
    bb=sumprz(mkont,gkont,sss,0,&sumd,&sumk);
    if(fabs(sumd-sumnprov) > 0.009 || fabs(sumuprov*(-1)-sumk) > 0.009)
     {
      printw("%4d %-*s  %s (%f %f/%f %f)\n",
      tabb,iceb_tu_kolbait(30,fio),fio,gettext("Не выполнены все проводки !"),
      sumd,sumnprov,sumuprov*-1,sumk);
      fprintf(ff,"%4d %-*s  %s (%f %f/%f %f)\n",
      tabb,iceb_tu_kolbait(30,fio),fio,gettext("Не выполнены все проводки !"),
      sumd,sumnprov,sumuprov*-1,sumk);
     }      
   }

  /*Смотрим введен ли табель и проверяем его*/
  kolrd=kolkd=0;

  sprintf(strsql,"select dnei,kdnei from Ztab where god=%d and \
mes=%d and tabn=%d",gkont,mkont,tabb);
  if((kolstr1=cur1.make_cursor(&bd,strsql)) < 0)
   {
    msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
    continue;
   }

  if(kolstr1 == 0)
   {        
    printw("%s - %d %s %s %d.%d%s\n",
    gettext("Табель не введен"),tabb,fio,
    gettext("за"),mkont,gkont,
    gettext("г."));
    fprintf(ff,"%s - %d %s %s %d.%d%s\n",
    gettext("Табель не введен"),tabb,fio,
    gettext("за"),mkont,gkont,
    gettext("г."));
    goto vp;
   }

  while(cur1.read_cursor(&row1) != 0)
   {
    kolrd+=atoi(row1[0]);
    kolkd+=atoi(row1[1]);
   }  
  if(mkont == 1 || mkont == 3 || mkont == 5 || mkont == 7 || mkont == 8 || mkont == 10 || mkont == 12)
    kolkd1=31;
  else
    kolkd1=30;
  /*В месяц приёма\увольнения количество календарных дней другое*/  
  if(mp != mkont && mu != mkont) 
   {
    if(mkont == 2 )
     {
      if(kolkd > 29 || kolkd < 28)
       {
        printw("%s %d %s\n",
        gettext("Не верно введено количество календарных дней"),
        tabb,fio);
        fprintf(ff,"\n%d %s %s\n%s\n",
        tabb,fio,pr,
        gettext("Не верно введено количество календарных дней"));
       }
     }
    else
     if(kolkd != kolkd1)
      {
       printw("%s %d %s\n",
       gettext("Не верно введено количество календарных дней"),
       tabb,fio);
       fprintf(ff,"\n%d %s %s %d != %d %d %d\n%s\n",
       tabb,fio,pr,kolkd,kolkd1,mp,mu,
       gettext("Не верно введено количество календарных дней"));
      }
   }
  if(kolkd != 0 && kolrd > kolkd)
   {
     printw("%s %d %s\n",
     gettext("Количество рабочих дней больше количества календарных дней"),
     tabb,fio);
     fprintf(ff,"%s %d %s\n",
     gettext("Количество рабочих дней больше количества календарных дней"),
     tabb,fio);
   }
 vp:;

   /*Проверяем был ли вход в карточку*/
   sprintf(strsql,"select tabn from Zarn where tabn=%d and god=%d and \
mes=%d",tabb,gkont,mkont);
   if(sql_readkey(&bd,strsql,&row1,&curr) != 1)
    {
     printw("%s %d %s\n",
     gettext("Не было входа в карточку для"),tabb,fio);
     fprintf(ff,"%s %d %s\n",
     gettext("Не было входа в карточку для"),tabb,fio);
    }
  fprintf(f,"%-4d %-*s %10.2f %10.2f %10.2f %10.2f\n",
  tabb,iceb_tu_kolbait(40,fio),fio,sal,sumn,sumu,sal+sumn+sumu);

 }


fprintf(f,"\
------------------------------------------------------------------------------------------\n");
fprintf(f,"%-*s %10.2f %10.2f %10.2f %10.2f\n",
iceb_tu_kolbait(45,gettext("Итого")),gettext("Итого"),itsl,itsn,itsu,itsl+itsn+itsu-itdl);

fprintf(ff,"\
---------------------------------------------------------------\n\
%s %d\n",gettext("Количество работников"),kol);
printw("%s %d\n",gettext("Количество работников"),kol);
fclose(f);
fclose(ff);
printw("\n\
%s %15.2f\n\
%s %15.2f\n\
%s %15.2f\n\
%s %15.2f\n\
%s %15.2f\n",
gettext("Сальдо         :"),itsl,
gettext("Итого начислено:"),itsn,
gettext("Итого удержано :"),itsu,
gettext("Итого долгов   :"),itdl,
gettext("К выдаче       :"),itsl+itsn+itsu-itdl);


OSTANOV();

class spis_oth oth;
oth.spis_imaf.plus(imaf);
oth.spis_naim.plus(gettext("Контроль расчета зарплаты"));
oth.spis_imaf.plus(imaf1);
oth.spis_naim.plus(gettext("Свод начислений и удержаний"));

for(int nom=0; nom < oth.spis_imaf.kolih();nom++)
 iceb_t_ustpeh(oth.spis_imaf.ravno(nom),3);

iceb_t_rabfil(&oth,"");
}
