/* $Id: kredit.c,v 5.16 2011-01-13 13:43:22 sasa1 Exp $ */
/*29.11.2010    01.12.1992      Белых А.И.      kredit.c
Подпрограмма расчета удержаний за кредит
Переменные данные лежат в файле кредит
*/
#include        <errno.h>
#include        "buhg.h"
#ifdef	HAVE_UNISTD_H
#include        <unistd.h>
#endif
#include "zar11.h"

extern struct ZAR zar;

void kredit(long tn,short mp,short gp,int podr,const char *uder_only,FILE *ff_prot)
{
char            br[512];
int             ku=0;   /*Код начисления*/
double          nah=0.;
int             tnn=0;
short		d,m,g;
SQL_str         row;
char		strsql[512];
char		shet[32];
struct ZARP	zp;
SQL_str row_alx;
class SQLCURSOR cur_alx;
int kolstr=0;

if(ff_prot != NULL)
 fprintf(ff_prot,"\nРасчёт удержания по кредиту\n----------------------------------------------\n");

sprintf(strsql,"select str from Alx where fil='zarkredit.alx' order by ns asc");
if((kolstr=cur_alx.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return;
 }

if(kolstr == 0)
 {
  if(ff_prot != NULL)
   fprintf(ff_prot,"Не найдены настройки zarkredit.alx\n");
  return;
 }

while(cur_alx.read_cursor(&row_alx) != 0)
 {
  if(row_alx[0][0] == '#')
   continue;
   
  POLE(row_alx[0],br,2,'|');
  ku=(int)ATOFM(br);
  if(ku == 0)
     continue;


  polen(row_alx[0],br,sizeof(br),1,'|');
  tnn=atoi(br);
  if(tnn == tn)
   {
    if(proverka(uder_only,ku,0,0) != 0)
     {
      if(ff_prot != NULL)
       fprintf(ff_prot,"Код %d исключён из расчёта\n",ku);
      return;
     }
    polen(row_alx[0],br,sizeof(br),4,'|');
    d=0;
    rsdat(&d,&m,&g,br,1);
    if(d != 0 && mp > m && gp >= g)
     {
      if(ff_prot != NULL)
       fprintf(ff_prot,"Закончисля срок действия. Расчёт не производим.\n");
      break;
     }
    polen(row_alx[0],br,sizeof(br),3,'|');
    if(strchr(br,'%') != NULL)
     {
      double procent=ATOFM(br);
      if(ff_prot != NULL)
       fprintf(ff_prot,"Процент от суммы начисленной %f\n",procent);
      //Узнаём всю сумму начиления
      for(int ii=0 ; ii < razm; ii++)
       {
        if(zar.denz[ii] == 0)
         break;

        if(zar.prnu[ii] == 1)
          nah+=zar.sm[ii];
       }
      if(ff_prot != NULL)
       fprintf(ff_prot,"Сумма всех начислений:%.2f\n",nah);
       
      nah=nah*procent/100.;
      nah=okrug(nah,0.01);
     }
    else
     {
      if(ff_prot != NULL)
       fprintf(ff_prot,"Стабильная сумма\n");
      nah=(double)ATOFM(br);
      
     }
    break;
   }
 }

if(tn != tnn)
 {
   if(ff_prot != NULL)
    fprintf(ff_prot,"Нет настроек для удержания\n");
  return;
 }

/*printw("tn=%ld tnn=%ld nah=%.2f ku=%d\n",tn,tnn,nah,ku);*/
if(nah == 0.)
 {
  if(ff_prot != NULL)
    fprintf(ff_prot,"Начисленная сумма равна нолю.\n");
   
  return;
 }

if(ff_prot != NULL)
 fprintf(ff_prot,"Код удержания %d. Сумма удержания %.2f\n",ku,nah);
 
SQLCURSOR curr;
/*Проверяем есть ли код начисления в списке*/
sprintf(strsql,"select shet from Zarn1 where tabn=%ld and prn='2' and \
knah=%d",tn,ku); 
if(sql_readkey(&bd,strsql,&row,&curr) != 1)
 {
  if(ff_prot != NULL)
   fprintf(ff_prot,"Не введён код удержания %d в список удержаний !\n",ku);
  return;
 }
strncpy(shet,row[0],sizeof(shet)-1);

nah=nah*(-1);

dpm(&d,&mp,&gp,5);
memset(br,'\0',sizeof(br));
zp.dz=d;
zp.mesn=mp; zp.godn=gp;
zp.nomz=0;
zp.podr=podr;
strcpy(zp.shet,shet);
zapzarp(d,mp,gp,tn,2,ku,nah,shet,mp,gp,0,0,br,podr,"",zp); 
}
