/* $Id: matspo.c,v 5.8 2011-01-13 13:43:22 sasa1 Exp $ */
/*04.11.2007    03.06.1997      Белых А.И.      matspo.c
Соэдание массива операций - материалов
*/
#include        <math.h>
#include	"buhg.h"


char            *spoprp;/*Массив с перечнем операций приходов*/
char            *spoprr;/*Массив с перечнем операций расходов*/
int             *mko;  /*Массив кодов материалов*/
double          *mkm1p; /*Массив количества материалла для прихода*/
double          *mkm2p; /*Массив веса материалла для прихода*/
double          *mkm3p; /*Массив цены материалла для прихода*/
double          *mkm1r; /*Массив количества материалла для расхода*/
double          *mkm2r; /*Массив веса материалла для расхода*/
double          *mkm3r; /*Массив цены материалла для расхода*/

double          *mko1r; /*Массив количества отхода материалла для расхода*/
double          *mko2r; /*Массив веса отхода материалла для расхода*/
double          *mko3r; /*Массив цены отхода материалла для расхода*/

int             *mkg;  /*Массив кодов групп материалов*/
double          *mkg1p; /*Массив количества материалла по группе для прихода*/
double          *mkg2p; /*Массив веса материалла по группе для прихода*/
double          *mkg3p; /*Массив цены материалла по группе для прихода*/
double          *mkg1r; /*Массив количества материалла по группе для прихода*/
double          *mkg2r; /*Массив веса материалла по группе для прихода*/
double          *mkg3r; /*Массив цены материалла по группе*/

int             matspo(int *k1,/*Количество операций приходов*/
int *k2, /*Количество операций расходов*/
int *k3, /*Количество материалов*/
int *k4) /*Количество групп материалов*/
{
short           kolopp;  /*Количество операций приходов*/
short           kolopr;  /*Количество операций расходов*/
short           kolmat; /*Количество материалов*/
short           kolgru; /*Количество групп материалов*/
short           dlmp;    /*Длинна маасива приходов*/
short           dlmr;    /*Длинна маасива расходов*/
short           dln;
long		kolstr;
SQL_str         row;
char		strsql[512];

sprintf(strsql,"select kodm from Material");
SQLCURSOR cur;
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  printw("%s\n",sql_error(&bd));
  OSTANOV();
 }

if(kolstr == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);
 }


kolmat=0;

while(cur.read_cursor(&row) != 0)
 {
/*
printw("%d %s %s %s\n",mt3.mzz,mt3.kodm,mt3.kgrm,mt3.naim);
  */
  kolmat++;
  if(kolmat == 1)
   {
    if((mko=(int*)malloc(kolmat*sizeof(int))) == NULL)
     { 
      error2(20,0,1,"Не могу выделить память для mko!!!");
      return(1);
     }
    mko[0]=atoi(row[0]);
   }
  else
   {
    if((mko=(int *)realloc(mko,kolmat*sizeof(int))) == NULL)
     { 
      error2(20,0,1,"Не могу добавить память для mko !!!");
      return(1);
     }
    mko[kolmat-1]=atoi(row[0]);
   }

 }


printw(gettext("Количество кодов материалов - %d\n"),kolmat);
refresh();
/*
for(i=0; i<kolmat ;i++)
  printw("%d\n",mko[i]);
OSTANOV();
  */

/*Читаем список приходов*/

sprintf(strsql,"select kod from Prihod");

if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  printw("%s\n",sql_error(&bd));
  OSTANOV();
 }

if(kolstr == 0)
 {
   error2(20,0,1,gettext("matspo Нет записей приходов !"));
   return(1);
 }

dlmp=dlmr=kolopp=kolopr=kolgru=0;
while(cur.read_cursor(&row) != 0)
 {
  kolopp++;
  if(kolopp == 1)
   {
    dln=strlen(row[0])+2;
    dlmp+=dln;
    if((spoprp=(char *)malloc(dlmp*sizeof(char))) == NULL)
     { 
      error2(20,0,1,"Не могу выделить память для spoprp !!!");
      return(1);
     }
    strcpy(spoprp,row[0]);
    strcat(spoprp,"#");
   }

  if(kolopp > 1)
   {
    dln=strlen(row[0])+2;
    dlmp+=dln;
    if((spoprp=(char *)realloc(spoprp,dlmp*sizeof(char))) == NULL)
     { 
      error2(20,0,1,"Не могу добавить память для spoprp !!!");

      return(1);
     }
    strcat(spoprp,row[0]);
    strcat(spoprp,"#");
   }

 }

/*Читаем список расходов*/
sprintf(strsql,"select kod from Rashod");

if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  printw("%s\n",sql_error(&bd));
  OSTANOV();
 }

if(kolstr == 0)
 {
   error2(20,0,1,gettext("matspo Нет записей расходов !"));
   return(1);
 }

while(cur.read_cursor(&row) != 0)
 {
  kolopr++;
  if(kolopr == 1)
   {
    dln=strlen(row[0])+2;
    dlmr+=dln;
    if((spoprr=(char *)malloc(dlmr*sizeof(char))) == NULL)
     { 
      error2(20,0,1,"Не могу выделить память для spoprr !!!");
      return(1);
     }
    strcpy(spoprr,row[0]);
    strcat(spoprr,"#");
   }
  if(kolopr > 1)
   {
    dln=strlen(row[0])+2;
    dlmr+=dln;
    if((spoprr=(char *)realloc(spoprr,dlmr*sizeof(char))) == NULL)
     { 
      error2(20,0,1,"Не могу добавить память для spoprr !!!");
      return(1);
     }
    strcat(spoprr,row[0]);
    strcat(spoprr,"#");
   }

 }

/*Читаем список групп*/

sprintf(strsql,"select kod from Grup");

if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  printw("%s\n",sql_error(&bd));
  OSTANOV();
 }

if(kolstr == 0)
 {
   error2(20,0,1,gettext("matspo Нет записей групп !"));
   return(1);
 }
kolgru=0;
while(cur.read_cursor(&row) != 0)
 {
  kolgru++;
  if(kolgru == 1)
   {
    if((mkg=(int*)malloc(kolgru*sizeof(int))) == NULL)
     { 
      error2(20,0,1,"Не могу выделить память для mkg!!!");
      return(1);
     }
    mkg[0]=atoi(row[0]);
   }
  if(kolgru > 1)
   {
    if((mkg=(int *)realloc(mkg,kolgru*sizeof(int))) == NULL)
     { 
      error2(20,0,1,"Не могу добавить память для mkg !!!");
      return(1);
     }
    mkg[kolgru-1]=atoi(row[0]);
   }

 }

/*
for(i=0; i<kolgru ;i++)
  printw(" %d",mkg[i]);
printw("\n");
OSTANOV();
*/  

printw(gettext("Количество операций приходов - %d\n"),kolopp);
printw(gettext("Количество операций расходов - %d\n"),kolopr);
printw(gettext("Количество кодов групп материалов - %d\n"),kolgru);
refresh();

/*Маcсивы приходов для материалов*/
if((mkm1p=(double *)calloc(kolopp*kolmat,sizeof(double))) == NULL)
 {
  error2(20,0,1,"Не могу открыть массив mkm1p !!!");
  return(1);
 }
if((mkm2p=(double *)calloc(kolopp*kolmat,sizeof(double))) == NULL)
 {
  error2(20,0,1,"Не могу открыть массив mkm2p !!!");
  return(1);
 }
if((mkm3p=(double *)calloc(kolopp*kolmat,sizeof(double))) == NULL)
 {
  error2(20,0,1,"Не могу открыть массив mkm3p !!!");
  return(1);
 }
/*Маcсивы расходов для материалов*/
if((mkm1r=(double *)calloc(kolopr*kolmat,sizeof(double))) == NULL)
 {
  error2(20,0,1,"Не могу открыть массив mkm1r !!!");
  return(1);
 }
if((mkm2r=(double *)calloc(kolopr*kolmat,sizeof(double))) == NULL)
 {
  error2(20,0,1,"Не могу открыть массив mkm2r !!!");
  return(1);
 }
if((mkm3r=(double *)calloc(kolopr*kolmat,sizeof(double))) == NULL)
 {
  error2(20,0,1,"Не могу открыть массив mkm3r !!!");
  return(1);
 }


/*Маcсивы приходов для групп материалов*/
if((mkg1p=(double *)calloc(kolopp*kolgru,sizeof(double))) == NULL)
 {
  error2(20,0,1,"Не могу открыть массив mkg1p !!!");
  return(1);
 }
if((mkg2p=(double *)calloc(kolopp*kolgru,sizeof(double))) == NULL)
 {
  error2(20,0,1,"Не могу открыть массив mkg2p !!!");
  return(1);
 }
if((mkg3p=(double *)calloc(kolopp*kolgru,sizeof(double))) == NULL)
 {
  error2(20,0,1,"Не могу открыть массив mkg3p !!!");
  return(1);
 }
/*Маcсивы расходов для групп материалов*/
if((mkg1r=(double *)calloc(kolopr*kolgru,sizeof(double))) == NULL)
 {
  error2(20,0,1,"Не могу открыть массив mkg1r !!!");
  return(1);
 }
if((mkg2r=(double *)calloc(kolopr*kolgru,sizeof(double))) == NULL)
 {
  error2(20,0,1,"Не могу открыть массив mkg2r !!!");
  return(1);
 }
if((mkg3r=(double *)calloc(kolopr*kolgru,sizeof(double))) == NULL)
 {
  error2(20,0,1,"Не могу открыть массив mkg3r !!!");
  return(1);
 }

/*Маcсивы расходов для отхода по материаллам*/
if((mko1r=(double *)calloc(kolopr*kolmat,sizeof(double))) == NULL)
 {
  error2(20,0,1,"Не могу открыть массив mko1r !!!");
  return(1);
 }
if((mko2r=(double *)calloc(kolopr*kolmat,sizeof(double))) == NULL)
 {
  error2(20,0,1,"Не могу открыть массив mko2r !!!");
  return(1);
 }
if((mko3r=(double *)calloc(kolopr*kolmat,sizeof(double))) == NULL)
 {
  error2(20,0,1,"Не могу открыть массив mko3r !!!");
  return(1);
 }

*k1=kolopp;
*k2=kolopr;
*k3=kolmat;
*k4=kolgru;
return(0);
}
