/* $Id: matstatr.c,v 5.13 2011-01-13 13:43:22 sasa1 Exp $ */
/*10.12.2004	17.03.1998	Белых А.И. matstatr.c
Распечатка массива для графического отображение динамики реализации
товаров за любой период времени
*/
             
#include        <errno.h>
#include        <time.h>
#include        "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

extern double		*mkdp; /*Массив динамики приходов*/
extern double		*mkdr; /*Массив динамики расходов*/
extern char     *organ;

short		matstatr(VVOD *VV,
short dn,short mn,short gn,short dk,short mk,
short gk,char imaf[])
{
struct  tm      *bf;
time_t		tmm;
FILE		*ff;
unsigned short  i,i1,i2;
double		big;
short		d,m,g;
double		itogo;
int		klst=0;

time(&tmm);
bf=localtime(&tmm);

sprintf(imaf,"gr%d.lst",getpid());
if((ff = fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return(0);
 }

fprintf(ff,"%s\n\n\
%s %d.%d.%d%s %s %d.%d.%d%s\n\
%s %d.%d.%d%s %s - %d:%d\n",
organ,
gettext("Движение товарно-материалных ценностей за период с"),
dn,mn,gn,
gettext("г."),
gettext("до"),
dk,mk,gk,
gettext("г."),
gettext("По состоянию на"),
bf->tm_mday,bf->tm_mon+1,bf->tm_year+1900,
gettext("г."),
gettext("Время"),
bf->tm_hour,bf->tm_min);


if(VV->VVOD_SPISOK_return_data(2)[0] != '\0')
  fprintf(ff,gettext("Склад - %s\n"),VV->VVOD_SPISOK_return_data(2));
if(VV->VVOD_SPISOK_return_data(4)[0] != '\0')
  fprintf(ff,"%s - %s\n",gettext("Код операции"),VV->VVOD_SPISOK_return_data(4));
if(VV->VVOD_SPISOK_return_data(5)[0] != '\0')
  fprintf(ff,gettext("Материал - %s\n"),VV->VVOD_SPISOK_return_data(5));
if(VV->VVOD_SPISOK_return_data(6)[0] != '\0')
  fprintf(ff,gettext("Отпускная цена - %s\n"),VV->VVOD_SPISOK_return_data(6));
if(VV->VVOD_SPISOK_return_data(7)[0] != '\0')
  fprintf(ff,gettext("Код контрагента - %s\n"),VV->VVOD_SPISOK_return_data(7));
if(VV->VVOD_SPISOK_return_data(8)[0] != '\0')
  fprintf(ff,gettext("Группа - %s\n"),VV->VVOD_SPISOK_return_data(8));
if(VV->VVOD_SPISOK_return_data(9)[0] != '\0')
  fprintf(ff,gettext("Набор операций - %s\n"),VV->VVOD_SPISOK_return_data(9));
if(VV->VVOD_SPISOK_return_data(10)[0] != '\0')
  fprintf(ff,gettext("Счета - %s\n"),VV->VVOD_SPISOK_return_data(10));
if(VV->VVOD_SPISOK_return_data(11)[0] != '\0')
 {
  fprintf(ff,"%s:\n",gettext("Группы контрагентов"));
  printcod(ff,"Gkont","kod","naik",0,VV->VVOD_SPISOK_return_data(11),&klst);
 }

/*Определяем наибольшее значение*/
/*
printw("Період %d.%d.%d > %d %d %d Днів=%f/%f\n",
dn,mn,gn,dk,mk,gk,mkdp[0],mkdr[0]);
*/
big=0.;
for(i=1;i<mkdp[0];i++)
 if(mkdp[i] > big)
  big=mkdp[i];
/*printw("Прибутки=%f\n",big);*/
d=dn;
m=mn;
g=gn;  
itogo=0.;
if(big != 0.)
 {
  fprintf(ff,"%s\n",gettext("Приходы."));
  fprintf(ff,"\
---------------------------------------------------------------------------------------------------------------------------\n");
  fprintf(ff,gettext("   Дата   |Количество|\n"));
  fprintf(ff,"\
---------------------------------------------------------------------------------------------------------------------------\n");
  for(i=31*(mn-1)+dn; i<mkdp[0] ; i++)
   {
    if(g == gk && m == mk && d > dk)
     break;

    if(d > 31)
     {
      d=1; m++;
     }
    if(m > 12)
     {
      m=1;
      g++;
     }  

    i1=0;
    if(mkdp[i] != 0.)
      i1=(int)(mkdp[i]*100./big);
 
    fprintf(ff,"%02d.%02d.%d|%10.2f|",d,m,g,mkdp[i]);
    for(i2=0; i2<i1 ; i2++)
      fprintf(ff,"*");
    fprintf(ff,"\n");
    
    itogo+=mkdp[i];

    d++;
  
   }
 }
if(itogo > 0.)
 fprintf(ff,"%*s: %10.2f\n\n",iceb_tu_kolbait(9,gettext("Итого")),gettext("Итого"),itogo);

big=0.;
for(i=1;i<mkdr[0];i++)
 if(mkdr[i] > big)
  big=mkdr[i];
/*printw("Відатки=%f\n",big);*/

d=dn;
m=mn;
g=gn;  

itogo=0.;

if(big != 0.)
 {
  fprintf(ff,"%s\n",gettext("Расходы."));
  fprintf(ff,"\
---------------------------------------------------------------------------------------------------------------------------\n");
  fprintf(ff,gettext("   Дата   |Количество|\n"));
  fprintf(ff,"\
---------------------------------------------------------------------------------------------------------------------------\n");

  for(i=31*(mn-1)+dn; i<mkdr[0] ; i++)
   {
    if(g == gk && m == mk && d > dk)
     break;

    if(d > 31)
     {
      d=1; m++;
     }
    if(m > 12)
     {
      m=1;
      g++;
     }  
 

    i1=0;
    if(mkdr[i] != 0.)
      i1=(int)(mkdr[i]*100./big);
 
    fprintf(ff,"%02d.%02d.%d|%10.2f|",d,m,g,mkdr[i]);
    for(i2=0; i2<i1 ; i2++)
      fprintf(ff,"*");
    fprintf(ff,"\n");
    itogo+=mkdr[i];  
    d++;
  
   }
 }
if(itogo > 0.)
  fprintf(ff,"%*s: %10.2f\n\n",iceb_tu_kolbait(9,gettext("Итого")),gettext("Итого"),itogo);

podpis(ff);


fclose(ff);
free(mkdp);
free(mkdr);
return(0);
}
