/*$Id: mu_shet_fak.c,v 5.8 2011-01-13 13:43:22 sasa1 Exp $*/
/*29.11.2009	21.12.2005	Белых А.И.	mu_shet_fak.c
Распечатка счёта-фактуры для материального учёта
*/
#include        <errno.h>
#include	"buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif


extern double	okrcn;  /*Округление цены*/
extern double   okrg1; /*Округление*/
extern short	vtara; /*Код группы возвратная тара*/

void mu_shet_fak(short dd,short md,short gd, //Дата документа
int sklad, //склад
const char *nomdok, //Номер документа
char *imafil, //имя файла с распечаткой
int tipz)  //1-приход 2-расход
{
char            nmo[512],nmo1[512];  /*Наименование организации*/
char            gor[512],gor1[512]; /*Адрес*/
char            pkod[32],pkod1[32]; //Код ЕДРПУО
char            nmb[512],nmb1[512];  /*Наименование банка*/
char            mfo[32],mfo1[32];  /*МФО*/
char            nsh[30],nsh1[32];  /*Номер счета*/
char		strsql[1024];
SQL_str row;
SQLCURSOR cur;
int		kolstr;
char		kodop[32];
char		kontr[32];
char		datop[16];
double sumkor=0.;
char		osnov[512];
char		kodkontr00[32];
char bros[512];
short lnds=0; //Льготы по НДС
char dover[512];
char sherez[512];
short		mvnpp=0;
float pnds=0.;

/*Читаем шапку документа*/
sprintf(strsql,"select * from Dokummat \
where datd='%04d-%02d-%02d' and sklad=%d and nomd='%s' and tip=%d",
gd,md,dd,sklad,nomdok,tipz);

if(sql_readkey(&bd,strsql,&row,&cur) != 1)
 {
  VVOD SOOB(1);

  SOOB.VVOD_SPISOK_add_MD(gettext("Не найден документ !"));

  sprintf(strsql,gettext("Дата=%d.%d.%d Документ=%s Склад=%d"),
  dd,md,gd,nomdok,sklad);
  SOOB.VVOD_SPISOK_add_MD(strsql);

  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return;
 }

pnds=atof(row[13]);
strncpy(kontr,row[3],sizeof(kontr)-1);
strncpy(kodop,row[6],sizeof(kodop)-1);

//Читаем сумму корректировки
sprintf(strsql,"select sodz from Dokummat2 where god=%d and sklad=%d and nomd='%s' and nomerz=13",
gd,sklad,nomdok);

if(readkey(strsql,&row,&cur) == 1)
 sumkor=atof(row[0]);

//читаем дату оплаты
memset(datop,'\0',sizeof(datop));

sprintf(strsql,"select sodz from Dokummat2 where god=%d and sklad=%d and nomd='%s' and nomerz=9",
gd,sklad,nomdok);

if(readkey(strsql,&row,&cur) == 1)
  strncpy(datop,row[0],sizeof(datop)-1);

//читаем онование

memset(osnov,'\0',sizeof(osnov));

sprintf(strsql,"select sodz from Dokummat2 where god=%d and sklad=%d and nomd='%s' and nomerz=3",
gd,sklad,nomdok);

if(readkey(strsql,&row,&cur) == 1)
  strncpy(osnov,row[0],sizeof(osnov)-1);


sprintf(strsql,"select sodz from Dokummat2 where god=%d and sklad=%d and nomd='%s' and nomerz=11",
gd,sklad,nomdok);

if(readkey(strsql,&row,&cur) == 1)
 lnds=atoi(row[0]);


sprintf(strsql,"select sodz from Dokummat2 where god=%d and sklad=%d and nomd='%s' and nomerz=1",
gd,sklad,nomdok);

if(readkey(strsql,&row,&cur) == 1)
 {
  polen(row[0],dover,sizeof(dover),1,'#');
 }

sprintf(strsql,"select sodz from Dokummat2 where god=%d and sklad=%d and nomd='%s' and nomerz=2",
gd,sklad,nomdok);

if(readkey(strsql,&row,&cur) == 1)
 strncpy(sherez,row[0],sizeof(sherez)-1);

if(tipz == 1)
 sprintf(strsql,"select vido from Prihod where kod='%s'",kodop);

if(tipz == 2)
 sprintf(strsql,"select vido from Rashod where kod='%s'",kodop);

if(sql_readkey(&bd,strsql,&row,&cur) != 1)
 {
  VVOD SOOB(1);

  sprintf(strsql,gettext("Не найден код операции %s !"),kodop);
  SOOB.VVOD_SPISOK_add_MD(strsql);

  soobshw(&SOOB,stdscr,-1,-1,0,1);
 }
else
 {
  mvnpp=atoi(row[0]);
 }

strcpy(kodkontr00,"00");
if(tipz == 2)
 {
  if(iceb_t_poldan(kodop,bros,"matnast.alx") == 0)
   {
    memset(kodkontr00,'\0',sizeof(kodkontr00));
    strncpy(kodkontr00,bros,sizeof(kodkontr00)-1);
   }
 }
/*Читаем реквизиты организации свои */

memset(nmo,'\0',sizeof(nmo));
memset(gor,'\0',sizeof(gor));
memset(pkod,'\0',sizeof(pkod));
memset(nmb,'\0',sizeof(nmb));
memset(mfo,'\0',sizeof(mfo));
memset(nsh,'\0',sizeof(nsh));

sprintf(bros,"select * from Kontragent where kodkon='%s'",kodkontr00);
if(sql_readkey(&bd,bros,&row,&cur) != 1)
 {
  VVOD SOOB(1);
  sprintf(strsql,"%s %s !",
  gettext("Не найден код контрагента"),kodkontr00);
  SOOB.VVOD_SPISOK_add_MD(strsql);
  soobshw(&SOOB,stdscr,-1,-1,0,1);
 }
else
 {
  strncpy(nmo,row[1],sizeof(nmo)-1);
  strncpy(gor,row[3],sizeof(gor)-1);
  strncpy(pkod,row[5],sizeof(pkod)-1);
  strncpy(nmb,row[2],sizeof(nmb)-1);
  strncpy(mfo,row[6],sizeof(mfo)-1);
  strncpy(nsh,row[7],sizeof(nsh)-1);
 } 


memset(nmo1,'\0',sizeof(nmo1));
memset(gor1,'\0',sizeof(gor1));
memset(pkod1,'\0',sizeof(pkod1));
memset(nmb1,'\0',sizeof(nmb1));
memset(mfo1,'\0',sizeof(mfo1));
memset(nsh1,'\0',sizeof(nsh1));

/*Читаем реквизиты организации чужие*/
/*При внутреннем перемещении не читать*/
if(ATOFM(kontr) != 0. || kontr[0] != '0')
 {

  sprintf(bros,"select * from Kontragent where kodkon='%s'",kontr);
  if(sql_readkey(&bd,bros,&row,&cur) != 1)
   {
    VVOD SOOB(1);
    sprintf(strsql,"%s %s !",
    gettext("Не найден код контрагента"),kontr);
    SOOB.VVOD_SPISOK_add_MD(strsql);
    soobshw(&SOOB,stdscr,-1,-1,0,1);
   }
  else
   {
    if(row[16][0] == '\0')
      strncpy(nmo1,row[1],sizeof(nmo1)-1);
    else
      strncpy(nmo1,row[16],sizeof(nmo1)-1);
    strncpy(gor1,row[3],sizeof(gor1)-1);
    strncpy(pkod1,row[5],sizeof(pkod1)-1);
    strncpy(nmb1,row[2],sizeof(nmb1)-1);
    strncpy(mfo1,row[6],sizeof(mfo1)-1);
    strncpy(nsh1,row[7],sizeof(nsh1)-1);
    
   }
 }
sprintf(strsql,"select * from Dokummat1 where datd='%04d-%02d-%02d' and \
sklad=%d and nomd='%s' order by kodm asc",
gd,md,dd,sklad,nomdok);
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return;
 }
sprintf(imafil,"mshfk%d.lst",getpid());
FILE *ff;

if((ff = fopen(imafil,"w")) == NULL)
 {
  error_op_nfil(imafil,errno,"");
  return;
 }
startfil(ff);


fprintf(ff,"\x1b\x6C%c",10); /*Установка левого поля*/

if(tipz == 1)
if(shet_fak_sap(dd,md,gd,nomdok,nsh1,mfo1,pkod1,nmo,dover,sherez,ff) != 0)
 {
  fclose(ff);
  unlink(imafil);
  return;
 }

if(tipz == 2)
if(shet_fak_sap(dd,md,gd,nomdok,nsh,mfo,pkod,nmo1,dover,sherez,ff) != 0)
 {
  fclose(ff);
  unlink(imafil);
  return;
 }


SQLCURSOR cur1;
SQL_str row1;
int kodzap;
double kolih;
double cena;
double cenasnd;
double itogo=0.;
double suma;
char naim[512];
int nom_str=0;
int mnt=0;
while(cur.read_cursor(&row) != 0)
 {
  /*Читаем наименование материалла*/
  memset(naim,'\0',sizeof(naim));
  sprintf(strsql,"select naimat,kodgr from Material where kodm=%s",row[4]);

  if(sql_readkey(&bd,strsql,&row1,&cur1) != 1)
   {
    VVOD SOOB(1);

    sprintf(strsql,"%s %s !",gettext("Не найден код материалла"),row[4]);
    SOOB.VVOD_SPISOK_add_MD(strsql);

    soobshw(&SOOB,stdscr,-1,-1,0,1);
   }
  else
   {
    strncpy(naim,row1[0],sizeof(naim)-1);
    if(row[16][0] != '\0')
     {
      strcat(naim," ");
      strcat(naim,row[16]);
     }
   }

  int kgrm=atoi(row1[1]);
  int vtr=atoi(row[8]);

  if(vtr != 0. || (vtara != 0 && kgrm == vtara))
   {
    mnt++;
    continue;
   }

  kodzap=atoi(row[4]);
  kolih=atof(row[5]);
  cena=atof(row[6]);
  cena=okrug(cena,okrcn);
  suma=cena*kolih;
  suma=okrug(suma,okrg1);
  itogo+=suma;
  cenasnd=cena+cena*pnds/100.;
  cenasnd=okrug(cenasnd,okrg1);

  fprintf(ff," %3d %-*.*s %6.6g %-*.*s %8.8g %10.2f\n",
  ++nom_str,
  iceb_tu_kolbait(30,naim),iceb_tu_kolbait(30,naim),naim,
  kolih,
  iceb_tu_kolbait(6,row[4]),iceb_tu_kolbait(6,row[4]),row[4],
  cena,suma);

  printw(" %3d %-*.*s %6.6g %-*.*s %8.8g %10.2f\n",
  nom_str,
  iceb_tu_kolbait(30,naim),iceb_tu_kolbait(30,naim),naim,
  kolih,
  iceb_tu_kolbait(6,row[4]),iceb_tu_kolbait(6,row[4]),row[4],
  cena,suma);

  if(iceb_tu_strlen(naim) > 30)
     fprintf(ff,"%3s %s\n"," ",iceb_tu_adrsimv(30,naim));


 }

fprintf(ff,"\
---------------------------------------------------------------------\n");
int dlina=58;
fprintf(ff,"%*s:%10.2f\n",iceb_tu_kolbait(dlina,gettext("Итого")),gettext("Итого"),itogo);

double itogo1=0.;
if(mvnpp == 0) /*Внешнее перемещение*/
  itogo1=dok_end_mu(tipz,dd,md,gd,nomdok,sklad,dlina-1,itogo,pnds,lnds,mnt,3,ff);

shet_fak_end(ff); //распечатка концовки документа

fclose(ff);
 
}
