/* $Id: pens.c,v 5.16 2011-04-14 16:07:34 sasa Exp $ */
/*12.04.2011	02.08.2000	Белых А.И.	pens.c
Расчет отчисления в пенсионный фонд
*/
#include <errno.h>
#include        <stdio.h>
#include        <math.h>
#include "buhg.h"
#ifdef	HAVE_UNISTD_H
#include        <unistd.h>
#endif

float pens_pp(int tabn,short mes,short god,FILE *ff);

extern short    kodpen;  /*Код пенсионных отчислений*/
extern float    procpen[2]; /*Процент отчисления в пенсионный фонд*/
extern double   ogrzp[2]; /*Ограничение на начисление пенсионного отчисления*/
//extern float  max_sum_for_soc; //Максимальная сумма с которой начисляются соц.отчисления
//extern float  prog_min_tek; //Прожиточный минимум текущий

double pens(int tabn,short mes,short god,double suma,FILE *ff)
{
double		bbpr,suma_pens_oth;

class zar_read_tn1h nastr;
zar_read_tn1(1,mes,god,&nastr,ff);

suma_pens_oth=0.;
float proc_per=0.;
if((proc_per=pens_pp(tabn,mes,god,ff)) != 0.)
 {
  double suma_vr=suma;
  if(suma_vr > nastr.max_sum_for_soc)
   {
    suma_vr=nastr.max_sum_for_soc;
    if(ff != NULL)
     fprintf(ff,"Сумма с которой нужно начислять %.2f больше максимальной суммы с которой можно начислять налог %.2f.\n\
Берём в расчёт %.2f\n",suma,nastr.max_sum_for_soc,suma_vr);     
   }  

  suma_pens_oth=suma_vr*proc_per/100.;
    
  if(ff != NULL)
   fprintf(ff,"Персональная сумма пенсионного отчисления %.2f*%.2f/100.=%.2f\n",suma_vr,proc_per,suma_pens_oth);
  return(suma_pens_oth);
 }

if(procpen[0] == procpen[1])
 {

  if(suma <= nastr.max_sum_for_soc)
   {
    suma_pens_oth=suma*procpen[0]/100.;
    if(ff != NULL)
     fprintf(ff,"%.2f*%.2f/100.=%.2f\n",suma,procpen[0],suma_pens_oth);
   }
  else
   {
    suma_pens_oth=nastr.max_sum_for_soc*procpen[0]/100.;
    if(ff != NULL)
     fprintf(ff,"Превышение %.2f\n%.2f*%.2f/100.=%.2f",
     nastr.max_sum_for_soc,nastr.max_sum_for_soc,procpen[0],suma_pens_oth);
  }

  return(suma_pens_oth);

 }

if(fabs(suma) <= nastr.prog_min_tek)
 {

  bbpr=0.;
  if(procpen[0] != 0.)
    bbpr=procpen[0]/100.;
  suma_pens_oth=suma*bbpr;
  
  if(ff != NULL)
   fprintf(ff,"%s %.2f-%.2f%% %s %.2f %s %.2f\n",
  gettext("Пенсионные"),suma_pens_oth,procpen[0],
  gettext("Сумма"),suma,
  gettext("Ограничение"),nastr.prog_min_tek);
 }
else
 {
    double suma1=nastr.prog_min_tek*procpen[0]/100.;

    double suma2=0.;
    
    if(suma <= nastr.max_sum_for_soc)
       suma2=(suma-nastr.prog_min_tek)*procpen[1]/100.;
    else
     {
      if(ff != NULL)
       fprintf(ff,"Превышение %.2f\n",nastr.max_sum_for_soc);
       suma2=(nastr.max_sum_for_soc-nastr.prog_min_tek)*procpen[1]/100.;
     }
    suma_pens_oth=suma1+suma2;
    if(ff != NULL)
     {
      fprintf(ff,"%.2f*%.2f/100=%.2f\n",nastr.prog_min_tek,procpen[0],suma1);
      if(suma <= nastr.max_sum_for_soc)
        fprintf(ff,"(%.2f-%.2f)*%.2f/100=%.2f\n",suma,nastr.prog_min_tek,procpen[1],suma2);
      else      
        fprintf(ff,"(%.2f-%.2f)*%.2f/100=%.2f\n",nastr.max_sum_for_soc,nastr.prog_min_tek,procpen[1],suma2);
      fprintf(ff,"%.2f+%.2f=%.2f\n",suma1,suma2,suma_pens_oth);
     }    
 }

return(suma_pens_oth);
}

/**********************/
/*смотрим файл с персоналными процентами отчисления в пенсионный фонд*/
/***********************************************************************/
float pens_pp(int tabn,short mes,short god,FILE *ff)
{
SQL_str row_alx;
class SQLCURSOR cur_alx;
int kolstr=0;
char strsql[512];
if(ff != NULL)
 fprintf(ff,"Проверяем список персональных процентов отчисления в пенсионный фонд.\n");
 
sprintf(strsql,"select str from Alx where fil='zarsppo.alx' order by ns asc");
if((kolstr=cur_alx.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(0.);
 }

if(kolstr == 0)
 {
  if(ff != NULL)
   fprintf(ff,"Не найдены настройки zarsppo.alx\n");
  return(0.);
 }


float proc=0.;
int tabnom=0;
short d,m,g;
char data[512];

while(cur_alx.read_cursor(&row_alx) != 0)
 {
  if(row_alx[0][0] == '#')
   continue; 

  if(polen(row_alx[0],&tabnom,1,'|') != 0)
   continue;  
  if(tabnom == 0)
   continue;
  if(tabnom != tabn)
   continue;

  if(polen(row_alx[0],data,sizeof(data),3,'|') != 0)
   continue;  

  if(data[0] != '\0')
  if(rsdat(&d,&m,&g,data,1) != 0)
   {
    if(ff != NULL)
     {
      fprintf(ff,"%s",row_alx[0]);
      fprintf(ff,"Не правильно введена дата!\n");
     }
    continue;
   }     

  if(sravmydat(1,mes,god,1,m,g) >= 0 || data[0] == '\0')
   {
    if(ff != NULL)
      fprintf(ff,"%s",row_alx[0]);
    polen(row_alx[0],&proc,2,'|');
    /*смотрим дальше так как могут быть настройки по более поздним датам*/
   }
 }

if(ff != NULL)
  fprintf(ff,"Персональный процент=%.2f\n",proc);

return(proc);
}


