/*$Id: platp.c,v 1.42 2011-01-13 13:43:22 sasa1 Exp $*/
/*12.01.2010	29.09.2001	Белых А.И.	platp.c
Печать платежного поручения в соответствии с постановлением
правления национального банка Украины от 29 марта 2001г. N135
Зарегистрировано в министерстве юстиции Украины 25 апреля 2001г
за N368/5559
Официальный весник Украины N18 часть 2 за 2001 год страница 848
В разделе 2 пункт 6 оговорена нумерация платежек

Если вернули 0 документ сформирован
             1 нет
*/
#include        <errno.h>
#include        "buhg.h"
#include        "dok4.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

extern short	kolstrdok; //Количество строк между документами
extern struct REC rec;
extern short	ots; /*Отступ от левого края*/
extern short	kor; /*Корректор межстрочного растояния*/
extern short    rzk;       /*0-преобразование числа с тире 1-со вставкой запятой*/
extern short    mvs;       /*1-с разбивкой суммы по счетам 0-без*/

int platp(const char *imaf1,
short kp, //Количество копий
short nomk, //Номер печатаемой копии
FILE *ff,
int viddok) //0-Платежное поручение 1- платежное требование
{
char		stroka[1024];
char		stroka1[512];
char		stroka2[512];
FILE		*ff1;
char bank_plat[512];
char bank_poluh[512];
char		imaf[112];
short		kolstrok=0;
char		bros[512];
char dt2[32]; //Дата платежа
double		bb=0.;
short dt,mt,gt;
SQL_str row_alx;
class SQLCURSOR cur_alx;
int kolstr=0;
char strsql[512];
poltekdat(&dt,&mt,&gt);

char mescc[32];
memset(mescc,'\0',sizeof(mescc));
mesc(rec.md,1,mescc);
sprintf(dt2,"%02d %s %d%s",rec.dd,mescc,rec.gd,gettext("г."));
memset(bank_plat,'\0',sizeof(bank_plat));
memset(bank_poluh,'\0',sizeof(bank_poluh));

if(sravmydat(3,7,2009,rec.ddi,rec.mdi,rec.gdi) <= 0)
 {
  if(viddok == 0)
    sprintf(imaf,"%s","pp03072009.alx");
  if(viddok == 1)
    sprintf(imaf,"%s","pt03072009.alx");
 }
else
 {
  if(viddok == 0)
    sprintf(imaf,"%s","platp.alx");
  if(viddok == 1)
    sprintf(imaf,"%s","platt.alx");
 }

sprintf(strsql,"select str from Alx where fil='%s' order by ns asc",imaf);
if((kolstr=cur_alx.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

if(kolstr == 0)
 {
  sprintf(strsql,"%s %s!",gettext("Не найдена настройка"),imaf);
  iceb_t_soob(strsql);
  return(1);
 }


if((ff1 = fopen(imaf1,"r")) == NULL)
 {
  error_op_nfil(imaf1,errno,"");
  return(1);
 }


fprintf(ff,"\x12"); //Выключить уплотненный режим
fprintf(ff,"\x1b\x6C%c",ots); /*Установка левого поля*/
fprintf(ff,"\x1B\x50"); /*10-знаков на дюйм*/
fprintf(ff,"\x1B\x78%c",1); //Включить черновой режим печати

if(sravmydat(3,7,2009,rec.ddi,rec.mdi,rec.gdi) > 0)
 if(kp > 1)
  fprintf(ff,"%70s N%d\n",gettext("Экземпляр"),nomk+1);

//fprintf(ff,"\x1B\x55\x31"); /*Включение однонаправленного режима*/
fprintf(ff,"\x1B\x33%c",20); /*Уменьшаем межстрочный интервал n/216 дюйма*/
//fprintf(ff,"\x1B\x41%c",7-kor); /*Уменьшаем межстрочный интервал n/72 дюйма*/
fprintf(ff,"\x1b\x45"); //Режим выделенного шрифта
memset(stroka,'\0',sizeof(stroka));
while(cur_alx.read_cursor(&row_alx) != 0)
 {
  if(row_alx[0][0] == '#')
   continue;
  memset(stroka,'\0',sizeof(stroka));
  strncpy(stroka,row_alx[0],sizeof(stroka)-1);
  kolstrok++;
  switch(kolstrok)
   {

    case 2: //Номер платежного поручения
     fprintf(ff,"\x1B\x33%c",16-kor); /*Уменьшаем межстрочный интервал n/216 дюйма*/
//     fprintf(ff,"\x1B\x41%c",5-kor); /*Уменьшаем межстрочный интервал n/72 дюйма*/
     BSTAB(stroka,rec.nomdk,30,50,1);
     break;

    case 3: 
      fprintf(ff,"\x1B\x33%c",30-kor); /*Уменьшаем межстрочный интервал n/216 дюйма*/
//      fprintf(ff,"\x1B\x41%c",10-kor); /*Уменьшаем межстрочный интервал n/72 дюйма*/
      break;

    case 4: //Дата документа
     BSTAB(stroka,dt2,16,45,1);
     break;

    case 6: //Год
     sprintf(bros,"%d",gt);
     BSTAB(stroka,bros,64,69,1);
     break;

    case 7: //Плательщик
     if(viddok == 0)
       BSTAB(stroka,rec.naior,8,51,1);
     if(viddok == 1)
       BSTAB(stroka,rec.naior1,8,51,1);

     break;

    case 8: //Наименование плательщика, которое не поместилось в первой строке
     
     if(viddok == 0)
      if(iceb_tu_strlen(rec.naior) > 43)
       BSTAB(stroka,iceb_tu_adrsimv(43,rec.naior),1,70,1);
     if(viddok == 1)
      if(iceb_tu_strlen(rec.naior1) > 43)
       BSTAB(stroka,iceb_tu_adrsimv(43,rec.naior1),1,70,1);

/***************** дата валютирования теперь не печатаестся
     if(rec.dv != 0)
      {
       sprintf(bros,"%02d",rec.dv);
       BSTAB(stroka,bros,53,56,1);

       sprintf(bros,"%02d",rec.mv);
       BSTAB(stroka,bros,59,62,1);

       sprintf(bros,"%d",rec.gv);
       BSTAB(stroka,bros,64,69,1);
      }
     else
      {
       sprintf(bros,"%d",gt);
       BSTAB(stroka,bros,64,69,1);
      }    
********************/
     break;

    case 10: //Код СДЗПОУ
     if(viddok == 0)
       BSTAB(stroka,rec.kod,11,26,1);
     if(viddok == 1)
       BSTAB(stroka,rec.kod1,11,26,1);
     break;

    case 12: //Банк плательщика
      if(viddok == 0)
       sprintf(bank_plat,"%s в м.%s",rec.naiban,rec.gorod);
      if(viddok == 1)
       sprintf(bank_plat,"%s в м.%s",rec.naiban1,rec.gorod1);
      BSTAB(stroka,bank_plat,14,32,1);
     break;
   
    case 13: //Банк плательщика, код банка, счет дебета, сумма платежа
     if(iceb_tu_strlen(bank_plat) > 18)
        BSTAB(stroka,iceb_tu_adrsimv(18,bank_plat),0,32,1);
     if(viddok == 0)
      {
/*       
       sprintf(bros,"%s в м.%s",rec.naiban,rec.gorod);
       BSTAB(stroka,bros,0,32,1);
*/
       BSTAB(stroka,rec.mfo,37,46,1);
       BSTAB(stroka,rec.nsh,57,74,1);
      }
     if(viddok == 1)
      {
/*******
       sprintf(bros,"%s в м.%s",rec.naiban1,rec.gorod1);
       BSTAB(stroka,bros,0,32,1);
***************/
       BSTAB(stroka,rec.mfo1,37,46,1);
       BSTAB(stroka,rec.nsh1,57,74,1);
      }
     bb=rec.sumd+rec.uslb;

     if(rzk == 0)
        prnb(bb,bros);
     if(rzk == 1)
        prnb1(bb,bros);

     BSTAB(stroka,bros,79,88,1);

     break;

    case 15: //Получатель
     if(viddok == 0)
      BSTAB(stroka,rec.naior1,10,62,1);
     if(viddok == 1)
      BSTAB(stroka,rec.naior,10,62,1);
     break;

    case 17: //Код, номер счета за услуги, сумма за услуги
     BSTAB(stroka,rec.kod1,11,26,1);
     break;

    case 18: //Кредит счет N
      bros[0]='\0';
      if(rec.uslb != 0. && mvs == 1)
       {
        bb=rec.sumd;
        if(rzk == 0)
         prnb(bb,bros);

        if(rzk == 1)
         prnb1(bb,bros);

       }
     if(viddok == 0)
        BSTAB(stroka,rec.nsh1,53,70,1);
     if(viddok == 1)
        BSTAB(stroka,rec.nsh,53,70,1);
      BSTAB(stroka,bros,75,84,1);
      break;

    case 19: /*Банк получателя*/
      if(viddok == 0)
       sprintf(bank_poluh,"%s в м.%s",rec.naiban1,rec.gorod1);
      if(viddok == 1)
        sprintf(bank_poluh,"%s в м.%s",rec.naiban,rec.gorod);
      BSTAB(stroka,bank_poluh,16,32,1);
      break;
        
    case 20: //Банк получателя, МФО, счет
      if(iceb_tu_strlen(bank_poluh) > 16)
        BSTAB(stroka,iceb_tu_adrsimv(16,bank_poluh),0,32,1);

      if(viddok == 0)
       {
/*********
        sprintf(bros,"%s в м.%s",rec.naiban1,rec.gorod1);
        BSTAB(stroka,bros,0,32,1);
**********/
        BSTAB(stroka,rec.mfo1,37,46,1);
       }
      if(viddok == 1)
       {
/*************
        sprintf(bros,"%s в м.%s",rec.naiban,rec.gorod);
        BSTAB(stroka,bros,0,32,1);
************/
        BSTAB(stroka,rec.mfo,37,46,1);
       }
      BSTAB(stroka,rec.shbzu,57,74,1);
      bros[0]='\0';
      if(rec.uslb != 0. && mvs == 1)
       {
        if(rzk == 0)
         prnb(rec.uslb,bros);

        if(rzk == 1)
         prnb1(rec.uslb,bros);

       }

      BSTAB(stroka,bros,79,88,1);
       
     break;

    case 23: //Сумма словами
      bb=rec.sumd+rec.uslb;

      memset(bros,'\0',sizeof(bros));
      preobr(bb,bros,0);
      BSTAB(stroka,bros,0,102,1);

      break;

    case 24: //Код нерезидента
      BSTAB(stroka,rec.kodnr,63,71,1);
      break;

    case 26: //Назначение платежа
    case 27: //Назначение платежа
    case 28: //Назначение платежа
    case 29: //Назначение платежа
//    case 30: //Назначение платежа Закомментарил
//      fprintf(ff,"\x1b\x46"); //Отмена режима выделенного шрифта
    
      memset(stroka1,'\0',sizeof(stroka1));
      if(FGETSS(stroka1,sizeof(stroka1),ff1) != 0)
       {
        //Включение/выключения режима 12 знаков на дюйм
        sprintf(stroka2,"\x1B\x4D%10s%s\x1B\x50","",stroka1);
        BSTAB(stroka,stroka2,0,300,1);
       }
      break;

    default:
     break;
   }
  fprintf(ff,"%s",stroka);
  memset(stroka,'\0',sizeof(stroka));
 }

fprintf(ff,"\x1b\x46"); //Отмена режима выделенного шрифта
fprintf(ff,"\x12"); /*Выключение ужатого режима*/
fprintf(ff,"\x1b\x6C%c",1); /*Установка левого поля в ноль*/
//fprintf(ff,"\x1B\x55\x30"); /*Выключение однонаправленного режима*/
fprintf(ff,"\x1B\x32\n");/*Межсточный интервал 1/6 дюйма*/

if(nomk == 0 || nomk == 2)
if(kp > 1)
  for(int i=0; i< kolstrdok ; i++)
     fprintf(ff,"\n");

fclose(ff1);

return(0);
}
