/* $Id: podoh1.c,v 5.56 2011-02-02 11:55:43 sasa1 Exp $ */
/*16.01.2011    01.12.1992      Белых А.И.      podoh1.c
Подпрограмма расчета подоходного налога 
отчисления в пенсионный фонд и отчисления на безработицу
с общей суммы
Возвращаем сумму налога
*/
#include        <math.h>
#include        <pwd.h>
#include        <errno.h>
#include        "buhg.h"


extern short	metkarnb; //0-Расчет налогов для бюджета пропорциональный 1-последовательный
extern char	*shetb; /*Бюджетные счета*/

void  podoh1(long tn, //Табельный номер*/
short mp,short gp,
int podr,
const char *uder_only,
FILE *ff)
{
//printw("\n%s\n",__FUNCTION__);
//refresh();

if(metkarnb == 1 && shetb != NULL) //Последовательный расчет бюджет/хозрасчет
 if(ff != NULL)
    fprintf(ff,"%s-Последовательный расчет\n",__FUNCTION__);

if(sravmydat(1,mp,gp,ICEB_DNDESV,ICEB_MNDESV,ICEB_GNDESV) < 0)
 {
  //расчёт отчисления в фонд безработицы
  double		fbezrab=0.,fbezrabb=0.;//Только с зарплаты
  double i_bezr=0.,i_bezrb=0.; //Со всей суммы
  fbezr(tn,mp,gp,podr,&fbezrab,&fbezrabb,0,0,0.,&i_bezr,&i_bezrb,uder_only,ff);

  //расчёт пенсионного отчисления
  double sumapo=0; //Общая сумма пенсионного отчисления только с зарплаты 
  double sumapob=0.; //Сумма пенсинного отчисления с бюджетных начислений только с зарплаты
  double i_pens=0.; //Пенсионное отчисление со всей суммы
  double i_pensb=0.; //Пенсионное отчисление со всей суммы бюджета
  ras_pens(tn,mp,gp,podr,&sumapo,&sumapob,0,0,0.,&i_pens,&i_pensb,uder_only,ff);

  //расчёт отчисления на соц-страх
  double sumaos=0.; //Сумма отчисления на соц-страх только с зарплаты
  double sumaosb=0.; //Сумма отчисления на соц-страх бюджет только с зарплаты
  double i_soc=0.; //Общая сумма соц-страха
  double i_socb=0.;//Общая сумма соц-страха для бюджета
  ras_soc(tn,mp,gp,podr,&sumaos,&sumaosb,0,0,0.,&i_soc,&i_socb,uder_only,ff);

  //расчёт подоходного налога
  ras_podoh(tn,mp,gp,podr,fbezrab,fbezrabb,sumapo,sumapob,sumaos,sumaosb,0,0,0.,uder_only,ff);
 }
else
 {
  double suma_esv=0.;
  double suma_esvb=0.;
  zaresv(tn,mp,gp,podr,&suma_esv,&suma_esvb,0,0.,uder_only,ff);

  //расчёт подоходного налога
  ras_podoh1(tn,mp,gp,podr,suma_esv,suma_esvb,0,0,0.,uder_only,ff);
 }


return;
}
