/*$Id: podohrs1.c,v 5.47 2011-06-23 09:58:02 sasa Exp $*/
/*04.01.2010	15.12.2003	Белых А.И.	podohrs1.c
Расчет подоходного налога в соответствии с новым законом вступающим в силу с 1.1.2004г.
Возвращяем величину подоходного налога
*/
#include        <errno.h>
#include        "buhg.h"

extern double   okrg;
extern float  kof_prog_min; //Коэффициент прожиточного минимума
extern float  ppn; //Процент подоходного налога
extern float  pomzp; //Процент от минимальной заработной платы



double  podohrs1(long tabn,
short mr,short gr,
double suma_zar, //Сумма зарплаты на которую распространяется соц-льгота
double suma_soc_ot, //сумма соц-отчислений c зарплаты
double suma_bsl, //Сумма без социальной льготы - не зарплата
double suma_ndfv, //Сумма неденежных форм выплаты
FILE *ffp)
{
char stroka[1024];
float procent=0.;
double nalog=0.;
double lgota=0.;
double  maxsum=0.;
double suma_bso=0.;
short du=0,mu=0,gu=0;

class zar_read_tn1h nastr;
zar_read_tn1(1,mr,gr,&nastr,ffp);

//читаем дату увольнения
sprintf(stroka,"select datk from Zarn where tabn=%ld and god=%d and mes=%d",tabn,gr,mr);

SQLCURSOR cur;
SQL_str   row;

if(sql_readkey(&bd,stroka,&row,&cur) == 1)
 rsdat(&du,&mu,&gu,row[0],2);
  
maxsum=nastr.prog_min_ng*kof_prog_min;
if(ffp != NULL)
 {
  fprintf(ffp,"\n%s:\nМинимальная зарплата на начало года=%.2f\n",__FUNCTION__,nastr.minzar_ng);
  fprintf(ffp,"Прожиточный минимум на начало года=%.2f\n",nastr.prog_min_ng);
  fprintf(ffp,"Коэффициент прожиточного минимума=%.2f\n",kof_prog_min);
  fprintf(ffp,"Процент подоходного налога=%.2f\n",ppn);
  fprintf(ffp,"Процент от минимальной зарплаты=%.2f\n",pomzp);
  fprintf(ffp,"Сумма на которую не распростаняется социальная льгота=%.2f\n",suma_bsl);
  fprintf(ffp,"Сумма на которую распростаняется социальная льгота=%.2f\n",suma_zar);
  fprintf(ffp,"Сумма социальных отчислений=%.2f\n",suma_soc_ot);
  fprintf(ffp,"Сумма неденежных форм выплаты=%.2f\n",suma_ndfv);
  fprintf(ffp,"Дата расчёта зарплаты %d.%d\n",mr,gr);
  fprintf(ffp,"Дата увольнения %d.%d.%d\n",du,mu,gu);
  fprintf(ffp,"Максимальный доход для льгот:%.2f*%.2f = %.2f\n",nastr.prog_min_ng,kof_prog_min,maxsum);
 }

maxsum=okrug(maxsum,10.);

if(ffp != NULL)
  fprintf(ffp,"Округлили %.2f\n",maxsum);

if(suma_ndfv != 0.)
  rudnfv(&suma_zar,suma_ndfv,ffp);


if(ffp != NULL)
  fprintf(ffp,"Сумма без соц-отчислений=%.2f %.2f=%.2f\n",suma_zar,suma_soc_ot,suma_zar+suma_soc_ot);

if(suma_zar > 0.)  //Отрицательные поэтому прибавляем
  suma_bso=suma_zar+suma_soc_ot;

int kollgot=0;
class iceb_tu_str kod_lgot("");
procent=zarlgot(tabn,mr,gr,&kollgot,&kod_lgot,ffp);


if(ffp != NULL)
 {   
  fprintf(ffp,"Количество социальных льгот=%d\n",kollgot);
  fprintf(ffp,"Максимальная сумма для которой применяется льгота %.2f*%d=%.2f\n",
  maxsum,kollgot,maxsum*kollgot);
 }

maxsum*=kollgot;

if(maxsum < suma_zar || (mu == mr && gu == gr))
 {

  nalog=(suma_bso+suma_bsl)*ppn/100.;

  if(ffp != NULL)
   {
    if(mu == mr && gu == gr)
      fprintf(ffp,"Месяц увольнения ! Льготы по подоходному налогу не применяються.\n");
    else
      fprintf(ffp,"*Льготы по подоходному налогу не применяються %.2f < %.2f\n",maxsum,suma_zar);

   fprintf(ffp,"(%.2f+%.2f)*%.2f/100=%.2f\n",suma_bso,suma_bsl,ppn,nalog);
  }

  nalog=okrug(nalog,okrg)*(-1);
  return(nalog);
 }




if(procent == 0.)
 {
  lgota=0.;
  if(ffp != NULL)
    fprintf(ffp,"Не имеет льгот!\n");

  nalog=(suma_bso+suma_bsl)*(ppn/100);

  if(ffp != NULL)
    fprintf(ffp,"Подоходный налог  - ((%.2f+%.2f)*%.2f/100=%.2f\n",suma_bso,suma_bsl,ppn,nalog);

  nalog=okrug(nalog,okrg)*(-1);

  return(nalog);
 }
else
 {

  lgota=nastr.minzar_ng*(procent/100)*(pomzp/100);
  
  if(ffp != NULL)
    fprintf(ffp,"Расчетная сумма льготы=%.2f*%.2f/100*%.2f/100=%.2f\n",nastr.minzar_ng,procent,pomzp,lgota);
 }


if(suma_zar+suma_bsl <= maxsum)
 {
  if(ffp != NULL)
   fprintf(ffp,"Льгота применяется так как %.2f+%.2f <= %.2f\n",suma_zar,suma_bsl,maxsum);

  if(suma_bso < lgota) /*Если отнять будет отрицательное число*/
   {
    if(ffp != NULL)
        fprintf(ffp,"Cумма начисления %.2f меньше льготы %.2f\n",suma_bso,lgota);

    if(suma_bsl != 0.)
     {
      nalog=suma_bsl*(ppn/100);
      if(ffp != NULL)
       {
        fprintf(ffp,"Подоходный налог  - %.2f*%.2f/100=%.2f\n",suma_bsl,ppn,nalog);
       }
     }
    else
     {
      if(ffp != NULL)
        fprintf(ffp,"Налог не берётся!\n");
      return(0.);
     }

   }
  else
   {
    nalog=((suma_bso-lgota)+suma_bsl)*(ppn/100);
    if(ffp != NULL)
      fprintf(ffp,"Подоходный налог  - ((%.2f-%.2f)+%.2f)*%.2f/100=%.2f\n",suma_bso,lgota,suma_bsl,ppn,nalog);
   }

  nalog=okrug(nalog,okrg)*(-1);

  
 }
else
 {
  if(ffp != NULL)
   fprintf(ffp,"Льгота не применяется так как %.2f+%.2f > %.2f\n",suma_zar,suma_bsl,maxsum);
  nalog=(suma_bso+suma_bsl)*(ppn/100);
  nalog=okrug(nalog,okrg)*(-1);

  if(ffp != NULL)
    fprintf(ffp,"Подоходный налог  - (%.2f+%.2f)*%.2f/100=%.2f\n",suma_bso,suma_bsl,ppn,nalog);
 }
return(nalog);

}
