/*$Id: ras_pens.c,v 5.13 2011-01-21 09:14:10 sasa1 Exp $*/
/*01.03.2010	17.02.2005	Белых А.И.	ras_pens.c
Расчёт пенсионного отчисления
*/
#include        "buhg.h"

extern short    kodpen;  /*Код пенсионных отчислений*/
extern char	*shetb; /*Бюджетные счета*/
extern char	*shetpf; /*Счета пенсионного фонда*/
extern short	*kodnvpen; /*Коды не входящие в расчет пенсионного отчисления*/
extern double   okrg; /*Округление*/
extern short	metkarnb; //0-Расчет налогов для бюджета пропорциональный 1-последовательный
extern  short   *kodbl; /*Код больничного*/
extern short    *kn_bsl; //Коды начислений на которые не распространяется льгота по подоходному налогу

void ras_pens(long tn, //Табельный номер*/
short mp,short gp,
int podr,
double *sumapo, //Общая сумма пенсионного отчисления только с зарплаты 
double *sumapob, //Сумма пенсинного отчисления с бюджетных начислений только с зарплаты
int metka_zap, //0-делать запись 1-нет
int metka_ras, //0-смотреть начиления в массиве 1- в базе
double suma_boln, //0 или сумма больничного для перерасчёта подоходного налога
double *i_pens,  //Пенсионный со всей суммы общий
double *i_pensb, //Пенсионный со всуй суммы для бюджета
const char *uder_only,
FILE *ff_prot)
{
char strsql[512];
SQL_str row;
SQLCURSOR curr;
char shet[32];
struct ZARP     zp;
short		d;

//printw("%s\n",__FUNCTION__);
//refresh();

dpm(&d,&mp,&gp,5);

zp.dz=d;
zp.mesn=mp; zp.godn=gp;
zp.nomz=0;
zp.podr=podr;

*i_pens=*i_pensb=*sumapo=*sumapob=0.;


double sumanb=0.;
double sumabu=0.;
double suma_ndfnz=0.;
double suma_ndfnz_b=0.;
double suma_zarp_o=0.;
double suma_zarp_b=0.;
double suma_boln_rm=0.; /*Сумма больничных за расчётный месяц*/

if(ff_prot != NULL)
 fprintf(ff_prot,"\n%s-Расчет пенсионного отчисления.\n\
---------------------------------------------------\n",__FUNCTION__);

/*Проверяем есть ли код удержания отчисления в пенсионный фонд*/
sprintf(strsql,"select shet from Zarn1 where tabn=%ld and prn='2' and \
knah=%d",tn,kodpen); 
if(sql_readkey(&bd,strsql,&row,&curr) <= 0)
 {

  if(ff_prot != NULL)
   fprintf(ff_prot,"\nНе введен код отчисления в пенсионный фонд ! %d\n",kodpen);
  return;
 }

if(proverka(uder_only,kodpen,0,0) != 0)
 {
  if(ff_prot != NULL)
   fprintf(ff_prot,"Код %d исключён из расчёта\n",kodpen);
  return; 
 }

strncpy(shet,row[0],sizeof(shet)-1);
double bbpn=0.;
if(metka_ras == 0)
  bbpn=findnahm(mp,2,kodnvpen,ff_prot,&sumanb,&sumabu,&suma_ndfnz,&suma_ndfnz_b,&suma_zarp_o,&suma_zarp_b,&suma_boln_rm);
else
 {
  bbpn=findnahm(mp,gp,tn,2,kodnvpen,ff_prot,&sumanb,&sumabu,&suma_ndfnz,&suma_ndfnz_b,&suma_zarp_o,&suma_zarp_b,&suma_boln_rm);
  //если есть сyмма больничного значит делаем перерасчёт подоходного для больничных на которые 
  //распространяется социальная льгота 
  if(suma_boln != 0.)
   if(ff_prot != NULL)
    fprintf(ff_prot,"Увеличиваем на сумму больничного\n");
  sumanb+=suma_boln;
  suma_zarp_o+=suma_boln;
 }

if(ff_prot != NULL)
 fprintf(ff_prot,"nah=%f Хозрасчет=:%.2f Бюджет=%.2f Недежная форма=%.2f/%.2f\n",
 bbpn,sumanb,sumabu,suma_ndfnz,suma_ndfnz_b);

//rudnfv(&bbpn,suma_ndfnz,ff_prot); 
bbpn=okrug(bbpn,okrg);

double bbpnb=sumabu;


if(ff_prot != NULL)
 fprintf(ff_prot,"Со всей суммы----------------\n");
double bb1=pens(tn,mp,gp,bbpn,ff_prot);
*i_pens=bb1=okrug(bb1,okrg)*(-1);

if(ff_prot != NULL)
  fprintf(ff_prot,"\nТолько с зарплаты (для расчёта подоходного налога)---------------\n");

/*Если на больничный не распространяестя социальная льгота
значит он не вошёл в сумму для расчёта пенсионного только с зарплаты
Однако с него нужно брать пенсионный для расчёта подоходного налога 
Для других соц фондов он не входит в расчёт подоходного налога*/

double suma_plus=0.;
if(suma_boln_rm != 0. && kn_bsl != NULL && kodbl != NULL)
 {
    
  for(int nom=1; nom < kn_bsl[0]; nom++)
   for(int nom1=1; nom1 < kodbl[0]; nom1++)
     if(kn_bsl[nom] == kodbl[nom1])
      {
       if(ff_prot != NULL)
        fprintf(ff_prot,"Прибавляем больничный %.2f к сумме на которую не распространяется социальная льгота\n",suma_boln_rm);
       suma_plus=suma_boln_rm;
       break;
      }
 }

*sumapo=pens(tn,mp,gp,suma_zarp_o+suma_plus,ff_prot);

*sumapo=okrug(*sumapo,okrg)*(-1);

//  printw("bb1=%f\n",bb1);
char bros[312];
memset(bros,'\0',sizeof(bros));
if(shetb == NULL || shetpf == NULL)
 {
  
  if(ff_prot != NULL)
    fprintf(ff_prot,"bb1=%f kodpen=%d\n",bb1,kodpen);
  
  strcpy(zp.shet,shet);
  if(metka_zap == 0)
   zapzarp(d,mp,gp,tn,2,kodpen,bb1,shet,mp,gp,0,0,bros,podr,"",zp);
 }
else
 {
  double bb2=0.;
  if(metkarnb == 1) //Последовательный метод расчет налогов
   {
    if(ff_prot != NULL)
      fprintf(ff_prot,"Расчёт пенсионного отчисления для бюджетных отчислений\n");
      
//    rudnfv(&bbpnb,suma_ndfnz_b,ff_prot);
    if(ff_prot != NULL)
      fprintf(ff_prot,"Со всей суммы-------------\n");
    bb2=pens(tn,mp,gp,bbpnb,ff_prot)*-1;
    if(ff_prot != NULL)
      fprintf(ff_prot,"\nТолько с зарплаты (для расчёта подоходного налога)------------\n");
    *sumapob=pens(tn,mp,gp,suma_zarp_b,ff_prot)*-1;
   } 
  if(metkarnb == 0) //Пропорциональный метод расчет налогов
   {
    if(ff_prot != NULL)
     fprintf(ff_prot,"Пропорциональный:Разбивка суммы:%.2f хозрасчет=%.2f бюджет:%.2f\n",
     bbpn,sumanb,sumabu);

    if(sumabu != 0.)
     {
      if(bbpn != 0.)
       {
        //Если хозрасчет не равен нолю то долю определять надо
        if(sumanb != 0.)
         bb2=bb1*sumabu/bbpn;
        else
         bb2=bb1;

        if(suma_zarp_b != 0.)
         *sumapob=*sumapo*suma_zarp_b/suma_zarp_o;
        else
         *sumapob=0.;
       }
     }
   }

  *sumapob=okrug(*sumapob,okrg);
  *i_pensb=bb2=okrug(bb2,okrg);
  polen(shetpf,shet,sizeof(shet),2,',');
  if(ff_prot != NULL)
    fprintf(ff_prot,"Налог бюджет=%.2f\n",bb2);
 
  if(shet[0] != '\0')
   {
    strcpy(bros,gettext("Бюджет"));
    strcpy(zp.shet,shet);
    if(metka_zap == 0)
      zapzarp(d,mp,gp,tn,2,kodpen,bb2,shet,mp,gp,0,0,bros,podr,"",zp);
   }

  polen(shetpf,shet,sizeof(shet),1,',');
  bb2=bb1-bb2;

  bb2=okrug(bb2,okrg);
  if(shet[0] != '\0')
   {
    strcpy(bros,gettext("Хозрасчет"));
    strcpy(zp.shet,shet);
    if(metka_zap == 0)
      zapzarp(d,mp,gp,tn,2,kodpen,bb2,shet,mp,gp,0,0,bros,podr,"",zp);
   }
   
 }

}
