/*$Id: rasalk.c,v 5.13 2011-01-13 13:43:22 sasa1 Exp $*/
/*29.11.2009	07.06.2007	Белых А.И.	rasalk.c
Распечатка товарно-транспортной накладной на перемещение алкогольных напитков
*/
#include        <errno.h>
#include        <pwd.h>
#include	"buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

class tov_tr_nak
 {
  public:
  char p_list[40];
  char marka_avt[40];
  char gos_nomer[40];
  char pricep[56];
  char perevoz[56];
  char zakaz[56];
  char voditel[56];
  char punkt_zag[56];
  char punkt_roz[56];
  char dover[56];
  char data_dov[20];
  char akciz_sbor[20];
  
  char naim00[512];
  char adres00[512];
  char mfo00[32];
  char r_shet00[40];
  char naimb00[512];
  char ind_kod00[56];
  char edrpou00[56];
  char nomer_lic00[512];
  char datan_lic00[56];
  char datak_lic00[56];

  char naim[512];
  char adres[512];
  char mfo[32];
  char r_shet[40];
  char naimb[512];
  char ind_kod[56];
  char edrpou[56];
  char nomer_lic[512];
  char datan_lic[56];
  char datak_lic[56];

  float pnds;
  short lnds;  //Льготы по НДС
  char imaf[56];
  short tipz;  
  tov_tr_nak()
   {
    clear_data();
    pnds=0.;
    lnds=0;
    memset(naim00,'\0',sizeof(naim00));
    memset(adres00,'\0',sizeof(adres00));
    memset(mfo00,'\0',sizeof(mfo00));
    memset(r_shet00,'\0',sizeof(r_shet00));
    memset(naimb00,'\0',sizeof(naimb00));
    memset(ind_kod00,'\0',sizeof(ind_kod00));
    memset(edrpou00,'\0',sizeof(edrpou00));
    memset(nomer_lic00,'\0',sizeof(nomer_lic00));
    memset(datan_lic00,'\0',sizeof(datan_lic00));
    memset(datak_lic00,'\0',sizeof(datak_lic00));
    memset(akciz_sbor,'\0',sizeof(akciz_sbor));
    memset(naim,'\0',sizeof(naim));
    memset(adres,'\0',sizeof(adres));
    memset(mfo,'\0',sizeof(mfo));
    memset(r_shet,'\0',sizeof(r_shet));
    memset(naimb,'\0',sizeof(naimb));
    memset(ind_kod,'\0',sizeof(ind_kod));
    memset(edrpou,'\0',sizeof(edrpou));
    memset(nomer_lic,'\0',sizeof(nomer_lic));
    memset(datan_lic,'\0',sizeof(datan_lic));
    memset(datak_lic,'\0',sizeof(datak_lic));
    memset(imaf,'\0',sizeof(imaf));  
   }

  void clear_data()
   {
    memset(p_list,'\0',sizeof(p_list));
    memset(marka_avt,'\0',sizeof(marka_avt));
    memset(gos_nomer,'\0',sizeof(gos_nomer));
    memset(pricep,'\0',sizeof(pricep));
    memset(perevoz,'\0',sizeof(perevoz));
    memset(zakaz,'\0',sizeof(zakaz));
    memset(voditel,'\0',sizeof(voditel));
    memset(punkt_zag,'\0',sizeof(punkt_zag));
    memset(punkt_roz,'\0',sizeof(punkt_roz));
    memset(dover,'\0',sizeof(dover));
    memset(data_dov,'\0',sizeof(data_dov));
    memset(akciz_sbor,'\0',sizeof(akciz_sbor));
   }
 };

int rasalk_zap(short gg,int skl,const char *nomdok,class tov_tr_nak *rek_nak);
int rasalk_read_rk(short,short,short,const char *nomdok,int skl,const char *kontr,char *naim,char *adres,char *mfo,char *r_shet,char *naimb,char *ind_kod,char *edrpou,char *nomer_lic,char *datan_lic,char *datak_lic);
void rasalk_rs(short dg,short mg,short gg,int skl,const char *nomdok,class tov_tr_nak *rek_nak);
 
extern double	okrcn;  /*Округление цены*/
extern double   okrg1; /*Округление*/

void rasalk(short dg,short mg,short gg, //дата документа
int skl,  //Склад
const char *nomdok) //Номер документа
{
char strsql[512];
class spis_oth oth;
class tov_tr_nak rek_nak;
class SQLCURSOR cur;
SQL_str row;
char kontr_pol[56];

class iceb_tu_str printer("lpr -r");

iceb_t_poldan("Системный принтер",&printer,"nastsys.alx");

memset(kontr_pol,'\0',sizeof(kontr_pol));


if(rasalk_read_rk(dg,mg,gg,nomdok,skl,"00",rek_nak.naim00,rek_nak.adres00,rek_nak.mfo00,rek_nak.r_shet00,rek_nak.naimb00,\
rek_nak.ind_kod00,rek_nak.edrpou00,rek_nak.nomer_lic00,rek_nak.datan_lic00,rek_nak.datak_lic00) != 0)
 return;


//читаем шапку документа

sprintf(strsql,"select tip,kontr,pn from Dokummat where datd='%04d-%02d-%02d' and sklad=%d and nomd='%s'",gg,mg,dg,skl,nomdok);
if(readkey(strsql,&row,&cur) != 1)
 {
  VVOD SOOB(1);
  
  SOOB.VVOD_SPISOK_add_MD("Не найдена шапка документа !");
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return;    
 } 
rek_nak.tipz=atoi(row[0]);
strncpy(kontr_pol,row[1],sizeof(kontr_pol)-1);
rek_nak.pnds=atof(row[2]);

if(rasalk_read_rk(dg,mg,gg,nomdok,skl,kontr_pol,rek_nak.naim,rek_nak.adres,rek_nak.mfo,rek_nak.r_shet,rek_nak.naimb,\
rek_nak.ind_kod,rek_nak.edrpou,rek_nak.nomer_lic,rek_nak.datan_lic,rek_nak.datak_lic) != 0)
 return;

//читаем дополнительные реквизиты шапки документа
sprintf(strsql,"select nomerz,sodz from Dokummat2 where god=%d and sklad=%d and nomd='%s'",gg,skl,nomdok);
int kolstr=0;
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return;
 }
int nomerz=0;
while(cur.read_cursor(&row) != 0)
 {
  nomerz=atoi(row[0]);

  if(nomerz == 1) //Доверенность#дата выдачи доверенности
   {
    polen(row[1],rek_nak.dover,sizeof(rek_nak.dover),1,'#');
    polen(row[1],rek_nak.data_dov,sizeof(rek_nak.data_dov),2,'#');
    continue;
   }  
  if(nomerz == 10) //Гос-номер машины
   {
    strncpy(rek_nak.gos_nomer,row[1],sizeof(rek_nak.gos_nomer)-1);
    continue;
   }  
  if(nomerz == 11) //льготы по НДС
   {
    rek_nak.lnds=atoi(row[1]);
    continue;
   }  
  if(nomerz == 15) //Номер путевого листа
   {
    strncpy(rek_nak.p_list,row[1],sizeof(rek_nak.p_list)-1);
    continue;
   }  
  if(nomerz == 16) //марка автомобиля
   {
    strncpy(rek_nak.marka_avt,row[1],sizeof(rek_nak.marka_avt)-1);
    continue;
   }  
  if(nomerz == 17) //марка и номер прицепа
   {
    strncpy(rek_nak.pricep,row[1],sizeof(rek_nak.pricep)-1);
    continue;
   }  
  if(nomerz == 18) //Перевозчик груза
   {
    strncpy(rek_nak.perevoz,row[1],sizeof(rek_nak.perevoz)-1);
    continue;
   }  
  if(nomerz == 19) //Заказчик плательщик
   {
    strncpy(rek_nak.zakaz,row[1],sizeof(rek_nak.zakaz)-1);
    continue;
   }  
  if(nomerz == 20) //Фамилия водителя
   {
    strncpy(rek_nak.voditel,row[1],sizeof(rek_nak.voditel)-1);
    continue;
   }  
  if(nomerz == 21) //Пункт загрузки
   {
    strncpy(rek_nak.punkt_zag,row[1],sizeof(rek_nak.punkt_zag)-1);
    continue;
   }  
  if(nomerz == 22) //Пункт разгрузки
   {
    strncpy(rek_nak.punkt_roz,row[1],sizeof(rek_nak.punkt_roz)-1);
    continue;
   }  

  if(nomerz == 23) //Акцизный сбор
   {
    strncpy(rek_nak.akciz_sbor,row[1],sizeof(rek_nak.akciz_sbor)-1);
    continue;
   }  

 }
 
int metka_blok=0;
//class iceb_tu_str imaf_bl;
//imafn("blokmak.alx",&imaf_bl);
if(iceb_t_pblok(mg,gg,ICEB_PS_MU) != 0)
  metka_blok=1;


VVOD VV(0);
sprintf(strsql,"Накладная N%s от %d.%d.%dг.",nomdok,dg,mg,gg);
VV.VVOD_SPISOK_add_ZAG(strsql);

VV.VVOD_SPISOK_add_ZAG(rek_nak.naim00);
sprintf(strsql,"%s %s-%s",rek_nak.nomer_lic00,rek_nak.datan_lic00,rek_nak.datak_lic00);
VV.VVOD_SPISOK_add_ZAG(strsql);

sprintf(strsql,"%s %s",kontr_pol,rek_nak.naim);
VV.VVOD_SPISOK_add_ZAG(strsql);

sprintf(strsql,"%s %s-%s",rek_nak.nomer_lic,rek_nak.datan_lic,rek_nak.datak_lic);
VV.VVOD_SPISOK_add_ZAG(strsql);

VV.VVOD_SPISOK_add_MD("Путевой лист...........");//0
VV.VVOD_SPISOK_add_MD("Марка автомобиля.......");//1
VV.VVOD_SPISOK_add_MD("Гос-номер автомобиля...");//2
VV.VVOD_SPISOK_add_MD("Марка и номер прицепа..");//3
VV.VVOD_SPISOK_add_MD("Перевозчик.............");//4
VV.VVOD_SPISOK_add_MD("Заказчик (плательщик)..");//5
VV.VVOD_SPISOK_add_MD("Водитель...............");//6
VV.VVOD_SPISOK_add_MD("Пункт загрузки.........");//7
VV.VVOD_SPISOK_add_MD("Пункт разгрузки........");//8
VV.VVOD_SPISOK_add_MD("Доверенность...........");//9
VV.VVOD_SPISOK_add_MD("Дата доверенности......");//10
VV.VVOD_SPISOK_add_MD("Акцизный сбор..........");//11


VV.VVOD_SPISOK_add_data(rek_nak.p_list,sizeof(rek_nak.p_list));
VV.VVOD_SPISOK_add_data(rek_nak.marka_avt,sizeof(rek_nak.marka_avt));
VV.VVOD_SPISOK_add_data(rek_nak.gos_nomer,sizeof(rek_nak.gos_nomer));
VV.VVOD_SPISOK_add_data(rek_nak.pricep,sizeof(rek_nak.pricep));
VV.VVOD_SPISOK_add_data(rek_nak.perevoz,sizeof(rek_nak.perevoz));
VV.VVOD_SPISOK_add_data(rek_nak.zakaz,sizeof(rek_nak.zakaz));
VV.VVOD_SPISOK_add_data(rek_nak.voditel,sizeof(rek_nak.voditel));
VV.VVOD_SPISOK_add_data(rek_nak.punkt_zag,sizeof(rek_nak.punkt_zag));
VV.VVOD_SPISOK_add_data(rek_nak.punkt_roz,sizeof(rek_nak.punkt_roz));
VV.VVOD_SPISOK_add_data(rek_nak.dover,sizeof(rek_nak.dover));
VV.VVOD_SPISOK_add_data(rek_nak.data_dov,sizeof(rek_nak.data_dov));
VV.VVOD_SPISOK_add_data(rek_nak.akciz_sbor,sizeof(rek_nak.akciz_sbor));

naz:;

clear();
 
helstr(LINES-1,0,"F1",gettext("помощь"),
"F2/+",gettext("запись"),
"F4",gettext("очистить"),
"F5 4",gettext("печать"),
"F6",gettext("печать"),
"F10",gettext("выход"),NULL);

int kom=VV.vvod(0,1,1,-1,-1);

move(LINES-1,0);

if(metka_blok == 0)
 {
  strcpy(rek_nak.p_list,VV.VVOD_SPISOK_return_data(0));
  strcpy(rek_nak.marka_avt,VV.VVOD_SPISOK_return_data(1));
  strcpy(rek_nak.gos_nomer,VV.VVOD_SPISOK_return_data(2));
  strcpy(rek_nak.pricep,VV.VVOD_SPISOK_return_data(3));
  strcpy(rek_nak.perevoz,VV.VVOD_SPISOK_return_data(4));
  strcpy(rek_nak.zakaz,VV.VVOD_SPISOK_return_data(5));
  strcpy(rek_nak.voditel,VV.VVOD_SPISOK_return_data(6));
  strcpy(rek_nak.punkt_zag,VV.VVOD_SPISOK_return_data(7));
  strcpy(rek_nak.punkt_roz,VV.VVOD_SPISOK_return_data(8));
  strcpy(rek_nak.dover,VV.VVOD_SPISOK_return_data(9));
  strcpy(rek_nak.data_dov,VV.VVOD_SPISOK_return_data(10));
  strcpy(rek_nak.akciz_sbor,VV.VVOD_SPISOK_return_data(11));
 }


switch(kom)
 {
  case FK1:   /*Помощь*/
   GDITE();
   iceb_t_pdoc("matu2_1_3.txt");
   goto naz;

  case ESC:
  case FK10:
   return;

  case FK2: //Запись данных
    if(metka_blok == 1)
     {
      VVOD SOOB(1);
      sprintf(strsql,gettext("Дата %d.%dг. заблокирована !"),mg,gg);
      SOOB.VVOD_SPISOK_add_MD(strsql);
      soobshw(&SOOB,stdscr,-1,-1,0,1);
      goto naz;
     }
    rasalk_zap(gg,skl,nomdok,&rek_nak);
    goto naz;

  case FK5: //Печать 
    if(metka_blok == 0)
     rasalk_zap(gg,skl,nomdok,&rek_nak);
    rasalk_rs(dg,mg,gg,skl,nomdok,&rek_nak);
    pehf(rek_nak.imaf,4,printer.ravno());
    unlink(rek_nak.imaf);
    return;

  case FK6: //Печать 
    if(metka_blok == 0)
      rasalk_zap(gg,skl,nomdok,&rek_nak);
    rasalk_rs(dg,mg,gg,skl,nomdok,&rek_nak);
    oth.clear();
    oth.spis_imaf.plus(rek_nak.imaf);
    oth.spis_naim.plus("Товарно-транспортная накладная");
    iceb_t_rabfil(&oth,"");
    return;
    
  case FK4: /*Очистить меню*/
    VV.VVOD_clear_data();  
    goto naz;

  default:
     goto naz;
 }


}
/************************/
/*Распечатка*/
/*************************/
void rasalk_rs(short dg,short mg,short gg, //дата документа
int skl,  //Склад
const char *nomdok,
class tov_tr_nak *rek_nak)
{
char strsql[512];
int kolstr=0;
SQL_str row;
class SQLCURSOR cur;

sprintf(strsql,"select * from Dokummat1 where datd='%04d-%02d-%02d' and \
sklad=%d and nomd='%s' order by kodm asc",
gg,mg,dg,skl,nomdok);
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return;
 }

if(kolstr == 0)
  return;
double cena;
double kolih=0.;
double suma=0;
double itogo_bnds=0.;
//double itogo_snds=0.;
while(cur.read_cursor(&row) != 0)
 {
  kolih=atof(row[5]);
  cena=atof(row[6]);
  cena=okrug(cena,okrcn);
  suma=cena*kolih;
  suma=okrug(suma,okrg1);
  itogo_bnds+=suma;
 }

SQL_str row1;
class SQLCURSOR cur1;

  /*Читаем сумму корректировки*/
sprintf(strsql,"select sodz from Dokummat2 \
where god=%d and nomd='%s' and sklad=%d and nomerz=%d",
gg,nomdok,skl,13);

double sumkor=0.;

if(sql_readkey(&bd,strsql,&row1,&cur1) == 1)
 {
  sumkor=atof(row1[0]);
  sumkor=okrug(sumkor,0.01);
 }
 

double itogo_k_oplate=0.;
double suma_nds=0.;
if(rek_nak->lnds == 0 )
 {
  suma_nds=(itogo_bnds+sumkor)*rek_nak->pnds/100.;

  suma_nds=okrug(suma_nds,0.01);

 }

double sumt=0.;
      
itogo_k_oplate=(itogo_bnds+sumkor)+suma_nds+sumt;
char suma_prop[512];
memset(suma_prop,'\0',sizeof(suma_prop));
preobr(itogo_k_oplate,suma_prop,0);


FILE *ff;

sprintf(rek_nak->imaf,"alkog%d.lst",getpid());
if((ff = fopen(rek_nak->imaf,"w")) == NULL)
 {
  error_op_nfil(rek_nak->imaf,errno,"");
  return;
 }
startfil(ff);
startfil(ff);

char naim_mes[40];
memset(naim_mes,'\0',sizeof(naim_mes));
mesc(mg,1,naim_mes);

fprintf(ff,"\n\n\n\n\n\n\n\n%29s %02d %-13s%02d %20s%s\n","",dg,naim_mes,gg-2000,"",rek_nak->p_list);

sprintf(strsql,"%s:%s",rek_nak->marka_avt,rek_nak->gos_nomer);
fprintf(ff,"\n%12s %-*s %s\n","",iceb_tu_kolbait(46,strsql),strsql,rek_nak->pricep);

fprintf(ff,"\n%12s %-*s %-*s %s\n","",
iceb_tu_kolbait(36,rek_nak->perevoz),rek_nak->perevoz,
iceb_tu_kolbait(30,rek_nak->zakaz),rek_nak->zakaz,
rek_nak->voditel);

fprintf(ff,"\x1B\x4D"); /*12-знаков*/
fprintf(ff,"\x0F");  /*Ужатый режим*/
fprintf(ff,"\x1B\x33%c\n",14); /*Уменьшаем межстрочный интервал*/
if(rek_nak->tipz == 1);
 {

  fprintf(ff,"\n%24s %s %s МФО %s Р/р %s в %s\n",
  "",rek_nak->naim,rek_nak->adres,rek_nak->mfo,rek_nak->r_shet,rek_nak->naimb);

  fprintf(ff,"\n%24s Код %s Ліцензія %s дійсна з %s по %s\n",
  " ",rek_nak->edrpou,rek_nak->nomer_lic,rek_nak->datan_lic,rek_nak->datak_lic);

  fprintf(ff,"\n%24s %s %s МФО %s Р/р %s в %s\n",
  "",rek_nak->naim00,rek_nak->adres00,rek_nak->mfo00,rek_nak->r_shet00,rek_nak->naimb00);
  fprintf(ff,"\x1B\x33%c\n",28); /*Уменьшаем межстрочный интервал*/

  fprintf(ff,"\n%24s Код %s Ліцензія %s дійсна з %s по %s\n",
  " ",rek_nak->edrpou00,rek_nak->nomer_lic00,rek_nak->datan_lic00,rek_nak->datak_lic00);

 }
if(rek_nak->tipz == 2);
 {
  fprintf(ff,"\n%24s %s %s МФО %s Р/р %s в %s\n",
  "",rek_nak->naim00,rek_nak->adres00,rek_nak->mfo00,rek_nak->r_shet00,rek_nak->naimb00);
  fprintf(ff,"\x1B\x33%c\n",28); /*Уменьшаем межстрочный интервал*/

  fprintf(ff,"\n%24s Код %s Ліцензія %s дійсна з %s по %s\n",
  " ",rek_nak->edrpou00,rek_nak->nomer_lic00,rek_nak->datan_lic00,rek_nak->datak_lic00);

  fprintf(ff,"\n%24s %s %s МФО %s Р/р %s в %s\n",
  "",rek_nak->naim,rek_nak->adres,rek_nak->mfo,rek_nak->r_shet,rek_nak->naimb);

  fprintf(ff,"\n%24s Код %s Ліцензія %s дійсна з %s по %s\n",
  " ",rek_nak->edrpou,rek_nak->nomer_lic,rek_nak->datan_lic,rek_nak->datak_lic);
 }
 
fprintf(ff,"\n%40s %-*s %s\n",
"",
iceb_tu_kolbait(100,rek_nak->punkt_zag),rek_nak->punkt_zag,
rek_nak->punkt_roz);

short ddov,mdov,gdov;
rsdat(&ddov,&mdov,&gdov,rek_nak->data_dov,1);

memset(naim_mes,'\0',sizeof(naim_mes));
mesc(mdov,1,naim_mes);
char seriq[40];
char nomer_dov[56];

polen(rek_nak->dover,seriq,sizeof(seriq),1,' ');

polen(rek_nak->dover,nomer_dov,sizeof(nomer_dov),2,' ');

fprintf(ff,"\n%64s %-*s %-*s %02d    %-*s %02d\n",
"",
iceb_tu_kolbait(16,seriq),seriq,
iceb_tu_kolbait(23,nomer_dov),nomer_dov,
ddov,
iceb_tu_kolbait(25,naim_mes),naim_mes,
gdov-2000);

for(int ii=0; ii < 15; ii++)
 fprintf(ff,"\n");

fprintf(ff,"%-50s %10.10g %50s %s\n","",kolih,"",suma_prop);
 
fprintf(ff,"\n%20s %10.2f %110s %s\n","",suma_nds,"",rek_nak->akciz_sbor);
fprintf(ff,"\n%165s Накладна %s від %02d.%02d.%d\n","",nomdok,dg,mg,gg);

fprintf(ff,"\f"); //Прогон листа
fprintf(ff,"\x1B\x33%c\n",28); /*Уменьшаем межстрочный интервал*/

int max_kolih_str=21; //Максимальное количество строк которые можно заполнить в документе
int kolih_r=0; //количество распечатаных строк

for(int ii=0; ii < 14; ii++)
 fprintf(ff,"\n");

fprintf(ff,"\x1B\x33%c",21); /*Уменьшаем межстрочный интервал*/
 
int nom_kart=0;
char reg_nom[56];
short dr,mr,gr;
char data_reg[20];
float krat=0.;
char naim_prod[512];
double suma_spdv=0.;

cur.poz_cursor(0);
while(cur.read_cursor(&row) != 0)
 {
  nom_kart=atoi(row[3]);
  memset(reg_nom,'\0',sizeof(reg_nom));
  memset(data_reg,'\0',sizeof(data_reg));  
  krat=0.;

  kolih=atof(row[5]);
  cena=atof(row[6]);
  cena=okrug(cena,okrcn);
  suma=cena*kolih;
  suma=okrug(suma,okrg1);
  suma_spdv=suma+suma*rek_nak->pnds/100.;
  
  suma_spdv=okrug(suma_spdv,0.01);

  if(nom_kart != 0)
   {
    sprintf(strsql,"select krat,datv,rnd from Kart where sklad=%d and nomk=%d",skl,nom_kart);
    if(readkey(strsql,&row1,&cur1) == 1)
     {
      rsdat(&dr,&mr,&gr,row1[1],2);
      sprintf(data_reg,"%02d.%02d.%d",dr,mr,gr);
      strncpy(reg_nom,row1[2],sizeof(reg_nom)-1);
     }
   }
  memset(naim_prod,'\0',sizeof(naim_prod));
  //читаем наименование материалла
  sprintf(strsql,"select naimat from Material where kodm=%s",row[4]);
  if(readkey(strsql,&row1,&cur1) == 1)
   strncpy(naim_prod,row1[0],sizeof(naim_prod)-1);
  
  //читаем в карточке регистрационный номер
  fprintf(ff,"%12s %2d  %-*.*s %10.10g %6s %-25.25s %-26s %10.10g %5s %10.2f %4s %10.2f\n\n",
  "",
  ++kolih_r,
  iceb_tu_kolbait(30,naim_prod),iceb_tu_kolbait(30,naim_prod),naim_prod,
  krat,"",reg_nom,data_reg,kolih,"",suma,"",suma_spdv);
 }

for(int ii=kolih_r; ii < max_kolih_str; ii++)
 fprintf(ff,"\n\n");

fprintf(ff,"%148s %10.2f\n\n","",itogo_bnds+suma_nds);
fprintf(ff,"%148s %10.2f\n","",suma_nds);

fclose(ff);

class iceb_tu_str printer;

iceb_t_poldan("Системный принтер",&printer,"nastsys.alx");

pehf(rek_nak->imaf,4,printer.ravno());
}



/**************************/
/*Запрись реквизитов шапки накладной*/
/**************************************/

int rasalk_zap(short gg, //дата документа
int skl,  //Склад
const char *nomdok,
class tov_tr_nak *rek_nak)
{
char strsql[512];

sprintf(strsql,"delete from Dokummat2 where god=%d and sklad=%d and nomd='%s' and nomerz=1",gg,skl,nomdok);
sql_zapis(strsql,0,0);
if(rek_nak->dover[0] != '\0')
 {
  sprintf(strsql,"insert into Dokummat2 values(%d,%d,'%s',%d,'%s#%s')",gg,skl,nomdok,1,rek_nak->dover,rek_nak->data_dov);
  sql_zapis(strsql,0,0);
 }

sprintf(strsql,"delete from Dokummat2 where god=%d and sklad=%d and nomd='%s' and nomerz=10",gg,skl,nomdok);
sql_zapis(strsql,0,0);
if(rek_nak->gos_nomer[0] != '\0')
 {
  sprintf(strsql,"insert into Dokummat2 values(%d,%d,'%s',%d,'%s')",gg,skl,nomdok,10,rek_nak->gos_nomer);
  sql_zapis(strsql,0,0);
 }

sprintf(strsql,"delete from Dokummat2 where god=%d and sklad=%d and nomd='%s' and nomerz=15",gg,skl,nomdok);
sql_zapis(strsql,0,0);
if(rek_nak->p_list[0] != '\0')
 {
  sprintf(strsql,"insert into Dokummat2 values(%d,%d,'%s',%d,'%s')",gg,skl,nomdok,15,rek_nak->p_list);
  sql_zapis(strsql,0,0);
 }

sprintf(strsql,"delete from Dokummat2 where god=%d and sklad=%d and nomd='%s' and nomerz=16",gg,skl,nomdok);
sql_zapis(strsql,0,0);
if(rek_nak->marka_avt[0] != '\0')
 {
  sprintf(strsql,"insert into Dokummat2 values(%d,%d,'%s',%d,'%s')",gg,skl,nomdok,16,rek_nak->marka_avt);
  sql_zapis(strsql,0,0);
 }

sprintf(strsql,"delete from Dokummat2 where god=%d and sklad=%d and nomd='%s' and nomerz=17",gg,skl,nomdok);
sql_zapis(strsql,0,0);
if(rek_nak->pricep[0] != '\0')
 {
  sprintf(strsql,"insert into Dokummat2 values(%d,%d,'%s',%d,'%s')",gg,skl,nomdok,17,rek_nak->pricep);
  sql_zapis(strsql,0,0);
 }

sprintf(strsql,"delete from Dokummat2 where god=%d and sklad=%d and nomd='%s' and nomerz=18",gg,skl,nomdok);
sql_zapis(strsql,0,0);
if(rek_nak->perevoz[0] != '\0')
 {
  sprintf(strsql,"insert into Dokummat2 values(%d,%d,'%s',%d,'%s')",gg,skl,nomdok,18,rek_nak->perevoz);
  sql_zapis(strsql,0,0);
 }

sprintf(strsql,"delete from Dokummat2 where god=%d and sklad=%d and nomd='%s' and nomerz=19",gg,skl,nomdok);
sql_zapis(strsql,0,0);
if(rek_nak->zakaz[0] != '\0')
 {
  sprintf(strsql,"insert into Dokummat2 values(%d,%d,'%s',%d,'%s')",gg,skl,nomdok,19,rek_nak->zakaz);
  sql_zapis(strsql,0,0);
 }

sprintf(strsql,"delete from Dokummat2 where god=%d and sklad=%d and nomd='%s' and nomerz=20",gg,skl,nomdok);
sql_zapis(strsql,0,0);
if(rek_nak->voditel[0] != '\0')
 {
  sprintf(strsql,"insert into Dokummat2 values(%d,%d,'%s',%d,'%s')",gg,skl,nomdok,20,rek_nak->voditel);
  sql_zapis(strsql,0,0);
 }

sprintf(strsql,"delete from Dokummat2 where god=%d and sklad=%d and nomd='%s' and nomerz=21",gg,skl,nomdok);
sql_zapis(strsql,0,0);
if(rek_nak->punkt_zag[0] != '\0')
 {
  sprintf(strsql,"insert into Dokummat2 values(%d,%d,'%s',%d,'%s')",gg,skl,nomdok,21,rek_nak->punkt_zag);
  sql_zapis(strsql,0,0);
 }

sprintf(strsql,"delete from Dokummat2 where god=%d and sklad=%d and nomd='%s' and nomerz=22",gg,skl,nomdok);
sql_zapis(strsql,0,0);
if(rek_nak->punkt_roz[0] != '\0')
 {
  sprintf(strsql,"insert into Dokummat2 values(%d,%d,'%s',%d,'%s')",gg,skl,nomdok,22,rek_nak->punkt_roz);
  sql_zapis(strsql,0,0);
 }

sprintf(strsql,"delete from Dokummat2 where god=%d and sklad=%d and nomd='%s' and nomerz=23",gg,skl,nomdok);
sql_zapis(strsql,0,0);
if(rek_nak->akciz_sbor[0] != '\0')
 {
  sprintf(strsql,"insert into Dokummat2 values(%d,%d,'%s',%d,'%s')",gg,skl,nomdok,23,rek_nak->akciz_sbor);
  sql_zapis(strsql,0,0);
 }

sprintf(strsql,"delete from Dokummat2 where god=%d and sklad=%d and nomd='%s' and nomerz=24",gg,skl,nomdok);
sql_zapis(strsql,0,0);
if(rek_nak->akciz_sbor[0] != '\0')
 {
  sprintf(strsql,"insert into Dokummat2 values(%d,%d,'%s',%d,'%s|%s-%s')",gg,skl,nomdok,24,
  rek_nak->nomer_lic00,rek_nak->datan_lic00,rek_nak->datak_lic00);
  sql_zapis(strsql,0,0);
 }
sprintf(strsql,"delete from Dokummat2 where god=%d and sklad=%d and nomd='%s' and nomerz=25",gg,skl,nomdok);
sql_zapis(strsql,0,0);
if(rek_nak->akciz_sbor[0] != '\0')
 {
  sprintf(strsql,"insert into Dokummat2 values(%d,%d,'%s',%d,'%s|%s-%s')",gg,skl,nomdok,25,
  rek_nak->nomer_lic,rek_nak->datan_lic,rek_nak->datak_lic);
  sql_zapis(strsql,0,0);
 }

return(0);
}

/*********************/
/*чтение реквизитов контрагента*/
/*******************************/
int rasalk_read_rk(short dg,short mg,short gg,
const char *nomdok,
int skl,
const char *kontr,
char *naim,
char *adres,
char *mfo,
char *r_shet,
char *naimb,
char *ind_kod,
char *edrpou,
char *nomer_lic,
char *datan_lic,
char *datak_lic)
{
SQL_str row;
class SQLCURSOR cur;

if(SRAV(kontr,"00",0) != 0)
if(SRAV(kontr,"00-",1) == 0)
 {
    VVOD SOOB(1);
    SOOB.VVOD_SPISOK_add_MD("Для внутреннего перемещения этот документ не печатается !");
    soobshw(&SOOB,stdscr,-1,-1,0,1);
    return(1);    
  
 }

char strsql[512];
sprintf(strsql,"select naikon,naiban,adres,kod,mfo,nomsh,innn,pnaim from Kontragent where kodkon='%s'",kontr);
if(readkey(strsql,&row,&cur) != 1)
 return(1);
 
strcpy(naim,row[7]);
if(naim[0] == '\0')
 strcpy(naim,row[0]);
strcpy(adres,row[2]);
strcpy(mfo,row[4]);
strcpy(r_shet,row[5]);
strcpy(naimb,row[1]);
strcpy(ind_kod,row[6]);
strcpy(edrpou,row[3]);

int nomer_zap=24;
if(SRAV("00",kontr,0) != 0)
 nomer_zap=25;
 
sprintf(strsql,"select sodz from Dokummat2 where god=%d and nomd='%s' and sklad=%d and nomerz=%d",
gg,nomdok,skl,nomer_zap);
if(readkey(strsql,&row,&cur) == 1)
 {
  POLE(row[0],nomer_lic,1,'|');
  POLE(row[0],strsql,2,'|');
  POLE(strsql,datan_lic,1,'-');
  POLE(strsql,datak_lic,2,'-');
 }
else  
 {
  sprintf(strsql,"select zapis from Kontragent1 where kodkon='%s' and zapis like '%s%%'",
  kontr,
  "Лицензия на алкогольную продукцию");
  if(readkey(strsql,&row,&cur) != 1)
   {
    VVOD SOOB(1);
    sprintf(strsql,"Не найден номер лицензии для контрагента %s !",kontr);
    SOOB.VVOD_SPISOK_add_MD(strsql);
    soobshw(&SOOB,stdscr,-1,-1,0,1);
    return(1);    
   
   }

  POLE(row[0],nomer_lic,2,'|');
  if(nomer_lic[0] == '\0')
   {
    VVOD SOOB(1);
    sprintf(strsql,"Не введён номер лицензии для контрагента %s !",kontr);
    SOOB.VVOD_SPISOK_add_MD(strsql);
    soobshw(&SOOB,stdscr,-1,-1,0,1);
    return(1);    
   }

  sprintf(strsql,"select zapis from Kontragent1 where kodkon='%s' and zapis like '%s%%'",
  kontr,
  "Период действия лицензии на алкогольную продукцию");
  if(readkey(strsql,&row,&cur) != 1)
   {
    VVOD SOOB(1);
    sprintf(strsql,"Не найден период действия лицензии для контрагента %s !",kontr);
    SOOB.VVOD_SPISOK_add_MD(strsql);
    soobshw(&SOOB,stdscr,-1,-1,0,1);
    return(1);    
   
   }
  POLE(row[0],strsql,2,'|');
  POLE(strsql,datan_lic,1,'-');
  POLE(strsql,datak_lic,2,'-');
 }

if(datan_lic[0] == '\0')
 {
  VVOD SOOB(1);
  sprintf(strsql,"Не введена дата начала действия лицензии для контрагента %s !",kontr);
  SOOB.VVOD_SPISOK_add_MD(strsql);
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);    
 }
if(datak_lic[0] == '\0')
 {
  VVOD SOOB(1);
  sprintf(strsql,"Не введена дата конца действия лицензии для контрагента %s !",kontr);
  SOOB.VVOD_SPISOK_add_MD(strsql);
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);    
 }
short dn,mn,gn;
short dk,mk,gk;

if(rsdat(&dn,&mn,&gn,datan_lic,1) != 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD("Не правильно введена дата начала действия лицензии !");
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);    

 }

if(rsdat(&dk,&mk,&gk,datak_lic,1) != 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD("Не правильно введена дата конца действия лицензии !");
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);    

 }

if(sravmydat(dg,mg,gg,dn,mn,gn) < 0)
 {
  VVOD SOOB(1);
  sprintf(strsql,"Не начался срок действия лиценции лицензии для контрагента %s !",kontr);
  SOOB.VVOD_SPISOK_add_MD(strsql);

  sprintf(strsql,"%d.%d.%d-%d.%d.%d",dn,mn,gn,dk,mk,gk);
  SOOB.VVOD_SPISOK_add_MD(strsql);
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);    
 } 

if(sravmydat(dg,mg,gg,dk,mk,gk) > 0)
 {
  VVOD SOOB(1);
  sprintf(strsql,"Закончился срок действия лицензии для контрагента %s !",kontr);
  SOOB.VVOD_SPISOK_add_MD(strsql);
  
  sprintf(strsql,"%d.%d.%d-%d.%d.%d",dn,mn,gn,dk,mk,gk);
  SOOB.VVOD_SPISOK_add_MD(strsql);
  
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);    
 } 

return(0);
}
