/* $Id: rasshetz.c,v 5.24 2011-04-14 16:07:34 sasa Exp $ */
/*22.12.2010	15.09.2000	Белых А.И.	rasshetz.c
Расчет начислений и удержаний заработной платы
*/
#include        <errno.h>
#include        "buhg.h"

double dolhn(long tn,short mp,short gp,int kp,const char *kom,const char *nah_only,FILE *ff);
void     zvanie(long,short,short,int,const char *nah_only,FILE*);
void	zarindex(long,short,short,int,const char *nah_only,FILE*);
void	zarindexv(int,short,short,int,const char *nah_only,FILE*);
void     zarkmd(int tn,short mp,short gp,int podr,const char *nah_only,FILE *ff);
double   podoh1(long,short,short,int,const char *uder_only,FILE*);
void     procent(long,short,short,int,const char *nah_only,FILE*);
double   boln(long,short,short,int,const char *uder_only,FILE*);
double boln1(int tn,short mp,short gp,int podr,const char *uder_only,FILE *ff_prot);
void     profs(long,short,short,int,const char *uder_only,FILE*);
void     kredit(long,short,short,int,const char *uder_only,FILE*);
void     alim(long,short,short,int,const char *uder_only,FILE*);
void     zaruoz(int,short,short,int,const char *uder_only,FILE*);
void     zarvpn(int,short,short,int,const char *uder_only,FILE*);
void zardzn(int tn,short mp,short gp,int podr,const char *nah_only,FILE *ff);

extern short	kodindex;  /*Код индексации*/

void		rasshetz(long tabn,short mp,short gp,int kp,
int prn,  //1-только начисления 2-только удержания 3-все
const char *nah_only,
const char *uder_only,
FILE *ff_prot)
{
double		koefpv;
/*
printw("rasshetz-%ld %d.%d %d %d %d\n",tabn,mp,gp,sovm,kp,prn);
refresh();
*/

if(ff_prot != NULL)
 {
  fprintf(ff_prot,"\nТабельный номер %ld\n",tabn);
  fprintf(ff_prot,"Код начисления:%s\nКод удержания:%s\n",nah_only,uder_only);
 }
if(prn == 1 || prn == 3)
 {
  if(ff_prot != NULL)
    fprintf(ff_prot,"%s\n",gettext("Протокол расчета начислений"));

  /*читаем их здесь так как при пересчёте подоходного для больничного они перечитываются на нужные месяца*/
  /*чтение величины минимальной зарплаты и прожиточного минимума*/
  zar_read_tn(1,mp,gp,ff_prot); 

  koefpv=dolhn(tabn,mp,gp,kp,nah_only,"",ff_prot); /*Должносной оклад*/

  zvanie(tabn,mp,gp,kp,nah_only,ff_prot); /*За звание*/

  procent(tabn,mp,gp,kp,nah_only,ff_prot); /*Процент*/

  zarindex(tabn,mp,gp,kp,nah_only,ff_prot); /*Расчет индексации начислений*/
  zarindexv(tabn,mp,gp,kp,nah_only,ff_prot); /*Расчет индексации на не вовремя выплаченную зарплату*/

  dopdomin(tabn,mp,gp,kp,koefpv,nah_only,ff_prot); /*Расчет начисления до минимальной зарплаты*/
  
  zarkmd(tabn,mp,gp,kp,nah_only,ff_prot); //Расчёт командировочных
  zardzn(tabn,mp,gp,kp,nah_only,ff_prot); /*Расчёт доплаты до средней зарплаты в командировке с учётом надбавки за награду*/
    
 }


if(prn == 2 || prn == 3)
 {
  if(ff_prot != NULL)
    fprintf(ff_prot,"%s\n",gettext("Протокол расчета удержаний"));

  if(zapmas(tabn,mp,gp) == 0)
   {
    /*читаем их здесь так как при пересчёте подоходного для больничного они перечитываются на нужные месяца*/
    /*чтение величины минимальной зарплаты и прожиточного минимума*/
    zar_read_tn(1,mp,gp,ff_prot); 

    podoh1(tabn,mp,gp,kp,uder_only,ff_prot); /*Расчет подоходного налога,пенсионных,соцстраха*/


    zarvpn(tabn,mp,gp,kp,uder_only,ff_prot); /*Возврат подоходного налога*/
    profs(tabn,mp,gp,kp,uder_only,ff_prot); /*Профсоюзный взнос*/

    kredit(tabn,mp,gp,kp,uder_only,ff_prot);  /*кредит */

    alim(tabn,mp,gp,kp,uder_only,ff_prot);    /*алименты*/
 
    zaruoz(tabn,mp,gp,kp,uder_only,ff_prot);    /*расчёт удержания дневного заработка*/
 
    /* перерасчёт больничного делаем здесь так как будут перечитаны настройки по месяцам расчёта*/
    if(sravmydat(1,mp,gp,ICEB_DNDESV,ICEB_MNDESV,ICEB_GNDESV) < 0)
      boln(tabn,mp,gp,kp,uder_only,ff_prot); /*Перерасчет подоходного из за больничных*/
    else        
      boln1(tabn,mp,gp,kp,uder_only,ff_prot); /*Перерасчет подоходного из за больничных*/
    
   }
 }
}
