/* $Id: rasved.c,v 5.121 2011-03-09 08:16:55 sasa Exp $ */
/*20.04.2010    17.11.1992      Белых А.И.      rasved.c
Подпрограмма распечатки ведомости на зарплату с сортировкой по
возростанию табельного номера
Вертикальная форма
*/
#include        <errno.h>
#include        <math.h>
#include        <time.h>
#include        "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif
#define         STR1    16   /*Количество строк на 1-ом листе*/
#define         STR2    28  /*Количество строк на 2-ом листе*/
#define         STRKOR  76  /*Количество строк на листах с корешками*/

class koreshok
 {
  public:
   class SPISOK nahis;
   class SPISOK uder;
   class SPISOK viplati;
   double i_nahis;
   double i_uder;
   double i_viplati;
   double saldo;      

  void clear()
   {
    nahis.free_class();
    uder.free_class();
    viplati.free_class();
    saldo=i_nahis=i_uder=i_viplati=0.;
   }
 };



void            razbiv(char*,char*,char*,char*);
void            srasved(short,short,FILE*,struct tm*);
void rasved_kornuv(class koreshok *kor,FILE *ff);
void rasved_iknuv(class koreshok *kor,FILE *ff);
void rasved_rbknuv(char *imaf_nuv);

extern char     shrpz[16]; /*Счет расчетов по зарплате*/
extern double   okrg; /*Округление*/
extern short    mmm,ggg;
extern char     *organ;/*Наименование организации*/
extern short	*obud; /*Обязательные удержания*/
extern char	*shetb; /*Бюджетные счета начислений*/
extern char	*shetbu; /*Бюджетные счета удержаний*/
extern char	pktn[16]; /*Приставка к табельному номеру*/

int rasved(short ps,class spis_oth *oth) //Признак сортировки 0-по таб. номерам 1-по алфав.
{
double          itsal; /*Общая сумма сальдо*/
char            st[512];
char            str[512];
char            bros[512];
char            naipod[512]; /*Наименование подразделения*/
time_t          tmm;
int            tabb;   /*Табельный номер*/
double          inah,in1;   /*Итого начислено*/
double          iu=0.;   /*Итого удержано с учетом сальдо*/
double          iub=0.;   /*Итого удержано бюджета с учетом сальдо*/
double          ius=0.,ius1=0.;   /*Итого удержано без учета сальдо*/
double          iusb=0.;   /*Итого удержано без учета сальдо бюджета*/
double		iusb1=0.;  /*Итого удержано без учета сальдо бюджета */
double		nahshet=0.; //Итого начислено бюджет
double          bb=0.,bb1=0.;
double          oin;   /*Всего начислено*/
double          oiu;   /*Всего удержано*/
double          dolg;  /*Долг*/
double          itogo,itogo1,itogoo,itogoopb=0.; /*Обший итог по подразделению*/
int             kodnah;  /*Код начисления 1- начисление 2-удержание*/
double          bbr;
int             podr,kpd;
short           listn=0,listn1=0; /*Номер листа*/
short           kolst=0,kolst1=0; /*Счетчик количества строк*/
double          prom;
short           im;
short           kd;
FILE            *kaw,*kawk1,*kawk2,*ffvedom;
FILE            *ff1=NULL,*ff=NULL,*ff2=NULL,*ffpodr=NULL,*ffpodrb=NULL,*ffkor2s=NULL;
FILE *ff_nuv;
char            imaf[24],imaf1[24],imaf2[24],imaf3[24],imafsort[24],imaftmp[24];
char		imafkor1[24],imafkor2[24];
char		imafkor1t[24],imafkor2t[24];
char		imafpodr[30],imafpodrb[30];
char		imafkor2s[30];
char imaf_nuv[56];

short           mkvk; /*0 не выдано кассой 1-выдано кассой*/
short           uhsl; /*Учет сальдо в распечатке ведомости на зарплату 0-включено 1-выключено*/
double		sal;
long		kolstr,kolstr1,kolstr2,kolstr3;
SQL_str         row,row1;
char		strsql[512];
char		fio[312];
class iceb_tu_str fiov("");
char		inn[24];
short		prn;
char		naim[512];
short		mz,gz;
double		sym;
int		knah;
static char	tabel[112];
static char	kodn[112];
static char	podrz[112];
static char	dat1[11];
static char     shetbudget[112];
static char	kateg[112];
static char	grupa[112];
static char	procvip[16];
double 		procentvp=100.;
short		mr,gr;
int		kom,kom1;
short		d,m,g;
char		naived[512];
double		saldb;
short		metkakas=0;
char		nomp[512];
char		dolgn[112];
int		metkavs=0; //Метка выдачи шапки
int		metkavsb=0; //Метка выдачи шапки для бюджета
double		viplata=0.;
int bros_int=0; /*не используемая пока переменная в алгоритме*/

struct  tm      *bf;
SQLCURSOR curr;
tabb=0L;
kodnah=0;
nahshet=itsal=ius=iu=inah=in1=oin=oiu=0.;
if(dat1[0] == '\0')
 sprintf(dat1,"%d.%d",mmm,ggg);
if(procvip[0] == '\0')
 strcpy(procvip,"100");
 
memset(naipod,'\0',sizeof(naipod));
memset(shetbudget,'\0',sizeof(shetbudget));
if(shetb != NULL)
  strncpy(shetbudget,shetb,sizeof(shetbudget)-1);
VVOD MENU(3);
VVOD VV(0);
VV.VVOD_SPISOK_add_ZAG(gettext("Распечатка ведомости на выплату зарплаты"));
 
VV.VVOD_SPISOK_add_data(dat1,8);
VV.VVOD_SPISOK_add_data(podrz,sizeof(podrz));
VV.VVOD_SPISOK_add_data(kodn,sizeof(kodn));
VV.VVOD_SPISOK_add_data(tabel,sizeof(tabel));
VV.VVOD_SPISOK_add_data(kateg,sizeof(kateg));
VV.VVOD_SPISOK_add_data(shetbudget,sizeof(shetbudget));
VV.VVOD_SPISOK_add_data(procvip,sizeof(procvip));
VV.VVOD_SPISOK_add_data(grupa,sizeof(grupa));

VV.VVOD_SPISOK_add_MD(gettext("Дата.............(м.г)..."));//0
VV.VVOD_SPISOK_add_MD(gettext("Подразделение......(,,).."));//1
VV.VVOD_SPISOK_add_MD(gettext("Код начисления.....(,,).."));//2
VV.VVOD_SPISOK_add_MD(gettext("Табельный номер....(,,).."));//3
VV.VVOD_SPISOK_add_MD(gettext("Код категории......(,,).."));//4
VV.VVOD_SPISOK_add_MD(gettext("Счет...............(,,).."));//5
VV.VVOD_SPISOK_add_MD(gettext("Процент выплаты.........."));//6
VV.VVOD_SPISOK_add_MD(gettext("Код группы под-ния..(,,)."));//7


naz:;
clear();

helstr(LINES-1,0,"F1",gettext("помощь"),
"F2/+",gettext("расчитать"),
"F3",gettext("реквизиты"),
"F4",gettext("очистить"),
"F10",gettext("выход"),NULL);

kom=VV.vvod(0,1,1,-1,-1);

strncpy(dat1,VV.VVOD_SPISOK_return_data(0),sizeof(dat1)-1);
strncpy(podrz,VV.VVOD_SPISOK_return_data(1),sizeof(podrz)-1);
strncpy(kodn,VV.VVOD_SPISOK_return_data(2),sizeof(kodn)-1);
strncpy(tabel,VV.VVOD_SPISOK_return_data(3),sizeof(tabel)-1);
strncpy(kateg,VV.VVOD_SPISOK_return_data(4),sizeof(kateg)-1);
strncpy(shetbudget,VV.VVOD_SPISOK_return_data(5),sizeof(shetbudget)-1);
strncpy(procvip,VV.VVOD_SPISOK_return_data(6),sizeof(procvip)-1);
strncpy(grupa,VV.VVOD_SPISOK_return_data(7),sizeof(grupa)-1);

switch (kom)
 {
  case ESC:
  case FK10:
     return(1);
     break;

  case FK1:
    GDITE();
    iceb_t_pdoc("zarp4_1_1.txt");
    goto naz;

  case PLU:
  case FK2:
     break;



  case FK3:
    
    MENU.VVOD_delete();
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка подразделений"));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка начислений"));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка работников"));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка категорий"));
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка групп"));
    MENU.VVOD_SPISOK_add_MD(gettext("Выход"));

    clearstr(LINES-1,0);
    kom1=0;    
    while(menu3w(stdscr,&MENU,&kom1,-1,-1,0) != 0);

    switch (kom1)
     {
      case 5 :
      case -1:
       goto naz;


      case 0 :
        vibrek("Podr",podrz,sizeof(podrz),naim);
        VV.VVOD_SPISOK_zapis_data(1,podrz);
        goto naz;

      case 1 :
        vibrek("Nash",kodn,sizeof(kodn),naim);
        VV.VVOD_SPISOK_zapis_data(2,kodn);
        goto naz;

      case 2 :

        clear();
        tabb=0;
        fiov.new_plus("");
        if(dirtab(&tabb,&fiov,0,1) == 0)
         {
          if(tabel[0] == '\0')
            sprintf(tabel,"%d",tabb);
          else
           {
            sprintf(bros,"%d",tabb);
            if(strlen(tabel)+strlen(bros)+1 < sizeof(tabel)-1)
             {
              strcat(tabel,",");
              strcat(tabel,bros);
             }
           }
          VV.VVOD_SPISOK_zapis_data(3,tabel);

         }
        goto naz;

      case 3 :
        vibrek("Kateg",kateg,sizeof(kateg),naim);
        VV.VVOD_SPISOK_zapis_data(4,kateg);
        goto naz;

      case 4 :
        vibrek("Zargrupp",grupa,sizeof(grupa),naim);
        VV.VVOD_SPISOK_zapis_data(7,grupa);
        goto naz;

     }
  case FK4:
    VV.VVOD_clear_data();
    goto naz;

  default:
    goto naz;
    break;
 }

if(rsdat1(&mr,&gr,dat1) != 0)
 { 
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введена дата !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 } 
procentvp=ATOFM(procvip);

uhsl=0; /*Учет сальдо включен*/
if(iceb_t_poldan("Учет сальдо в распечатке",bros,"zarnast.alx") == 0)
 if(SRAV(bros,"Вкл",1) != 0)
   uhsl=1;  /*Учет сальдо выключен*/

VVOD DANET(1);
DANET.VVOD_SPISOK_add_MD(gettext("С учетом сальдо ?"));

if(uhsl == 1)
 {
  if(danet(&DANET,2,stdscr) == 1)
   uhsl=0; /*Учет сальдо включен*/
 }
else
 if(danet(&DANET,2,stdscr) == 2)
  uhsl=1;/*Учет сальдо выключен*/


memset(naived,'\0',sizeof(naived));
iceb_t_poldan("Наименование ведомости",naived,"zarnast.alx");
if(naived[0] == '\0')
  strncpy(naived,gettext("на выдачу зарплаты"),sizeof(naived)-1);



clear(); /*Очистить экран и закрасить фоновым цветом*/

time(&tmm);
bf=localtime(&tmm);
  
printw("%s\n",gettext("Сортируем записи"));
refresh();
sprintf(strsql,"select tabn,podr,kateg from Zarn where god=%d and mes=%d",
gr,mr);
class SQLCURSOR cur;
if((kolstr2=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

if(kolstr2 == 0)
 {
  iceb_t_soob(gettext("Не найдено ни одной записи !"));
  return(1);
 }
sprintf(imafsort,"sort%d.tmp",getpid());
if((ff1 = fopen(imafsort,"w")) == NULL)
 {
  error_op_nfil(imafsort,errno,"");
  return(1);
 }

kolstr3=kolstr1=0;
while(cur.read_cursor(&row) != 0)
 {
  strzag(LINES-1,0,kolstr2,++kolstr1);

  if(proverka(tabel,row[0],0,0) != 0)
    continue;

  if(proverka(podrz,row[1],0,0) != 0)
    continue;

  if(proverka(kateg,row[2],0,0) != 0)
    continue;

  if(grupa[0] != '\0')
   {
    //Узнаем в какой группе подразделение
    sprintf(strsql,"select grup from Podr where kod=%s",row[1]);
    if(readkey(strsql,&row1,&curr) == 1)
     if(proverka(grupa,row1[0],1,0) != 0)
       continue;
   }

  tabb=atol(row[0]);
  sprintf(strsql,"select fio,inn,nomp,vidan,dolg,kateg from Kartb where tabn=%d",tabb);
  if(readkey(strsql,&row1,&curr) != 1)
   {
    beep();
    printw("%s %d !\n",gettext("Не найден табельный номер"),tabb);
    OSTANOV();
    continue;
   }
  kolstr3++;
  strncpy(fio,row1[0],sizeof(fio));
  strncpy(inn,row1[1],sizeof(inn));
  strncpy(dolgn,row1[4],sizeof(dolgn));
  fprintf(ff1,"%s|%d|%s|%s|%s %s|%s|%s|%s|\n",
  row[1],tabb,fio,inn,gettext("Паспорт"),
  row1[2],row1[3],dolgn,row1[5]);
 }

GDITE();

fclose(ff1);
/*************
if(ps == 0)
  sprintf(strsql,"sort -o %s -t\\|  +0n +1 %s",imafsort,imafsort);
if(ps == 1)
  sprintf(strsql,"sort -o %s -t\\|  +0n -1 +2  %s",imafsort,imafsort);
***********/
if(ps == 0)
  sprintf(strsql,"sort -o %s -t\\| -n -k1,2 -k2,3 %s",imafsort,imafsort);
if(ps == 1)
  sprintf(strsql,"sort -o %s -t\\|  -k1,1 -k3,4  %s",imafsort,imafsort);

//runsystem1(strsql,1);
iceb_t_system(strsql,0);

printw(gettext("Распечатываем ведомость\n"));
refresh();


if((ff1 = fopen(imafsort,"r")) == NULL)
 {
  error_op_nfil(imafsort,errno,"");
  return(1);
 }

sprintf(imaf,"kor%d.lst",getpid());
sprintf(imaf1,"vedom%d.lst",getpid());
sprintf(imaf2,"kasord%d.lst",getpid());
sprintf(imaftmp,"tt%d.tmp",getpid());
sprintf(imafkor1t,"kor1%d.tmp",getpid());
sprintf(imafkor2t,"kor2%d.tmp",getpid());
sprintf(imafkor2s,"kor2s%d.tmp",getpid());
sprintf(imafpodr,"zpodr%d.lst",getpid());
sprintf(imaf_nuv,"kornuv%d.lst",getpid());

class masiv_din_double SUMPODRHOZ;
class masiv_din_double SUMPODRBUD;

class masiv_din_int KOLLISTHOZ;
class masiv_din_int KOLLISTBUD;

if((ff_nuv = fopen(imaf_nuv,"w")) == NULL)
 {
  error_op_nfil(imaf_nuv,errno,"");
  return(1);
 }

fprintf(ff_nuv,"\x1B%s\x1E","3"); //Изменение межстрочного расстояния

if((ffpodr = fopen(imafpodr,"w")) == NULL)
 {
  error_op_nfil(imafpodr,errno,"");
  return(1);
 }


sapreestp(mr,gr,0,ffpodr);

memset(imafpodrb,'\0',sizeof(imafpodrb));
if(shetbudget[0] != '\0')
 {
  sprintf(imafpodrb,"zpodrb%d.lst",getpid());

  if((ffpodrb = fopen(imafpodrb,"w")) == NULL)
   {
    error_op_nfil(imafpodrb,errno,"");
    return(1);
   }

  sapreestp(mr,gr,0,ffpodrb);

 }

if((kaw = fopen(imaftmp,"w")) == NULL)
 {
  error_op_nfil(imaftmp,errno,"");
  return(1);
 }
fprintf(kaw,"\x1B%s\x1E","3"); //Изменение межстрочного расстояния

if((ffkor2s = fopen(imafkor2s,"w")) == NULL)
 {
  error_op_nfil(imafkor2s,errno,"");
  return(1);
 }
fprintf(ffkor2s,"\x1B%s\x1E","3"); //Изменение межстрочного расстояния

if((kawk1 = fopen(imafkor1t,"w")) == NULL)
 {
  error_op_nfil(imafkor1t,errno,"");
  return(1);
 }
fprintf(kawk1,"\x1B%s\x1E","3"); //Изменение межстрочного расстояния

if((kawk2 = fopen(imafkor2t,"w")) == NULL)
 {
  error_op_nfil(imafkor2t,errno,"");
  return(1);
 }
fprintf(kawk2,"\x1B%s\x1E","3"); //Изменение межстрочного расстояния

if((ffvedom = fopen(imaf1,"w")) == NULL)
 {
  error_op_nfil(imaf1,errno,"");
  return(1);
 }

memset(imaf3,'\0',sizeof(imaf3));
if(shetbudget[0] != '\0')
 {
  sprintf(imaf3,"vvsh%d.lst",getpid());
  if((ff2 = fopen(imaf3,"w")) == NULL)
   {
    error_op_nfil(imaf3,errno,"");
    return(1);
   }
 }

if((ff = fopen(imaf2,"w")) == NULL) 
 {
  error_op_nfil(imaf2,errno,"");
  return(1);
 }

srasved(mr,gr,kaw,bf);
srasved(mr,gr,ff_nuv,bf);
srasved(mr,gr,ffkor2s,bf);
srasved(mr,gr,kawk1,bf);
srasved(mr,gr,kawk2,bf);


podr=0;
sal=itogo=itogo1=itogoo=itogoopb=0.;
kolstr1=0;
int nomer_vedom=0;
int nomer_vedom_b=0;
class koreshok kor_nuv;
int kategor=0;

while(fgets(str,sizeof(str),ff1) != 0)
 {
  strzag(LINES-1,0,kolstr3,++kolstr1);
 
  in1=inah=nahshet=iu=ius=iub=iusb=0.;
 
  polen(str,bros,sizeof(bros),1,'|');
  kpd=atoi(bros);

  polen(str,bros,sizeof(bros),2,'|');
  tabb=atol(bros);

  polen(str,fio,sizeof(fio),3,'|');
  polen(str,inn,sizeof(inn),4,'|');
  polen(str,nomp,sizeof(nomp),5,'|');
  polen(str,dolgn,sizeof(dolgn),7,'|');
  polen(str,&kategor,8,'|');
  
  kor_nuv.clear();

  sal=0.;
  /*Читаем сальдо*/

  kor_nuv.saldo=sal=zarsald(1,mr,gr,tabb,&saldb);

  itsal+=sal;

  if(sal < -0.009 && uhsl == 1)
   {
    VVOD SOOB(1);
    SOOB.VVOD_SPISOK_add_MD(gettext("Внимание ! Отрицательное сальдо !"));
    sprintf(strsql,"%s:%d %s",gettext("Табельный номер"),tabb,fio);
    SOOB.VVOD_SPISOK_add_MD(strsql);
    soobshw(&SOOB,stdscr,-1,-1,0,1);
   }            



  if(podr != kpd)
   {
    if(podr != 0)
     {
      if(metkavs == 0)
       {
        itog(ffvedom,itogo);
        fprintf(ffvedom,"\f");
       }

      if(shetbudget[0] != '\0')
       if(metkavsb == 0)
        {
         itog(ff2,itogo1);
         fprintf(ff2,"\f");
         fprintf(ffpodrb,"%3d %-*.*s %10.2f\n",podr,iceb_tu_kolbait(40,naipod),iceb_tu_kolbait(40,naipod),naipod,itogo1);
         itogoopb+=itogo1; 
         if(itogo1 != 0.)
          {
           SUMPODRBUD.plus(itogo1,-1);
           KOLLISTBUD.plus(listn1,-1);
          }
        }

      fprintf(ffpodr,"%3d %-*.*s %10.2f\n",podr,iceb_tu_kolbait(40,naipod),iceb_tu_kolbait(40,naipod),naipod,itogo);
      if(itogo != 0.)
       {
        SUMPODRHOZ.plus(itogo,-1);
        KOLLISTHOZ.plus(listn,-1);
       }      

      itogoo+=itogo; 

      nomer_vedom=nomer_vedom_b=0;
      itogo1=itogo=0.;
     }
    sprintf(strsql,"select naik from Podr where kod=%d",kpd);
    if(readkey(strsql,&row1,&curr) != 1)
     {
      beep();
      printw("%s %d !\n",gettext("Не найден код подразделения"),kpd);
      OSTANOV();
      continue;
     }
    memset(naipod,'\0',sizeof(naipod));
    strncpy(naipod,row1[0],sizeof(naipod));
    ud_simv(naipod,"#");
    
    printw("\n%s%d %s\n",gettext("Подразделение N"),kpd,naipod);
    fprintf(kaw,"\n%s%d %s\n",gettext("Подразделение N"),kpd,naipod);
    fprintf(ff_nuv,"\n%s%d %s\n",gettext("Подразделение N"),kpd,naipod);
    fprintf(ffkor2s,"\n%s%d %s\n",gettext("Подразделение N"),kpd,naipod);
    fprintf(kawk1,"\n%s%d %s\n",gettext("Подразделение N"),kpd,naipod);
    fprintf(kawk2,"\n%s%d %s\n",gettext("Подразделение N"),kpd,naipod);
    listn=listn1=1;
    kolst=kolst1=0;

    metkavs=metkavsb=1;
    podr=kpd;
   }

  sprintf(strsql,"select * from Zarp where datz >= '%04d-%02d-01' and \
datz <= '%04d-%02d-31' and tabn=%d and suma <> 0. order by prn,knah asc",
  gr,mr,gr,mr,tabb);

  if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
   {
    msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
    continue;
   }

  if(kolstr == 0)
   {
    continue;
   }
  im=0;
  while(cur.read_cursor(&row) != 0)
   {

/*
    printw("%s %s %s %s %s %s %s %s\n",
    row[0],row[1],row[2],row[3],row[4],row[5],row[6],row[7]);
*/
    
    if(im == 0)
      peh1(naipod,fio,tabb,inn,mr,gr,dolgn,kategor,kaw,kawk1,kawk2,ffkor2s,ff_nuv);

    prn=atoi(row[2]);

    if(kodnah != prn)
     {
      if(prn == 1)
       {
        sprintf(str,"\
         %s",gettext("Н а ч и с л е н и я"));
	strfil(str,str,1,kaw);
	strfil(str,str,1,ffkor2s);
        fprintf(kawk1,"\n%s\n",str);
        fprintf(kawk2,"\n%s\n",str);
       }

      if(prn == 2)
       {
        sprintf(str,"\
         %s",gettext("У д е р ж а н и я"));
	strfil(str,str,1,kaw);
	strfil(str,str,1,ffkor2s);
        fprintf(kawk1,"\n%s\n",str);
        fprintf(kawk2,"\n%s\n",str);
       }
      kodnah=prn;
     }

    if(prn == 1)
     {
      if(proverka(kodn,row[3],0,1) == 0)
        continue;
      sprintf(strsql,"select naik from Nash where kod=%s",row[3]);
     }

    if(prn == 2)
      sprintf(strsql,"select naik from Uder where kod=%s",row[3]);
       
    if(readkey(strsql,&row1,&curr) != 1)
     {
      beep();
      if(prn == 1)
       printw("%s %s !\n",gettext("Не найден код начисления"),row[3]);
      if(prn == 2)
       printw("%s %s !\n",gettext("Не найден код удержания"),row[3]);
      OSTANOV();
      memset(naim,'\0',sizeof(naim));
     }
    else
      strncpy(naim,row1[0],sizeof(naim)-1);

    knah=atoi(row[3]);
    sym=atof(row[4]);
    gz=atoi(row[6]);
    mz=atoi(row[7]);

    memset(st,'\0',sizeof(st));
    prom=sym;
    mkvk=0;
    if(prn == 2)
     {
      prom*=-1;

      if(provkod(obud,knah) < 0)
        if(gz != gr || mz != mr)
            mkvk=1;
      
     }

    kd=atoi(row[8]);

    prnb(prom,st);
    bros[0]='\0';

    if(kd != 0)
     sprintf(bros,"%d",kd);     

    sprintf(str,"%3d %-*.*s %2s %2d.%4d %-2s %11s",
    knah,
    iceb_tu_kolbait(30,naim),iceb_tu_kolbait(30,naim),naim,
    bros,mz,gz,row[13],st);

    if(prn == 1)
     {
      kor_nuv.nahis.plus(str);
      kor_nuv.i_nahis+=sym;
     }
 
    if(prn == 2)
     {
      if(provkod(obud,knah) >= 0)
       {
        kor_nuv.uder.plus(str);
        kor_nuv.i_uder+=prom;
       }
      else
       {
        kor_nuv.viplati.plus(str);
        kor_nuv.i_viplati+=prom;
       }
     }     


    if(prn == 2 && mkvk == 1)
     {
      strfil(str," ",0,kaw);
      strfil(str,str,0,ffkor2s);

      rsdat(&d,&m,&g,row[0],2);
      sprintf(str,"%3d %-*.*s %2s %2d.%4d %-2s %12s %02d.%02d.%d %-5s %s",
      knah,
      iceb_tu_kolbait(35,naim),iceb_tu_kolbait(35,naim),naim,
      bros,mz,gz,row[13],st,d,m,g,row[5],row[12]);

      fprintf(kawk1,"%s\n",str);
      fprintf(kawk2,"\n");
     }
    else
     {
      strfil(str,str,0,kaw);
      strfil(str,str,0,ffkor2s);

      rsdat(&d,&m,&g,row[0],2);
      sprintf(str,"%3d %-*.*s %2s %2d.%4d %-2s %12s %02d.%02d.%d %-5s %s",
      knah,
      iceb_tu_kolbait(35,naim),iceb_tu_kolbait(35,naim),naim,
      bros,mz,gz,row[13],st,d,m,g,row[5],row[12]);

      fprintf(kawk1,"%s\n",str);
      fprintf(kawk2,"%s\n",str);
     }

    if(prn == 1)
     {

      in1+=sym;
      inah+=sym;
      oin+=sym;

      if(proverka(shetbudget,row[5],0,1) == 0)
         nahshet+=sym;
     }

    if(prn == 2)
     {
      iu+=sym;
      if(proverka(shetbu,row[5],0,1) == 0)
         iub+=sym;
      
      if(gz == gr && mz == mr)
       {
	ius+=sym;

        if(proverka(shetbu,row[5],0,1) == 0)
          iusb+=sym;
       }
      else
       {
        if(provkod(obud,knah) >= 0)
         {
          ius+=sym;
          if(proverka(shetbu,row[5],0,1) == 0)
            iusb+=sym;
         }
       }
      oiu+=sym;


     }

    im++;
   }

  rasved_kornuv(&kor_nuv,ff_nuv);
  
  if(im > 0 || sal != 0.)
   {
    if(im == 0)
      peh1(naipod,fio,tabb,inn,mr,gr,dolgn,kategor,kaw,kawk1,kawk2,ffkor2s,ff_nuv);

    dolg=bbr=inah+iu+sal;
    itogiz(inah,iu,ius,sal,nahshet,iub,iusb,saldb,kaw,kawk1,kawk2,ffkor2s);
    rasved_iknuv(&kor_nuv,ff_nuv);

    if(uhsl == 0)
      dolg=bbr=in1+iu+sal;

    if(uhsl == 1)
     {
      ius1=prbper(mr,gr,mmm,ggg,tabb,&iusb1,0,NULL);
      dolg=bbr=in1+ius+ius1;
     }
/*
    printw("2dolg=%.2f bbr=%.2f\n",dolg,bbr);
    getch();
*/

    if(bbr > 0.009)
     {
      char osnovan[50];
      sprintf(osnovan,"%s %d.%d%s",
      gettext("Заработная плата"),mr,gr,
      gettext("г."));
      sprintf(bros,"%s%d",pktn,tabb);
      kasord2("","",0,bf->tm_mon+1,bf->tm_year+1900,shrpz,bros,bbr,fio,osnovan,"",nomp,"",ff);
      if(metkakas == 0)
       {
        metkakas++;
        fprintf(ff,"\n\n\n");
       }
      else
       {
        metkakas=0;
        fprintf(ff,"\f");
       }
      
      bb=bbr;

      if(shetbu == NULL)
       {
        if(nahshet != 0.)
         {
          bb=(inah-nahshet)*bbr/inah;
          bb=okrug(bb,okrg);        
         }
        if(bb > 0.009)
         {
          if(metkavs == 1)
           {
            if(zarstfn53(naipod,mr,gr,shrpz,"",&bros_int,ffvedom) != 0)
              return(1);
            sspp1(ffvedom,listn,&bros_int);
            metkavs=0;
           }         

          if(procentvp != 100.)
           {
            viplata=bb*procentvp/100.;                    
            viplata=okrug(viplata,okrg);
           }
          else
            viplata=bb;

          itogo+=viplata;
          kolst++;
          
          zarstved(&nomer_vedom,tabb,fio,viplata,ffvedom);
         }

        if(shetbudget[0] != '\0' && nahshet != 0.)
         {
          bb1=bbr-bb;
          if(procentvp != 100.)
           {
            bb1=bb1*procentvp/100.;                    
            bb1=okrug(bb1,okrg);
           }
          if(bb1 > 0.009)
           {
            if(metkavsb == 1)
             {
              if(zarstfn53(naipod,mr,gr,shrpz,"",&bros_int,ff2) != 0)
                return(1);
              sspp1(ff2,listn1,&bros_int);
              metkavsb=0;
             }
            itogo1+=bb1;
            kolst1++;
            zarstved(&nomer_vedom_b,tabb,fio,bb1,ff2);
           }
         }
       }
     }

    if(shetbu != NULL)
     {
      if(uhsl == 0 ) /*С учетом сальдо*/
       {
        bb=bbr-(nahshet+iub+saldb);
       }               
      if(uhsl == 1 ) /*Без учета сальдо*/
       {
        bb=in1-nahshet+(ius-iusb)+(ius1-iusb1);

       }
       
      if(bb > 0.009)
       {
        if(metkavs == 1)
         {
            if(zarstfn53(naipod,mr,gr,shrpz,"",&bros_int,ffvedom) != 0)
              return(1);
          sspp1(ffvedom,listn,&bros_int);
          metkavs=0;
         }         
        if(procentvp != 100.)
         {
          viplata=bb*procentvp/100.;                    
          viplata=okrug(viplata,okrg);
         }
        else
          viplata=bb;
        itogo+=viplata;
        kolst++;
        
        zarstved(&nomer_vedom,tabb,fio,viplata,ffvedom);
       }
      bb=bbr-bb;
      if(procentvp != 100.)
       {
        bb=bb*procentvp/100.;                    
        bb=okrug(bb,okrg);
       }
      if(bb > 0.009)
       {
        if(metkavsb == 1)
          {
           if(zarstfn53(naipod,mr,gr,shrpz,"",&bros_int,ff2) != 0)
                return(1);
           sspp1(ff2,listn1,&bros_int);
           metkavsb=0;
          }
        itogo1+=bb;
        kolst1++;

        zarstved(&nomer_vedom_b,tabb,fio,bb,ff2);
       }

     }

    printw("%8.2f\n",bbr);
   }



  if(listn == 1 && kolst >= STR1)
   {
    listn++;
    kolst=1;
    sspp1(ffvedom,listn,&bros_int);
   }
  if(listn > 1 && kolst > STR2)
   {
    listn++;
    kolst=1;
    sspp1(ffvedom,listn,&bros_int);
   }

  if(shetbudget[0] != '\0')
   {
    if(listn1 == 1 && kolst1 >= STR1)
     {
      listn1++;
      kolst1=1;
      sspp1(ff2,listn1,&bros_int);
     }
    if(listn1 > 1 && kolst1 > STR2)
     {
      listn1++;
      kolst1=1;
      sspp1(ff2,listn1,&bros_int);
     }
   }
 }


GDITE();

if(metkavs == 0)
  itog(ffvedom,itogo);
fprintf(ffpodr,"%3d %-*.*s %10.2f\n",podr,iceb_tu_kolbait(40,naipod),iceb_tu_kolbait(40,naipod),naipod,itogo);
SUMPODRHOZ.plus(itogo,-1);
KOLLISTHOZ.plus(listn,-1);

itogoo+=itogo;
itogoopb+=itogo1;

fprintf(ffpodr,"\
--------------------------------------------------------\n");
fprintf(ffpodr,"%*s %10.2f\n",iceb_tu_kolbait(44,gettext("Итого")),gettext("Итого"),itogoo);

if(shetbudget[0] != '\0')
 {
  fprintf(ffpodrb,"%3d %-*.*s %10.2f\n",podr,iceb_tu_kolbait(40,naipod),iceb_tu_kolbait(40,naipod),naipod,itogo1);
  SUMPODRBUD.plus(itogo1,-1);
  KOLLISTBUD.plus(listn1,-1);
  fprintf(ffpodrb,"\
--------------------------------------------------------\n");
  fprintf(ffpodrb,"%*s %10.2f\n",iceb_tu_kolbait(44,gettext("Итого")),gettext("Итого"),itogoopb);
  if(metkavsb == 0)
   itog(ff2,itogo1);

  podpis(ffpodrb);
  fclose(ffpodrb);

  fclose(ff2);

  sumprved(&SUMPODRBUD,&KOLLISTBUD,imaf3);
 }
printw("\n%s %15s\n",
gettext("Сальдо          -"),prnbr(itsal));

prnb(oin,st);

printw("\
%s %15s\n\
%s %15s\n",
gettext("Итого начислено -"),st,
gettext("Итого удержано  -"),prnbr(oiu));

printw("%s: %.2f\n",
gettext("Общая сумма к выдаче"),itogoo);

fprintf(kaw,"%s: %.2f\n",
gettext("Общая сумма к выдаче"),itogoo);

fprintf(kawk1,"%s: %.2f\n",
gettext("Общая сумма к выдаче"),itogoo);

fprintf(kawk2,"%s: %.2f\n",
gettext("Общая сумма к выдаче"),itogoo);

printw("%s: %.2f\n",
gettext("Общий итог с учетом сальдо"),itsal+oin+oiu);


//Установка левого поля в ноль делается ниже

fclose(kaw);
fclose(ffkor2s);
fclose(ff_nuv);
fclose(kawk1);
fclose(kawk2);
fclose(ffvedom);

sumprved(&SUMPODRHOZ,&KOLLISTHOZ,imaf1);

podpis(ffpodr);

fclose(ffpodr);

fclose(ff1);
fclose(ff);

unlink(imafsort);

razbiv(imaf,imafkor1,imafkor2,imafkor2s);
/*разбивка корешков с начислениями удержаниями и выплатами на листы*/
rasved_rbknuv(imaf_nuv);

printw_vr(tmm);


OSTANOV();


oth->spis_imaf.plus(imaf);
oth->spis_naim.plus(gettext("Корешки (1-с сальдо 2-без сальдо)"));

oth->spis_imaf.plus(imaf1);
oth->spis_naim.plus(gettext("Ведомости на получение заработной платы"));

oth->spis_imaf.plus(imaf2);
oth->spis_naim.plus(gettext("Кассовые ордера на получение заработной платы"));

oth->spis_imaf.plus(imafkor1);
oth->spis_naim.plus(gettext("Корешки с сальдо развёрнутые"));

oth->spis_imaf.plus(imafkor2);
oth->spis_naim.plus(gettext("Корешки без сальдо развёрнутые"));

oth->spis_imaf.plus(imafpodr);
oth->spis_naim.plus(gettext("Свод по подразделениям"));

oth->spis_imaf.plus(imafkor2s);
oth->spis_naim.plus(gettext("Корешки (1-с сальдо 2-с сальдо)"));

oth->spis_imaf.plus(imaf_nuv);
oth->spis_naim.plus(gettext("Корешки c разбивкой на начисления, удержания выплаты"));

if(shetbudget[0] != '\0')
 {
  oth->spis_imaf.plus(imafpodrb);
  oth->spis_naim.plus(gettext("Свод по бюджетным подразделениям"));

  oth->spis_imaf.plus(imaf3);
  oth->spis_naim.plus(gettext("Ведомости на получение бюджетной зарплаты"));

 }
for(int nomer=0; nomer < oth->spis_imaf.kolih(); nomer++)
 iceb_t_ustpeh(oth->spis_imaf.ravno(nomer),1);
 
return(0);
}




/******************************/
/*Разбивка распечатки на листы*/
/******************************/
void razbiv(char *imaf,char *imafkor1,char *imafkor2,char *imafkor2s)
{
FILE            *ff,*ff1,*ff2,*ffk1,*ffk2,*ffk1t,*ffk2t;
FILE		*ffkor2s,*ffkor2ss;
short           dlkr;
short           mok;
short           i;
char		str[1024];
char		bros[1024];
char		imaf1[56],imaf2[56];
char		imafkor1t[56],imafkor2t[56];
char		imafkor2ss[56];

if(iceb_t_poldan("Распечатка корешков на рулоне",bros,"zarnast.alx") == 0)
 if(SRAV(bros,"Вкл",1) == 0)
  {
   printw("%s.\n",gettext("Распечатка корешков на рулоне"));
   refresh();
   sprintf(imaf1,"tt%d.tmp",getpid());
   rename(imaf1,imaf);
   if((ff = fopen(imaf,"a")) == NULL)
     {
      error_op_nfil(imaf,errno,"");
      return;
     }
   fclose(ff);

   sprintf(imafkor1t,"kor1%d.tmp",getpid());
   sprintf(imafkor1,"kor1_%d.lst",getpid());
   rename(imafkor1t,imafkor1);
   if((ff = fopen(imafkor1,"a")) == NULL)
     {
      error_op_nfil(imafkor1,errno,"");
      return;
     }
   fclose(ff);

   sprintf(imafkor2ss,"kor2s%d.tmp",getpid());
   sprintf(imafkor2s,"kor2s%d.lst",getpid());
   rename(imafkor2ss,imafkor2s);
   if((ff = fopen(imafkor2s,"a")) == NULL)
     {
      error_op_nfil(imafkor2s,errno,"");
      return;
     }
   fclose(ff);


   sprintf(imafkor2t,"kor2%d.tmp",getpid());
   sprintf(imafkor2,"kor2_%d.lst",getpid());
   rename(imafkor2t,imafkor2);

   if((ff = fopen(imafkor2,"a")) == NULL)
     {
      error_op_nfil(imafkor2,errno,"");
      return;
     }
   fclose(ff);

   return;   
  }



sprintf(imaf1,"tt%d.tmp",getpid());
if((ff= fopen(imaf1,"r")) == NULL)
 {
  error_op_nfil(imaf1,errno,"");
  return;
 }

sprintf(imaf2,"t%d.tmp",getpid());
if((ff1= fopen(imaf2,"w")) == NULL)
 {
  error_op_nfil(imaf2,errno,"");
  return;
 }

mok=dlkr=0;
while(fgets(str,sizeof(str),ff) != 0)
 {
  dlkr++;
  if(SRAV(str,"------",1) == 0)
   mok++;
  if(mok == 2)
   {
    fprintf(ff1,"%d\n",dlkr);
    mok=dlkr=0;
   }

 }

fclose(ff1);
rewind(ff);

if((ff1= fopen(imaf2,"r")) == NULL)
 {
  error_op_nfil(imaf2,errno,"");
  return;
 }

sprintf(imafkor1t,"kor1%d.tmp",getpid());
if((ffk1t= fopen(imafkor1t,"r")) == NULL)
 {
  error_op_nfil(imafkor1t,errno,"");
  return;
 }

sprintf(imafkor2t,"kor2%d.tmp",getpid());
if((ffk2t= fopen(imafkor2t,"r")) == NULL)
 {
  error_op_nfil(imafkor2t,errno,"");
  return;
 }

sprintf(imafkor2ss,"kor2s%d.tmp",getpid());
if((ffkor2ss= fopen(imafkor2ss,"r")) == NULL)
 {
  error_op_nfil(imafkor2ss,errno,"");
  return;
 }



if((ff2= fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return;
 }
sprintf(imafkor1,"kor1_%d.lst",getpid());
if((ffk1= fopen(imafkor1,"w")) == NULL)
 {
  error_op_nfil(imafkor1,errno,"");
  return;
 }

sprintf(imafkor2,"kor2_%d.lst",getpid());
if((ffk2= fopen(imafkor2,"w")) == NULL)
 {
  error_op_nfil(imafkor2,errno,"");
  return;
 }

sprintf(imafkor2s,"kor2s%d.lst",getpid());
if((ffkor2s= fopen(imafkor2s,"w")) == NULL)
 {
  error_op_nfil(imafkor2s,errno,"");
  return;
 }

mok=dlkr=0;
while(fgets(str,sizeof(str),ff1) != NULL)
 {
  dlkr=atoi(str);
  mok+=dlkr;
  if(mok > STRKOR)
   {
    fprintf(ff2,"\f");
    fprintf(ffk1,"\f");
    fprintf(ffk2,"\f");
    fprintf(ffkor2s,"\f");
    mok=dlkr;
   }

  for(i=0; i < dlkr; i++)
   {
    memset(str,'\0',sizeof(str));
    fgets(str,sizeof(str),ff);
    fprintf(ff2,"%s",str);

    memset(str,'\0',sizeof(str));
    fgets(str,sizeof(str),ffk1t);
    fprintf(ffk1,"%s",str);

    memset(str,'\0',sizeof(str));
    fgets(str,sizeof(str),ffk2t);
    fprintf(ffk2,"%s",str);

    memset(str,'\0',sizeof(str));
    fgets(str,sizeof(str),ffkor2ss);
    fprintf(ffkor2s,"%s",str);

   }

 }

while(fgets(str,sizeof(str),ff) != NULL)
  fprintf(ff2,"%s",str);

memset(str,'\0',sizeof(str));
while(fgets(str,sizeof(str),ffk1t) != NULL)
 fprintf(ffk1,"%s",str);

memset(str,'\0',sizeof(str));
while(fgets(str,sizeof(str),ffk2t) != NULL)
  fprintf(ffk2,"%s",str);

memset(str,'\0',sizeof(str));
while(fgets(str,sizeof(str),ffkor2ss) != NULL)
 fprintf(ffkor2s,"%s",str);



fclose(ff);
fclose(ff1);
fclose(ff2);
fclose(ffk1);
fclose(ffk2);
fclose(ffk1t);
fclose(ffk2t);
fclose(ffkor2ss);
fclose(ffkor2s);

unlink(imaf1);
unlink(imaf2);
unlink(imafkor1t);
unlink(imafkor2t);
unlink(imafkor2ss);

}

/*************************************/
/*Шапка для рееста по подразделениям*/
/*************************************/
void	sapreestp(short mr,short gr,
int metka, //0-не бюджет 1-бюджет
FILE *ffpodr)
{
fprintf(ffpodr,"%s\n\n",organ);
if(metka == 1)
  fprintf(ffpodr,"%s",gettext("Бюджет"));

fprintf(ffpodr,"%s %02d.%d%s\n",
gettext("Реестр платежных ведомостей за"),mr,gr,
gettext("г."));

fprintf(ffpodr,"\
--------------------------------------------------------\n");
fprintf(ffpodr,gettext("\
Код|     Наименование подразделения         |  Сумма   |\n"));
fprintf(ffpodr,"\
--------------------------------------------------------\n");
}
/***************************/
/*Шапка распечаток корешков*/
/***************************/
void srasved(short mr,short gr,FILE *kaw,
struct tm *bf)
{
fprintf(kaw,"\
%s\n\
%s %d.%d%s\n\
%s %d.%d.%d%s  %s: %d.%d\n\n",
organ,
gettext("Ведомость на зарплату за"),
mr,gr,
gettext("г."),
gettext("По состоянию на"),
bf->tm_mday,bf->tm_mon+1,bf->tm_year+1900,
gettext("г."),
gettext("Время"),
bf->tm_hour,bf->tm_min);

}
/***************************************/
/*Распечатка начислений, удержаний и выплат в корешок*/
/***************************************************/

void rasved_kornuv(class koreshok *kor,FILE *ff)
{
char str[512];
int kol=kor->nahis.kolih();
if(kol > 0)
 {
  sprintf(str,"\
         %s",gettext("Н а ч и с л е н и я"));
  strfil(str,str,1,ff);
  for(int ii=0; ii < kol;ii++)
   {
    strncpy(str,kor->nahis.ravno(ii),sizeof(str)-1);
    strfil(str,str,0,ff);

   }

 }
kol=kor->uder.kolih();
if(kol > 0)
 {
  sprintf(str,"\
         %s",gettext("У д е р ж а н и я"));
  strfil(str,str,1,ff);
  for(int ii=0; ii < kol;ii++)
   {
    strncpy(str,kor->uder.ravno(ii),sizeof(str)-1);
    strfil(str,str,0,ff);

   }

 }

kol=kor->viplati.kolih();
if(kol > 0)
 {
  sprintf(str,"\
         %s",gettext("В ы п л а т ы"));
  strfil(str,str,1,ff);
  for(int ii=0; ii < kol;ii++)
   {
    strncpy(str,kor->viplati.ravno(ii),sizeof(str)-1);
    strfil(str,str,0,ff);

   }

 }

}
/******************************/
/*итог по корешку с начислениями удержаниями выплатами*/
/**************************************************/
void rasved_iknuv(class koreshok *kor,FILE *ff)
{
char str[512];
sprintf(str,"%s %14s",gettext("Сальдо на начало месяца -"),prnbr(kor->saldo));
strfil(str,str,1,ff);

sprintf(str,"\
%s %14s",
gettext("Итого начислено         -"),
prnbr(kor->i_nahis));

strfil(str,str,0,ff);

sprintf(str,"\
%s %14s",
gettext("Итого удержано          -"),
prnbr(kor->i_uder));

strfil(str,str,0,ff);

sprintf(str,"\
%s %14s",
gettext("Итого выплачено         -"),
prnbr(kor->i_viplati));

strfil(str,str,0,ff);

double bbr=kor->saldo+kor->i_nahis-kor->i_uder-kor->i_viplati;

if(bbr < 0.)
 sprintf(str,"\
%s %14s",
 gettext("Сальдо конечное        -"),prnbr(bbr));
else
 sprintf(str,"\
%s %14s",
  gettext("К выдаче               -"),prnbr(bbr));

strfil(str,str,0,ff);

sprintf(str,"\
------------------------------------------------------------");
strfil(str,str,0,ff);

}

/*****************************************************************/
/*разбивка на листы корешков с начислениями удержаниями выплатами*/
/******************************************************************/

void rasved_rbknuv(char *imaf_nuv)
{
char str[1024];
char bros[1024];
char imaf_dat[56];
char imaf_tmp[56];
FILE *ff;
FILE *ff_dat;
FILE *ff_tmp;

if(iceb_t_poldan("Распечатка корешков на рулоне",bros,"zarnast.alx") == 0)
 if(SRAV(bros,"Вкл",1) == 0)
  {
   if((ff = fopen(imaf_nuv,"a")) == NULL)
     {
      error_op_nfil(imaf_nuv,errno,"");
      return;
     }
   fclose(ff);
   return;
  }


if((ff= fopen(imaf_nuv,"r")) == NULL)
 {
  error_op_nfil(imaf_nuv,errno,"");
  return;
 }

sprintf(imaf_dat,"kordat%d.tmp",getpid());

if((ff_dat= fopen(imaf_dat,"w")) == NULL)
 {
  error_op_nfil(imaf_dat,errno,"");
  return;
 }

int dlkr=0,mok=0;
while(fgets(str,sizeof(str),ff) != 0)
 {
  dlkr++;
  if(SRAV(str,"------",1) == 0)
   mok++;
  if(mok == 2)
   {
    fprintf(ff_dat,"%d\n",dlkr);
    mok=dlkr=0;
   }

 }

fclose(ff_dat);
rewind(ff);


sprintf(imaf_tmp,"kortmp%d.tmp",getpid());

if((ff_tmp= fopen(imaf_tmp,"w")) == NULL)
 {
  error_op_nfil(imaf_tmp,errno,"");
  return;
 }

if((ff_dat= fopen(imaf_dat,"r")) == NULL)
 {
  error_op_nfil(imaf_dat,errno,"");
  return;
 }


while(fgets(str,sizeof(str),ff_dat) != NULL)
 {
  dlkr=atoi(str);
  mok+=dlkr;
  if(mok > STRKOR)
   {
    fprintf(ff_tmp,"\f");
    mok=dlkr;
   }

  for(int i=0; i < dlkr; i++)
   {
    memset(str,'\0',sizeof(str));
    fgets(str,sizeof(str),ff);
    fprintf(ff_tmp,"%s",str);


   }

 }

while(fgets(str,sizeof(str),ff) != NULL)
  fprintf(ff_tmp,"%s",str);


fclose(ff_dat);
fclose(ff_tmp);
fclose(ff);

rename(imaf_tmp,imaf_nuv);
unlink(imaf_dat);
}
