/* $Id: raszall.c,v 5.24 2011-01-13 13:43:23 sasa1 Exp $ */
/*21.12.2010	15.09.2000	Белых А.И.	raszall.c
Автоматизированный расчет зарплаты по всем карточкам сразу
*/
#include        <errno.h>
#include        <math.h>
#include        <time.h>
#include        "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

void	raszallr(short,short,const char*,const char*,const char *nah_only,const char *uder_only,int,FILE*);

extern short	mmm,ggg;

void	raszall(int metka)   //1-только начисления 2-только удержания 3-все
{
time_t          tmm;
static char	dat1[9];
static class iceb_tu_str podr("");
static class iceb_tu_str tabnom("");
static class iceb_tu_str nah_only("");
static class iceb_tu_str uder_only("");
int		kom,kom1;
short		mn,gn;
class iceb_tu_str naimp;
int		metkaprot=0;
FILE		*ff=NULL;
char		imaf[32];
int tabnomer=0;
if(dat1[0] == '\0')
 sprintf(dat1,"%d.%d",mmm,ggg);

VVOD VV(0);
VVOD MENU(3);

if(metka == 3)
  VV.VVOD_SPISOK_add_ZAG(gettext("Расчет начислений и удержаний по всем карточкам"));
if(metka == 1)
  VV.VVOD_SPISOK_add_ZAG(gettext("Расчет только начислений по всем карточкам"));
if(metka == 2)
  VV.VVOD_SPISOK_add_ZAG(gettext("Расчет только удержаний по всем карточкам"));

VV.VVOD_SPISOK_add_MD(gettext("Дата.............(м.г).."));
VV.VVOD_SPISOK_add_MD(gettext("Код подразделения..(,,)."));
VV.VVOD_SPISOK_add_MD(gettext("Табельный номер....(,,)."));
VV.VVOD_SPISOK_add_MD(gettext("Код начисления.....(,,)."));
VV.VVOD_SPISOK_add_MD(gettext("Код удержания......(,,)."));

VV.VVOD_SPISOK_add_data(dat1,8);
VV.VVOD_SPISOK_add_data(podr.ravno(),112);
VV.VVOD_SPISOK_add_data(tabnom.ravno(),112);
VV.VVOD_SPISOK_add_data(nah_only.ravno(),112);
VV.VVOD_SPISOK_add_data(uder_only.ravno(),112);

naz:;

clear(); 

helstr(LINES-1,0,"F1",gettext("помощь"),
"F2/+/-",gettext("расчет"),
"F3",gettext("реквизиты"),
"F4",gettext("очистить"),
"F10",gettext("выход"),NULL);

kom=VV.vvod(0,1,1,-1,-1);

strncpy(dat1,VV.VVOD_SPISOK_return_data(0),sizeof(dat1)-1);
podr.new_plus(VV.VVOD_SPISOK_return_data(1));
tabnom.new_plus(VV.VVOD_SPISOK_return_data(2));
nah_only.new_plus(VV.VVOD_SPISOK_return_data(3));
uder_only.new_plus(VV.VVOD_SPISOK_return_data(4));

switch(kom)
 {
  case FK1:   /*Помощь*/
   GDITE();
   iceb_t_pdoc("zarp2_7.txt");
   goto naz;

  case FK10:
  case ESC:
   return;

  case FK2:
  case PLU:
   metkaprot=0; //Без протокола
   break;

  case OTN:
   metkaprot=1; //С протоколом
   break;

  case FK3:
    MENU.VVOD_delete();
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка подразделений"));//0
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка начислений"));//1
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка удержаний"));//2
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка табельных номеров"));//3
    MENU.VVOD_SPISOK_add_MD(gettext("Выход"));//4

    clearstr(LINES-1,0);
    
    kom1=0;
    while(menu3w(stdscr,&MENU,&kom1,-1,-1,0) != 0);

    switch (kom1)
     {
      case 4 :
      case -1:
       goto naz;

      case 0 :
        if(vibrek("Podr",&podr,&naimp) == 0)
          VV.VVOD_SPISOK_zapis_data(1,podr.ravno());
        break;

      case 1 :
        if(vibrek("Nash",&nah_only,&naimp) == 0)
          VV.VVOD_SPISOK_zapis_data(3,nah_only.ravno());
        break;

      case 2 :
        if(vibrek("Uder",&uder_only,&naimp) == 0)
          VV.VVOD_SPISOK_zapis_data(4,uder_only.ravno());
        break;
      case 3 :
        if(dirtab(&tabnomer,&naimp,0,1) == 0)
          VV.data_z_plus(2,tabnomer);
        break;
       
     }      

    goto naz;

  case FK4:
   VV.VVOD_clear_data();
   goto naz;

  default:
    goto naz;
 }

if(rsdat1(&mn,&gn,dat1) != 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введена дата !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }
if(iceb_t_pbpds(mn,gn) != 0)
 goto naz;

time(&tmm);

sprintf(imaf,"avtr%d.lst",getpid());

if(metkaprot == 1)
 {
  printw("%s\n",gettext("Проотокол расчета"));
  if((ff = fopen(imaf,"w")) == NULL)
   {
    error_op_nfil(imaf,errno,"");
    return;
   }
 }

raszallr(mn,gn,podr.ravno(),tabnom.ravno(),nah_only.ravno(),uder_only.ravno(),metka,ff);

printw_vr(tmm);

VVOD SOOB(1);
SOOB.VVOD_SPISOK_add_MD(gettext("Расчет закончен"));
soobshw(&SOOB,stdscr,-1,-1,0,1);


if(metkaprot == 1)
 {
  
  fclose(ff);

  class spis_oth oth;
  oth.spis_imaf.plus(imaf);
  oth.spis_naim.plus(gettext("Протокол расчета"));
  iceb_t_ustpeh(imaf,3);
  iceb_t_rabfil(&oth,"");

 }



}
