/* $Id: specnast.c,v 5.15 2011-01-13 13:43:23 sasa1 Exp $ */
/*12.12.2010    14.04.1997      Белых А.И.     specnast.c
Чтение настpойки для работы со спецификациями
*/
#include        <errno.h>
#include	"buhg.h"
#ifdef	HAVE_UNISTD_H
#include        <unistd.h>
#endif

SQL_baza	bd;

short           mfnn; /*Метка формирования номера накладной
                      -1 - Автоматическая нумерация выключена
                       0 - Приходы и расходы - нумерация общая
                       1 - Приходы отдельно расходы отдельно
                       */
short		startgodb;
short		startgod;
short		vplsh; /*0-двух уровневый план счетов 1-многоуровневый*/
char            *mtsh=NULL;  /*Перечень материальных счетов*/
double		okrcn;  /*Округление цены*/
double		okrg1;  /*Округление 1*/
char		*shrt=NULL;    /*Счета розничной торговли*/
double		kursue;/*Курс условной единицы*/
short		vtara; /*Код группы возвратная тара*/
short metka_pros_mat_s_ost=0; //0-показывать все материалы 1-только имеющие остаток (для расходных документов)

int		specnast(void)
{
char		st1[1024];
char		bros[512];
int		i;
SQL_str row_alx;
class SQLCURSOR cur_alx;
int kolstr=0;
char strsql[512];

mfnn=(-1);

vplsh=startgodb=0;
okrcn=0.;
metka_pros_mat_s_ost=0;

sprintf(strsql,"select str from Alx where fil='matnast.alx' order by ns asc");
if((kolstr=cur_alx.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

if(kolstr == 0)
 {
  sprintf(strsql,"%s %s!",gettext("Не найдена настройка"),"matnast.alx");
  iceb_t_soob(strsql);
  return(1);
 }


vtara=startgod=0;
//cnsnds=0;
kursue=okrg1=0.;
if(shrt != NULL)
 {
  free(shrt);
  shrt=NULL;
 }
if(mtsh != NULL)
 {
  free(mtsh);
  mtsh=NULL;
 }

while(cur_alx.read_cursor(&row_alx) != 0)
 {
  if(row_alx[0][0] == '#')
   continue;
  polen(row_alx[0],st1,sizeof(st1),1,'|');

  if(SRAV(st1,"Раздельная нумерация накладных",0) == 0)
    {
     mfnn=0;
     
     polen(row_alx[0],st1,sizeof(st1),2,'|');
     if(st1[0] == '\0' || st1[0] == '\n')
      mfnn=(-1);
      
     if(SRAV(st1,"Вкл",1) == 0)
       mfnn=1;
     continue;
    }
  if(SRAV(st1,"Показывать только материалы имеющие остаток",0) == 0)
    {
     polen(row_alx[0],st1,sizeof(st1),2,'|');
     if(SRAV(st1,"Вкл",1) == 0)
        metka_pros_mat_s_ost=1;
     else
        metka_pros_mat_s_ost=0;
     
     continue;
    }

  if(SRAV(st1,"Код группы возвратная тара",0) == 0)
    {
     POLE(row_alx[0],st1,2,'|');
     vtara=(int)ATOFM(st1);
     continue;
    }
  if(SRAV(st1,"Стартовый год",0) == 0)
    {
     POLE(row_alx[0],st1,2,'|');
     startgod=(int)ATOFM(st1); 
     continue;
    }
  if(SRAV(st1,"Курс УЕ",0) == 0)
    {
     POLE(row_alx[0],st1,2,'|');
     kursue=ATOFM(st1);
     continue;
    }
  if(SRAV(st1,"Перечень материальных счетов",0) == 0)
    {
     POLE(row_alx[0],bros,2,'|');
     i=strlen(bros)+1;
     if((mtsh=(char *)malloc(i*sizeof(char))) == NULL)
       error2(20,0,1,"Не могу выделить пямять для mtsh !");
     strcpy(mtsh,bros);
     continue;
    }

  if(SRAV(st1,"Счета розничной торговли",0) == 0)
    {
     memset(bros,'\0',sizeof(bros));
     POLE(row_alx[0],bros,2,'|');
     i=strlen(bros)+1;
     if((shrt=(char *)malloc(i*sizeof(char))) == NULL)
       error2(20,0,1,"Не могу выделить пямять для shrt !");
     strcpy(shrt,bros);
     continue;
    }

  if(SRAV(st1,"Округление цены",0) == 0)
    {
     polen(row_alx[0],st1,sizeof(st1),2,'|');
     okrcn=ATOFM(st1);
     continue;
    }

  if(SRAV(st1,"Округление 1",0) == 0)
    {
     POLE(row_alx[0],st1,2,'|');
     okrg1=ATOFM(st1);
     continue;
    }
/**************
  if(SRAV(st1,"Цена материалла с НДС",0) == 0)
    {
     POLE(row_alx[0],st1,2,'|');
     if(SRAV(st1,"Вкл",1) == 0)
       cnsnds=1;
     continue;
    }
  if(SRAV(st1,"Н.Д.С.",0) == 0)
    {
     POLE(row_alx[0],st1,2,'|');
     nds1=ATOFM(st1);
     nds1=okrug(nds1,0.01);
     continue;
    }
******************/

 }

iceb_t_poldan("Многопорядковый план счетов",bros,"nastrb.alx");
if(SRAV(bros,"Вкл",1) == 0)
 vplsh=1;

memset(bros,'\0',sizeof(bros));
startgodb=0;
if(iceb_t_poldan("Стартовый год",bros,"nastrb.alx") == 0)
 {
  startgodb=(short)ATOFM(bros);
 }
 
return(0);

}
