/* $Id: srvcenr.c,v 5.35 2011-01-13 13:43:23 sasa1 Exp $ */
/*11.01.2010	23.02.2001	Белых А.И	srvcenr.c	
Программа определения средневзвешенной цены на материал
Необходимо посмотреть на какие материалы был приход в заказанном
месяце. определить ненулевые остатки по карточкам и суммы остатков
Разделить сумму на количество и получить средневзвешенную цену
Записать новую карточку с общим остатком и списать остатки со всех 
остальных карточек

Для каких материалов был приход в карточки
Определяем все карточки на этот материал с не нулевым остатком
вычисляем средне-взвешеннуюцену

*/

#include        <time.h>
#include        <pwd.h>
#include        <sys/types.h>
#include        <sys/stat.h>
#include        <math.h>
#include        <errno.h>
#include        "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

void	zapiskart(short,short,short,char*,char*,char*,char*,double*,
double*,char*,char*,char*,char*,char*,int*);

extern char	*maskmat; /*Массив кодов отмеченных материалов*/
extern double	okrcn;
extern char	*kodopsrvc; //Код операции расчета средневзвешенной цены
extern short	vtara; /*Код группы возвратная тара*/

void srvcenr(short mr,short gr,char shet[],char gruppa[],char kodmat[],char sklz[])
{
class ostatokt ost;
struct stat work;
long		kolstr;
SQL_str         row,row1;
char		strsql[512];
char		imaftmp[32],imaftmp2[32];
FILE		*fftmp,*fftmp2;
char		skladz[32],sklad[32];
char		kodmz[32],kodm[32];
char		cena[32];
short		dr;
char		nomd[56],nomdo[56];
time_t		tmm=0;
double		kolihi=0.;
double  	suma=0.;
char		ei[32],eiz[32];
char		mnds[5],mndsz[5];
char    	nds[32],ndsz[32];
char		shetuz[32],shetu[32];
char 		strok[1024];
char		nomkar[32],nomkarz[32];
int		kolzom=0; //Количество записей одного материалла
char		kontr[32];
SQLCURSOR cur;

clear();
printw(gettext("Расчет средневзвешенных цен на материалы."));
printw("\n%d.%d\n",mr,gr);
GDITE();

int prov1=0;
int prov2=0;
//Смотрим нужно ли делать проводки

//Проверяем есть ли код операции в списке приходов и расходов
sprintf(strsql,"select prov from Prihod where kod='%s'",kodopsrvc);
if(sql_readkey(&bd,strsql,&row,&cur) != 1)
 {
  VVOD SOOB(1);
  sprintf(strsql,gettext("Не найден код %s в списке операций приходов !"),kodopsrvc);
  SOOB.VVOD_SPISOK_add_MD(strsql);
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return;

 }
prov1=atoi(row[0]);
sprintf(strsql,"select prov from Rashod where kod='%s'",kodopsrvc);
if(sql_readkey(&bd,strsql,&row,&cur) != 1)
 {
  VVOD SOOB(1);
  sprintf(strsql,gettext("Не найден код %s в списке операций расходов !"),kodopsrvc);
  SOOB.VVOD_SPISOK_add_MD(strsql);
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return;
 }
prov2=atoi(row[0]);

dpm(&dr,&mr,&gr,5);

sprintf(strsql,"select sklad,nomk from Zkart where \
datdp >= '%04d-%d-01' and datdp <= '%04d-%d-%d' and tipz=1 order by \
nomk asc",gr,mr,gr,mr,dr);


if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);

if(kolstr == 0)
 {
//  printw("%s\n",strsql);
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не было ни одного прихода !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return;
 }

sprintf(imaftmp,"srvcen%d.tmp",getpid());
if((fftmp = fopen(imaftmp,"w")) == NULL)
   {
    error_op_nfil(imaftmp,errno,"");
    return;
   }
int kolstr1=0; 
SQLCURSOR cur1;
while(cur.read_cursor(&row) != 0)
 {  
//  printw("***%s %s\n",row[0],row[1]);
  strzag(LINES-1,0,kolstr,++kolstr1);
  if(proverka(sklz,row[0],0,0) != 0)
   continue;
  strncpy(sklad,row[0],sizeof(sklad)-1);

  strncpy(nomkar,row[1],sizeof(nomkar)-1);
    
  ostkar(1,mr,gr,31,mr,gr,atoi(row[0]),atoi(row[1]),&ost);
/**********
  printw("%s %s\n",sklad,nomkar);
  printw("%f %f %f %f\n",ost.ostg[0],ost.ostg[1],ost.ostg[1],ost.ostg[1]);
  printw("%f %f %f %f\n",ost.ostm[0],ost.ostm[1],ost.ostm[1],ost.ostm[1]);
************/  

  if(ost.ostg[3] <= 0.) //Если нет остатка
     continue;
  if(ost.ostm[1] <= 0.) //Если не было прихода
     continue;

  //Читаем код материалла
  sprintf(strsql,"select shetu,ei,nds,mnds,kodm,innom,nomz from Kart where sklad=%s and nomk=%s",
  row[0],row[1]);
  if(sql_readkey(&bd,strsql,&row1,&cur1) != 1)
   {
    printw("Не найдена карточка %s на складе %s !\n",row[1],row[0]);
    OSTANOV();
    continue;
   } 
  if(row1[5][0] != '\0' || row1[6][0] != '\0')
    continue;
  strncpy(shetu,row1[0],sizeof(shetu)-1);
  strncpy(ei,row1[1],sizeof(ei)-1);
  strncpy(nds,row1[2],sizeof(nds)-1);
  strncpy(mnds,row1[3],sizeof(mnds)-1);
  strncpy(kodm,row1[4],sizeof(kodm)-1);
  if(proverka(shet,shetu,0,0) != 0)
    continue;

  if(kodmat[0] != '\0')
   {
   if(kodmat[0] == '*' && maskmat != NULL)
    {
     if(proverka(maskmat,kodm,0,0) != 0)
      continue;
    }
   else
    if(proverka(kodmat,kodm,0,0) != 0)
      continue;
   }
  sprintf(strsql,"select kodgr,naimat from Material where kodm=%s",kodm);
  if(sql_readkey(&bd,strsql,&row1,&cur1) != 1)
   {
    VVOD SOOB(1);
    sprintf(strsql,"%s %s !\n",gettext("Не найден код материалла"),kodm);
    SOOB.VVOD_SPISOK_add_MD(strsql);
    soobshw(&SOOB,stdscr,-1,-1,0,1);
    continue;
   }

  if(vtara == atoi(row1[0]))
    continue;
    
  if(proverka(gruppa,row1[0],0,0) != 0)
     continue;

/*
  printw("%4s %s\n",
  kodm,row1[1]);
*/
  fprintf(fftmp,"%s|%s|%s|%s|\n",
  sklad,shetu,ei,kodm);
/**********
  fprintf(fftmp,"%s|%s|%s|%s|%s|%s|\n",
  sklad,shetu,ei,nds,mnds,kodm);
**********/
 } 
GDITE();
fclose(fftmp);
sprintf(strsql,"sort -o %s -t\\| -u %s",imaftmp,imaftmp);
runsystem(strsql);

stat(imaftmp,&work);

if((fftmp = fopen(imaftmp,"r")) == NULL)
   {
    error_op_nfil(imaftmp,errno,"");
    return;
   }

sprintf(imaftmp2,"srvcenn%d.tmp",getpid());
if((fftmp2 = fopen(imaftmp2,"w")) == NULL)
   {
    error_op_nfil(imaftmp2,errno,"");
    return;
   }
kolstr1=0;
while(fgets(strok,sizeof(strok),fftmp) != NULL)
 {
  kolstr1+=strlen(strok);
  strzag(LINES-1,0,work.st_size,kolstr1);

  polen(strok,sklad,sizeof(sklad),1,'|');
  polen(strok,shetu,sizeof(shetu),2,'|');
  polen(strok,ei,sizeof(ei),3,'|');
//  polen(strok,nds,sizeof(nds),4,'|');
//  polen(strok,mnds,sizeof(mnds),5,'|');
  polen(strok,kodm,sizeof(kodm),4,'|');

  //Ищем все карточки с этим материалом
/*
  sprintf(strsql,"select shetu,ei,nds,mnds,kodm,cena,nomk from Kart \
where sklad=%s and kodm=%s and shetu='%s' and ei='%s' and nds=%s and \
mnds=%s",sklad,kodm,shetu,ei,nds,mnds);
*/
  
  sprintf(strsql,"select shetu,ei,nds,mnds,kodm,cena,nomk from Kart \
where sklad=%s and kodm=%s and shetu='%s' and ei='%s'",
  sklad,kodm,shetu,ei);

//  printw("%s\n",strsql);
  
  if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
   {
    printw("%s\n",sql_error(&bd));
    OSTANOV();
   }

  if(kolstr == 0)
   {
    continue;
   }

  while(cur.read_cursor(&row) != 0)
   {
    ostkar(1,mr,gr,31,mr,gr,atoi(sklad),atoi(row[6]),&ost);

//  printw("%f %f %f %f\n",ost.ostg[0],ost.ostg[1],ost.ostg[1],ost.ostg[1]);
//  printw("%f %f %f %f\n",ost.ostm[0],ost.ostm[1],ost.ostm[1],ost.ostm[1]);


    if(ost.ostm[3] <= 0.) //Если нет остатка
     continue;

    strncpy(shetu,row[0],sizeof(shetu)-1);
    strncpy(ei,row[1],sizeof(ei)-1);
    strncpy(nds,row[2],sizeof(nds)-1);
    strncpy(mnds,row[3],sizeof(mnds)-1);
    strncpy(kodm,row[4],sizeof(kodm)-1);
    strncpy(cena,row[5],sizeof(cena)-1);
    strncpy(nomkar,row[6],sizeof(nomkar)-1);
    
/******
    fprintf(fftmp2,"%s|%s|%s|%s|%s|%.10g|%s|\n",
    sklad,shetu,ei,kodm,cena,ost.ostm[3],nomkar);
***********/
    fprintf(fftmp2,"%s|%s|%s|%s|%s|%s|%s|%.10g|%s|\n",
    sklad,shetu,ei,kodm,nds,mnds,cena,ost.ostm[3],nomkar);
   }
  
/*************
1 - склад
2 - счет учета
3 - единица измерения
4 - НДС
5 - 0-цена без НДС 1-цена с НДС
6 - код материалла
7 - цена
8 - количество 
9 - номер карточки
 ****************/
 }
GDITE();
fclose(fftmp2);
fclose(fftmp);
unlink(imaftmp);


//sprintf(strsql,"sort -o %s -t\\| +0n -1 %s",imaftmp2,imaftmp2);
sprintf(strsql,"sort -o %s -t\\| -k1,2n %s",imaftmp2,imaftmp2);
runsystem(strsql);

stat(imaftmp2,&work);

if((fftmp2 = fopen(imaftmp2,"r")) == NULL)
   {
    error_op_nfil(imaftmp2,errno,"");
    return;
   }

memset(skladz,'\0',sizeof(skladz));
memset(nomd,'\0',sizeof(nomd));
memset(nomdo,'\0',sizeof(nomdo));
memset(kodmz,'\0',sizeof(kodmz));

memset(shetuz,'\0',sizeof(shetuz));
memset(eiz,'\0',sizeof(eiz));
memset(ndsz,'\0',sizeof(ndsz));
memset(mndsz,'\0',sizeof(mndsz));
memset(nomkarz,'\0',sizeof(nomkarz));
kolstr1=0;
while(fgets(strok,sizeof(strok),fftmp2) != NULL)
 {
  kolstr1+=strlen(strok);
//  printw("%s",strok);
  strzag(LINES-1,0,work.st_size,kolstr1);
/*************
1 - склад
2 - счет учета
3 - единица измерения
4 - НДС
5 - 0-цена без НДС 1-цена с НДС
6 - код материалла
7 - цена
8 - количество 
9 - номер карточки
 ****************/
  
  polen(strok,sklad,sizeof(sklad),1,'|');
  memset(shetu,'\0',sizeof(shetu));
  polen(strok,shetu,sizeof(shetu),2,'|');
  memset(ei,'\0',sizeof(ei));
  polen(strok,ei,sizeof(ei),3,'|');
  polen(strok,kodm,sizeof(kodm),4,'|');
  polen(strok,nds,sizeof(nds),5,'|');
  polen(strok,mnds,sizeof(mnds),6,'|');
  polen(strok,strsql,sizeof(strsql),7,'|');
  double cena=atof(strsql);  
  polen(strok,strsql,sizeof(strsql),8,'|');
  double kolih=atof(strsql);  
  polen(strok,nomkar,sizeof(nomkar),9,'|');

/******************
  sprintf(strsql,"select mnds,nds from Kart where sklad=%s and nomk=%s",
  sklad,nomkar);
  if(sql_readkey(&bd,strsql,&row1,&cur1) != 1)
   {
    printw("Не найдена карточка %s на складе %s !\n",row[1],row[0]);
    OSTANOV();
//    continue;
   } 
  else
   {
    strcpy(mnds,row1[0]);
    strcpy(nds,row1[1]);
   }
****************/

  if(SRAV(skladz,sklad,0) != 0)
   {
    if(skladz[0] != '\0')
      zapiskart(dr,mr,gr,skladz,nomd,nomdo,kodmz,&kolihi,&suma,ndsz,eiz,shetuz,mndsz,nomkarz,&kolzom);

    memset(kodmz,'\0',sizeof(kodmz));
    memset(shetuz,'\0',sizeof(shetuz));
    memset(eiz,'\0',sizeof(eiz));
    memset(ndsz,'\0',sizeof(ndsz));
    memset(mndsz,'\0',sizeof(mndsz));
    kolzom=0;
    
    //Открываем новый документ
    sprintf(nomd,"%s+%d*",sklad,mr);
    sprintf(nomdo,"%s-%d*",sklad,mr);
    sprintf(kontr,"00-%s",sklad);
    printw("Создаем документ %s\n",nomd);

    //Проверяем есть ли документ на приход
    sprintf(strsql,"select nomd from Dokummat where tip=%d and \
datd >= '%04d-01-01' and datd <= '%04d-12-31' and sklad=%s and nomd='%s'",
    1,gr,gr,sklad,nomd);
    if(sql_readkey(&bd,strsql,&row,&cur1) >= 1)
     {
      VVOD SOOB(1);
      sprintf(strsql,gettext("С номером %s документ уже есть !"),nomd);
      SOOB.VVOD_SPISOK_add_MD(strsql);
      soobshw(&SOOB,stdscr,-1,-1,0,1);
      fclose(fftmp2);
      unlink(imaftmp2);
      return;
     }
    //Проверяем есть ли документ на расход
    sprintf(strsql,"select nomd from Dokummat where tip=%d and \
datd >= '%04d-01-01' and datd <= '%04d-12-31' and sklad=%s and nomd='%s'",
    2,gr,gr,sklad,nomdo);
    if(sql_readkey(&bd,strsql,&row,&cur1) >= 1)
     {
      VVOD SOOB(1);
      sprintf(strsql,gettext("С номером %s документ уже есть !"),nomdo);
      SOOB.VVOD_SPISOK_add_MD(strsql);
      soobshw(&SOOB,stdscr,-1,-1,0,1);
      fclose(fftmp2);
      unlink(imaftmp2);
      return;
     }

    sprintf(strsql,"insert into Dokummat \
values (%d,'%04d-%02d-%02d',%s,'%s','%s','%s','%s',%d,%d,%d,%ld,'%s',\
'%04d-%d-%d')",
1,gr,mr,dr,sklad,kontr,nomd,"",kodopsrvc,0,prov1,iceb_t_getuid(),tmm,
nomdo,0,0,0);
    if(sql_zap(&bd,strsql) != 0)
     {
      msql_error(&bd,"",strsql);
      fclose(fftmp2);
      unlink(imaftmp2);
      return;
     }

    sprintf(strsql,"insert into Dokummat2 \
values (%d,%s,'%s',3,'%s')",gr,sklad,nomd,
    gettext("Расчет средневзвешенных цен на материалы."));
    sql_zap(&bd,strsql);

    printw("Создаем документ %s\n",nomdo);

    sprintf(strsql,"insert into Dokummat \
values (%d,'%04d-%02d-%02d',%s,'%s','%s','%s','%s',%d,%d,%d,%ld,'%s',\
'%04d-%d-%d')",
2,gr,mr,dr,sklad,kontr,nomdo,"",kodopsrvc,0,prov2,iceb_t_getuid(),tmm,
nomd,0,0,0);
    
    if(sql_zap(&bd,strsql) != 0)
     {
      msql_error(&bd,"",strsql);
      fclose(fftmp2);
      unlink(imaftmp2);
      return;
     }
    sprintf(strsql,"insert into Dokummat2 \
values (%d,%s,'%s',3,'%s')",gr,sklad,nomdo,
    gettext("Расчет средневзвешенных цен на материалы."));
    sql_zap(&bd,strsql);
    
    strcpy(skladz,sklad);
   }
  if(SRAV(kodmz,kodm,0) != 0)
   {
    if(kodmz[0] != '\0')
      zapiskart(dr,mr,gr,skladz,nomd,nomdo,kodmz,&kolihi,&suma,ndsz,eiz,shetuz,mndsz,nomkarz,&kolzom);
    
    strcpy(kodmz,kodm);
   }

  if(SRAV(shetuz,shetu,0) != 0)
   {
    if(shetuz[0] != '\0')
      zapiskart(dr,mr,gr,skladz,nomd,nomdo,kodmz,&kolihi,&suma,ndsz,eiz,shetuz,mndsz,nomkarz,&kolzom);

    strcpy(shetuz,shetu);
   }  
  if(SRAV(eiz,ei,0) != 0)
   {
    if(eiz[0] != '\0')
      zapiskart(dr,mr,gr,skladz,nomd,nomdo,kodmz,&kolihi,&suma,ndsz,eiz,shetuz,mndsz,nomkarz,&kolzom);

    strcpy(eiz,ei);
   }  

//  Клиент попросил не разделять карточки ндс и без ндс
  if(SRAV(ndsz,nds,0) != 0)
   {
//    if(ndsz[0] != '\0')
//      zapiskart(dr,mr,gr,skladz,nomd,nomdo,kodmz,&kolihi,&suma,ndsz,eiz,shetuz,mndsz,nomkarz,&kolzom);

    strcpy(ndsz,nds);
   }  
  if(SRAV(mndsz,mnds,0) != 0)
   {
//    if(mndsz[0] != '\0')
//      zapiskart(dr,mr,gr,skladz,nomd,nomdo,kodmz,&kolihi,&suma,ndsz,eiz,shetuz,mndsz,nomkarz,&kolzom);

    strcpy(mndsz,mnds);
   }  

  kolzom++;
  //Записываем в расходный документ
//  printw("Записываем\n");
  zapvdok(dr,mr,gr,atoi(sklad),atoi(nomkar),atoi(kodm),nomdo,kolih,cena,
  ei,atof(nds),atoi(mnds),0,2,0,"","");
  strcpy(nomkarz,nomkar);
//  OSTANOV();
  
  suma+=cena*kolih;
  kolihi+=kolih;  

 }

zapiskart(dr,mr,gr,skladz,nomd,nomdo,kodmz,&kolihi,&suma,ndsz,eiz,shetuz,mndsz,nomkar,&kolzom);

fclose(fftmp2);
unlink(imaftmp2);

OSTANOV();
}

/*************************************/
/*Запись в приходный документ        */
/*************************************/

void	zapiskart(short dd,short md,short gd,
char *sklad,char *nomd,char *nomdo,char *kodm,double *kolih,double *suma,
char *nds,char *ei,char *shbm,char *mnds,char *nomkar,int *kolzom)
{
int	nomk=0;
char strsql[512];

//printw("kolih=%f\n",*kolih);
if(*kolih == 0.)
  return;

if(*kolzom == 1)
 {
  //Удаляем запись из расходного документа
  sprintf(strsql,"delete from Dokummat1 where nomd='%s' and sklad=%s \
and kodm=%s and nomkar=%s",nomdo,sklad,kodm,nomkar);
//  printw("%s\n",strsql);
//  OSTANOV();
  if(sql_zap(&bd,strsql) != 0)
    msql_error(&bd,gettext("Ошибка удаления записи !"),strsql);

  *kolih=*suma=0.;

  *kolzom=0;
  
  return; 
 }   

*kolzom=0;

//Определяем средневзвешенную цену

double sredcn;

sredcn=(*suma)/(*kolih);
sredcn=okrug(sredcn,okrcn);

//Проверяем может карточка с введенными уникальными реквизитами уже есть на складе

sprintf(strsql,"select nomk from Kart where kodm=%s and sklad=%s \
and shetu='%s' and cena=%.10g and ei='%s' and nds=%s and cenap=%.10g \
and krat=%.10g and mnds=%s and dat_god='0000-00-00'",kodm,sklad,shbm,sredcn,ei,nds,0.,0.,mnds);


//printw("\n%s\n",strsql);
//OSTANOV();

SQL_str row;
SQLCURSOR cur;
if(sql_readkey(&bd,strsql,&row,&cur) > 0)
 {
  nomk=atoi(row[0]);
  zapvdok(dd,md,gd,atoi(sklad),nomk,atoi(kodm),nomd,*kolih,sredcn,
  ei,atof(nds),atoi(mnds),0,1,0,"","");
 }
else
 {
  nomk=nomkr(atoi(sklad));
//  printw("nds=%s shbm=%s\n",nds,shbm);
  short denv=0,mesv=0,godv=0;
  char innom[16];
  innom[0]='\0';
//  char rnd[20];
       
  if(zapkar(atoi(sklad),nomk,atoi(kodm),sredcn,ei,shbm,0.,0.,0,
  atof(nds),atoi(mnds),0.,denv,mesv,godv,innom,"","",0,0,0,0) == 0)
    zapvdok(dd,md,gd,atoi(sklad),nomk,atoi(kodm),nomd,*kolih,sredcn,
    ei,atof(nds),atoi(mnds),0,1,0,"","");
 }
 
*kolih=*suma=0.;

}
