/*$Id: usl_shet_fak.c,v 5.23 2011-01-13 13:43:24 sasa1 Exp $*/
/*04.11.2009	22.02.2005	Белых А.И.	usl_shet_fak.c
Распечатка счёта фактуры для подсистемы "Учёт услуг"
Если вернули 0-сделали докумет
             1-нет
*/

#include        <errno.h>
#include	"buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif


extern double	okrcn;  /*Округление цены*/
extern double   okrg1; /*Округление*/

int usl_shet_fak(short dg,short mg,short gg, //Дата документа
int podr, //Подразделение
const char *nomdok, //Номер документа
char *imafil, //имя файла с распечаткой
int tipz)  //1-приход 2-расход
{
char            nmo[512],nmo1[512];  /*Наименование организации*/
char            gor[512],gor1[512]; /*Адрес*/
char            pkod[32],pkod1[32]; //Код ЕДРПУО
char            nmb[512],nmb1[512];  /*Наименование банка*/
char            mfo[32],mfo1[32];  /*МФО*/
char            nsh[30],nsh1[32];  /*Номер счета*/
char		strsql[1024];
SQL_str row;
SQLCURSOR cur;
int		kolstr;
char		kodop[32];
char		kontr[32];
char		datop[16];
double sumkor;
char		osnov[512];
char		naimnal[512];
float		procent=0.;
char		kodkontr00[32];
char bros[512];
short lnds=0; //Льготы по НДС
char dover[20];
char sherez[512];
short		mvnpp;
float pnds=0.;

/*Читаем шапку документа*/
sprintf(strsql,"select kontr,kodop,sumkor,datop,osnov,nds,dover,sherez,pn from Usldokum \
where datd='%04d-%02d-%02d' and podr=%d and nomd='%s' and tp=%d",
gg,mg,dg,podr,nomdok,tipz);

if(sql_readkey(&bd,strsql,&row,&cur) != 1)
 {
  VVOD SOOB(1);

  sprintf(strsql,"usl_shet_fak-Не найден документ !"),
  SOOB.VVOD_SPISOK_add_MD(strsql);

  sprintf(strsql,"Дата:%d.%d.%d Документ:%s Подразделение:%d",
  dg,mg,gg,nomdok,podr);
  SOOB.VVOD_SPISOK_add_MD(strsql);

  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);
 }
pnds=atof(row[8]);
strncpy(kontr,row[0],sizeof(kontr)-1);
strncpy(kodop,row[1],sizeof(kodop)-1);
sumkor=atof(row[2]);

memset(datop,'\0',sizeof(datop));
strncpy(datop,row[3],sizeof(datop)-1);

memset(osnov,'\0',sizeof(osnov));
strncpy(osnov,row[4],sizeof(osnov)-1);
lnds=atoi(row[5]);

strncpy(dover,row[6],sizeof(dover)-1);

strncpy(sherez,row[7],sizeof(sherez)-1);

usldopnal(tipz,kodop,&procent,naimnal,sizeof(naimnal));

  
/*Читаем наименование операции*/
if(tipz == 1)
 strcpy(bros,"Usloper1");
if(tipz == 2)
 strcpy(bros,"Usloper2");

mvnpp=0;

sprintf(strsql,"select naik,vido from %s where kod='%s'",
bros,kodop);
if(sql_readkey(&bd,strsql,&row,&cur) != 1)
 {
  VVOD SOOB(1);

  sprintf(strsql,gettext("Не найден код операции %s !"),kodop);
  SOOB.VVOD_SPISOK_add_MD(strsql);

  soobshw(&SOOB,stdscr,-1,-1,0,1);
 }
else
 {
  mvnpp=atoi(row[1]);
 }

strcpy(kodkontr00,"00");
if(tipz == 2)
 {
  memset(bros,'\0',sizeof(bros));
  if(iceb_t_poldan(kodop,bros,"uslnast.alx") == 0)
   {
    memset(kodkontr00,'\0',sizeof(kodkontr00));
    strncpy(kodkontr00,bros,sizeof(kodkontr00)-1);
   }
 }
//printw("\nkodkontr00=%s\n",kodkontr00);
//OSTANOV();

/*Читаем реквизиты организации свои */

memset(nmo,'\0',sizeof(nmo));
memset(gor,'\0',sizeof(gor));
memset(pkod,'\0',sizeof(pkod));
memset(nmb,'\0',sizeof(nmb));
memset(mfo,'\0',sizeof(mfo));
memset(nsh,'\0',sizeof(nsh));

sprintf(bros,"select * from Kontragent where kodkon='%s'",kodkontr00);
if(sql_readkey(&bd,bros,&row,&cur) != 1)
 {
  VVOD SOOB(1);
  sprintf(strsql,"%s %s !",
  gettext("Не найден код контрагента"),kodkontr00);
  SOOB.VVOD_SPISOK_add_MD(strsql);
  soobshw(&SOOB,stdscr,-1,-1,0,1);
 }
else
 {
  strncpy(nmo,row[1],sizeof(nmo)-1);
  strncpy(gor,row[3],sizeof(gor)-1);
  strncpy(pkod,row[5],sizeof(pkod)-1);
  strncpy(nmb,row[2],sizeof(nmb)-1);
  strncpy(mfo,row[6],sizeof(mfo)-1);
  strncpy(nsh,row[7],sizeof(nsh)-1);
 } 


memset(nmo1,'\0',sizeof(nmo1));
memset(gor1,'\0',sizeof(gor1));
memset(pkod1,'\0',sizeof(pkod1));
memset(nmb1,'\0',sizeof(nmb1));
memset(mfo1,'\0',sizeof(mfo1));
memset(nsh1,'\0',sizeof(nsh1));

/*Читаем реквизиты организации чужие*/
/*При внутреннем перемещении не читать*/
if(ATOFM(kontr) != 0. || kontr[0] != '0')
 {

  sprintf(bros,"select * from Kontragent where kodkon='%s'",kontr);
  if(sql_readkey(&bd,bros,&row,&cur) != 1)
   {
    VVOD SOOB(1);
    sprintf(strsql,"%s %s !",
    gettext("Не найден код контрагента"),kontr);
    SOOB.VVOD_SPISOK_add_MD(strsql);
    soobshw(&SOOB,stdscr,-1,-1,0,1);
   }
  else
   {
    if(row[16][0] == '\0')
      strncpy(nmo1,row[1],sizeof(nmo1)-1);
    else
      strncpy(nmo1,row[16],sizeof(nmo1)-1);
    strncpy(gor1,row[3],sizeof(gor1)-1);
    strncpy(pkod1,row[5],sizeof(pkod1)-1);
    strncpy(nmb1,row[2],sizeof(nmb1)-1);
    strncpy(mfo1,row[6],sizeof(mfo1)-1);
    strncpy(nsh1,row[7],sizeof(nsh1)-1);
    
   }
 }

sprintf(strsql,"select metka,kodzap,kolih,cena,ei,dnaim from Usldokum1 \
where datd='%d-%02d-%02d' and podr=%d and nomd='%s' and tp=%d order by metka,kodzap asc",
gg,mg,dg,podr,nomdok,tipz);
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

if(kolstr == 0)
  return(1);

sprintf(imafil,"shfk%d.lst",getpid());
FILE *ff;

if((ff = fopen(imafil,"w")) == NULL)
 {
  error_op_nfil(imafil,errno,"");
  return(1);
 }

if(tipz == 1)
if(shet_fak_sap(dg,mg,gg,nomdok,nsh1,mfo1,pkod1,nmo,dover,sherez,ff) != 0)
 {
  fclose(ff);
  unlink(imafil);
  return(1);
 }

if(tipz == 2)
if(shet_fak_sap(dg,mg,gg,nomdok,nsh,mfo,pkod,nmo1,dover,sherez,ff) != 0)
 {
  fclose(ff);
  unlink(imafil);
  return(1);
 }


SQLCURSOR curr;
SQL_str row1;
int metka;
int kodzap;
double kolih;
double cena;
double cenasnd;
double itogo=0.;
double suma;
char naim[512];
int nom_str=0;
while(cur.read_cursor(&row) != 0)
 {
//  printw("%s %s %s %s %s %s\n",row[0],row[1],row[2],row[3],row[4],row[5]);
 
  metka=atoi(row[0]);
  kodzap=atoi(row[1]);
  kolih=atof(row[2]);
  cena=atof(row[3]);
  cena=okrug(cena,okrcn);
  suma=cena*kolih;
  suma=okrug(suma,okrg1);
  itogo+=suma;
  cenasnd=cena+cena*pnds/100.;
  cenasnd=okrug(cenasnd,okrg1);
  
  /*Читаем наименование услуги*/
  memset(naim,'\0',sizeof(naim));

  if(metka == 0)
   sprintf(strsql,"select naimat from Material where kodm=%d",kodzap);

  if(metka == 1)
   sprintf(strsql,"select naius from Uslugi where kodus=%d",kodzap);

  if(sql_readkey(&bd,strsql,&row1,&curr) != 1)
   {
    printw("%s\n",strsql);
    if(metka == 0)
     printw("%s %d !\n",gettext("Не найден код материалла"),kodzap);
    if(metka == 1)
     printw("%s %d !\n",gettext("Не найден код услуги"),kodzap);
    OSTANOV();
   }
  else
   {
    strncpy(naim,row1[0],sizeof(naim)-1);
    if(row[5][0] != '\0')
     {
      strcat(naim," ");
      strcat(naim,row[5]);
     }    
   }

  fprintf(ff," %3d %-*.*s %6.6g %-*.*s %8.8g %10.2f\n",
  ++nom_str,
  iceb_tu_kolbait(30,naim),iceb_tu_kolbait(30,naim),naim,
  kolih,
  iceb_tu_kolbait(6,row[4]),iceb_tu_kolbait(6,row[4]),row[4],
  cena,suma);

  if(iceb_tu_strlen(naim) > 30)
     fprintf(ff,"%3s %s\n"," ",iceb_tu_adrsimv(30,naim));
 }
fprintf(ff,"\
---------------------------------------------------------------------\n");
int dlina=58;
fprintf(ff,"%*s:%10.2f\n",iceb_tu_kolbait(dlina,gettext("Итого")),gettext("Итого"),itogo);

if(mvnpp == 0) /*Внешнее перемещение*/
  dok_end_usl(tipz,dg,mg,gg,nomdok,podr,dlina,sumkor,itogo,pnds,lnds,procent,naimnal,ff);


shet_fak_end(ff); //распечатка концовки документа

fclose(ff);

iceb_t_ustpeh(imafil,3);

return(0);

}
