/*$Id: vdupl.c,v 5.56 2011-01-13 13:43:24 sasa1 Exp $*/
/*14.01.2010	14.04.2003	Белых А.И.	vdupl.c
Ввод и корректировка шапки путевых листов.
*/
#include        <time.h>
#include        <pwd.h>
#include	"buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

class vdupld_data
 {
  public:
  short dve,mve,gve; //дата выезда
  short dvz,mvz,gvz; //дата возвращения
  short has_ve,min_ve,sek_ve; //Время выезда
  short has_vz,min_vz,sek_vz; //Время возвращения
  char otmet[256];  
  char nomb[32];
  
  double vremr; //Время работы двигателя
  double rt_vremr_n; //норма расхода топлива на время работы двигателя
  double rt_vremr_f; //Расход топлива фактический
  double tk; //Тонно-километры
  double vesgr;  //Вес груза
  double rt_vesgr_n; //Норма расхода топлива на перевозимый груз
  double rt_vesgr_f; //Расход топлива по факту

  double zat_fact; //Общие затраты топлива по норме
  double zat_norma;//Общие затраты топлива по факту

  char		naimpod[512];
  class iceb_tu_str naimvod;
  char          gos_nomer[56];
  class iceb_tu_str naimavt;

  char data_dok[11]; //Дата документа
  char nomd[56]; //Номер документа
  char kod_avt[32]; //Код автомобиля  
  int  probeg;     //Пробег
  vdupld_data()
   {
    tk=0.;
    dve=mve=gve=0;
    dvz=mvz=gvz=0;
    has_ve=min_ve=sek_ve=0;
    has_vz=min_vz=sek_vz=0;
    memset(otmet,'\0',sizeof(otmet));
    memset(nomb,'\0',sizeof(nomb));

    vremr=0.;
    rt_vremr_n=0.;
    rt_vremr_f=0.;
    vesgr=0.;
    rt_vesgr_n=0.;
    rt_vesgr_f=0.;

    memset(data_dok,'\0',sizeof(data_dok));
    memset(nomd,'\0',sizeof(nomd));
    memset(kod_avt,'\0',sizeof(kod_avt));
    memset(naimpod,'\0',sizeof(naimpod));
    naimvod.new_plus("");
    naimavt.new_plus("");
    memset(gos_nomer,'\0',sizeof(gos_nomer));
    zat_fact=zat_norma=0.;
   }

 };


void		uplnomdok(short,const char*,char*);
int             vduplz(short,short,short,const char*,const char*,VVOD*,class vdupld_data *data);
int             poippl(short,short,short,const char*);
void vdupld(class vdupld_data *data);
void vdupld1(class vdupld_data *data);



int vdupl(short *dd,short *md,short *gd,class iceb_tu_str *nomd,class iceb_tu_str *podr)
{
class vdupld_data data;

int             N=0;
int		K=0;
char		strsql[512];
char		bros[312];
short		dv=*dd,mv=*md,gv=*gd; //Дата документа введенная
char		kod[32];
int		kom1=0;
SQL_str		row;
int             snr=0; //Зимняя норма расхода
class iceb_tu_str kodn("");
SQLCURSOR curr;

VVOD MENU(3);

VVOD VV(0);

VV.VVOD_SPISOK_add_data(11); //0
VV.VVOD_SPISOK_add_data(10); //1
VV.VVOD_SPISOK_add_data(10); //2
VV.VVOD_SPISOK_add_data(10); //3
VV.VVOD_SPISOK_add_data(10); //4
VV.VVOD_SPISOK_add_data(10); //5
VV.VVOD_SPISOK_add_data(10); //6
VV.VVOD_SPISOK_add_data(10); //7
VV.VVOD_SPISOK_add_data(10); //8
VV.VVOD_SPISOK_add_data(10); //9
VV.VVOD_SPISOK_add_data(10); //10

VV.VVOD_SPISOK_add_data(10); //11
VV.VVOD_SPISOK_add_data(10); //12
VV.VVOD_SPISOK_add_data(10); //13
VV.VVOD_SPISOK_add_data(10); //14

if(*dd != 0) //Читаем реквизиты шапки
 {
  //Читаем шапку документа
  sprintf(strsql,"select * from Upldok where datd='%d-%d-%d' and kp=%d and nomd='%s'",
  *gd,*md,*dd,podr->ravno_atoi(),nomd->ravno());

  if(sql_readkey(&bd,strsql,&row,&curr) != 1)
   {
    printw("\n%s",strsql);
    VVOD SOOB(1);
    sprintf(strsql,"%s !",gettext("Не найдена шапка документа"));
    SOOB.VVOD_SPISOK_add_MD(strsql);
    soobshw(&SOOB,stdscr,-1,-1,0,1);
    return(1);
   }
  rsdat(&dv,&mv,&gv,row[0],2);
  sprintf(strsql,"%d.%d.%d",dv,mv,gv);
  VV.VVOD_SPISOK_zapis_data(0,strsql);
  VV.VVOD_SPISOK_zapis_data(1,row[1]);
  VV.VVOD_SPISOK_zapis_data(2,row[2]);
  VV.VVOD_SPISOK_zapis_data(3,row[5]);
  VV.VVOD_SPISOK_zapis_data(4,row[6]);
  VV.VVOD_SPISOK_zapis_data(5,row[7]);
  VV.VVOD_SPISOK_zapis_data(6,row[8]);
  VV.VVOD_SPISOK_zapis_data(7,row[11]);
  VV.VVOD_SPISOK_zapis_data(8,row[19]);

  VV.VVOD_SPISOK_zapis_data(9,row[9]);
  VV.VVOD_SPISOK_zapis_data(10,row[10]);
  rsdat(&data.dve,&data.mve,&data.gve,row[12],2);

  rstime(&data.has_ve,&data.min_ve,&data.sek_ve,row[14]);
  rsdat(&data.dvz,&data.mvz,&data.gvz,row[13],2);
  rstime(&data.has_vz,&data.min_vz,&data.sek_vz,row[15]);
  
  strncpy(data.otmet,row[18],sizeof(data.otmet)-1);
  strncpy(data.nomb,row[4],sizeof(data.nomb)-1);

  VV.VVOD_SPISOK_zapis_data(11,row[24]);
  VV.VVOD_SPISOK_zapis_data(12,row[25]);
  VV.VVOD_SPISOK_zapis_data(13,row[22]);
  VV.VVOD_SPISOK_zapis_data(14,row[23]);
  
  data.vesgr=atof(row[26]);
  data.rt_vesgr_n=atof(row[27]);
  data.rt_vesgr_f=atof(row[28]);
  data.vremr=atof(row[29]);
  data.rt_vremr_n=atof(row[30]);
  data.rt_vremr_f=atof(row[31]);
  data.tk=atof(row[32]);
  
  //читаем наименование подразделения
  sprintf(strsql,"select naik from Uplpodr where kod=%s",VV.VVOD_SPISOK_return_data(1)); 
  if(sql_readkey(&bd,strsql,&row,&curr) == 1)
   strncpy(data.naimpod,row[0],sizeof(data.naimpod)-1);  

  //читаем фамилию водителя
  sprintf(strsql,"select naik from Uplouot where kod=%s",VV.VVOD_SPISOK_return_data(4));
  if(sql_readkey(&bd,strsql,&row,&curr) == 1)
   data.naimvod.new_plus(row[0]);

  //читаем наименование автомобиля
  sprintf(strsql,"select nomz,naik from Uplavt where kod=%s",VV.VVOD_SPISOK_return_data(3));
  if(sql_readkey(&bd,strsql,&row,&curr) == 1)
   {
    strncpy(data.gos_nomer,row[0],sizeof(data.gos_nomer)-1);  
    data.naimavt.new_plus(row[1]);
   }
 }


VV.VVOD_SPISOK_add_MD(gettext("Дата...................(д.м.г)........"));//0
VV.VVOD_SPISOK_add_MD(gettext("Код подразделения....................."));//1
VV.VVOD_SPISOK_add_MD(gettext("Номер документа......................."));//2
VV.VVOD_SPISOK_add_MD(gettext("Код автомобиля........................"));//3
VV.VVOD_SPISOK_add_MD(gettext("Код водителя.........................."));//4
VV.VVOD_SPISOK_add_MD(gettext("Показания спидометра при выезде......."));//5
VV.VVOD_SPISOK_add_MD(gettext("Показания спидометра при возвращении.."));//6
VV.VVOD_SPISOK_add_MD(gettext("Пробег...................(по городу).."));//7
VV.VVOD_SPISOK_add_MD(gettext("Норма списания топлива...(по городу).."));//8
VV.VVOD_SPISOK_add_MD(gettext("Затраты топлива по норме.(по городу).."));//9
VV.VVOD_SPISOK_add_MD(gettext("Затраты топлива фак-кие..(по городу).."));//10

VV.VVOD_SPISOK_add_MD(gettext("Пробег...................(за городом)."));//11
VV.VVOD_SPISOK_add_MD(gettext("Норма списания топлива...(за городом)."));//12
VV.VVOD_SPISOK_add_MD(gettext("Затраты топлива по норме.(за городом)."));//13
VV.VVOD_SPISOK_add_MD(gettext("Затраты топлива фак-кие..(за городом)."));//14

nazad:;

clear();

helstr(LINES-1,0,"F1",gettext("помощь"),
"F2/+",gettext("запись"),
"F3",gettext("реквизиты"),
"F4",gettext("номер докум."),
"F6",gettext("доп.инф-ция"),
"F10",gettext("выход"),NULL);

VV.vramka(4,0,0);

for(;;)
 {
  attron(VV.VVOD_return_cs(iceb_CFS)); 

  if(data.naimpod[0] != '\0')
   {
    sprintf(strsql,"%s:%s",gettext("Подразделение"),data.naimpod);
    mvprintw(0,0,"%.*s",COLS,strsql);
   }
  if(data.naimvod.ravno()[0] != '\0')
   {
    sprintf(strsql,"%s:%s",gettext("Водитель"),data.naimvod.ravno());
    mvprintw(1,0,"%.*s",COLS,strsql);
   }
  if(data.naimavt.getdlinna() > 1)
   {
    sprintf(strsql,"%s:%s %s",gettext("Автомобиль"),data.naimavt.ravno(),data.gos_nomer);
    mvprintw(2,0,"%.*s",COLS,strsql);
   }

  data.probeg=VV.data_ravno_atoi(6)-VV.data_ravno_atoi(5);

  data.zat_norma=(VV.data_ravno_atof(12)*VV.data_ravno_atof(11)/100.)+\
  (VV.data_ravno_atof(8)*VV.data_ravno_atof(7)/100.)+\
  (data.tk*data.rt_vesgr_n/100.)+\
  (data.vremr*data.rt_vremr_n);

  data.zat_fact=VV.data_ravno_atof(10)+VV.data_ravno_atof(14)+data.rt_vesgr_f+data.rt_vremr_f;
  
  
  sprintf(strsql,"%s:%.3f/%.3f/%.3f",
  gettext("Общие затраты топлива (факт/по норме/разница)"),
  data.zat_fact,data.zat_norma,data.zat_fact-data.zat_norma);
  mvprintw(3,0,"%.*s",COLS,strsql);
  
  VV.vprintw(N,stdscr);
  
  K=getch();

  attroff(VV.VVOD_return_cs(iceb_CFS));
  attron(VV.VVOD_return_cs(iceb_CFM));

  VV.vprintw(N,stdscr);

  if(K == KEY_MOUSE)
    K=mouseklic(&N,VV.PY,VV.PX,VV.MDLS,VV.KLST,stdscr);

  if(K == KEY_RESIZE)
   {
    getch();
    goto nazad;
   }    

  if(K == ENTER)
   {
    attroff(VV.VVOD_return_cs(iceb_CFM));
    attron(VV.VVOD_return_cs(iceb_CFV));
    VV.vprintw_clear(N,stdscr);

//    my_getstr(VV.VVOD_SPISOK_return_data(N),dlinastr,VV.VVOD_SPISOK_return_dls(N),stdscr);
    VV.vgetstr(N,stdscr);
    
    attroff(VV.VVOD_return_cs(iceb_CFV));
    attron(VV.VVOD_return_cs(iceb_CFM));

    if(N == 0 && VV.VVOD_SPISOK_return_data(N)[0] != '\0')  //Дата документа
     {
      if(rsdat(&dv,&mv,&gv,VV.VVOD_SPISOK_return_data(N),1) != '\0')
       {
        attroff(VV.VVOD_return_cs(iceb_CFM));
        VVOD SOOB(1);
        SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введена дата !"));
        soobshw(&SOOB,stdscr,-1,-1,0,1);
	goto nazad;
       }

      if(VV.VVOD_SPISOK_return_data(2)[0] == '\0')
       if(VV.VVOD_SPISOK_return_data(1)[0] != '\0')
        {
         char nomer_dok[40];
         uplnomdok(gv,VV.VVOD_SPISOK_return_data(1),nomer_dok);
         VV.data_plus(2,nomer_dok);
         goto nazad;
        }
     }

    if(N == 1 && VV.VVOD_SPISOK_return_data(N)[0] != '\0')  //Код подразделения
     {
      sprintf(strsql,"select naik from Uplpodr where kod=%s",VV.VVOD_SPISOK_return_data(N));
      if(sql_readkey(&bd,strsql,&row,&curr) != 1)
       {
        attroff(VV.VVOD_return_cs(iceb_CFM));
        VVOD SOOB(1);
        sprintf(strsql,"%s %s !",gettext("Не найден код подразделения"),
        VV.VVOD_SPISOK_return_data(N));
        SOOB.VVOD_SPISOK_add_MD(strsql);
        soobshw(&SOOB,stdscr,-1,-1,0,1);
        memset(data.naimpod,'\0',sizeof(data.naimpod));
	goto nazad;
       }
      strncpy(data.naimpod,row[0],sizeof(data.naimpod)-1);

      if(VV.VVOD_SPISOK_return_data(2)[0] == '\0')
       if(VV.VVOD_SPISOK_return_data(0)[0] != '\0')
        {
         char nomer_dok[40];
         uplnomdok(gv,VV.VVOD_SPISOK_return_data(1),nomer_dok);
         VV.data_plus(2,nomer_dok);
         N+=2;
         goto nazad;
        }

     }

    if(N == 2 && VV.VVOD_SPISOK_return_data(N)[0] != '\0')  //Номер документа
     {
      if(SRAV(nomd->ravno(),VV.VVOD_SPISOK_return_data(N),0) != 0)
       {
        sprintf(strsql,"select datd from Upldok where god=%d and kp=%d and nomd='%s'",
        gv,atoi(VV.VVOD_SPISOK_return_data(1)),VV.VVOD_SPISOK_return_data(N));
        if(sql_readkey(&bd,strsql,&row,&curr) > 0)
         {
          attroff(VV.VVOD_return_cs(iceb_CFM));

          VVOD SOOB(1);
          sprintf(strsql,gettext("С номером %s документ уже есть !"),
          VV.VVOD_SPISOK_return_data(N));
          
          SOOB.VVOD_SPISOK_add_MD(strsql);
          soobshw(&SOOB,stdscr,-1,-1,0,1);
  	  goto nazad;
         }
       }

     }

    if(N == 3 && VV.VVOD_SPISOK_return_data(N)[0] != '\0')  //Код автомобиля
     {

kodavt:; //По клавише F3 должно прочитать

      memset(bros,'\0',sizeof(bros));
      snr=0; //Зимняя норма расхода
      if(iceb_t_poldan("Летняя норма расхода топлива",bros,"uplnast.alx") == 0)
       if(SRAV(bros,"Вкл",1) == 0)
         snr=1;  //Летняя норма расхода


      GDITE();

      sprintf(strsql,"select lnr,znr,naik,lnrzg,znrzg,nomz from Uplavt where kod=%s",VV.VVOD_SPISOK_return_data(3));
      if(sql_readkey(&bd,strsql,&row,&curr) != 1)
       {
        attroff(VV.VVOD_return_cs(iceb_CFM));
        VVOD SOOB(1);
        sprintf(strsql,"%s %s !",gettext("Не найден код автомобиля"),
        VV.VVOD_SPISOK_return_data(3));
        SOOB.VVOD_SPISOK_add_MD(strsql);
        soobshw(&SOOB,stdscr,-1,-1,0,1);
        data.naimavt.new_plus("");
        goto nazad;
       }
      data.naimavt.new_plus(row[2]);
      strncpy(data.gos_nomer,row[5],sizeof(data.gos_nomer)-1);
      if(VV.VVOD_SPISOK_return_data(8)[0] == '\0')
       {
        if(snr == 0)
         {
          VV.VVOD_SPISOK_zapis_data(8,row[1]);
          VV.VVOD_SPISOK_zapis_data(12,row[4]);
         }
        if(snr == 1)
         {
          VV.VVOD_SPISOK_zapis_data(8,row[0]);
          VV.VVOD_SPISOK_zapis_data(12,row[3]);
         }
       }
      if(dv != 0 && *dd == 0)
       {
        int poks=poippl(dv,mv,gv,VV.VVOD_SPISOK_return_data(3));
        if(poks != 0)
         {
          sprintf(strsql,"%d",poks);
          VV.VVOD_SPISOK_zapis_data(5,strsql);
         }
       }

      N++;
      goto nazad;
     }

    if(N == 4 && VV.VVOD_SPISOK_return_data(N)[0] != '\0')  //Код водителя
     {
      sprintf(strsql,"select naik from Uplouot where kod=%s",VV.VVOD_SPISOK_return_data(N));
      if(sql_readkey(&bd,strsql,&row,&curr) != 1)
       {
        attroff(VV.VVOD_return_cs(iceb_CFM));
        VVOD SOOB(1);
        sprintf(strsql,"%s %s !",gettext("Не найден код водителя"),
        VV.VVOD_SPISOK_return_data(N));
        SOOB.VVOD_SPISOK_add_MD(strsql);
        soobshw(&SOOB,stdscr,-1,-1,0,1);
        data.naimvod.new_plus("");
        goto nazad;
       }
      data.naimvod.new_plus(row[0]);

      if(dd == 0)
       {
        //Проверяем был ли уже выписан документ по этой дате
        sprintf(strsql,"select nomd from Upldok where datd='%d-%d-%d' and ka=%d and kv=%d",
        gv,mv,dv,atoi(VV.VVOD_SPISOK_return_data(3)),atoi(VV.VVOD_SPISOK_return_data(4)));
        if(sql_readkey(&bd,strsql,&row,&curr) > 0)
         {
          char  nombros[20];
          strcpy(nombros,row[0]);
          attroff(VV.VVOD_return_cs(iceb_CFM));
          VVOD SOOB(1);

          sprintf(strsql,"%s !",gettext("Для этого водителя и этого автомобиля уже введен документ"));
          SOOB.VVOD_SPISOK_add_MD(strsql);

          sprintf(strsql,"%s %d.%d.%d %s %s",gettext("Дата"),dv,mv,gv,
          gettext("Номер документа"),nombros);
          SOOB.VVOD_SPISOK_add_MD(strsql);

          soobshw(&SOOB,stdscr,-1,-1,0,1);
          goto nazad;
         }
       }
     }

    if(N == 6 && VV.VVOD_SPISOK_return_data(N)[0] != '\0')  //Показания спидометра при возвращении
     {
      sprintf(strsql,"%d",atoi(VV.VVOD_SPISOK_return_data(6))-atoi(VV.VVOD_SPISOK_return_data(5)));
      VV.VVOD_SPISOK_zapis_data(7,strsql);

      sprintf(strsql,"%.3f",ATOFM(VV.VVOD_SPISOK_return_data(8))* ATOFM(VV.VVOD_SPISOK_return_data(7))/100.);
      VV.VVOD_SPISOK_zapis_data(9,strsql);
      VV.VVOD_SPISOK_zapis_data(10,strsql);
      N++;
      goto nazad;
     }

    if(N == 7 && VV.VVOD_SPISOK_return_data(N)[0] != '\0')  //Пробег по городу
     {
      sprintf(strsql,"%.3f",ATOFM(VV.VVOD_SPISOK_return_data(8)) * ATOFM(VV.VVOD_SPISOK_return_data(7))/100.);
      VV.VVOD_SPISOK_zapis_data(9,strsql);
      VV.VVOD_SPISOK_zapis_data(10,strsql);
      
      //Вычисляем пробег за городом      
      if(VV.data_ravno(11)[0] == '\0')
       {
        sprintf(strsql,"%d",VV.data_ravno_atoi(6)- VV.data_ravno_atoi(5)-VV.data_ravno_atoi(N));
        VV.data_plus(11,strsql);
       }
      sprintf(strsql,"%.3f",ATOFM(VV.VVOD_SPISOK_return_data(12)) * ATOFM(VV.VVOD_SPISOK_return_data(11))/100.);
      VV.VVOD_SPISOK_zapis_data(13,strsql);
      VV.VVOD_SPISOK_zapis_data(14,strsql);
            
      N++;
      goto nazad;
     }

    if(N == 8 && VV.VVOD_SPISOK_return_data(N)[0] != '\0')  //Норма списания топлива по городу
     {
      sprintf(strsql,"%.3f",ATOFM(VV.VVOD_SPISOK_return_data(N)) * ATOFM(VV.VVOD_SPISOK_return_data(7))/100.);
      VV.VVOD_SPISOK_zapis_data(9,strsql);
      VV.VVOD_SPISOK_zapis_data(10,strsql);

      N++;
      goto nazad;
     }
     
    if(N == 11 && VV.VVOD_SPISOK_return_data(N)[0] != '\0')  //Пробег за городом
     {
      sprintf(strsql,"%.3f",ATOFM(VV.VVOD_SPISOK_return_data(12)) * ATOFM(VV.VVOD_SPISOK_return_data(N))/100.);
      VV.VVOD_SPISOK_zapis_data(13,strsql);
      VV.VVOD_SPISOK_zapis_data(14,strsql);

      //Вычисляем пробег по городу      
      if(VV.data_ravno(7)[0] == '\0')
       {
        sprintf(strsql,"%d",VV.data_ravno_atoi(6)- VV.data_ravno_atoi(5)-VV.data_ravno_atoi(N));
        VV.VVOD_SPISOK_zapis_data(7,strsql);
       }
      sprintf(strsql,"%.3f",ATOFM(VV.VVOD_SPISOK_return_data(8)) * ATOFM(VV.VVOD_SPISOK_return_data(7))/100.);
      VV.VVOD_SPISOK_zapis_data(9,strsql);
      VV.VVOD_SPISOK_zapis_data(10,strsql);
      N++;
      goto nazad;
     }

    if(N == 12 && VV.VVOD_SPISOK_return_data(N)[0] != '\0')  //Норма списания топлива за городом
     {
      sprintf(strsql,"%.3f",ATOFM(VV.VVOD_SPISOK_return_data(N)) * ATOFM(VV.VVOD_SPISOK_return_data(11))/100.);
      VV.VVOD_SPISOK_zapis_data(13,strsql);
      VV.VVOD_SPISOK_zapis_data(14,strsql);

      N++;
      goto nazad;
     }

    VV.vprintw(N,stdscr);
    N++;
   }

  if(K==SDN) /*Стрелка вниз*/
   {
    N++;
   }
  if(K==SUP) /*Стрелка вверх*/
   {
    N--;
   }
  if(N > VV.KLST-1)
   {
    N=0;
   }
  if(N < 0)
   {
    N=VV.KLST-1;
   }

  if(K == ESC || K == FK10)
   {
    attroff(VV.VVOD_return_cs(iceb_CFS));
    attron(VV.VVOD_return_cs(iceb_CB));
    return(1);
   }

  if(K == FK1) /*Помощь*/
   {
    attroff(VV.VVOD_return_cs(iceb_CFS));
    attron(VV.VVOD_return_cs(iceb_CB));
    GDITE();
    iceb_t_pdoc("upl2_1.txt");
    goto nazad;
   }

  if(K == PLU || K == FK2) /*Продолжать*/
   {
    attroff(VV.VVOD_return_cs(iceb_CFS));
    attron(VV.VVOD_return_cs(iceb_CFM));
    if(iceb_t_pbpds(mv,gv) != 0)
     goto nazad;

    break;
   }

  if(K == FK3) /*Посмотреть реквизиты*/
   {
    attroff(VV.VVOD_return_cs(iceb_CFS)); 

    MENU.VVOD_delete();
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка подразделений"));//0
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка водителей"));//1
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка автомобилей"));//2
    MENU.VVOD_SPISOK_add_MD(gettext("Выход"));

    clearstr(LINES-1,0);
    kom1=0;    
    while(menu3w(stdscr,&MENU,&kom1,-1,-1,0) != 0);

    switch (kom1)
     {
      case 3:
      case -1:
       goto nazad;


      case 0:
        memset(kod,'\0',sizeof(kod));
        memset(data.naimpod,'\0',sizeof(data.naimpod));
        if(vibrek("Uplpodr",kod,sizeof(kod),data.naimpod) == 0)
          VV.VVOD_SPISOK_zapis_data(1,kod);
        break;

      case 1:
        clear();
        data.naimvod.new_plus("");
        if(dirout(&kodn,&data.naimvod,1,2) == 0)
          VV.VVOD_SPISOK_zapis_data(4,kodn.ravno());
        break;

      case 2:
        clear();
        data.naimavt.new_plus("");
        if(diravt(&kodn,&data.naimavt,1) == 0)
         {
          VV.VVOD_SPISOK_zapis_data(3,kodn.ravno());
          goto kodavt;
         }
        break;

     }
    goto nazad;
   }  
 
  if(K == FK4) //Получить новый номер документа
   {
    char nomer_dok[40];
    uplnomdok(gv,VV.VVOD_SPISOK_return_data(1),nomer_dok);
    VV.data_plus(2,nomer_dok);
    goto nazad;
   }   

  if(K == FK6) //Ввод дополнительной информации
   {
    strncpy(data.data_dok,VV.data_ravno(0),sizeof(data.data_dok)-1);
    strncpy(data.nomd,VV.data_ravno(2),sizeof(data.nomd)-1);
    strncpy(data.kod_avt,VV.data_ravno(3),sizeof(data.kod_avt)-1);

    MENU.VVOD_delete();
    MENU.VVOD_SPISOK_add_ZAG(gettext("Выберите нужное и нажмите Enter"));

    MENU.VVOD_SPISOK_add_MD(gettext("Страница 1"));//0
    MENU.VVOD_SPISOK_add_MD(gettext("Страница 2"));//1
    MENU.VVOD_SPISOK_add_MD(gettext("Выход"));//2

    clearstr(LINES-1,0);
    kom1=0;    
    while(menu3w(stdscr,&MENU,&kom1,-1,-1,0) != 0);

    switch (kom1)
     {
      case 2:
      case -1:
       break;
      case 0:
       vdupld1(&data);
       break;

      case 1:
       vdupld(&data);
       break;
     }

    goto nazad;
   }   
 }
attroff(VV.VVOD_return_cs(iceb_CFS));
attron(VV.VVOD_return_cs(iceb_CB));

if(vduplz(*dd,*md,*gd,nomd->ravno(),podr->ravno(),&VV,&data) != 0)
 goto nazad;

*dd=dv; 
*md=mv;
*gd=gv;
nomd->new_plus(VV.VVOD_SPISOK_return_data(2));
podr->new_plus(VV.VVOD_SPISOK_return_data(1));
return(0);
}

/*****************************/
/*Запись шапки документа     */
/*****************************/
//Если вернули 0-записали 1-нет

int vduplz(short dd,short md,short gd,const char *nomd,const char *podr,
VVOD *VV,class vdupld_data *data)
{
short dv=0,mv=0,gv=0; //Введенная дата документа

char  strsql[512];
SQL_str row;
SQLCURSOR curr;

if(rsdat(&dv,&mv,&gv,VV->VVOD_SPISOK_return_data(0),1) != 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введена дата !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);
 }


if(iceb_t_pbpds(mv,gv) != 0)
 return(1);
sprintf(strsql,"select naik from Uplpodr where kod=%s",VV->VVOD_SPISOK_return_data(1));
if(sql_readkey(&bd,strsql,&row,&curr) != 1)
 {
  attroff(VV->VVOD_return_cs(iceb_CFM));
  VVOD SOOB(1);
  sprintf(strsql,"%s %s !",gettext("Не найден код подразделения"),
  VV->VVOD_SPISOK_return_data(1));
  SOOB.VVOD_SPISOK_add_MD(strsql);
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);
 }

if(SRAV(nomd,VV->VVOD_SPISOK_return_data(2),0) != 0)
 {
  sprintf(strsql,"select datd from Upldok where god=%d and kp=%d and nomd='%s'",
  gv,atoi(VV->VVOD_SPISOK_return_data(1)),VV->VVOD_SPISOK_return_data(2));
  if(sql_readkey(&bd,strsql,&row,&curr) > 0)
   {
    VVOD SOOB(1);
    sprintf(strsql,gettext("С номером %s документ уже есть !"),
    VV->VVOD_SPISOK_return_data(2));
    
    SOOB.VVOD_SPISOK_add_MD(strsql);
    soobshw(&SOOB,stdscr,-1,-1,0,1);
    return(1);
   }
 }

sprintf(strsql,"select naik from Uplavt where kod=%s",VV->VVOD_SPISOK_return_data(3));
if(sql_readkey(&bd,strsql,&row,&curr) != 1)
 {
  VVOD SOOB(1);
  sprintf(strsql,"%s %s !",gettext("Не найден код автомобиля"),
  VV->VVOD_SPISOK_return_data(3));
  SOOB.VVOD_SPISOK_add_MD(strsql);
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);
 }


sprintf(strsql,"select naik from Uplouot where kod=%s",VV->VVOD_SPISOK_return_data(4));
if(sql_readkey(&bd,strsql,&row,&curr) != 1)
 {
  VVOD SOOB(1);
  sprintf(strsql,"%s %s !",gettext("Не найден код водителя"),
  VV->VVOD_SPISOK_return_data(4));
  SOOB.VVOD_SPISOK_add_MD(strsql);
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);
 }


time_t   vrem;
time(&vrem);

if(dd == 0) //Ввод нового документа
 {
  int nom_zap=0;
  //Определяем номер записи для документа
  sprintf(strsql,"select nz from Upldok where datd='%d-%d-%d' and ka=%d order by nz desc limit 1",
  gv,mv,dv,atoi(VV->VVOD_SPISOK_return_data(3)));
  if(readkey(strsql,&row,&curr) > 0)
   nom_zap=atoi(row[0])+1;

  sprintf(strsql,"insert into Upldok \
values ('%04d-%d-%d',%s,'%s',%d,'%s',%s,%s,%d,%d,%.3f,%.3f,%.10g,\
'%04d-%d-%d','%04d-%d-%d','%02d:%02d:%02d','%02d:%02d:%02d',0,0,'%s',%.3f,%d,%ld,\
%.3f,%.3f,%d,%.3f,%.2f,%.3f,%.3f,%.2f,%.3f,%.3f,%.3f,%d)",
  gv,mv,dv,
  VV->VVOD_SPISOK_return_data(1),
  VV->VVOD_SPISOK_return_data(2),
  gv,
  data->nomb,
  VV->VVOD_SPISOK_return_data(3),
  VV->VVOD_SPISOK_return_data(4),
  atoi(VV->VVOD_SPISOK_return_data(5)),
  atoi(VV->VVOD_SPISOK_return_data(6)),
  ATOFM(VV->VVOD_SPISOK_return_data(9)),
  ATOFM(VV->VVOD_SPISOK_return_data(10)),
  ATOFM(VV->VVOD_SPISOK_return_data(7)),
  data->gve,data->mve,data->dve,
  data->gvz,data->mvz,data->dvz,
  data->has_ve,data->min_ve,data->sek_ve,
  data->has_vz,data->min_vz,data->sek_vz,
  data->otmet,
  ATOFM(VV->VVOD_SPISOK_return_data(8)),
  iceb_t_getuid(),vrem,
  ATOFM(VV->VVOD_SPISOK_return_data(13)),
  ATOFM(VV->VVOD_SPISOK_return_data(14)),
  atoi(VV->VVOD_SPISOK_return_data(11)),
  ATOFM(VV->VVOD_SPISOK_return_data(12)),
  data->vesgr,
  data->rt_vesgr_n,
  data->rt_vesgr_f,
  data->vremr,
  data->rt_vremr_n,
  data->rt_vremr_f,
  data->tk,
  nom_zap);
    
 }
else  //Корректировка старого документа 
 {
  //исправляем записи в таблице списания топлива по счетам и объектам
  sprintf(strsql,"update Upldok2 set \
datd='%d-%d-%d',\
kp=%d,\
nomd='%s' \
where datd='%d-%d-%d' and kp=%d and nomd='%s'",
  gv,mv,dv,
  atoi(VV->VVOD_SPISOK_return_data(1)),
  VV->VVOD_SPISOK_return_data(2),
  gd,md,dd,atoi(podr),nomd);

  if(sql_zapis(strsql,0,0) != 0)
   return(1);

  //Исправлям записи в документе
  
  sprintf(strsql,"update Upldok1 set \
datd='%d-%d-%d',\
kp=%d,\
nomd='%s',\
ka=%s,\
kv=%s \
where datd='%d-%d-%d' and kp=%d and nomd='%s'",
  gv,mv,dv,
  atoi(VV->VVOD_SPISOK_return_data(1)),
  VV->VVOD_SPISOK_return_data(2),
  VV->VVOD_SPISOK_return_data(3),
  VV->VVOD_SPISOK_return_data(4),
  gd,md,dd,atoi(podr),nomd);

  if(sql_zapis(strsql,0,0) != 0)
   return(1);




  //Исправляем шапку документа

  sprintf(strsql,"update Upldok set \
datd='%d-%d-%d',\
kp=%d,\
nomd='%s',\
god=%d,\
nomb='%s',\
ka=%s,\
kv=%s,\
psv=%d,\
psz=%d,\
ztpn=%.3f,\
ztfa=%.3f,\
prob=%d,\
denn='%d-%d-%d',\
denk='%d-%d-%d',\
vremn='%02d:%02d:%02d',\
vremk='%02d:%02d:%02d',\
otmet='%s',\
nst=%.3f,\
ktoz=%d,\
vrem=%ld,\
ztpnzg=%.3f,\
ztfazg=%.3f,\
probzg=%d,\
nstzg=%.3f,\
vesg=%.2f,\
ztvsn=%.3f,\
ztvsf=%.3f,\
vrr=%.2f,\
ztvrn=%.3f,\
ztvrf=%.3f,\
tk=%.3f \
where god=%d and kp=%d and nomd='%s'",
  gv,mv,dv,
  atoi(VV->VVOD_SPISOK_return_data(1)),
  VV->VVOD_SPISOK_return_data(2),
  gv,
  data->nomb,
  VV->VVOD_SPISOK_return_data(3),
  VV->VVOD_SPISOK_return_data(4),
  atoi(VV->VVOD_SPISOK_return_data(5)),
  atoi(VV->VVOD_SPISOK_return_data(6)),
  ATOFM(VV->VVOD_SPISOK_return_data(9)),
  ATOFM(VV->VVOD_SPISOK_return_data(10)),
  atoi(VV->VVOD_SPISOK_return_data(7)),
  data->gve,data->mve,data->dve,
  data->gvz,data->mvz,data->dvz,
  data->has_ve,data->min_ve,data->sek_ve,
  data->has_vz,data->min_vz,data->sek_vz,
  data->otmet,
  ATOFM(VV->VVOD_SPISOK_return_data(8)),
  iceb_t_getuid(),vrem,
  ATOFM(VV->VVOD_SPISOK_return_data(13)),
  ATOFM(VV->VVOD_SPISOK_return_data(14)),
  atoi(VV->VVOD_SPISOK_return_data(11)),
  ATOFM(VV->VVOD_SPISOK_return_data(12)),
  data->vesgr,
  data->rt_vesgr_n,
  data->rt_vesgr_f,
  data->vremr,
  data->rt_vremr_n,
  data->rt_vremr_f,
  data->tk,
  gd,atoi(podr),nomd);
  

  
 }

//printw("\n%s\n",strsql);
//OSTANOV();
 
if(sql_zapis(strsql,0,0) != 0)
 return(1);

return(0);

}
/******************************************************************/
/*Поиск предыдущего путевого листа и возврат показания спидометра*/
/******************************************************************/

int	poippl(short dd,short md,short gd,const char *kodavt)
{
int	poksp=0;
char	strsql[512];
SQL_str row;
SQLCURSOR cur;

sprintf(strsql,"select psz from Upldok where datd <= '%d-%d-%d' and ka=%s and psz != 0 order by datd desc,nz desc limit 1",
gd,md,dd,kodavt);

if(sql_readkey(&bd,strsql,&row,&cur) > 0)
 poksp=atoi(row[0]);

return(poksp);

}
/********************************/
/*Ввод дополнительной информации 1*/
/*********************************/


void vdupld(class vdupld_data *dataa)
{
//Сделано специално, чтобы записать данные только по F2
//class vdupld_data data=*dataa;
int             N=0;
int		K=0;
char strsql[512];

VVOD VV(0);
VV.VVOD_SPISOK_add_ZAG(gettext("Ввод дополнительной информации к путевому листу"));

VV.VVOD_SPISOK_add_data(11); //0
VV.VVOD_SPISOK_add_data(9);  //1
VV.VVOD_SPISOK_add_data(11); //2
VV.VVOD_SPISOK_add_data(9);  //3
VV.VVOD_SPISOK_add_data(250); //4
VV.VVOD_SPISOK_add_data(20); //5

if(dataa->dve != 0)
 {
  sprintf(strsql,"%d.%d.%d",dataa->dve,dataa->mve,dataa->gve);
  VV.VVOD_SPISOK_zapis_data(0,strsql);
 }

if(dataa->has_ve+dataa->min_ve+dataa->sek_ve != 0)
 {  
  sprintf(strsql,"%d:%d:%d",dataa->has_ve,dataa->min_ve,dataa->sek_ve);
  VV.VVOD_SPISOK_zapis_data(1,strsql);
 }

if(dataa->dvz != 0)
 {
  sprintf(strsql,"%d.%d.%d",dataa->dvz,dataa->mvz,dataa->gvz);
  VV.VVOD_SPISOK_zapis_data(2,strsql);
 }

if(dataa->has_vz+dataa->min_vz+dataa->sek_vz != 0)
 {  
  sprintf(strsql,"%d:%d:%d",dataa->has_vz,dataa->min_vz,dataa->sek_vz);
  VV.VVOD_SPISOK_zapis_data(3,strsql);
 }
VV.VVOD_SPISOK_zapis_data(4,dataa->otmet);
VV.VVOD_SPISOK_zapis_data(5,dataa->nomb);

VV.VVOD_SPISOK_add_MD(gettext("Дата выезда...........(д.м.г)........."));//0
VV.VVOD_SPISOK_add_MD(gettext("Время выезда..........(ч.м)..........."));//1
VV.VVOD_SPISOK_add_MD(gettext("Дата возвращения......(д.м.г)........."));//2
VV.VVOD_SPISOK_add_MD(gettext("Время возвращения.....(ч.м)..........."));//3
VV.VVOD_SPISOK_add_MD(gettext("Особенные отметки....................."));//4
VV.VVOD_SPISOK_add_MD(gettext("Номер бланка строгой отчетности......."));//5

nazad:;

clear();
sprintf(strsql,"%s:%s",gettext("Подразделение"),dataa->naimpod);
mvprintw(0,0,"%.*s",COLS,strsql);

sprintf(strsql,"%s:%s",gettext("Водитель"),dataa->naimvod.ravno());
mvprintw(1,0,"%.*s",COLS,strsql);

sprintf(strsql,"%s:%s %s %s",gettext("Автомобиль"),dataa->kod_avt,dataa->naimavt.ravno(),dataa->gos_nomer);
mvprintw(2,0,"%.*s",COLS,strsql);

sprintf(strsql,"%s N%s %s %s",gettext("Документ"),dataa->nomd,
gettext("от"),dataa->data_dok);
mvprintw(3,0,"%.*s",COLS,strsql);

helstr(LINES-1,0,\
//"F1",gettext("помощь"),
"F2/+",gettext("запись"),
"F10",gettext("выход"),NULL);

VV.vramka(5,0,0);

for(;;)
 {
  attron(VV.VVOD_return_cs(iceb_CFS)); 

  VV.vprintw(N,stdscr);

  K=getch();

  attroff(VV.VVOD_return_cs(iceb_CFS));
  attron(VV.VVOD_return_cs(iceb_CFM));

  VV.vprintw(N,stdscr);

  if(K == KEY_MOUSE)
    K=mouseklic(&N,VV.PY,VV.PX,VV.MDLS,VV.KLST,stdscr);

  if(K == KEY_RESIZE)
   {
    getch();
    goto nazad;
   }    

  if(K == ENTER)
   {
    attroff(VV.VVOD_return_cs(iceb_CFM));
    attron(VV.VVOD_return_cs(iceb_CFV));
    VV.vprintw_clear(N,stdscr);

//    my_getstr(VV.VVOD_SPISOK_return_data(N),dlinastr,VV.VVOD_SPISOK_return_dls(N),stdscr);
    VV.vgetstr(N,stdscr);
    
    attroff(VV.VVOD_return_cs(iceb_CFV));
    attron(VV.VVOD_return_cs(iceb_CFM));

    if(N == 0 && VV.VVOD_SPISOK_return_data(N)[0] != '\0')  //Дата выезда
     {
      if(rsdat(&dataa->dve,&dataa->mve,&dataa->gve,VV.VVOD_SPISOK_return_data(N),1) != '\0')
       {
        attroff(VV.VVOD_return_cs(iceb_CFM));
        VVOD SOOB(1);
        SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введена дата выезда !"));
        soobshw(&SOOB,stdscr,-1,-1,0,1);
	goto nazad;
       }
     }

    if(N == 1 && VV.VVOD_SPISOK_return_data(N)[0] != '\0')  //Время выезда
     {
      if(rstime(&dataa->has_ve,&dataa->min_ve,&dataa->sek_ve,VV.VVOD_SPISOK_return_data(N)) != '\0')
       {
        attroff(VV.VVOD_return_cs(iceb_CFM));
        VVOD SOOB(1);
        SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введено время выезда !"));
        soobshw(&SOOB,stdscr,-1,-1,0,1);
	goto nazad;
       }
     }

    if(N == 2 && VV.VVOD_SPISOK_return_data(N)[0] != '\0')  //Дата возвращения
     {
      if(rsdat(&dataa->dvz,&dataa->mvz,&dataa->gvz,VV.VVOD_SPISOK_return_data(N),1) != '\0')
       {
        attroff(VV.VVOD_return_cs(iceb_CFM));
        VVOD SOOB(1);
        SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введена дата возвращения !"));
        soobshw(&SOOB,stdscr,-1,-1,0,1);
	goto nazad;
       }
     }

    if(N == 3 && VV.VVOD_SPISOK_return_data(N)[0] != '\0')  //Время возвращения
     {
      if(rstime(&dataa->has_vz,&dataa->min_vz,&dataa->sek_vz,VV.VVOD_SPISOK_return_data(N)) != '\0')
       {
        attroff(VV.VVOD_return_cs(iceb_CFM));
        VVOD SOOB(1);
        SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введено время возвращения !"));
        soobshw(&SOOB,stdscr,-1,-1,0,1);
	goto nazad;
       }
     }
    if(N == 4)
     {
      memset(dataa->otmet,'\0',sizeof(dataa->otmet));
      strncpy(dataa->otmet,VV.VVOD_SPISOK_return_data(N),sizeof(dataa->otmet)-1);
     }
    if(N == 5)
     {
      memset(dataa->nomb,'\0',sizeof(dataa->nomb));
      strncpy(dataa->nomb,VV.VVOD_SPISOK_return_data(N),sizeof(dataa->nomb)-1);
     }
    VV.vprintw(N,stdscr);
    N++;
   }

  if(K==SDN) /*Стрелка вниз*/
   {
    N++;
   }
  if(K==SUP) /*Стрелка вверх*/
   {
    N--;
   }
  if(N > VV.KLST-1)
   {
    N=0;
   }
  if(N < 0)
   {
    N=VV.KLST-1;
   }

  if(K == ESC || K == FK10)
   {
    attroff(VV.VVOD_return_cs(iceb_CFS));
    attron(VV.VVOD_return_cs(iceb_CB));
    return;
   }

  if(K == FK1) /*Помощь*/
   {
    attroff(VV.VVOD_return_cs(iceb_CFS));
    attron(VV.VVOD_return_cs(iceb_CB));
    GDITE();
//    prosf(strsql);
    goto nazad;
   }

  if(K == PLU || K == FK2) /*Продолжать*/
   {
    attroff(VV.VVOD_return_cs(iceb_CFS));
    attron(VV.VVOD_return_cs(iceb_CFM));

    if(VV.VVOD_SPISOK_return_data(0)[0] != '\0')  //Дата выезда
     {
      if(rsdat(&dataa->dve,&dataa->mve,&dataa->gve,VV.VVOD_SPISOK_return_data(0),1) != '\0')
       {
        attroff(VV.VVOD_return_cs(iceb_CFM));
        VVOD SOOB(1);
        SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введена дата выезда !"));
        soobshw(&SOOB,stdscr,-1,-1,0,1);
	goto nazad;
       }
     }

    if(VV.VVOD_SPISOK_return_data(1)[0] != '\0')  //Время выезда
     {
      if(rstime(&dataa->has_ve,&dataa->min_ve,&dataa->sek_ve,VV.VVOD_SPISOK_return_data(1)) != '\0')
       {
        attroff(VV.VVOD_return_cs(iceb_CFM));
        VVOD SOOB(1);
        SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введено время выезда !"));
        soobshw(&SOOB,stdscr,-1,-1,0,1);
	goto nazad;
       }
     }

    if(VV.VVOD_SPISOK_return_data(2)[0] != '\0')  //Дата возвращения
     {
      if(rsdat(&dataa->dvz,&dataa->mvz,&dataa->gvz,VV.VVOD_SPISOK_return_data(2),1) != '\0')
       {
        attroff(VV.VVOD_return_cs(iceb_CFM));
        VVOD SOOB(1);
        SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введена дата возвращения !"));
        soobshw(&SOOB,stdscr,-1,-1,0,1);
	goto nazad;
       }
     }

    if(VV.VVOD_SPISOK_return_data(3)[0] != '\0')  //Время возвращения
     {
      if(rstime(&dataa->has_vz,&dataa->min_vz,&dataa->sek_vz,VV.VVOD_SPISOK_return_data(3)) != '\0')
       {
        attroff(VV.VVOD_return_cs(iceb_CFM));
        VVOD SOOB(1);
        SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введено время возвращения !"));
        soobshw(&SOOB,stdscr,-1,-1,0,1);
	goto nazad;
       }
     }
//    *dataa=data;
    break;
   }

 }
attroff(VV.VVOD_return_cs(iceb_CFS));
attron(VV.VVOD_return_cs(iceb_CB));

}
/********************************/
/*Ввод дополнительной информации 1*/
/*********************************/


void vdupld1(class vdupld_data *data)
{
int             N=0;
int		K=0;
char strsql[512];
SQL_str row;
SQLCURSOR cur;
float nrtk=0.;
float nrmh=0.;

sprintf(strsql,"select nrtk,nrmh from Uplavt where kod=%s",data->kod_avt);
if(sql_readkey(&bd,strsql,&row,&cur) == 1)
 {
  nrtk=atof(row[0]);
  nrmh=atof(row[1]);
 }
if(data->rt_vesgr_n == 0.)
  data->rt_vesgr_n=nrtk;
if(data->rt_vremr_n == 0.)
  data->rt_vremr_n=nrmh;

VVOD VV(0);
VV.VVOD_SPISOK_add_ZAG(gettext("Ввод дополнительной информации к путевому листу"));

VV.VVOD_SPISOK_add_data(10); //0
VV.VVOD_SPISOK_add_data(10); //1
VV.VVOD_SPISOK_add_data(10); //2
VV.VVOD_SPISOK_add_data(10); //3
VV.VVOD_SPISOK_add_data(10); //4
VV.VVOD_SPISOK_add_data(10); //5
VV.VVOD_SPISOK_add_data(10); //6

VV.data_plus(0,data->vesgr,5);
VV.data_plus(1,data->tk,5);
VV.data_plus(2,data->rt_vesgr_n,5);
VV.data_plus(3,data->rt_vesgr_f,5);
VV.data_plus(4,data->vremr,5);
VV.data_plus(5,data->rt_vremr_n,5);
VV.data_plus(6,data->rt_vremr_f,5);

VV.VVOD_SPISOK_add_MD(gettext("Вес груза.............................................."));//0
VV.VVOD_SPISOK_add_MD(gettext("Тоннокилометры........................................."));//1
VV.VVOD_SPISOK_add_MD(gettext("Норма затрат топлива на перевозку груза................"));//2
VV.VVOD_SPISOK_add_MD(gettext("Затраты топлива фактические на перевозку груза........."));//3
VV.VVOD_SPISOK_add_MD(gettext("Время работы двигателя................................."));//4
VV.VVOD_SPISOK_add_MD(gettext("Норма затрат топлива на время работы двигателя........."));//5
VV.VVOD_SPISOK_add_MD(gettext("Затраты топлива фактические на время работы двигателя.."));//6

nazad:;

clear();

sprintf(strsql,"%s:%s",gettext("Подразделение"),data->naimpod);
mvprintw(0,0,"%.*s",COLS,strsql);

sprintf(strsql,"%s:%s",gettext("Водитель"),data->naimvod.ravno());
mvprintw(1,0,"%.*s",COLS,strsql);

sprintf(strsql,"%s:%s %s %s",gettext("Автомобиль"),data->kod_avt,data->naimavt.ravno(),data->gos_nomer);
mvprintw(2,0,"%.*s",COLS,strsql);

sprintf(strsql,"%s N%s %s %s %s:%d",gettext("Документ"),data->nomd,
gettext("от"),data->data_dok,
gettext("Пробег"),data->probeg);
mvprintw(3,0,"%.*s",COLS,strsql);

printw("\n%s:%.3f\n",gettext("Затраты топлива по норме на перевозку груза"),
VV.data_ravno_atof(1)*VV.data_ravno_atof(2)/100.);
printw("%s:%.3f\n",gettext("Затраты топлива по норме на время работы двигателя"),
VV.data_ravno_atof(3)*VV.data_ravno_atof(4));
helstr(LINES-1,0,\
//"F1",gettext("помощь"),
"F2/+",gettext("запись"),
"F10",gettext("выход"),NULL);

VV.vramka(7,0,0);

for(;;)
 {
  attron(VV.VVOD_return_cs(iceb_CFS)); 

  VV.vprintw(N,stdscr);

  K=getch();

  attroff(VV.VVOD_return_cs(iceb_CFS));
  attron(VV.VVOD_return_cs(iceb_CFM));

  VV.vprintw(N,stdscr);

  if(K == KEY_MOUSE)
    K=mouseklic(&N,VV.PY,VV.PX,VV.MDLS,VV.KLST,stdscr);

  if(K == KEY_RESIZE)
   {
    getch();
    goto nazad;
   }    

  if(K == ENTER)
   {
    attroff(VV.VVOD_return_cs(iceb_CFM));
    attron(VV.VVOD_return_cs(iceb_CFV));
    VV.vprintw_clear(N,stdscr);

//    my_getstr(VV.VVOD_SPISOK_return_data(N),dlinastr,VV.VVOD_SPISOK_return_dls(N),stdscr);
    VV.vgetstr(N,stdscr);
    
    attroff(VV.VVOD_return_cs(iceb_CFV));
    attron(VV.VVOD_return_cs(iceb_CFM));

    if(N == 0 && VV.VVOD_SPISOK_return_data(N)[0] != '\0') 
     {
      double bb=data->probeg*VV.data_ravno_atof(0)*VV.data_ravno_atof(1);
      if(VV.VVOD_SPISOK_return_data(2)[0] == '\0')
        VV.data_plus(2,bb);
      N++;
      goto nazad;
     }
    if(N == 1 && VV.VVOD_SPISOK_return_data(N)[0] != '\0') 
     {
      double bb=VV.data_ravno_atof(1)*VV.data_ravno_atof(2)/100.;
      if(VV.VVOD_SPISOK_return_data(3)[0] == '\0')
        VV.data_plus(3,bb);
      N++;
      goto nazad;
     }
    if(N == 4 && VV.VVOD_SPISOK_return_data(N)[0] != '\0') 
     {
      double bb=VV.data_ravno_atof(4)*VV.data_ravno_atof(5);
      if(VV.VVOD_SPISOK_return_data(6)[0] == '\0')
        VV.data_plus(6,bb);
      N++;
      goto nazad;
     }
    if(N == 5 && VV.VVOD_SPISOK_return_data(N)[0] != '\0') 
     {
      double bb=VV.data_ravno_atof(4)*VV.data_ravno_atof(5);
      if(VV.VVOD_SPISOK_return_data(6)[0] == '\0')
        VV.data_plus(6,bb);
      N++;
      goto nazad;
     }
    VV.vprintw(N,stdscr);
    N++;
   }
  if(K==SDN) /*Стрелка вниз*/
   {
    N++;
   }
  if(K==SUP) /*Стрелка вверх*/
   {
    N--;
   }
  if(N > VV.KLST-1)
   {
    N=0;
   }
  if(N < 0)
   {
    N=VV.KLST-1;
   }

  if(K == ESC || K == FK10)
   {
    attroff(VV.VVOD_return_cs(iceb_CFS));
    attron(VV.VVOD_return_cs(iceb_CB));
    return;
   }

  if(K == FK1) /*Помощь*/
   {
    attroff(VV.VVOD_return_cs(iceb_CFS));
    attron(VV.VVOD_return_cs(iceb_CB));
    GDITE();
//    prosf(strsql);
    goto nazad;
   }

  if(K == PLU || K == FK2) /*Продолжать*/
   {
    attroff(VV.VVOD_return_cs(iceb_CFS));
    attron(VV.VVOD_return_cs(iceb_CFM));

    data->vesgr=VV.data_ravno_atof(0);
    data->tk=VV.data_ravno_atof(1);
    data->rt_vesgr_n=VV.data_ravno_atof(2);
    data->rt_vesgr_f=VV.data_ravno_atof(3);
    data->vremr=VV.data_ravno_atof(4);
    data->rt_vremr_n=VV.data_ravno_atof(5);
    data->rt_vremr_f=VV.data_ravno_atof(6);

    break;
   }
 }
attroff(VV.VVOD_return_cs(iceb_CFS));
attron(VV.VVOD_return_cs(iceb_CB));

}
