/*$Id: zarppn.c,v 5.62 2011-04-14 16:07:34 sasa Exp $*/
/*02.02.2010	23.04.2004	Белых А.И.	zarppn.c
Перерасчет подоходного налога действующий с 1.1.2004г.
*/
#include        <errno.h>
#include        "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

struct ppnal
 {
  int   tabn;      //табельный номер
  char   fio[512];  //фамилия
  double osuma[2][12]; //общая сумма начислений
  double suma_nvrpn[2][12]; //сумма не входящая в расчет для подоходного налога (общая)
  double zarpl[2][12]; //сумма зарплаты 
  double sumalgot[2][12]; // сумма социальных льгот
  double podnal[12];   // сумма подоходного налога  
  double sumasoc[12];  //сумма соц-отчислений
  double suma_ndfv[2][12]; //сумма не денежных форм выплаты
  double blag_pom[2][12];  //Сумма благотворительной помощи
  double nn_blag_pom[2][12];  //Сумма необлагоемой налогом благотворительной помощи
  double suma_sk_pens[2][12]; //Сумма зарплаты с которой должны браться пенсионные отчисления
  double suma_sk_bezr[2][12]; //Сумма зарплаты с которой должны браться отчисления в фонд безработицы
  double suma_sk_socstr[2][12]; //Сумма зарплаты с которой должны браться отчисления в соц-страх
  char   kodlg[12][20]; //коды льгот введенные по месяцам
  short  dn,mn,gn; //Дата приёма на работу
  short  dk,mk,gk;  //Дата увольнения с работы
 };
 

int  zarppn1(short mnr,short mkr,short godr,const char *tabnom,const char *podr,class spis_oth *oth);
double  zarppn_r(short,short,short god,struct ppnal *PP,masiv_din_double *,FILE *ff,FILE*,FILE*);
int zarppn_read_nastr();


extern float  ppn; //Процент подоходного налога
extern char	*organ;
extern short    *kn_bsl; //Коды начислений на которые не распространяется льгота по подоходному налогу
extern short    kodpn;   /*Код подоходного налога*/
extern short    kodpen;  /*Код пенсионных отчислений*/
extern short    kodsocstr;  /*Код отчисления на соц-страх*/
extern short    kodbzr;  /*Код отчисления на безработицу*/
extern short    *knvr;/*Коды начислений не входящие в расчет подоходного налога*/
extern float    prog_min_ng; //Прожиточный минимум на начало года
extern float    kof_prog_min; //Коэффициент прожиточного минимума
extern short    *kodmp;  //Коды благотворительной помощи
//extern double minzar_ng; /*Минимальная зарплата*/		
extern float  pomzp; //Процент от минимальной заработной платы
extern short    kodbzr;  /*Код отчисления на безработицу*/
extern float  ppn; //Процент подоходного налога
extern float  procpen[2]; /*Процент отчисления в пенсионный фонд*/

extern short	*kodnvpen; /*Коды не входящие в расчет пенсионного отчисления*/
extern short	*kodsocstrnv; //Коды не входящие в расчет соцстраха
extern short	*kodbzrnv; //Коды не входящие в расчет отчислений на безработицу

extern float procsoc; /*Процент отчисления в соц-страх*/
extern float procsoc1; /*Процент отчисления в соц-страх*/
extern float procbez; /*Процент отчисления на безработицу*/

int  zarppn(class spis_oth *oth)
{
int kom1=0;
int tabn=0;
char fam[512];
char strsql[512];
static char mn[3];
static char mk[3];
static char god[5];
static char tabnom[112];
static char podr[112];
short mnr,mkr,godr;
class iceb_tu_str fiov("");
VVOD MENU(3);
VVOD VV(0);

VV.VVOD_SPISOK_add_data(mn,sizeof(mn));
VV.VVOD_SPISOK_add_data(mk,sizeof(mk));
VV.VVOD_SPISOK_add_data(god,sizeof(god));
VV.VVOD_SPISOK_add_data(tabnom,sizeof(tabnom));
VV.VVOD_SPISOK_add_data(podr,sizeof(podr));

VV.VVOD_SPISOK_add_MD(gettext("Месяц начала............"));//0
VV.VVOD_SPISOK_add_MD(gettext("Месяц конца............."));//1
VV.VVOD_SPISOK_add_MD(gettext("Год....................."));//2
VV.VVOD_SPISOK_add_MD(gettext("Табельный номер...(,,).."));//3
VV.VVOD_SPISOK_add_MD(gettext("Код подразделения.(,,).."));//4

naz:;

VV.VVOD_delete_ZAG();
zarppn_read_nastr();


VV.VVOD_SPISOK_add_ZAG(organ);
VV.VVOD_SPISOK_add_ZAG(gettext("Перерасчет подоходного налога"));


sprintf(strsql,"%s:%.2f",gettext("Коэффициент прожиточного минимума"),kof_prog_min);
VV.VVOD_SPISOK_add_ZAG(strsql);


sprintf(strsql,"%s:%.2f",gettext("Процент от минимальной зарплаты"),pomzp);
VV.VVOD_SPISOK_add_ZAG(strsql);

sprintf(strsql,"%s:%.2f",gettext("Процент подоходного налога"),ppn);
VV.VVOD_SPISOK_add_ZAG(strsql);



clear();

helstr(LINES-1,0,\
//"F1",gettext("помощь"),
"F2/+",gettext("расчeт"),
"F3",gettext("реквизиты"),
"F4",gettext("очистить"),
"F5",gettext("настройка"),
"F10",gettext("выход"),NULL);

kom1=VV.vvod(0,1,1,-1,-1);

strncpy(mn,VV.VVOD_SPISOK_return_data(0),sizeof(mn)-1);
strncpy(mk,VV.VVOD_SPISOK_return_data(1),sizeof(mk)-1);
strncpy(god,VV.VVOD_SPISOK_return_data(2),sizeof(god)-1);
strncpy(tabnom,VV.VVOD_SPISOK_return_data(3),sizeof(tabnom)-1);
strncpy(podr,VV.VVOD_SPISOK_return_data(4),sizeof(podr)-1);

switch(kom1)
 {
  case FK1:
    GDITE();
//    prosf(bros);
    goto naz;

  case FK2:
  case PLU:
   break;

  case FK10:
   return(1);

  case FK3:

    MENU.VVOD_delete();
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка табельных номеров"));//0
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка подразделений"));//1
    MENU.VVOD_SPISOK_add_MD(gettext("Выход"));//2

    clearstr(LINES-1,0);
    
    kom1=0;
    while(menu3w(stdscr,&MENU,&kom1,-1,-1,0) != 0);

    switch (kom1)
     {
      case 2 :
      case -1:
       goto naz;

      case 0 :
        clear();
        tabn=0;
        fiov.new_plus("");
        if(dirtab(&tabn,&fiov,0,1) == 0)
         {
          sprintf(strsql,"%d",tabn);
          VV.data_z_plus(3,strsql);
         }
        
        break;

      case 1 :
        vibrek("Podr",podr,sizeof(podr),fam);
        VV.VVOD_SPISOK_zapis_data(4,podr);
        break;
     }
    goto naz;

  case FK4:
    VV.VVOD_clear_data();
    goto naz;

  case FK5:
   iceb_redfil("zarppn.alx",0);
   goto naz;

  default:
   goto naz;
 }

mnr=atoi(mn);
mkr=atoi(mk);
godr=atoi(god);

if(mnr == 0 || mnr > 11)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введен месяц начала !"));

  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }

if(mkr == 0 || mkr > 12 || mkr < 2)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введен месяц конца !"));

  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }

if(god == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не верно введен год !"));

  soobshw(&SOOB,stdscr,-1,-1,0,1);
  goto naz;
 }

clear();
GDITE();

if(godr >= 2011)
  return(zarppn1(mnr,mkr,godr,tabnom,podr,oth));

SQLCURSOR cur;
SQLCURSOR cur1;
int kolstr;
SQL_str row;
SQL_str row1;

sprintf(strsql,"select datz,tabn,prn,knah,suma,mesn,godn,podr from Zarp where \
datz >= '%04d-%d-1' and datz <= '%04d-%d-31' and suma <> 0. \
order by tabn asc, datz asc",godr,mnr,godr,mkr);


if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

if(kolstr == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Не найдено ни одной записи !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);
 }

char imaf[30];
FILE *ff;

sprintf(imaf,"ppn%d.lst",getpid());
if((ff = fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return(1);
 }

char imaf_spis[30];
FILE *ff_spis;

sprintf(imaf_spis,"ppnsp%d.lst",getpid());
if((ff_spis = fopen(imaf_spis,"w")) == NULL)
 {
  error_op_nfil(imaf_spis,errno,"");
  return(1);
 }
struct tm *bf;
time_t vrem;
time(&vrem);
bf=localtime(&vrem);

zagolov(gettext("Перерасчет подоходного налога"),bf,1,mnr,godr,31,mkr,godr,organ,ff_spis);
fprintf(ff_spis,"\n");
char imaf_p[30];
FILE *ff_p;
sprintf(imaf_p,"ppnp%d.lst",getpid());
if((ff_p = fopen(imaf_p,"w")) == NULL)
 {
  error_op_nfil(imaf_p,errno,"");
  return(1);
 }


short metkapropuska=0;
long tabnz=0;
int kolstr1=0;
ppnal PP;
memset(&PP,'\0',sizeof(PP));    

double suma;
short d,m,g;
int knah;
short mesz=0;

masiv_din_double suma_ne_zarpl;
if(kn_bsl != NULL)
 if(kn_bsl[0] != 0)
  suma_ne_zarpl.make_class(kn_bsl[0]*12);
int kol_tab_nom=0;  
short mes_vshet;
short god_vshet;
double suma_per=0.;

while(cur.read_cursor(&row) != 0)
 {
  strzag(LINES-1,0,kolstr,++kolstr1);
  if(proverka(tabnom,row[1],0,0) != 0)
   continue;
  if(proverka(podr,row[7],0,0) != 0)
   continue;

  tabn=atol(row[1]);

  if(tabnz != tabn)
   {

    if(tabnz != 0 && metkapropuska == 0)
     {
      if(kol_tab_nom > 0)
       fprintf(ff,"\f");
      
      suma_per+=zarppn_r(mnr,mkr,godr,&PP,&suma_ne_zarpl,ff,ff_p,ff_spis);
      kol_tab_nom++;
     }

    memset(&PP,'\0',sizeof(PP));    
    suma_ne_zarpl.clear_class();
    PP.tabn=tabnz=tabn;
    
    sprintf(strsql,"select fio,datn,datk from Kartb where tabn=%d",PP.tabn);
    if(sql_readkey(&bd,strsql,&row1,&cur1) == 1)
     {
      strncpy(PP.fio,row1[0],sizeof(PP.fio)-1);                   
      rsdat(&PP.dn,&PP.mn,&PP.gn,row1[1],2);
      rsdat(&PP.dk,&PP.mk,&PP.gk,row1[2],2);
      
     }
    printw("%5d %s\n",PP.tabn,PP.fio);
    mesz=0;

    metkapropuska=1;     
    int kollgot=0;    
    class iceb_tu_str kod_lgot("");
    for(m=mnr; m <= mkr; m++)
     if(zarlgot(tabn,m,godr,&kollgot,&kod_lgot,NULL) != 0.)
      {
       metkapropuska=0;
       break;
      }    
    if(metkapropuska == 1)
     {
      fprintf(ff,"%5d %s\n",PP.tabn,PP.fio);
      fprintf(ff,"Пропускаем так как нет у него социальной льготы !\n");
     }
/*********    
     {
      fprintf(ff,"%5d %s\n",PP.tabn,PP.fio);
      fprintf(ff,"Пропускаем так как нет у него социальной льготы !\n");
      metkapropuska=1;
     }
    else 
     metkapropuska=0;     
**************/
   }


  if(metkapropuska == 1)
    continue;
  
  rsdat(&d,&m,&g,row[0],2);
  knah=atoi(row[3]);    
  suma=atof(row[4]);
  mes_vshet=atoi(row[5]);
  god_vshet=atoi(row[6]);
  
  if(mesz != m)
   {
    sprintf(strsql,"select lgot from Zarn where tabn=%d and god=%d and mes=%d",
    tabn,g,m);
    if(sql_readkey(&bd,strsql,&row1,&cur1) == 1)
      strncpy(PP.kodlg[m-1],row1[0],10);
    mesz=m;
   }  

  if(atoi(row[2]) == 1)
   {
    PP.osuma[0][m-1]+=suma;
    if(g == god_vshet)
      PP.osuma[1][mes_vshet-1]+=suma;

    if(provkod(knvr,knah) >= 0)
     {
      PP.suma_nvrpn[0][m-1]+=suma;
      if(g == god_vshet)
        PP.suma_nvrpn[1][mes_vshet-1]+=suma;

      continue;
     }

    if(provkod(kodmp,knah) >= 0)
     {
      PP.blag_pom[0][m-1]+=suma;
      if(g == god_vshet)
        PP.blag_pom[1][mes_vshet-1]+=suma;

     //Код благотворительности должен быть в списке не зарплаты
//      continue;
     }

    if(provkod(kn_bsl,knah) < 0)
     {
      PP.zarpl[0][m-1]+=suma;
      if(g == god_vshet)
        PP.zarpl[1][mes_vshet-1]+=suma;
       
      if(provkod(kodnvpen,knah) < 0)
       {
        PP.suma_sk_pens[0][m-1]+=suma;
        if(g == god_vshet)
          PP.suma_sk_pens[1][mes_vshet-1]+=suma;
       
       }

      if(provkod(kodsocstrnv,knah) < 0)
       {
        PP.suma_sk_socstr[0][m-1]+=suma;
        if(g == god_vshet)
          PP.suma_sk_socstr[1][mes_vshet-1]+=suma;
       }
      if(provkod(kodbzrnv,knah) < 0)
       {
        PP.suma_sk_bezr[0][m-1]+=suma;
        if(g == god_vshet)
          PP.suma_sk_bezr[1][mes_vshet-1]+=suma;
       }
     }
    else
     {
//      printw("%s %s %s %s %s\n",row[0],row[1],row[2],row[3],row[4]);
      int nomer=0;
      for(int i=1; i <= kn_bsl[0]; i++)
       if(knah == kn_bsl[i])
        {
         nomer=i;
         break;
        }
//      printw("nomer=%d m=%d %d %d %d\n",nomer,m,kn_bsl[0],kn_bsl[1],kn_bsl[2]);
      if(nomer != 0)
       suma_ne_zarpl.plus(suma,(nomer-1)*12+(m-1));
     }
    double budget=0.;
    double suma_s_nds=knnfnds(1,knah,"",suma,&budget,NULL);
    PP.suma_ndfv[0][m-1]+=suma_s_nds;
    if(g == god_vshet)
        PP.suma_ndfv[1][mes_vshet-1]+=suma_s_nds;
/************
    if(provkod(knnf,knah) >= 0)
     {
      double suma_s_nds=suma;
      knnfnds(knah,&suma_s_nds,NULL);
      
      PP.suma_ndfv[0][m-1]+=suma_s_nds;
      if(g == god_vshet)
        PP.suma_ndfv[1][mes_vshet-1]+=suma_s_nds;
     }
**************/     
   }
  else
   {
    if(kodpn == knah)
      PP.podnal[m-1]+=suma;

    if(knah == kodpen)
      PP.sumasoc[m-1]+=suma;

    if(knah == kodsocstr)
      PP.sumasoc[m-1]+=suma;

    if(knah == kodbzr)
      PP.sumasoc[m-1]+=suma;
    
   }
   
 }

if(metkapropuska == 0)
 {
  if(kol_tab_nom > 0)
       fprintf(ff,"\f");

  suma_per+=zarppn_r(mnr,mkr,godr,&PP,&suma_ne_zarpl,ff,ff_p,ff_spis);
 }

fprintf(ff_spis,"%37s:%10.2f\n","Разом",suma_per);

podpis(ff);
podpis(ff_p);
podpis(ff_spis);
fclose(ff);
fclose(ff_p);
fclose(ff_spis);

oth->spis_imaf.plus(imaf);
oth->spis_naim.plus(gettext("Перерасчет подоходного налога за год"));
oth->spis_imaf.plus(imaf_spis);
oth->spis_naim.plus(gettext("Общий итог"));
oth->spis_imaf.plus(imaf_p);
oth->spis_naim.plus(gettext("Протокол расчёта"));

for(int nom=0; nom < oth->spis_imaf.kolih(); nom++)
 iceb_t_ustpeh(oth->spis_imaf.ravno(nom),3);
 
return(0);
 
}
/****************************************/
/*Распечатка данных и перерасчет*/
/**************************************/

double  zarppn_r(short mn,short mk,short god,struct ppnal *PP,masiv_din_double *suma_ne_zarpl,
FILE *ff,FILE *ff_p,FILE *ff_spis)
{
double itogo[10];

memset(&itogo,'\0',sizeof(itogo));

fprintf(ff,"\n%d %s\n",PP->tabn,PP->fio);
fprintf(ff,"Дата початку роботи:%02d.%02d.%04d\n",PP->dn,PP->mn,PP->gn);
fprintf(ff,"Дата звільнення    :%02d.%02d.%04d\n",PP->dk,PP->mk,PP->gk);

fprintf(ff_p,"\n%d %s\n",PP->tabn,PP->fio);

fprintf(ff,"\
---------------------------------------------------------------------------------------------------------------------------------\n");

fprintf(ff,"\
 Дата  |Нараховано|Не оподат.|Благдійна |Неопо.благ|  Податок |Зарплата  |Не гро.фор|Соціальні |Податок з |Соц.відра.|Код пільги|\n\
       |          |податком  |допомога  |одійна доп|загальний |          |ми нар.зар|від.загал.|зарплати  |з зарплати|          |\n");

fprintf(ff,"\
---------------------------------------------------------------------------------------------------------------------------------\n");
double matpomb;
double nalsz;
double bezrab;
double pension;
double socstrah;
double it_soc=0.;
double podoh_sz[12];
int metka_bezr=0;
char strsql[512];

//проверяем есть ли удержание на безработицу (для пенсионеров безработица не считаестя)
sprintf(strsql,"select shet from Zarn1 where tabn=%d and prn='2' and \
knah=%d",PP->tabn,kodbzr);

if(readkey(strsql) == 0)
 {
  fprintf(ff_p,"Нет в списке удержаний отчислени в фонд безработицы.\n");
  metka_bezr=1;
 }
class zar_read_tn1h nastr;
for(int i=mn-1 ; i < mk; i++)
 {
  //Вычисяем соц-отчисления с зарплаты
//  zar_read_tn(1,i+1,god,NULL);
  zar_read_tn1(1,i+1,god,&nastr,NULL);
  bezrab=0;
  if(metka_bezr == 0)
    bezrab=fbezr_sumnal(PP->suma_sk_bezr[0][i]);

  pension=pens(PP->tabn,i+1,god,PP->suma_sk_pens[0][i],NULL)*-1;
  if(god == 2004 && i+1 < 5)
   {
    socstrah=PP->suma_sk_socstr[0][i]*-0.5/100.;
    socstrah=okrug(socstrah,0.01);
   }
  else
    socstrah=zar_rsoc(PP->suma_sk_socstr[0][i],nastr.prog_min_tek,NULL);
  
  it_soc=bezrab+pension+socstrah;

  fprintf(ff_p,"Месяц %d Пенсионный %.2f(%.2f) Безработица %.2f(%.2f) Соцстрах %.2f(%.2f) Итого %.2f\n",
  i+1,pension,PP->suma_sk_pens[0][i],bezrab,PP->suma_sk_bezr[0][i],socstrah,PP->suma_sk_socstr[0][i],it_soc);

    
  double suma_blag_pom=0.,suma_blag_pom_b=0.;
  /*Определение необлагаемай налогом благотворительной помощи*/
  if(PP->blag_pom[0][i] != 0.)
    PP->nn_blag_pom[0][i]+=matpom1(PP->tabn,i+1,god,kodmp,NULL,1,&matpomb,1,&suma_blag_pom,&suma_blag_pom_b);

  if(PP->osuma[0][i] == PP->zarpl[0][i] || PP->osuma[0][i] - PP->suma_nvrpn[0][i] == PP->zarpl[0][i])
   {
    nalsz=PP->podnal[i];
    it_soc=PP->sumasoc[i];
   }
  else
   {
    //Сумму не зарплаты не передаём для того чтобы получить налог только с зарплаты
    nalsz=podohrs1(PP->tabn,i+1,god,PP->zarpl[0][i],it_soc,0.,PP->suma_ndfv[0][i],NULL);
   }  
  fprintf(ff,"%02d.%04d %10.2f %10.2f %10.2f %10.2f %10.2f %10.2f %10.2f %10.2f %10.2f %10.2f %s\n",
  i+1,god,
  PP->osuma[0][i],
  PP->suma_nvrpn[0][i],
  PP->blag_pom[0][i],
  PP->nn_blag_pom[0][i],
  PP->podnal[i],
  PP->zarpl[0][i],
  PP->suma_ndfv[0][i],
  PP->sumasoc[i],
  nalsz,
  it_soc,
  PP->kodlg[i]);


  podoh_sz[i]=nalsz;
  itogo[0]+=PP->osuma[0][i];
  itogo[1]+=PP->suma_nvrpn[0][i];
  itogo[2]+=PP->blag_pom[0][i];
  itogo[3]+=PP->nn_blag_pom[0][i];
  itogo[4]+=PP->podnal[i];
  itogo[5]+=PP->zarpl[0][i];
  itogo[6]+=PP->suma_ndfv[0][i];
  itogo[7]+=PP->sumasoc[i];
  itogo[8]+=nalsz;
  itogo[9]+=it_soc;
  
 }

fprintf(ff,"\
---------------------------------------------------------------------------------------------------------------------------------\n");

fprintf(ff,"%7s %10.2f %10.2f %10.2f %10.2f %10.2f %10.2f %10.2f %10.2f %10.2f %10.2f\n",
" ",itogo[0],itogo[1],itogo[2],itogo[3],itogo[4],itogo[5],itogo[6],itogo[7],itogo[8],itogo[9]);


if(kn_bsl != NULL)
 if(kn_bsl[0] != 0)
 if(suma_ne_zarpl->suma() != 0.)
  {
   double itogo_nz=0.;
   char naim_nash[100];
   char strsql[512];
   SQL_str row;
   SQLCURSOR cur;

   fprintf(ff,"\n%s:\n","Нарахування, на які не розповсюджуеться социальна пільга");
   fprintf(ff,"\
--------------------------------------------------------------------------------------------------------------------------------------------------------\n");   
   fprintf(ff,"Код|  Найменування нарахування    |");

   for(int i=0; i < 12 ; i++)
    fprintf(ff," %02d.%04d|",i+1,god);

   fprintf(ff,"%-*.*s|\n",iceb_tu_kolbait(8,"Разом"),iceb_tu_kolbait(8,"Разом"),"Разом");
   fprintf(ff,"\
--------------------------------------------------------------------------------------------------------------------------------------------------------\n");   
   double itogo_nzi[12];
   memset(&itogo_nzi,'\0',sizeof(itogo_nzi));
   for(int i=1; i <= kn_bsl[0]; i++)
    {
     //Проверяем есть ли начисления
     itogo_nz=0.;
     for(int ii=0; ii < 12; ii++)
      {
       itogo_nz+=suma_ne_zarpl->ravno((i-1)*12+ii);
       itogo_nzi[ii]+=suma_ne_zarpl->ravno((i-1)*12+ii);
      }
     if(itogo_nz == 0.)
      continue;
     memset(naim_nash,'\0',sizeof(naim_nash));
    //Читаем наименование начисления
     sprintf(strsql,"select naik from Nash where kod=%d",kn_bsl[i]);
     if(sql_readkey(&bd,strsql,&row,&cur) == 1)
      strncpy(naim_nash,row[0],sizeof(naim_nash)-1);

     fprintf(ff,"%3d %-*.*s ",
     kn_bsl[i],
     iceb_tu_kolbait(30,naim_nash),iceb_tu_kolbait(30,naim_nash),naim_nash);
     
     for(int ii=0; ii < 12; ii++)
       fprintf(ff,"%8.2f ",suma_ne_zarpl->ravno((i-1)*12+ii));
     fprintf(ff,"%8.2f\n",itogo_nz);     

    }
   fprintf(ff,"\
--------------------------------------------------------------------------------------------------------------------------------------------------------\n");   

   fprintf(ff,"%*s ",iceb_tu_kolbait(34,"Разом"),"Разом");
   for(int ii=0; ii < 12; ii++)
       fprintf(ff,"%8.2f ",itogo_nzi[ii]);
   fprintf(ff,"%8.2f\n",suma_ne_zarpl->suma());
  }

fprintf(ff,"\nРозсчёт по місяцях в счёт яких були зроблені нарахування.\n");

fprintf(ff,"\
---------------------------------------------------------------------------------------------------------------------------------\n");

fprintf(ff,"\
 Дата  |Нараховано|Не оподат.|Благдійна |Неопо.благ|Зарплата  |Не гро.фор|Соц.відра.|Податок   |Податок   |Різниця|\n\
       |          |податком  |допомога  |одійна доп|          |ми нар.зар|з зарплати|розрахунк.|утриманий |       |\n");

fprintf(ff,"\
---------------------------------------------------------------------------------------------------------------------------------\n");

memset(&itogo,'\0',sizeof(itogo));

fprintf(ff_p,"\nПерерасчёт\n");

for(int i=mn-1 ; i < mk; i++)
 {
//  zar_read_tn(1,i+1,god,ff_p);
  zar_read_tn1(1,i+1,god,&nastr,ff_p);
  //Вычисяем соц-отчисления с зарплаты
  bezrab=0;
  if(metka_bezr == 0)
    bezrab=fbezr_sumnal(PP->suma_sk_bezr[1][i]);
  pension=pens(PP->tabn,i+1,god,PP->suma_sk_pens[1][i],NULL)*-1;

  if(god == 2004 && i+1 < 5)
   {
    socstrah=PP->suma_sk_socstr[0][i]*-0.5/100.;
    socstrah=okrug(socstrah,0.01);
    fprintf(ff_p,"Соцстрах=%.2f\n",socstrah);
   }
  else
   socstrah=zar_rsoc(PP->suma_sk_socstr[1][i],nastr.prog_min_tek,NULL);
  
  it_soc=bezrab+pension+socstrah;
  it_soc=okrug(it_soc,0.01);
  fprintf(ff_p,"Месяц %d Пенсионный %.2f(%.2f) Безработица %.2f(%.2f) Соцстрах %.2f(%.2f) Итого %.2f\n",
  i+1,pension,PP->suma_sk_pens[1][i],bezrab,PP->suma_sk_bezr[1][i],socstrah,PP->suma_sk_socstr[1][i],it_soc);

    
  double suma_blag_pom=0.,suma_blag_pom_b=0.;
  /*Определение необлагаемай налогом благотворительной помощи*/
  if(PP->blag_pom[1][i] != 0.)
    PP->nn_blag_pom[1][i]+=matpom1(PP->tabn,i+1,god,kodmp,NULL,1,&matpomb,1,&suma_blag_pom,&suma_blag_pom_b);

  //Сумму не зарплаты не передаём для того чтобы получить налог только с зарплаты
  nalsz=podohrs1(PP->tabn,i+1,god,PP->zarpl[1][i],it_soc,0.,PP->suma_ndfv[1][i],ff_p);

  fprintf(ff,"%02d.%04d %10.2f %10.2f %10.2f %10.2f %10.2f %10.2f %10.2f %10.2f %10.2f %7.2f\n",
  i+1,god,
  PP->osuma[1][i],
  PP->suma_nvrpn[1][i],
  PP->blag_pom[1][i],
  PP->nn_blag_pom[1][i],
  PP->zarpl[1][i],
  PP->suma_ndfv[1][i],
  it_soc,
  nalsz,
  podoh_sz[i],
  nalsz-podoh_sz[i]);



  itogo[0]+=PP->osuma[1][i];
  itogo[1]+=PP->suma_nvrpn[1][i];
  itogo[2]+=PP->blag_pom[1][i];
  itogo[3]+=PP->nn_blag_pom[1][i];
  itogo[4]+=PP->zarpl[1][i];
  itogo[5]+=PP->suma_ndfv[1][i];
  itogo[6]+=it_soc;
  itogo[7]+=nalsz;
  itogo[8]+=podoh_sz[i];
  itogo[9]+=nalsz-podoh_sz[i];  
 }

fprintf(ff,"\
---------------------------------------------------------------------------------------------------------------------------------\n");

fprintf(ff,"%7s %10.2f %10.2f %10.2f %10.2f %10.2f %10.2f %10.2f %10.2f %10.2f %7.2f\n",
" ",itogo[0],itogo[1],itogo[2],itogo[3],itogo[4],itogo[5],itogo[6],itogo[7],itogo[8],itogo[9]);


fprintf(ff_spis,"%6d %-*.*s %10.2f\n",
PP->tabn,
iceb_tu_kolbait(30,PP->fio),iceb_tu_kolbait(30,PP->fio),PP->fio,
itogo[9]);

return(itogo[9]);
 

}
/****************************/
/*Чтение настроек для расчёта*/
/*****************************/

int zarppn_read_nastr()
{
SQL_str row_alx;
class SQLCURSOR cur_alx;
int kolstr=0;
char strsql[512];
char pole[1024];


sprintf(strsql,"select str from Alx where fil='zarppn.alx' order by ns asc");
if((kolstr=cur_alx.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

if(kolstr == 0)
 {
  sprintf(strsql,"%s %s!",gettext("Не найдена настройка"),"zarppn.alx");
  iceb_t_soob(strsql);
  return(1);
 }



while(cur_alx.read_cursor(&row_alx) != 0)
 {
  if(row_alx[0][0] == '#')
   continue;
  polen(row_alx[0],pole,sizeof(pole),1,'|');

  if(SRAV(pole,"Коэффициент прожиточного минимума",0) == 0)
   {
    polen(row_alx[0],pole,sizeof(pole),2,'|');
    kof_prog_min = ATOFM(pole);
    continue;
   }
  if(SRAV(pole,"Процент подоходного налога",0) == 0)
   {
    polen(row_alx[0],pole,sizeof(pole),2,'|');
    ppn = ATOFM(pole);
    continue;
   }

  if(SRAV(pole,"Процент от минимальной заработной платы",0) == 0)
   {
    polen(row_alx[0],pole,sizeof(pole),2,'|');
    pomzp = ATOFM(pole);
    continue;
   }

  if(SRAV(pole,"Процент отчисления в пенсионный фонд",0) == 0)
    {
     polen(row_alx[0],pole,sizeof(pole),2,'|');
     procpen[0]=(float)ATOFM(pole);
     if(polen(row_alx[0],pole,sizeof(pole),3,'|') == 0)
       procpen[1]=(float)ATOFM(pole);
     else
       procpen[1]=procpen[0];
     
     continue;
    }

  if(SRAV(pole,"Процент отчисления в соц-страх",0) == 0)
    {
     polen(row_alx[0],pole,sizeof(pole),2,'|');
     procsoc=(float)ATOFM(pole);
     polen(row_alx[0],pole,sizeof(pole),3,'|');
     procsoc1=(float)ATOFM(pole);
     continue;
    }

  if(SRAV(pole,"Процент отчисления в фонд безработицы",0) == 0)
    {
     polen(row_alx[0],pole,sizeof(pole),2,'|');
     procbez=(float)ATOFM(pole);
     continue;
    }

 }
return(0);

}
