/*$Id: zarsruv.c,v 1.41 2011-08-29 07:09:00 sasa Exp $*/
/*13.08.2011	22.11.2001	Белых А.И.	zarsruv.c
Расчет средней заработной платы социальной помощи
*/
#include        <errno.h>
#include        <math.h>
#include        <time.h>
#include        "buhg.h"
#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

void zarsruv_sh(const char *inn,const char *fio,FILE *ff);
void zarsruv_end(double suma,FILE *ff);

extern short	*kodsocstrnv; //Коды не входящие в расчет соцстраха
extern short    *knvr;/*Коды начислений не входящие в расчет подоходного налога*/
extern char     *organ;
extern short    *kodmp;   /*Коды материальной помощи*/
extern short    kodpen;  /*Код пенсионных отчислений*/
extern short    kodsocstr;  /*Код отчисления на соц-страх*/
extern short    kodbzr;  /*Код отчисления на безработицу*/
extern class iceb_tu_str kods_esv_all;  /*Все коды удержания единого социального взноса*/
extern class iceb_tu_str knvr_esv_r; /*Коды не входящие в расчёт единого социального взноса с работника*/

int zarsruv(short dn,short mn,short gn,
short dk,short mk,short gk,char *tabnom,char *fam,char *inn,class spis_oth *oth)
{
struct  tm      *bf;
char		strsql[512];
SQL_str		row,row1;
int		kolstr=0;
short		kolmes=0; //Количество месяцев в периоде
double		suma=0.;
time_t		tmmn;
short		kkk;
char		imaf[64],imafprot[64],imaf_bezr[64];
FILE		*ff,*ffprot,*ff_bezr;
char		kodtabotrv[312]; //Коды табеля отработанного времени
char		kodtabotp[312]; //Коды табеля отпускных
short		knah;
short		dr,mr,gr;
char		fambuh[512];
short		prn=0;
double		matpomb=0.;
SQLCURSOR curr;
clear();
GDITE();
time(&tmmn);
bf=localtime(&tmmn);


kolmes=period(1,mn,gn,1,mk,gk,1);
if(kolmes == 0)
 {
  VVOD SOOB(1);
  SOOB.VVOD_SPISOK_add_MD(gettext("Количество месяцев в периоде равно нолю !"));
  soobshw(&SOOB,stdscr,-1,-1,0,1);
  return(1);
 }

printw("%s\n",gettext("Расчет средней зарплаты социальной помощи."));
printw("%s %d.%d %s %d.%d %s %s\n",
gettext("Период с"),mn,gn,
gettext("до"),mk,gk,tabnom,fam);
printw("%s:%d\n",gettext("Количество месяцев"),kolmes);

memset(fambuh,'\0',sizeof(fambuh));
iceb_t_poldan("Табельный номер бухгалтера",fambuh,"zarnast.alx");
if(fambuh[0] != '\0')
 {
  sprintf(strsql,"select fio from Kartb where tabn=%s",fambuh);
  if(sql_readkey(&bd,strsql,&row,&curr) == 1)
   strncpy(fambuh,row[0],sizeof(fambuh)-1);
 }

double nash[kolmes]; //Всего начислено
double vrashet[kolmes]; //Всего берется в расчет
double pens[kolmes]; //Всего пенсионных отчислений
double bezr[kolmes]; //Всего по безработице
double netrud[kolmes]; //Всего по нетрудоспособности
int    kolkk[kolmes]; //Количество отработанных дней


memset(nash,'\0',sizeof(nash)); 
memset(vrashet,'\0',sizeof(vrashet));
memset(kolkk,'\0',sizeof(kolkk));
memset(pens,'\0',sizeof(pens));
memset(bezr,'\0',sizeof(bezr));
memset(netrud,'\0',sizeof(netrud));

//sprintf(strsql,"%s",iceb_t_imafnsi("zarsrbol.alx"));
iceb_t_poldan("Коды видов табеля отработанного времени",kodtabotrv,"zarsrbol.alx");
iceb_t_poldan("Коды видов табеля отпускных",kodtabotp,"zarsrbol.alx");

sprintf(imaf,"szu%s_%d.lst",tabnom,getpid());
if((ff = fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return(1);
 }

sprintf(imaf_bezr,"bezr%s_%d.lst",tabnom,getpid());
if((ff_bezr = fopen(imaf_bezr,"w")) == NULL)
 {
  error_op_nfil(imaf_bezr,errno,"");
  return(1);
 }


zarsruv_sh(inn,fam,ff_bezr);


sprintf(imafprot,"szup%s_%d.lst",tabnom,getpid());
if((ffprot = fopen(imafprot,"w")) == NULL)
 {
  error_op_nfil(imafprot,errno,"");
  return(1);
 }

zagolov(gettext("Протокол расчёта"),bf,dn,mn,gn,dk,mk,gk,organ,ffprot);
fprintf(ffprot,"%s %s\n",tabnom,fam);
fprintf(ffprot,"%s:%d\n",gettext("Количество месяцев"),kolmes);

class zar_read_tn1h nastr;

SQLCURSOR cur;
dr=1; mr=mn; gr=gn;
for(kkk=0; kkk < kolmes; kkk++)
 {
  fprintf(ffprot,"\n%d.%d\n",mr,gr);
  sprintf(strsql,"select prn,knah,suma from Zarp where tabn=%s and \
datz >= '%04d-%d-01' and datz <= '%04d-%d-31' and suma <> 0.",
  tabnom,gr,mr,gr,mr);
  if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
   {
    msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
    continue;
   }
  if(kolstr != 0)
   {
    //читаем настройки
    zar_read_tn(1,mr,gr,NULL);
    
    while(cur.read_cursor(&row) != 0)
     {
      prn=atoi(row[0]);
      knah=atoi(row[1]);
      suma=atof(row[2]);    
      if(prn == 1)
        sprintf(strsql,"select naik from Nash where kod=%d",knah);
      if(prn == 2)
        sprintf(strsql,"select naik from Uder where kod=%d",knah);
      sql_readkey(&bd,strsql,&row1,&curr);
      
      fprintf(ffprot,"%2d %-40s %8.2f\n",knah,row1[0],suma);
      if(prn == 1)
       {
        nash[kkk]+=suma;    
        
        if(provkod(knvr,knah) >= 0)
         {
          fprintf(ffprot,"%s !\n",gettext("Не вошло в расчет"));      
          continue;    
         }

        if(sravmydat(dn,mn,gn,ICEB_DNDESV,ICEB_MNDESV,ICEB_GNDESV) < 0)
         {
          if(provkod(kodsocstrnv,knah) >= 0)
           {
            fprintf(ffprot,"%s !\n",gettext("Не вошло в расчет"));      
            continue;    
           }
         }
        else
         {
          if(proverka(knvr_esv_r.ravno(),knah,0,1) == 0)
           {
            fprintf(ffprot,"%s !\n",gettext("Не вошло в расчет"));      
            continue;    
           }
         }
        
        vrashet[kkk]+=suma;    
       }
      if(prn == 2)
       {
        if(knah == kodpen) //Код пенсионных отчислений
          pens[kkk]+=suma;
        if(knah == kodsocstr) //Код отчисления на соц-страх
          netrud[kkk]+=suma;

        if(sravmydat(dn,mn,gn,ICEB_DNDESV,ICEB_MNDESV,ICEB_GNDESV) < 0)
         {
          if(knah == kodbzr) //Код отчисления на безработицу
            bezr[kkk]+=suma;
         }
        else
         {
          if(proverka(kods_esv_all.ravno(),knah,0,1) == 0)
            bezr[kkk]+=suma;
           
         }
       }
     }
    double suma_blag_pom,suma_blag_pom_b;
    vrashet[kkk]-=matpom1(atol(tabnom),mr,gr,kodmp,ffprot,1,&matpomb,0,&suma_blag_pom,&suma_blag_pom_b);

    zar_read_tn1(1,mr,gr,&nastr,NULL);

    if(vrashet[kkk] > nastr.max_sum_for_soc)
     {
      fprintf(ffprot,"Больше %.2f\n",nastr.max_sum_for_soc);
      vrashet[kkk]=nastr.max_sum_for_soc;
     }
    fprintf(ffprot,"%33s:%8.2f\n",gettext("Итого"),vrashet[kkk]);
   }  
  //Узнаем количество отработанных дней
  sprintf(strsql,"select kodt,dnei,kdnei from Ztab where tabn=%s and god=%d \
and mes=%d",tabnom,gr,mr);
  if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
   { 
    msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
    continue;
   }
  while(cur.read_cursor(&row) != 0)
   {
    sprintf(strsql,"select naik from Tabel where kod=%s",row[0]);
    sql_readkey(&bd,strsql,&row1,&curr);
    fprintf(ffprot,"%-2s %-30s %2s %2s\n",row[0],row1[0],row[1],row[2]);
    if(proverka(kodtabotrv,row[0],0,1) == 0)
      kolkk[kkk]+=atoi(row[2]);
    if(proverka(kodtabotp,row[0],0,1) == 0)
      kolkk[kkk]+=atoi(row[2]);
   }  
  dpm(&dr,&mr,&gr,3);
 }

//Распечатываем результат

fprintf(ff,"\
                   ДОВІДКА\n\
          про середню заробітну плату (дохід)\n\
видана особі %s\n\
яка працює (працювала) %s\n\
ідентифікаційний номер %-10s  Номер страхового свідоцтва____________\n",
fam,organ,inn);

if(sravmydat(dn,mn,gn,ICEB_DNDESV,ICEB_MNDESV,ICEB_GNDESV) < 0)
 {
  fprintf(ff,"\
------------------------------------------------------------------------\n\
 Дата  |Кількість|Нарахована|Сплачені|Cтрахові внески,сплачені особою  |\n\
       |  днів   |зарплата  |внески  |Пенсійний|Безробіття|Непра-тність|\n\
------------------------------------------------------------------------\n");

  printw("\
------------------------------------------------------------------------\n\
 Дата  |Кількість|Нарахована|Сплачені|Cтрахові внески,сплачені особою  |\n\
       |  днів   |зарплата  |внески  |Пенсійний|Безробіття|Непра-тність|\n\
------------------------------------------------------------------------\n");
 }
else
 {
  fprintf(ff,"\
-------------------------------------------------\n\
 Дата  |Кількість|Нарахована|Сплачені|Единий соц|\n\
       |  днів   |зарплата  |внески  | внесок   |\n\
-------------------------------------------------\n");

  printw("\
-------------------------------------------------\n\
 Дата  |Кількість|Нарахована|Сплачені|Единий соц|\n\
       |  днів   |зарплата  |внески  | внесок   |\n\
-------------------------------------------------\n");
 }
int nomer_str_bez=0;
int iotr=0;
char naim_mes[64];

double itog[5];
memset(itog,'\0',sizeof(itog));
dr=1; mr=mn; gr=gn;

for(kkk=0; kkk < kolmes; kkk++)
 {
  
  /*читаем значение max_sum_for_soc действующее в этом месяце*/
  class zar_read_tn1h nastr;
  zar_read_tn1(1,mr,gr,&nastr,NULL);

  
  if(sravmydat(dn,mn,gn,ICEB_DNDESV,ICEB_MNDESV,ICEB_GNDESV) < 0)
   {
    printw("%02d.%d %-9d %10.2f %8.2f %9.2f %10.2f %12.2f\n",
    mr,gr,kolkk[kkk],nash[kkk],vrashet[kkk],pens[kkk]*-1,bezr[kkk]*-1,
    netrud[kkk]*-1);

    fprintf(ff,"%02d.%d %-9d %10.2f %8.2f %9.2f %10.2f %12.2f\n",
    mr,gr,kolkk[kkk],nash[kkk],vrashet[kkk],pens[kkk]*-1,bezr[kkk]*-1,
    netrud[kkk]*-1);
   }  
  else
   {
    printw("%02d.%d %-9d %10.2f %8.2f %10.2f\n",
    mr,gr,kolkk[kkk],nash[kkk],vrashet[kkk],bezr[kkk]*-1);

    fprintf(ff,"%02d.%d %-9d %10.2f %8.2f %10.2f\n",
    mr,gr,kolkk[kkk],nash[kkk],vrashet[kkk],bezr[kkk]*-1);

   }
  memset(naim_mes,'\0',sizeof(naim_mes));
  mesc(mr,0,naim_mes);

  fprintf(ff_bezr,"|%02d|%02d.%04d%15s|%-*s|%14d|%13.2f|%13.2f|%16.2f|\n",
  ++nomer_str_bez,
  mr,
  gr,
  "",
  iceb_tu_kolbait(21,naim_mes),
  naim_mes,
  kolkk[kkk],nash[kkk],vrashet[kkk],bezr[kkk]*-1);
    

  iotr+=kolkk[kkk];
  itog[0]+=nash[kkk];
  itog[1]+=vrashet[kkk];
  itog[2]+=pens[kkk]*-1;
  itog[3]+=bezr[kkk]*-1;
  itog[4]+=netrud[kkk]*-1;
  

  dpm(&dr,&mr,&gr,3);
 }
fprintf(ff_bezr,"\
-------------------------------------------------------------------------------------------------------------\n");
fprintf(ff_bezr,"%*s|%14d|%13.2f|%13.2f|%16.2f|\n",
iceb_tu_kolbait(48,gettext("Итого")),gettext("Итого"),
iotr,itog[0],itog[1],itog[3]);
fprintf(ff_bezr,"\
-------------------------------------------------------------------------------------------------------------\n");
double ddd=0.;
if(iotr > 0)
 ddd=itog[0]/iotr;

zarsruv_end(ddd,ff_bezr);



if(sravmydat(dn,mn,gn,ICEB_DNDESV,ICEB_MNDESV,ICEB_GNDESV) < 0)
 {
  printw("\
------------------------------------------------------------------------\n");

  printw("%-*.*s %-9d %10.2f %8.2f %9.2f %10.2f %12.2f\n",
  iceb_tu_kolbait(7,gettext("Итого")),iceb_tu_kolbait(7,gettext("Итого")),gettext("Итого"),
  iotr,
  itog[0],itog[1],itog[2],itog[3],itog[4]);

  fprintf(ff,"\
------------------------------------------------------------------------\n");

  fprintf(ff,"%-*.*s %-9d %10.2f %8.2f %9.2f %10.2f %12.2f\n",
  iceb_tu_kolbait(7,gettext("Итого")),iceb_tu_kolbait(7,gettext("Итого")),gettext("Итого"),
  iotr,
  itog[0],itog[1],itog[2],itog[3],itog[4]);

  fprintf(ff,"\
------------------------------------------------------------------------\n");
 }
else
 {
  printw("\
-------------------------------------------------\n");

  printw("%-*.*s %-9d %10.2f %8.2f %10.2f\n",
  iceb_tu_kolbait(7,gettext("Итого")),iceb_tu_kolbait(7,gettext("Итого")),gettext("Итого"),
  iotr,
  itog[0],itog[1],itog[3]);

  fprintf(ff,"\
-------------------------------------------------\n");

  fprintf(ff,"%-*.*s %-9d %10.2f %8.2f %10.2f\n",
  iceb_tu_kolbait(7,gettext("Итого")),iceb_tu_kolbait(7,gettext("Итого")),gettext("Итого"),
  iotr,
  itog[0],itog[1],itog[3]);

  fprintf(ff,"\
-------------------------------------------------\n");
 }

if(iotr != 0)
 printw("%s: %.2f/%d=%.2f\n",gettext("Средняя зарплата"),
 itog[1],iotr,itog[1]/iotr);
else
 printw("%s: %.2f/%d=%.2f\n",gettext("Средняя зарплата"),
 itog[1],iotr,0.);
 
if(iotr != 0)
 fprintf(ff,"Середньоденна заробітна плата (дохід): %.2f/%d=%.2f\n",
 itog[1],iotr,itog[1]/iotr);
else
 fprintf(ff,"Середньоденна заробітна плата (дохід): %.2f/%d=%.2f\n",
 itog[1],iotr,0.);
fprintf(ff,"\
Примітка. Дата звільнення з роботи за сумісництвом________________\n\
(заповнюеться у разі видання довідки  для признячення страхових\n\
виплат, пов'язаних з безробіттям).\n\n\
Головний бухгалтер ________________________ %s\n\
(або фізична особа)\n\
 М.П.\n\
Телефон виконавця____________\n",fambuh); 


podpis(ff);
podpis(ff_bezr);
podpis(ffprot);

fclose(ff);
fclose(ff_bezr);
fclose(ffprot);


printw_vr(tmmn);

OSTANOV();

oth->spis_imaf.plus(imaf);
oth->spis_naim.plus(gettext("Расчет средней зарплаты социальной помощи"));
oth->spis_imaf.plus(imaf_bezr);
oth->spis_naim.plus(gettext("Справка в фонд занятости"));
oth->spis_imaf.plus(imafprot);
oth->spis_naim.plus(gettext("Протокол расчёта"));

for(int nomer=0; nomer < oth->spis_imaf.kolih(); nomer++)
 iceb_t_ustpeh(oth->spis_imaf.ravno(nomer),1);
 

return(0);
}
/*******************************************/
/*Заполнение шапки справки в фонд занятости*/
/*******************************************/
void zarsruv_sh(const char *inn,const char *fio,FILE *ff)
{
SQL_str row_alx;
class SQLCURSOR cur_alx;
int kolstr=0;
char strsql[512];
short dt,mt,gt;
int nomer_str=0;
char stroka[1024];
char bros[512];

poltekdat(&dt,&mt,&gt);

sprintf(strsql,"select str from Alx where fil='zarsvfz_start.alx' order by ns asc");
if((kolstr=cur_alx.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return;
 }

if(kolstr == 0)
 {
  sprintf(strsql,"%s %s!",gettext("Не найдена настройка"),"zarsvfz_start.alx");
  iceb_t_soob(strsql);
  return;
 }


while(cur_alx.read_cursor(&row_alx) != 0)
 {
  if(row_alx[0][0] == '#')
   continue;

  nomer_str++;
  memset(stroka,'\0',sizeof(stroka));
  strncpy(stroka,row_alx[0],sizeof(stroka)-1);
  switch(nomer_str)
   {
    case 1:
     sprintf(bros,"%02d.%02d.%d р.",dt,mt,gt);
     BSTAB(stroka,bros,1,14,1);
     break;

    case 5:
     BSTAB(stroka,fio,10,110,1);
     break;

    case 6:
     BSTAB(stroka,organ,25,110,1);
     break;
    case 7:
     BSTAB(stroka,inn,23,37,1);
     break;
   }

  fprintf(ff,"%s",stroka);

 }

}
/*******************/
/*Заполение концовки*/
/********************/
void zarsruv_end(double suma,FILE *ff)
{
SQL_str row_alx;
class SQLCURSOR cur_alx;
int kolstr=0;
char strsql[512];
int nomer_str=0;
char stroka[1024];
char suma_prop[100];
double cel=0.,drob=0.;
class iceb_t_fioruk_rk rekruk;

memset(suma_prop,'\0',sizeof(suma_prop));
preobr(suma,suma_prop,0);

drob=modf(suma,&cel);

sprintf(strsql,"select str from Alx where fil='zarsvfz_end.alx' order by ns asc");
if((kolstr=cur_alx.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return;
 }

if(kolstr == 0)
 {
  sprintf(strsql,"%s %s!",gettext("Не найдена настройка"),"zarsvfz_end.alx");
  iceb_t_soob(strsql);
  return;
 }


while(cur_alx.read_cursor(&row_alx) != 0)
 {
  if(row_alx[0][0] == '#')
   continue;
  nomer_str++;
  memset(stroka,'\0',sizeof(stroka));
  strncpy(stroka,row_alx[0],sizeof(stroka)-1);
  switch(nomer_str)
   {
    case 4:
     BSTAB(stroka,(int)cel,1,12,1);
     BSTAB(stroka,(int)drob*100,18,21,1);
     break;

    case 5:
     BSTAB(stroka,suma_prop,1,109,1);
     break;

    case 21:
     iceb_t_fioruk(1,&rekruk);      
     BSTAB(stroka,rekruk.fio.ravno(),45,109,1);
     break;

    case 24:
     iceb_t_fioruk(2,&rekruk);      
     BSTAB(stroka,rekruk.fio.ravno(),45,109,1);
     break;

    case 26:
     BSTAB(stroka,rekruk.telef.ravno(),48,109,1);
     break;

   }

  fprintf(ff,"%s",stroka);

 }



}

