/*$Id: buhl.h,v 5.153 2011-08-29 07:09:07 sasa Exp $*/
/*22.07.2011	14.02.2000	Белых А.И.	buhl.h
*/
#include	<util.h>
#include	<libsql.h>
#include        <lock_tables.h>
#include "icebt_sql_flag.h"
#include "iceb_t_mstr.h"
#include "iceb_t_fioruk.h"
#include "vvod.h"
#include "iceb_t_avp.h"
#include "iceb_t_tmptab.h"
#include "iceb_t_rnfxml.h"

#define ICEBEMAIL "sasa@ukrpost.ua"
#define ICEBSAIT "www.iceb.vc.ukrtel.net"
/*Права доступа к создаваемым программой файлам*/
//#define ICEB_UMASK 0117 /*хозяину и группе читать и писать*/
#define ICEB_UMASK 0111 /*всем читать и писать*/
// название файла с переводом для нашего приложения
#define ICEB_LOCALE "iceBt"

const short ICEB_PS_GK =  1; /*Код подсистемы "Главная книга"*/
const short ICEB_PS_MU =  2; /*Код подсистемы "Материальный учёт"*/
const short ICEB_PS_PD =  3; /*Код подсистемы "Платёжные документы"*/
const short ICEB_PS_ZP =  4; /*Код подсистемы "Заработная плата"*/
const short ICEB_PS_UOS=  5; /*Код подсистемы "Учёт основных средств"*/
const short ICEB_PS_UU =  6; /*Код подсистемы "Учёт услуг"*/
const short ICEB_PS_UKO=  7; /*Код подсистемы "Учёт кассовых ордеров"*/
const short ICEB_PS_UKR=  8; /*Код подсистемы "Учёт командировочных расходов"*/
const short ICEB_PS_UPL=  9; /*Код подсистемы "Учёт путевых листов"*/
const short ICEB_PS_RNN= 10; /*Код подсистемы "Реестр налоговых накладных"*/
const short ICEB_PS_UD = 11; /*Код подсистемы "Учёт доверенностей"*/
const short ICEB_PS_ABD= 12; /*Код подсистемы "Администрирование баз данных"*/

extern SQL_baza	bd;

class spis_oth
 {
  public:
   class SPISOK spis_imaf; /*Список имён файлов с отчётами*/
   class SPISOK spis_naim; /*Список наименований отчётов*/
  
  void clear()
   {
    spis_imaf.free_class();
    spis_naim.free_class();
   }
 };

struct OPSHET
 {
  char	naim[512];//Наименование
  short tips;    // 0-активный 1-пассивный 2-активно-пассивный
  short vids;    // 0-счет 1-субсчет
  short saldo;   // 0-сальдо свернутое 3-сальдо развернутое
  short stat;    // 0-балансовый 1-не балансовый
  short val;     // 0-национальная валюта или номер валюты из справочника валют
  short ksb;     //код суббаланса
 };

class akt_sverki //Для расчёта акта сверки по контрагентам
 {
  public:
   class SPISOK data_nomd; //Дата|номер документа
   class SPISOK koment;    //коментарий
   class masiv_din_double suma_deb; 
   class masiv_din_double suma_kre; 
   double start_saldo_deb;
   double start_saldo_kre;
   char shet[32];  
   short dn,mn,gn;
     
  akt_sverki()
   {
    start_saldo_deb=start_saldo_kre=0.;
    memset(shet,'\0',sizeof(shet));
    dn=mn=gn=0;
   }
  void clear()
   {
    start_saldo_deb=start_saldo_kre=0.;
    memset(shet,'\0',sizeof(shet));
    suma_deb.free_class();
    suma_kre.free_class();
    data_nomd.free_class();
    koment.free_class();    
    dn=mn=gn=0;
   }
 };







extern int	oprsk(const char*);
extern int	sql_zapis(const char*,int,int);
extern int	provinnom(const char*);
extern int	invnomer(int);
extern int   	nomnalnak(short,short);
extern int	provnomnnak(short,short,const char*);
extern void     eropbaz(const char*,int,const char *name,int);
extern void     eropbaz(const char*,int,const char *name,int,FILE*);
extern int	vibrek(const char*,char*,int,char*);
extern int      vibrek(const char *tabl,class iceb_tu_str *kodrec,class iceb_tu_str *naim);
extern int      vibrek(const char *tabl,class iceb_tu_str *kodrec);
extern int	vvodkod(const char*,class iceb_tu_str*,class iceb_tu_str*,int,int,int);
extern void	raspprov(SQLCURSOR*,short,short,short,const char*,int,int);
extern void	kasord1(const char*,const char*,short,short,short,const char*,const char*,double,const char*,const char*,const char*,const char*,FILE*);
extern void	kasord2(const char*,const char*,short,short,short,const char*,const char*,double,const char*,const char*,const char*,const char*,const char*,FILE*);
extern int	dirmat1(const char*,class iceb_tu_str*,class iceb_tu_str*,int,int,int,short,int*,int*,const char*,const char*);
extern int 	dirkontr(class iceb_tu_str*,class iceb_tu_str*,int);
extern int 	dirshet(class iceb_tu_str*,class iceb_tu_str*,int);
extern int      dirskont(const char *sht,class iceb_tu_str *kodo,class iceb_tu_str *nai,int met);
//extern int 	norn(void);
extern int	poivcur(const char*,int,SQLCURSOR*);
extern int	provsh(class iceb_tu_str *kor,const char*,struct OPSHET*,int,int);
extern int 	provud(const char*,const char*,int);
extern int 	prsh(const char*,OPSHET*);
extern int 	prsh1(const char*,OPSHET*);
extern int	salorok(const char*,const char*,class spis_oth*);
extern int	smenabaz(int);
extern int smenabaz_mysql(class iceb_tu_str *imabazv,int metka);
extern void 	vkontr(const char*,class iceb_tu_str*,int);
extern int      zapprov(int,int,int,int,const char*,const char*,const char*,const char*,const char*,\
const char*,const char*,double,double,const char*,short,int,time_t,short,short,short,int,int); 
extern double   sumvpr(const char*,const char*,short,short,short,const char*,int,const char*,time_t,int,const char*);
extern void zapmpr(short g,short m,short d,const char *sh,const char *shk,const char *kor1,const char *kor2,double deb,double kre,const char *kom,int kolpr,int kekv,class SPISOK *sp_prov,class masiv_din_double *sum_prov_dk,FILE*);
extern void zapmpr1(const char *nn,const char *kop,int skk,time_t vrem,const char *kto,short dd,short md,short gd,int tipz,class SPISOK *sp_prov,class masiv_din_double *sum_prov_dk,FILE*);

extern void     sozvprov1(VVOD*);
extern void     vprov1(VVOD*,const char*,short,char*,const char*,const char*,int,int,int,int,short,time_t,const char*,int,const char*,int,int,int);
extern void     salork(const char*,const char*,double*,double*,short,char*,char*,const char*,short,short,short,short,short,short,const char*,short,char*,char*);
extern void     printcod(FILE*,const char*,const char*,const char*,int,const char*,int*);
extern void	korkod(const char*,const char*,const char*);
extern int	udprgr(const char*,short,short,short,const char*,int,int);
extern int    	udprov(int,short,short,short,const char*,const char*,time_t,double,double,const char*,short);
extern void	poigod(int);
extern void	smenkodk(const char*,const char*);
extern int	dikont(char,const char*,const char*,const char*,const char*);
int iceb_redfil(const char*,int metka_r);
int iceb_redfil(const char *imafil,int metka_r,const char *editor);
extern void     zagacts(short,short,short,short,short,short,short,short,short,const char*,const char*,FILE*);
extern void	konact(FILE*);
extern void	zagsh(const char*,FILE*);
extern void     salorksl(double,double,double,double,double,double,FILE*,FILE*);
extern int	dirmt(class iceb_tu_str*,int);
extern void	msql_error(SQL_baza*,const char*,const char*,FILE*);
extern void	msql_error(SQL_baza*,const char*,const char*);
extern int      dolruk(char*,int,char*,int);
extern int      readkey(const char *zapros,SQL_str *row,SQLCURSOR *cur);
extern int      readkey(char *zapros);
extern void icebstart(int argc,char **argv);
extern int exit_iceb(int);
extern void imafn(const char*,char*);
extern void imafn(const char*,class iceb_tu_str*);
extern void rasnaln1(const char *imaf,int *nomer_str,int *kor,short dd,short md,short gd,short dnn,short mnn,short gnn,const char *nomnn,const char *osnov,const char *uspr,const char *frop,const char *kpos,int,FILE **f1,FILE **f2);
extern void rasnaln2(int nomer_str,int kor,short tipnn,double itogo,double sumkor,const char *naimnal,float procent,float pnds,const char*,const char*,double,double,FILE *f1,FILE *f2);
extern void pehf(const char *imaf,short kk,const char *print);
extern void dirlst(const char *ima);
extern int spis_koment(char *koment,int razmer_koment,const char *imaf_s_koment);
extern int dirf(char *tif,int mp,int y,int x,int kk);
extern int dirfajl(const char *name,int mi,class SPISOK *mfa);
extern int dirkatl(class iceb_tu_str *imafil);
extern void printw_vr(time_t vrem_n);
extern int iceb_t_spis_komp(const char *imaf);
extern void rabfil(char *naim,char *imafs,char *klush_peh);
extern void akt_sv(class akt_sverki *akt_svr,FILE *ff,FILE *ff_bi);
extern int  vvod1(char *strk,int dlstrk,int kolbiat,VVOD *VV,int (*outvvod)(char*),WINDOW *win1,int PY,int PX);
extern int  vvod1(class iceb_tu_str *strk,short dlstrk,VVOD *VV,int (*outvvod)(char*),WINDOW *win1,int PY,int PX);
extern void readkey_par(int argc,char **argv,char **parol,char **imabaz,char **host,int *regim);
extern int	mprintcap(void);
extern int iceb_t_rsdatp1(short *mn,short *gn,const char *datan,short *mk,short *gk,const char *datak);
extern int iceb_t_kolstrfil(const char *imaf);
extern int iceb_t_rstrf(int nomer_str,const char *imaf,class iceb_tu_str *str_fil);
extern int dirsubbal(int metkar,class iceb_tu_str *kod_subbal,class iceb_tu_str *naim_subbal);
extern void iceb_t_spk(short dk,short mk,short gk,const char *shet,const char *naimsh,const char *kontr,const char *naikontr,double suma,FILE *ff_spr);
extern void icebstart_rf();
extern void  iceb_t_rabfil(class spis_oth *oth,const char *klush_peh);
extern int iceb_t_system(const char *komanda,int);
extern int mydoscopy(const char *imafdbf);
extern int menufil(const char *imafil,int y,int x,int kk,SPISOK *masiv,char *soob);
extern int menufil1(const char *imafil,SPISOK *masiv);
extern int     dirmasiv(SPISOK *masivmenu,int y,int x,int kk,const char *soob,int nomras,int *kod_kl);
extern void iceb_t_ko2(const char *imaf,const char *nomd,short dd,short md,short gd,const char *shet,const char *shetkas,double suma,const char *fio,const char *osnov,const char *dopol,const char *dokum,const char *hcn,FILE *ff_f);
extern void iceb_t_ko1(const char *imaf,const char *nomd,short dd,short md,short gd,const char *shet,const char *shetkas,double suma,const char *fio,const char *osnov,const char *dopol,FILE *ff_f);
extern int iceb_t_pbp(int metka_ps,short dd,short md,short gd,const char *nomdok,int pod,int tipz,const char *soob);
extern int iceb_t_pbp(const char *kto,short dd,short md,short gd,const char *nomdok,int pod,int tipz,const char *soob);
extern int iceb_t_pbpds(short mes,short god);
extern int iceb_t_pbpds(const char *data_str);
extern int iceb_t_pbsh(short mes,short god,const char *shet,const char *shetkor,const char *repl);
extern int iceb_t_delfil(const char *katalog,const char *rashir);
extern int iceb_t_perzap(int metka);
extern int iceb_t_fioruk(int metka,class iceb_t_fioruk_rk *rek);
extern void iceb_t_mpods(int metka_ps,char *kto);
extern int iceb_t_pvkdd(int metka_ps,short dd,short md,short gd,short mk,short gk,int pod,const char *nomdok,int tipz);
extern int	vibprint(void);
extern int	nastsys();
extern void    pros_fil(const char *imaf,const char *klush_s_fil);
extern void	prosf(const char*);
int vizred(const char*);
int vizred(const char *imaf,const char *editor);

extern int iceb_t_pvglkni(short mes,short god);
extern int iceb_t_pvglkni(const char *data);
extern void iceb_t_soob(const char *soob);
extern void infosys(int y,int x,const char *host,const char *vess,const char *DV,short ddd,short mmm,short ggg,const char *imabaz,const char *nameprinter,int uid,const char *fioop);
extern int iceb_t_make_kat(class iceb_tu_str *putnakat,const char *podkat);
extern void iceb_t_fsystem(const char *imaf_nast);
extern int vparol(VVOD *VV,char parol[],int dlstrk,WINDOW *win1,int Y,int X,int TEN);
extern int parolv(VVOD *PAROL,short d,short m,short g,int metka);
extern void kzvz(const char *ktozap,const char *vrem,VVOD *VV);
extern void kzvz(int ktozap,time_t vrem,VVOD *VV);
extern int   rsdatp(short *dn,short *mn,short *gn,const char *datn,short *dk,short *mk,short *gk,const char *datk);
extern void error_op_nfil(const char *imafil,int koderrno,const char *soob);
extern int iceb_t_poldan(const char *strpoi,char *find_dat,const char *imaf);
extern int iceb_t_poldan(const char *strpoi,int *kod,const char *imaf);
extern int iceb_t_poldan(const char *strpoi,class iceb_tu_str *find_dat,const char *imaf);
int iceb_t_poldan_vkl(const char *strpoi,const char *imaf);
extern int vixod(short d,short m,short g);
extern void podpis(FILE *ff);
extern int perecod(int metka_kod,const char *imaf);
extern int danet(VVOD *VV,int N,WINDOW *win1);
extern int menu3(VVOD *VV,int *N,int mt,int PY,int PX);
extern int menu3w(WINDOW *win1,VVOD *VV,int *N,int Y,int X,int mt);
extern int soobsh(VVOD *VV,int PY,int PX,int TEN);
extern int soobshw(VVOD *VV,WINDOW *win1,int PY0,int PX0,int ost,int TEN);
extern int iceb_t_menudpr(int metka);
extern void iceb_t_ndelkod(const char *tablica,const char *kod);
extern void iceb_t_avp(class iceb_t_avp *avp,const char *imaf_nast,class SPISOK *sp_prov,class masiv_din_double *sum_prov_dk,FILE *ff_prot);
extern void iceb_t_ustpeh(const char *imaf,int orient);
extern int iceb_t_sortkk(int metkasort,class SPISOK *skontr,class SPISOK *skontr_sort);
extern int iceb_t_cat(const char *imaf1,const char *imaf2);
extern int iceb_t_cp(const char *imaf_out,const char *imaf_in,int metka);
extern const char *iceb_t_imafnsi(const char *imaf);
extern const char *iceb_t_imafdoc(const char *imaf);
extern int my_getstr(char *stroka,int dls,int mdls,int kolbait,WINDOW *okno);
extern int iceb_t_pnnnp(const char *datann,const char *datavnn,const char *kodkontr,const char *nomnn,const char *datadok,const char *nomdok,int metka_ps);
extern int iceb_t_00_skl(const char *kontr);
extern void helstr(int py,int px,...);
extern int iceb_t_getuid();
extern void iceb_tl_blok();
extern int iceb_t_pblok(short mes,short god,int kodps);
extern int iceb_t_prr();
extern int iceb_t_prr(int podsystem);
extern const char *iceb_t_getnps();
extern int iceb_t_alxout(const char *imaf);
extern void iceb_t_alxin(const char *imaf);
extern const char *iceb_t_getfioop();
extern int iceb_t_prn();
extern int iceb_t_prn(int podsystem);
extern int iceb_t_pdoc(const char *imafil);
extern const char *iceb_t_kszap(const char *kodop);
extern const char *iceb_t_kszap(int kodop);
extern int iceb_t_getnkontr(int nom_start);
extern int iceb_t_insfil(const char *imaf,FILE *ff);
extern double iceb_t_pnds(short d,short m,short g);
extern double iceb_t_pnds(const char *data);
extern double iceb_t_pnds();
extern void iceb_t_fplus(const char *stroka,class iceb_tu_str *stroka1,class SQLCURSOR *cur);
extern void iceb_t_fplus(int metka_sp,const char *stroka,class SPISOK *nastr,class SQLCURSOR *cur);
extern void iceb_t_sozmas(short **kod,char *st1,class SQLCURSOR *cur);
int iceb_t_nalnaks(const char *imaf,int *nomer_st,short dd,short md,short gd,short dnn,short mnn,short gnn,const char *nomnn,const char *osnov,const char *uspr,const char *frop,const char *kpos,int tipz,int kol_kop,FILE **ff);
void iceb_t_nalnake(int tipz,short tipnn,double itogo,double sumkor,const char *naimnal,float procent,float pnds,const char *imaf_nastr,const char *kodop,double okrg1,double suma_voz_tar,const char *kod_kontr,FILE *ff);
void iceb_t_nalnak_str(int metka_str,int tipnn,const char *razdel,const char *datop,const char *naim,const char *ei,double kolih,double cena,double suma,FILE *ff);
int iceb_t_getuslp(const char *kodkon,class iceb_tu_str *uslprod);
int iceb_t_getuslp(int un_nom_zap,class iceb_tu_str *uslprod);
int iceb_t_dirdog(int metka_r,const char *kodkon);
void iceb_t_vkk00();
void GDITE();
void iceb_t_rnfxml(class iceb_rnfxml_data *rek_zag_nn);
int iceb_t_openxml(short dn,short mn,short gn,short dk,short mk,short gk,char *imaf_xml,const char *tip_dok,const char *pod_tip_dok,const char *nomer_versii_dok,int nomer_dok_v_pakete,int *period_type,class iceb_rnfxml_data *rek_zag_nn,FILE **ff_xml);
